require("framework.init")
require("framework.shortcodes")
require("framework.cc.init")
require("lfs")
local scheduler = require("framework.scheduler")
require(cc.PACKAGE_NAME .. ".api.GameState")
require("framework.toluaEx")
require("framework.deprecated")

--[[
scheduler.scheduleGlobal(function()
    CCTextureCache:sharedTextureCache():dumpCachedTextureInfo()
    --CCTextureCache:sharedTextureCache():removeUnusedTextures()
  end,20)


scheduler.scheduleGlobal(function()
    tolua.fullgc()
end,10)]]


-----------------------------预加载资源管理------------------------------------------------------
globalResources = {}
globalResources["BattleScene"]={}
globalResources["enterGameScene"]={}
globalResources["MainScene"]={}
globalResources["storyScene"]={}
globalResources["storyScene"]={}
-----------------------------预加载资源管理------------------------------------------------------
checkInUse = function(sceneName,plist,image)-------检测此资源在当前场景中是否还在使用
    if true then return end
    if runningSceneName=="BattleScene" then
        if globalResources[runningSceneName][runningPassId]==nil then return false end
        for k, v in ipairs(globalResources[runningSceneName][runningPassId]) do
            if v[1]==plist and v[2]==image then
                return true
            end
        end
        return false
    else
        for k, v in ipairs(globalResources[runningSceneName]) do
            if v[1]==plist and v[2]==image then
                return true
            end
        end
        return false
    end
end

checkIfExist = function(sceneName,plist,image)-------检测此资源在当前场景中是否还在使用
    for k, v in ipairs(globalResources[sceneName]) do
        if v[1]==plist and v[2]==image then
            return true
        end
    end
    return false
end

addRes = function(sceneName,plist,image)
    if plist and image then
        if not checkIfExist(sceneName,plist,image) then
            if globalResources[sceneName]==nil then
                globalResources[sceneName] = {}
            end
            globalResources[sceneName][#globalResources[sceneName]+1] = {plist,image}
            display.addSpriteFramesWithFile(plist,image)
        end
    end
end
delRes = function(sceneName)
    --print("现在的场景的名字是",runningSceneName)
    --print("当前在"..runningSceneName.."中释放"..sceneName.."场景中的资源")
    if runningSceneName~="BattleScene" then
        for k, v in ipairs(globalResources[sceneName]) do
            local plist = v[1]
            local image = v[2]
            display.removeSpriteFramesWithFile(plist,image)
        end
        globalResources[sceneName] = {}
    end
end

local MyApp = class("MyApp", cc.mvc.AppBase)

function MyApp:ctor()
    MyApp.super.ctor(self)
    self.objects_ = {}
    
 
end
--yangdx add 对退出按钮进行监控
function  MyApp:controlcancle()  
    
   
    --[[定义基本的函数
    --]]
    --捕捉前台的返回操作，设置DEF_CANCLE_FLAG
    local  function setcanclefuncid()     
        local function getflag(call_result)
            call_result=call_result or "0"
            DEF_CANCLE_FLAG=call_result
        end 

        if  (device.platform == 'android') then
            local javaClassName = "org.cocos2dx.lib.Function"
            local javaMethodName = "setcanclefuncid"
            local javaParams = {getflag}
            local javaMethodSig = "(I)V"
            local ok, ret = luaj.callStaticMethod(javaClassName, javaMethodName,javaParams,javaMethodSig)
            if not ok then
                print('yangdx  setcanclefuncid 设置报错  ')
            else 
                print('yangdx  setcanclefuncid 设置成功  DEF_CANCLE_FLAG=',DEF_CANCLE_FLAG)
            end 
        end
    end  

    --重置前台的返回操作可用
    local  function setcancleflag(cancleflag)
        if  (device.platform == 'android') then
            local javaClassName = "org.cocos2dx.lib.Function"
            local javaMethodName = "getcancleflag"
            local javaParams = {cancleflag}
            local javaMethodSig = "(Ljava/lang/String;)V"
            local ok, ret = luaj.callStaticMethod(javaClassName, javaMethodName,javaParams,javaMethodSig)
            if not ok then
                print('yangdx  setcancleflag 传前台报错 ')
            else 
                print('yangdx  setcancleflag 传前台成功  ')
            end 
        end
    end 

    --执行前台回退操作
    local  function runcancle()
        if  (device.platform == 'android') then
            local javaClassName = "org.cocos2dx.lib.Function"
            local javaMethodName = "exitgame"
            local javaParams = {}
            local javaMethodSig = "()V"
            local ok, ret = luaj.callStaticMethod(javaClassName, javaMethodName,javaParams,javaMethodSig)
            if not ok then
                print('yangdx  退出执行 错误  the ret=',ret)
            else 
            end 
        else
            --print('yangdx 测试环境 runcancle 无效 ')  
        end
    end 

   --第0步 设定生效条件。退出只能生效一次。
   ---[[  正式需生效 ---留存用户和已经付费过一次的用户  or gPlayer.data.free_pay_count%100>0

    if  ( gPlayer.data.pass_id > 60009 ) or ( gPlayer.data.pay_hit_count%100> 0 and DEF_CONTROL_LEVEL >0) then   
        scheduler.unscheduleGlobal(self.handler) 
        return
    end
    --]]

    if not DEF_SPECIAL_PAY_PROCESS then  --线上则回退不生效。
        return 
    end 

   --第一步 获取前台 cancleflag 设置后台 DEF_CANCLE_FLAG

    if DEF_CANCLE_FLAG=="0" and DEF_SCHEDULE_COUNT==0 then
        --print('yangdx 设置前台退出触摸的捕捉函数 ')   
        setcanclefuncid()
        DEF_SCHEDULE_COUNT=1
    end 
   --第二步 根据 DEF_CANCLE_FLAG 值进行不同处理
     if (DEF_CANCLE_FLAG=="0" ) then  --退出未被点击
        return
     elseif (DEF_CANCLE_FLAG=="1")  then  --退出被点击

        if CURSCENE == nil then 
           DEF_CANCLE_FLAG="3"
           --setcancleflag(DEF_CANCLE_FLAG)
        else
           DEF_CANCLE_FLAG="2"
           --- 5至尊 6 新手礼包  一堆金币 yangdxtest 测试用例，正式要修改
            --CommUtil.showgiftPanel(6,1)  --直接卖一堆金币
            if (not gHero:isHeroExists(10003))  then 
                CommUtil.showgiftPanel(1,1)   
            elseif ((not gHero:isHeroExists(10004)) or (not gHero:isHeroExists(10005)) or (not gHero:isHeroExists(10006))) then
                CommUtil.showgiftPanel(5,1)  
            else
                CommUtil.showgiftPanel(8,1)  --直接卖一堆金币
            end 
        end  
        

     elseif (DEF_CANCLE_FLAG=="2")  then  --退出活动促销中事件进行中
        DEF_SCHEDULE_COUNT=DEF_SCHEDULE_COUNT+1 --对退出操作进行计数
        if(DEF_SCHEDULE_COUNT>140) then   --操作有各种异常，超过200秒未有相应  yangdx  test  正式需增加。
            DEF_CANCLE_FLAG="5"
            --print("yangdx 前台退出操作长时间无反应，强制退出 DEF_SCHEDULE_COUNT=",DEF_SCHEDULE_COUNT) 
        end 
        return 
     elseif (DEF_CANCLE_FLAG =="3" or  DEF_CANCLE_FLAG =="5")  then  --退出活动完成。真正退出
        --setcancleflag("0")
        if DEF_CANCLE_FLAG =="3" then
           --print("yangdx 前台操作完成(正常完成),执行退出") 
           setcancleflag("0")
           DEF_CANCLE_FLAG="0"
           DEF_SCHEDULE_COUNT=0
           runcancle()
        else
           --print("yangdx 前台操作(异常完成)，回到可操作状态") 
           setcancleflag("0")
           DEF_CANCLE_FLAG="0"
           DEF_SCHEDULE_COUNT=0
           runcancle()
        end
        
     end 

end 



function MyApp:rmdir(path)
    local function _rmdir(path)
    local iter, dir_obj = lfs.dir(path)
    while true do
        local dir = iter(dir_obj)
        if dir == nil then break end
            if dir ~= "." and dir ~= ".." then
                local curDir = path..dir
                local mode = lfs.attributes(curDir, "mode") 
                if mode == "directory" then
                    _rmdir(curDir.."/")
                elseif mode == "file" then
                    os.remove(curDir)
                end
            end
        end
        local succ, des = os.remove(path)
        if des then print(des) end
        return succ
    end
    _rmdir(path)
    return true
end

function MyApp:run()
    --print("RELEASE_PLATFORM222=", RELEASE_PLATFORM)
    audio.setMusicVolume(0.2)
    audio.setSoundsVolume(1)

    --local tempPath = CCFileUtils:sharedFileUtils():getUpdateFilePath().."temp/"--每次进入程序时清空可能因为更新不成功解压不成功而产生的临时目录的垃圾文件
    --self:rmdir(tempPath)
    
    --CPlusMathUtil:setRandSeed()
    --真机发布
    --[[
    if io.exists(device.writablePath.."game/config.lua") then
        CCFileUtils:sharedFileUtils():addSearchPath(device.writablePath.."game/res/")
    end
    CCFileUtils:sharedFileUtils():addSearchPath("res/")]]
    --print("RELEASE_PLATFORM=", RELEASE_PLATFORM)
    --获得要采用的SDK
    CCFileUtils:sharedFileUtils():addSearchPath("res/")
    self:init()

    

    --self:enterScene("BattleScene")
    
    --self:enterScene("SubjectScene")
    CHANNEL_ID = "nobaidu"
    SHOW4399 = true
    local getSdkFunc = function(funcStr, callback)
        if  (device.platform == 'android') then
            local callbackI = function(str)
            --print("yangdx  CHANNEL_ID=|" .. str .. "|")
                CHANNEL_ID = str
                callback()
                self:enterScene("enterGameScene")
            end  --模拟器直接用时间
            local ok, ret = luaj.callStaticMethod("org/cocos2dx/lib/Function", funcStr, {callbackI},"(I)V")
            if not ok then
                callback()
            end
        else
           self:enterScene("enterGameScene")
            callback()
        end
    end
    getSdkFunc("getSDK", function() 
        local aa = 1
        end)



end

function MyApp:init()
    package.loaded["config"] = nil
    require("config")
    require("app.AppDef")
    --CommUtil.InitAppData()
    --[[ yangdx add
    self.handler=scheduler.scheduleGlobal(handler(self,self.controlcancle), 1)  --每隔一定时间执行，循环。返回是函数句柄
    --]]

    self.recordnum=0;
    self.handler2=scheduler.scheduleGlobal(handler(self,self.DealPayCallback),1)  --每隔一定时间执行，循环。返回是函数句柄
    --初始化测试用数据
    DebugUtil.initAppTestData()
    --网络轮循
    --gSock.initSockScheduler() 
end

function MyApp:setObject(id, object)
    assert(self.objects_[id] == nil,string.format("MyApp:setObject() - id \"%s\" already exists",id))
    self.objects_[id] = object
end

function MyApp:getObject(id)
    assert(self.objects_[id] ~= nil, string.format("MyApp:getObject() - id \"%s\" not exists", id))
    return self.objects_[id]
end

function MyApp:isObjectExists(id)
    return self.objects_[id] ~= nil
end



function MyApp:DealPayCallback() 
    -- self.recordnum=self.recordnum+1
    -- if(self.recordnum<4) then 
    --    print('yangdx  DealPayCallback开始生效 ')
    -- end 
    --对退出礼包进行处理
    if DEF_CANCLE_FLAG=='1' then  --需要调出退出礼包
       DEF_CANCLE_FLAG='2' --礼包已经弹出
        math.randomseed(tostring(os.time()):reverse():sub(1,6)) 
        local indexid=math.random(4)+10

        -- if (not gHero:isHeroExists(10003))  then 
        --         CommUtil.showgiftPanel(1,1)   
        -- elseif ((not gHero:isHeroExists(10004)) or (not gHero:isHeroExists(10005)) or (not gHero:isHeroExists(10006))) then
        --         CommUtil.showgiftPanel(5,1)  
        -- else
        --         CommUtil.showgiftPanel(8,1)  --直接卖一堆金币
        -- end 
        CommUtil.showgiftPanel(indexid,1)

    end 

    --对计费成功进行处理

    if DEF_CURPAYSTATE==0  then
        return
    elseif DEF_CURPAYSTATE==1  then 
        --print('yangdx  计费道具发放成功 ')
        CommUtil.insertBuyItem(DEF_CURPAYCODE) --道具发放
        DEF_CURPAYSTATE=0 --道具发放后状态置为0
        CommUtil.toast(display.getRunningScene(),"有道具解锁发放成功..",0)
        --print("yangdx  计费道具发放成功 代码="..DEF_CURPAYCODE.."  代码状态="..DEF_CURPAYSTATE)

    elseif  DEF_CURPAYSTATE<0 then
        --print("yangdx  计费道具发放失败 代码="..DEF_CURPAYCODE.."  代码状态="..DEF_CURPAYSTATE)
        DEF_CURPAYSTATE=0 --道具发放后状态置为0
    end  
   
end




return MyApp
