local AnimationFactory = require("app.factory.AnimationFactory")
local MathUtil = require("app.common.MathUtil")
local Attacker = require("app.actor.Attacker")

local Boss = class("Boss",Attacker)

function Boss:ctor(attackerProperties,parent,path)
    Boss.super.ctor(self,attackerProperties,parent,path)
end

function Boss:doWalkAnimation(direction)
    self.mainSprite:stopAllActions()
    local animation = AnimationFactory.getBossAnimation(direction,self.attackerProperties.body_id,self.attackerProperties.walk_animation_time)
    if animation~=nil then 
        transition.execute(self.mainSprite, CCAnimate:create(animation), {
            onComplete = function()
                local wayPointCount = self._waypoints:count()
                local waypoint = tolua.cast(self._waypoints:objectAtIndex((self.curWaypoint+1>wayPointCount-1) and (wayPointCount-1) or (self.curWaypoint+1) ),"WayPoint")
                self:doWalkAnimation(waypoint.direction)
            end,
        })
    end
end

function Boss:isBigBoss()
   return false
end


return Boss