local MathUtil = require("app.common.MathUtil")
local Thief = require("app.actor.Thief")
local AnimationFactory = require("app.factory.AnimationFactory")

local BossThief = class("BossThief",Thief)

function BossThief:doWalkAnimation(direction)
    self.mainSprite:stopAllActions()
    local animation = AnimationFactory.getBossAnimation(direction,self.attackerProperties.body_id,self.attackerProperties.walk_animation_time)
    if animation~=nil then 
        transition.execute(self.mainSprite, CCAnimate:create(animation), {
            onComplete = function()
                local wayPointCount = self._waypoints:count()
                local waypoint = tolua.cast(self._waypoints:objectAtIndex((self.curWaypoint+1>wayPointCount-1) and (wayPointCount-1) or (self.curWaypoint+1) ),"WayPoint")
                self:doWalkAnimation(waypoint.direction)
            end,
        })
    end
end

function BossThief:isBigBoss()
   return false
end


return BossThief