local MathUtil = require("app.common.MathUtil")
local Attacker = require("app.actor.Attacker")

local Cat = class("Cat",Attacker)

function Cat:ctor(attackerProperties,parent,path)
    Cat.super.ctor(self,attackerProperties,parent,path)
end

function Cat:walk()
    if self.dead then
        return
    end
    if self.fCurLifeValue <= 0 then
        self:clean()
        return
    end
    
    local waypoint1 = tolua.cast(self._waypoints:objectAtIndex(self.curWaypoint),"WayPoint")
    local waypoint2 = tolua.cast(GameInstance:sharedInstance().beautyPoint,"WayPoint")
    local wayPointCount = self._waypoints:count()

    if self.curWaypoint == (wayPointCount-1) then
        self.curWaypoint = 0
        if  not self.reverse then
            self.reverse = true
            self:reverseAttackerPath(self.path)
        else
            self.reverse = false
            self:setAttackerPath(self.path)
        end
        self:walk()
        return
    end

    --取得下一个要到达地点的位置
    local currentPosition = ccp(self:getPositionX(),self:getPositionY())
    local waypoint = tolua.cast(self._waypoints:objectAtIndex(self.curWaypoint+1),"WayPoint")
    
    local destPosition = ccp(CommUtil.getBlankWidth() + waypoint.position.x,waypoint.position.y-self.offset)
    
    --计算时间采用设计分辨率800x480
    local dist = ccpDistance(destPosition,ccp(self:getPositionX(),self:getPositionY()))
    local runTime = dist/self.move_speed

    if dist > 0 then
        runTime = dist/self.move_speed *(1 + math.abs(destPosition.y-self:getPositionY())/dist)
    end
    if self.reverse then
        self.mainSprite:setFlipX(not waypoint.isFlipX)
    else
        self.mainSprite:setFlipX(waypoint.isFlipX)
    end
    local action = CCSequence:createWithTwoActions(
            CCMoveTo:create(runTime,destPosition),
            CCCallFunc:create(function()
                self.curWaypoint = self.curWaypoint + 1
                self:walk()
    end))
    action:setTag(99)
    self:runAction(action)
end

function Cat:reverseAttackerPath(path)
    if path ~= nil then
        self._waypoints:removeAllObjects()
        for i=0,path:count()-1 do
            local curWayPoint = tolua.cast(path:objectAtIndex(path:count()-1-i), "WayPoint")
            local wp = WayPoint:new(curWayPoint.position,curWayPoint.isFlipX,curWayPoint.direction,curWayPoint.underSea)
            self._waypoints:addObject(wp)
        end
    end
end

function Cat:getChildCatPathAndCurWayPoint()
    local paths = GameInstance:sharedInstance().paths
    for i=0,paths:count()-1 do
        local path = tolua.cast(GameInstance:sharedInstance().paths:objectAtIndex(i),"CCArray")
        for j=0,path:count()-1 do
            local curWayPoint = tolua.cast(path:objectAtIndex(j), "WayPoint")
            if ccpDistance(ccp(curWayPoint.position.x,curWayPoint.position.y),ccp(self:getPositionX(),self:getPositionY()))<20 then
                return path,j
            end
        end
    end
end

function Cat:isBigBoss()
   return false
end

return Cat