local MathUtil = require("app.common.MathUtil")
local Attacker = require("app.actor.Attacker")

local MonsterRunCycleWay = class("MonsterRunCycleWay",Attacker)

function MonsterRunCycleWay:ctor(attackerProperties,parent,path)
    MonsterRunCycleWay.super.ctor(self,attackerProperties,parent,path)
end

function MonsterRunCycleWay:walk()
    if self.dead then
        return
    end
    if self.fCurLifeValue <= 0 then
        self:clean()
        return
    end
    local waypoint1 = tolua.cast(self._waypoints:objectAtIndex(self.curWaypoint),"WayPoint")
    local waypoint2 = tolua.cast(GameInstance:sharedInstance().beautyPoint,"WayPoint")
    local wayPointCount = self._waypoints:count()

    if self.curWaypoint == (wayPointCount-1) then
        self:resetPath()
        self:walk()
        return
    end

    --取得下一个要到达地点的位置
    local currentPosition = ccp(self:getPositionX(),self:getPositionY())
    local waypoint = tolua.cast(self._waypoints:objectAtIndex(self.curWaypoint+1),"WayPoint")
    
    local destPosition = ccp(waypoint.position.x+CommUtil.getBlankWidth(),waypoint.position.y-self.offset)
    
    --计算时间采用设计分辨率800x480
    local dist = ccpDistance(destPosition,ccp(self:getPositionX(),self:getPositionY()))
    local runTime = dist/self.move_speed

    if dist > 0 then
        runTime = dist/self.move_speed *(1 + math.abs(destPosition.y-self:getPositionY())/dist)
    end
    self.mainSprite:setFlipX(waypoint.isFlipX)
    
    local action = CCSequence:createWithTwoActions(
            CCMoveTo:create(runTime,destPosition), 
            CCCallFunc:create(function()
                self.curWaypoint = self.curWaypoint + 1
                self:walk()
    end))
    action:setTag(99)
    self:runAction(action)
end

function MonsterRunCycleWay:resetPath()
    if self.way==1 then 
        self.way=5
        self._waypoints:removeAllObjects()
        local paths = GameInstance:sharedInstance().paths
        self.path = tolua.cast(GameInstance:sharedInstance().paths:objectAtIndex((self.way-1)),"CCArray")
        for i=0,self.path:count()-1 do
            local curWayPoint = tolua.cast(self.path:objectAtIndex(i), "WayPoint")
            local wp = WayPoint:new(curWayPoint.position,curWayPoint.isFlipX,curWayPoint.direction,curWayPoint.underSea)
            self._waypoints:addObject(wp)
        end
    elseif self.way==2 then
        self.way=6
        self._waypoints:removeAllObjects()
        local paths = GameInstance:sharedInstance().paths
        self.path = tolua.cast(GameInstance:sharedInstance().paths:objectAtIndex((self.way-1)),"CCArray")
        for i=0,self.path:count()-1 do
            local curWayPoint = tolua.cast(self.path:objectAtIndex(i), "WayPoint")
            local wp = WayPoint:new(curWayPoint.position,curWayPoint.isFlipX,curWayPoint.direction,curWayPoint.underSea)
            self._waypoints:addObject(wp)
        end
    elseif self.way==3 then
        self.way=7
        self._waypoints:removeAllObjects()
        local paths = GameInstance:sharedInstance().paths
        self.path = tolua.cast(GameInstance:sharedInstance().paths:objectAtIndex((self.way-1)),"CCArray")
        for i=0,self.path:count()-1 do
            local curWayPoint = tolua.cast(self.path:objectAtIndex(i), "WayPoint")
            local wp = WayPoint:new(curWayPoint.position,curWayPoint.isFlipX,curWayPoint.direction,curWayPoint.underSea)
            self._waypoints:addObject(wp)
        end
    elseif self.way==9 then
        self.way=13
        self._waypoints:removeAllObjects()
        local paths = GameInstance:sharedInstance().paths
        self.path = tolua.cast(GameInstance:sharedInstance().paths:objectAtIndex((self.way-1)),"CCArray")
        for i=0,self.path:count()-1 do
            local curWayPoint = tolua.cast(self.path:objectAtIndex(i), "WayPoint")
            local wp = WayPoint:new(curWayPoint.position,curWayPoint.isFlipX,curWayPoint.direction,curWayPoint.underSea)
            self._waypoints:addObject(wp)
        end
    elseif self.way==10 then
        self.way=14
        self._waypoints:removeAllObjects()
        local paths = GameInstance:sharedInstance().paths
        self.path = tolua.cast(GameInstance:sharedInstance().paths:objectAtIndex((self.way-1)),"CCArray")
        for i=0,self.path:count()-1 do
            local curWayPoint = tolua.cast(self.path:objectAtIndex(i), "WayPoint")
            local wp = WayPoint:new(curWayPoint.position,curWayPoint.isFlipX,curWayPoint.direction,curWayPoint.underSea)
            self._waypoints:addObject(wp)
        end
    elseif self.way==11 then
        self.way=15
        self._waypoints:removeAllObjects()
        local paths = GameInstance:sharedInstance().paths
        self.path = tolua.cast(GameInstance:sharedInstance().paths:objectAtIndex((self.way-1)),"CCArray")
        for i=0,self.path:count()-1 do
            local curWayPoint = tolua.cast(self.path:objectAtIndex(i), "WayPoint")
            local wp = WayPoint:new(curWayPoint.position,curWayPoint.isFlipX,curWayPoint.direction,curWayPoint.underSea)
            self._waypoints:addObject(wp)
        end
    end
    self.curWaypoint = 0
end

function MonsterRunCycleWay:isBigBoss()
   return false
end


return MonsterRunCycleWay