local MathUtil = require("app.common.MathUtil")
local Attacker = require("app.actor.Attacker")
local AnimationFactory = require("app.factory.AnimationFactory")
local scheduler = require("framework.scheduler")
local WhiteMonster = class("WhiteMonster",Attacker)

function WhiteMonster:ctor(attackerProperties,parent,path,whichDegree)
    WhiteMonster.super.ctor(self,attackerProperties,parent,path)
    self.mainSprite:setShaderProgram(CCShaderCache:sharedShaderCache():programForKey("white"))--红色怪物

    self.path = path

    if whichDegree==1 then
    	self.initTime = 5
	    local size = self.mainSprite:getCascadeBoundingBox().size
	    self.clock = display.newSprite("ui/beauty/beauty_icon_time.png",0,size.height):addTo(self)
	    self.clock:setScale(0.6)
	    self.timeLabel = ui.newTTFLabel({
		    text = self.initTime,
		    font = "Arial",
		    size = 18,
		    color = ccc3(255,0,0),
		    x = 18,
		    y = 15,
			align =	ui.TEXT_VALIGN_CENTER
		}):addTo(self.clock)


	    --self:schedule(handler(self,self.logic),1)

	    local logic = function()
	    	self.initTime = self.initTime -1
			self.timeLabel:setString(self.initTime)
			if self.initTime==0 then
				self.initTime = 6
				self:oneToTwo()
			end
		end

		self.logicHandler = scheduler.scheduleGlobal(logic,1)

    end

    

end

function  WhiteMonster:logic()
	self.initTime = self.initTime -1
	self.timeLabel:setString(self.initTime)
	if self.initTime==0 then
		self.initTime = 6
		self:oneToTwo()
	end
end

function  WhiteMonster:oneToTwo()
	CommUtil.playSound("music/beep.mp3")
	local action = transition.sequence({
		CCShake:createWithStrength(0.2,3,3),
		CCShake:createWithStrength(0.2,3,3),
        CCCallFunc:create(function()
            local child = require("app.actor.WhiteMonster").new(self.attackerProperties,self.gameScene,self.path,2)
			self.gameScene:addChild(child)
			GameInstance:sharedInstance().monsters:addObject(child)
			child.attackerProperties.hp = self.attackerProperties.fullHp/4
			child.attackerProperties.fullHp = self.attackerProperties.fullHp/4
			child.curWaypoint = self.curWaypoint
			child:setPosition(self:getPositionX()-10,self:getPositionY()+5)
			child:walk()
        end),
    })
    self.clock:runAction(action)
end

function  WhiteMonster:cancelLogic()
	if self.logicHandler then scheduler.unscheduleGlobal(self.logicHandler) self.logicHandler=nil end
end


function  WhiteMonster:runDeadAnimation()
	self:cancelLogic()
	self.gameScene:doWhiteMonsterDeadLogic(self.attackerProperties.index)
    WhiteMonster.super.runDeadAnimation(self)
end

function  WhiteMonster:isWhite()
	--print("我是白色小怪物")
	return true
end

return WhiteMonster