local MonsterRunCycleWay = require("app.actor.MonsterRunCycleWay")
local AnimationFactory = require("app.factory.AnimationFactory")

local WorldMiniBoss = class("WorldMiniBoss",MonsterRunCycleWay)

function WorldMiniBoss:ctor(attackerProperties,parent,path)
    WorldMiniBoss.super.ctor(self,attackerProperties,parent,path)
end

function WorldMiniBoss:doWalkAnimation(direction)
    self.mainSprite:stopAllActions()
    local animation = AnimationFactory.getBossAnimation(direction,self.attackerProperties.body_id,self.attackerProperties.walk_animation_time)
    if animation~=nil then 
        transition.execute(self.mainSprite, CCAnimate:create(animation), {
            onComplete = function()
                local wayPointCount = self._waypoints:count()
                local waypoint = tolua.cast(self._waypoints:objectAtIndex((self.curWaypoint+1>wayPointCount-1) and (wayPointCount-1) or (self.curWaypoint+1) ),"WayPoint")
                self:doWalkAnimation(waypoint.direction)
            end,
        })
    end
end

function WorldMiniBoss:doStandAnimation()
    self.mainSprite:stopAllActions()
    local animation = AnimationFactory.getBossStandAnimation(false,self.attackerProperties.body_id)
    if animation~=nil then 
        transition.execute(self.mainSprite, CCAnimate:create(animation), {
            onComplete = function()
                self:doStandAnimation()
            end,
        })
    end
end

return WorldMiniBoss