require ("config")
local scheduler = require(cc.PACKAGE_NAME .. ".scheduler")
local Text = require("app.ui.Text")
local Buff = require("app.actor.Buff")
local beauty_skill_list = require("app.client.desc.beauty_skill")
local DebugUtil = require("app.common.DebugUtil")


local BlockRoadSkill = class("BlockRoadSkill",function(parent,skill_id,releasePoint)
	local node = display.newNode()
	return node
end)

function BlockRoadSkill:ctor(parent,skill_id,releasePoint)

	self.damageMonsters = {}
	self.buffMonsters = {}

	self.mutipleDamage = false

	self.skill_id = skill_id
	self.releasePoint = releasePoint
	self.index = index

	self.beautySkillRigion = require("app.region.BeautySkill"..self.skill_id.."Rigion")

	self.frameIndex = 0
	self.frameNum = self:getFrameNum(index)
	self.removeTag = false

	
	self.skillProperties = beauty_skill_list[skill_id..""]
    if self.skillProperties == nil then return end

    self.totem = self.skillProperties.totem
    self.hp = self.totem.totem_hp

    local frames = display.newFrames("channel_41009_%02d.png", 1, 10)
	local animation = display.newAnimation(frames, 1 / 10)
    self.skillSprite = display.newSprite(frames[1],releasePoint.x,releasePoint.y+40):addTo(self)

	self:resetCheckHitSchedule(0.05,1)
	transition.execute(self.skillSprite,CCAnimate:create(animation),{
	onComplete = function()
		local frames = display.newFrames("channel_41009_%02d.png", 1, 10)
		local animation = display.newAnimation(frames, 1 / 10)
		self:resetCheckHitSchedule(0.05,1)
		transition.execute(self.skillSprite,CCAnimate:create(animation),{
		onComplete = function()
			local frames = display.newFrames("channel_41009_%02d.png", 1, 10)
			local animation = display.newAnimation(frames, 1 / 10)
			self:resetCheckHitSchedule(0.05,1)
			transition.execute(self.skillSprite,CCAnimate:create(animation),{
			onComplete = function()
				self:clean()
			end
			})
		end
		})
	end
	})

	CommUtil.playSound("music/soundeffect/"..self.skillProperties.sound..".mp3")
	
end

function BlockRoadSkill:getFrameNum()
	return 10
end

function BlockRoadSkill:ifAddBuff(monster)
	for i=1,#self.buffMonsters do
		local curMonster = self.buffMonsters[i]
		if curMonster==monster then
			return true
		end
	end
	return false
end

function BlockRoadSkill:ifHasDamaged(monster)
	if self.mutipleDamage then return false end
	for i=1,#self.damageMonsters do
		local curMonster = self.damageMonsters[i]
		if curMonster==monster then
			return true
		end
	end
	return false
end

function BlockRoadSkill:checkHit()
	if self.frameIndex==nil or self.frameStep==nil then return end
	self.frameIndex = self.frameIndex + self.frameStep
	if self.frameIndex>self.frameNum then
		self.frameIndex = self.frameNum
	end
	local curRigion = self.beautySkillRigion["skill"..self.skill_id.."_"..self.frameIndex.."_"]
	if curRigion==nil then
		return
	end
	for i = 0, GameInstance:sharedInstance().monsters:count()-1 do
		local monster = GameInstance:sharedInstance().monsters:objectAtIndex(i)
		
		if not self:ifAddBuff(monster) then
			--self:doBuffEffect(monster,curRigion)
			self:doBlockForMonster(monster,curRigion)
		else
			--print("已经给加了buff了")
		end
	end
end

function BlockRoadSkill:ifInBlockMonsters(monster)
	for i=1,#self.monsters do
		local curMonster = self.monsters[i]
		if curMonster==monster then
			return true
		end
	end
end

function BlockRoadSkill:doBlockForMonster(monster,curRigion)
	local centerX,centerY,textTureSize = nil
	if monster:isBigBoss() then
		centerX,centerY,textTureSize = monster:getTextureCenterPoint(monster:getPositionX(),monster:getPositionY())
	else
		centerX,centerY,textTureSize = monster:getTextureCenterPointInWorld(monster:getPositionX(),monster:getPositionY())
	end
	for i=1,#curRigion do
        local circle = curRigion[i]
        local worldPoint = self.skillSprite:convertToWorldSpace(ccp(circle[1],circle[2]))
        local distance = ccpDistance(ccp(centerX,centerY),worldPoint)
        local edge = nil
        if monster:isBigBoss() then
        	edge = (40+circle[3]*self.skillSprite:getScale())
        else
        	edge = (30+circle[3]*self.skillSprite:getScale())
        end
        if distance<(edge) then
           		--monster:decreaseHpBySkill(decreaseHp)
           		self.buffMonsters[#self.buffMonsters+1] = monster
           		monster:pause(false)
           		--self.hp = self.hp - 1
           		--monster:stopMove(-0.99)
            return
        end
    end
end

function BlockRoadSkill:resetCheckHitSchedule(cycleTime,totalTime)
	if self.handle~=nil then
		scheduler.unscheduleGlobal(self.handle)
		self.handle = nil
	end
	if totalTime==nil then return end
	self.checkEachTime = cycleTime
	self.totalTime = totalTime
	self.frameStep = math.ceil(cycleTime/totalTime * self.frameNum)
	self.frameIndex = 0
	self:checkHit()
	self.handle = scheduler.scheduleGlobal(handler(self, self.checkHit), self.checkEachTime)
end

--清除自己
function BlockRoadSkill:clean()
	self.removeTag = true
	if self.handle~=nil then
		scheduler.unscheduleGlobal(self.handle)
		self.handle = nil
	end
	for i = 0, GameInstance:sharedInstance().towers:count()-1 do
		local tower = GameInstance:sharedInstance().towers:objectAtIndex(i)
		tower:removeBuffID(self.skill_id)
	end
	for i = 0, GameInstance:sharedInstance().monsters:count()-1 do
		local monster = GameInstance:sharedInstance().monsters:objectAtIndex(i)
		monster:removeBuffID(self.skill_id)
	end
	
	for i = 1, #self.buffMonsters do
		local monster = self.buffMonsters[i]
		if monster~=nil and (not tolua.isnull(monster)) then
			if pauseStatus then
				monster:pause(true)
			else
				monster:resume()
			end
		end
	end
	self:removeFromParentAndCleanup(true)
end


return BlockRoadSkill