local MathUtil = require("app.common.MathUtil")

local HunterBullet = class("HunterBullet", function(sourcePoint,target,if_crit)
    local sprite = display.newSprite("#hunter_attack_1.png",sourcePoint.x,sourcePoint.y)
    --local sprite = display.newSprite("bullet_42003_13.png",sourcePoint.x,sourcePoint.y)
    --sprite:setScale(0.2)
    return sprite
end)

function HunterBullet:ctor(sourcePoint,target,if_crit)

    self.target = target

    self.if_crit = if_crit
    
    self.startX = sourcePoint.x
    self.startY = sourcePoint.y
    
    local centerX,centerY,textTureSize = target:getCenterPointInWorld(target:getPredictPosition().x,target:getPredictPosition().y)
    self.endX = centerX
    self.endY = centerY
    self.targetTextureSize = textTureSize
    
    --print("self.endX",self.endX,self.endY)

    CommUtil.playSound("music/attack_hunter.mp3")
    
    self.xSpeed = 0
    self.ySpeed = 0
    self.t0 = 0
    self.t1 = 25
    self.g = -0.8
    
    self.needRemove = false

    self.xSpeed = ((self.endX - sourcePoint.x) / self.t1)
    self.ySpeed = ( (((self.endY - sourcePoint.y) - ((self.g * self.t1) * (self.t1 / 2))) / self.t1) )

    self:schedule(handler(self, self.update),1/30)--定时更新子弹位置

end

function HunterBullet:update()
    if tolua.isnull(self) then
        return
    end
    if self.needRemove then
        return
    end
    self:setPositionAndAngle()
end


function HunterBullet:decreaseTargetHp()
    self.needRemove = true
    if tolua.isnull(self.target) then
    --if true then
        --print("怪物已经死了")
        transition.fadeTo(self, {opacity = 0, time = 1,onComplete = function()
            self:removeFromParentAndCleanup(true)
        end
        })
    else
        --[[self:setRotation(180)
        transition.fadeTo(self, {opacity = 0, time = 1,onComplete = function()
            self:removeFromParentAndCleanup(true)
        end
        })]]
       self.target:decreaseHp("hunter",self.damage,self.if_crit)
       self:removeFromParentAndCleanup(true)
       --CommUtil.playSound("music/die1.mp3")
    end
end

function HunterBullet:setPositionAndAngle()
    if self.needRemove then return end
    self.t0 = self.t0 + 2
    local x = (self.startX + (self.t0 * self.xSpeed))
    local y = ((self.startY + (self.t0 * self.ySpeed)) + (((self.g * self.t0) * self.t0) / 2))

    self:setPosition(CCPoint(x,y))--更新弓箭位置
    --碰撞检测
    --[[
    local dist = ccpDistance(ccp(self.endX,self.endY),ccp(self:getPositionX(),self:getPositionY()))
    if dist < 30 then
        self:decreaseTargetHp()
        return
    end]]
    
    --[[]]
    local BulletRigion = require("app.region.BulletRigion")
    local curRigion = BulletRigion["hunter_attack_1_"]
    for i=1,#curRigion do
        local circle = curRigion[i]
        local worldPoint = self:convertToWorldSpace(ccp(circle[1],circle[2]))
        --print(circle[1],circle[2],worldPoint.x,worldPoint.y)
        local distance = ccpDistance(ccp(self.endX,self.endY),worldPoint)
        local edge = 10+circle[3]
        if distance<edge then
            --print("你被击中了")
            self:decreaseTargetHp()
            --self:removeFromParentAndCleanup(true)
            return
        end
    end
    --------------------------------------------------------------------------------------------------

    self.t0 = self.t0 + 2

    local Sx = (self.startX + (self.t0 * self.xSpeed))
    local Sy = ((self.startY + (self.t0 * self.ySpeed)) + (((self.g * self.t0) * self.t0) / 2))

    self.t0 = self.t0 -2

    local dx = Sx - x
    local dy = Sy - y
    local angel = math.atan2(dy,dx)
    local rotation = -angel * 57.29577951 + 180 --更新弓箭角度

    self:setRotation(rotation)

end

return HunterBullet
