local MathUtil = require("app.common.MathUtil")

local SkillArrow = class("SkillArrow", function(sourcePoint,target,targetXOffset,targetYOffset,if_crit)
    --[[
    local sprite = display.newSprite("#channel_42004_01.png",sourcePoint.x,sourcePoint.y)
    sprite:setAnchorPoint(ccp(1,0))
    sprite:setScaleX(0.3)
    sprite:setScaleY(0.5)]]
    --local sprite = display.newSprite("hunter_attack_1.png",sourcePoint.x,sourcePoint.y)
    --sprite:setScaleX(0.7)
    local sprite = display.newSprite("#channel_42004_01.png",sourcePoint.x,sourcePoint.y)
    sprite:setScaleX(0.8)
    return sprite
end)

function SkillArrow:ctor(sourcePoint,target,targetXOffset,targetYOffset,if_crit)

    self.target = target

    self.if_crit = if_crit
    
    self.startX = sourcePoint.x
    self.startY = sourcePoint.y
    
    local centerX,centerY,textTureSize = target:getTextureCenterPointInWorld(target:getPredictPosition().x,target:getPredictPosition().y)
    self.endX = centerX + targetXOffset
    self.endY = centerY + targetYOffset
    self.targetTextureSize = textTureSize
    
    self.xSpeed = 0
    self.ySpeed = 0
    self.t0 = 0
    --self.t1 = 20+CPlusMathUtil:getRandomNum(5)
    self.t1 = 25
    self.g = -0.8
    
    self.needRemove = false

    self.xSpeed = (self.endX - sourcePoint.x) / self.t1
    self.ySpeed = (((self.endY - sourcePoint.y) - ((self.g * self.t1) * (self.t1 / 2))) / self.t1)

    self:schedule(handler(self, self.update),1/30)--定时更新子弹位置

end

function SkillArrow:update()
    if tolua.isnull(self) then
        return
    end
    if self.needRemove then
        return
    end
    self:setPositionAndAngle()
end


function SkillArrow:decreaseTargetHp()
    self.needRemove = true
    if tolua.isnull(self.target) then
        --print("怪物已经死了")
        transition.fadeTo(self, {opacity = 0, time = 0.3,onComplete = function()
            self:removeFromParentAndCleanup(true)
        end
        })
    else
       self:removeFromParentAndCleanup(true)
       self.target:decreaseHpBySkill(self.damage,self.if_crit)
       --CommUtil.playSound("music/die1.mp3")
    end
end

function SkillArrow:setPositionAndAngle()

    self.t0 = self.t0 + 2
    local x = (self.startX + (self.t0 * self.xSpeed))
    local y = ((self.startY + (self.t0 * self.ySpeed)) + (((self.g * self.t0) * self.t0) / 2))
    
    self:setPosition(CCPoint(x,y))--更新弓箭位置
    local zorder = GameInstance:sharedInstance():zorderForPosition(ccp(self:getPositionX(),self:getPositionY()))
    self:getParent():reorderChild(self,zorder)

    --碰撞检测
    local BulletRigion = require("app.region.BulletRigion")
    local curRigion = BulletRigion["skill_arrow"]
    for i=1,#curRigion do
        local circle = curRigion[i]
        local worldPoint = self:convertToWorldSpace(ccp(circle[1],circle[2]))
        --print(circle[1],circle[2],worldPoint.x,worldPoint.y)
        local distance = ccpDistance(ccp(self.endX,self.endY),worldPoint)
        if distance<(circle[3]*0.8) then
            --print("你被击中了")
            self:decreaseTargetHp()
            self:removeFromParentAndCleanup(true)
            return
        end
    end
    --------------------------------------------------------------------------------------------------

    self.t0 = self.t0 + 2

    local Sx = (self.startX + (self.t0 * self.xSpeed))
    local Sy = ((self.startY + (self.t0 * self.ySpeed)) + (((self.g * self.t0) * self.t0) / 2))

    self.t0 = self.t0 -2

    local dx = Sx - x
    local dy = Sy - y
    local angel = math.atan2(dy,dx)
    local rotation = -angel * 57.29577951 + 180 --更新弓箭角度

    self:setRotation(rotation)

end

return SkillArrow
