local MathUtil = require("app.common.MathUtil")
local AnimationFactory = require("app.factory.AnimationFactory")

local WarriorBullet = class("WarriorBullet", function(sourcePoint,target,if_crit,bulletIndex,sountdIndex)
    local sprite = display.newSprite(string.format("ui/fighting/fighting_attack_%d.png",bulletIndex),sourcePoint.x,sourcePoint.y)
    sprite:setScale(1.2)
    --local sprite = display.newSprite("#wizard_bullet_1.png",sourcePoint.x,sourcePoint.y)
    return sprite
end)

function WarriorBullet:ctor(sourcePoint,target,if_crit,bulletIndex,sountdIndex)
    
    self.target = target

    self.if_crit = if_crit

    local centerX,centerY,textTureSize = target:getCenterPointInWorld(target:getPredictPosition().x,target:getPredictPosition().y)
    self.endX = centerX
    self.endY = centerY
    self.targetTextureSize = textTureSize

    
    if sountdIndex==1 then
        CommUtil.playSound("music/attack_warrior.mp3")
    elseif sountdIndex==2 then
        CommUtil.playSound("music/attack_hunter.mp3")
    elseif sountdIndex==3 then
        CommUtil.playSound("music/attack_mage.mp3")
    end

    local destPos = ccp(self.endX,self.endY)

    local diffPos = ccpSub(destPos,sourcePoint)
    local dist = ccpDistance(destPos,sourcePoint)
    local bulletVelocity = 350

    self.needRemove = false

    local shootVector = ccpSub(destPos,sourcePoint)
    local shootAngle = -1*ccpToAngle(shootVector)*57.29577951
    self:setRotation(shootAngle)

    --local frames = display.newFrames("wizard_bullet_%d.png", 1, 8)
    --local animation = display.newAnimation(frames, 0.2 / 8)
    --self:playAnimationForever(animation)
    
    local flyTime = dist/bulletVelocity


    local actionMove = CCMoveBy:create(flyTime,diffPos)
    transition.execute(self,actionMove,{
        easing = "elastic",
        onComplete = function()
            self:decreaseTargetHp()
            self:removeFromParentAndCleanup(true)
        end,
    })

    transition.fadeIn(self,{opacity = 255,time = 0.1})

end

function WarriorBullet:decreaseTargetHp()
    self.needRemove = true
    if tolua.isnull(self.target) then
        transition.fadeTo(self, {opacity = 0, time = 0.3,onComplete = function()
            self:removeFromParentAndCleanup(true)
        end
        })
    else
        self.target:subHp(self.beHitType,self.damage,self.if_crit)
    end
end

return WarriorBullet
