local Attributes = {}
--local param_tmpl = import("app.client.template.parameter_template")
local hero_skill_list = import("app.client.desc.hero_skill")
local beauty_skill_list = import("app.client.desc.beauty_skill")
--[[local hero_skill_list2 = import("app.client.desc.hero_skill2")
local beauty_skill_list2 = import("app.client.desc.beauty_skill2")
local hero_skill_list3 = import("app.client.desc.hero_skill3")
local beauty_skill_list3 = import("app.client.desc.beauty_skill3")
local hero_skill_list4 = import("app.client.desc.hero_skill4")
local beauty_skill_list4 = import("app.client.desc.beauty_skill4")]]

--[[
一级属性 primary attributes
attack_power 		--攻击力
health_point 		--生命值
armor 				--护甲值
resist 				--抗性值
agility				--敏捷值
crit				--暴击值
accuracy			--精准值
lucky				--幸运值
toughness			--韧性值
willpower			--元神值

二级属性 secondary attributes
attack_power		--攻击力
health_point		--生命值
attack_speed		--攻击速度
crit_proc			--暴击率
crit_mul			--暴击伤害倍数
hit_proc			--命中率
sunder				--破甲率
skill_proc			--技能触发几率
damage_lower_proc	--伤害下限加成
necrit_proc			--免暴击率
necrit_mul			--免暴击伤害倍数
redamage_proc       --反伤几率
redebuff_proc       --反射几率
damage_rate         --PVP伤害转换比
]]

function Attributes.base_speed( class )
--[[ 返回标准攻速
attack_speed_warrior	--狂战标准攻击速度
attack_speed_hunter 	--神射标准攻击速度
attack_speed_wizard 	--方士标准攻击速度
attack_speed_mage   	--法师标准攻击速度
]]
	assert(class > 0 and class < 5, "class [" .. class .."] must between 1 and 4")
	if class == 1 then
		return param_tmpl.attack_speed_warrior
	elseif class == 2 then
		return param_tmpl.attack_speed_hunter
	elseif class == 3 then
		return param_tmpl.attack_speed_wizard
	else
		return param_tmpl.attack_speed_mage
	end
end

function Attributes.get_real_beauty_skill( skill_id, skill_lvl )
--[[ 根据妖姬skill_id返回对应级别的skill数据, 传入skill_lvl则返回该级别的数据
]]
	local skill_id = type(skill_id) ~= "number" and tonum(skill_id) or skill_id

	local switch = {
		[1] = beauty_skill_list[tostring(skill_id)],
	}
	local skill = switch[1]
	if not skill then
		print("[ERROR] Skill Level Error !")
		skill = switch[1]
	end
	return skill
end

function Attributes.get_real_hero_skill( skill_id, skill_lvl )
--[[ 根据仙将skill_id返回对应级别的skill数据, 传入skill_lvl则返回该级别的数据
]]
	local skill_id = type(skill_id) ~= "number" and tonum(skill_id) or skill_id
	local skill_level = 1
	if skill_lvl ~= nil then
		skill_level = skill_lvl
	else
		if skill_id > 45000 then --判断是否PVP技能ID
			skill_level = gSkillLvl:getSkillLvlBySkillId(skill_id-5000)
		else
			skill_level = gSkillLvl:getSkillLvlBySkillId(skill_id)
		end
	end
	local switch = {
		[1] = hero_skill_list[tostring(skill_id)],
		[2] = hero_skill_list2[tostring(skill_id)],
		[3] = hero_skill_list3[tostring(skill_id)],
		[4] = hero_skill_list4[tostring(skill_id)],
	}
	local skill = switch[skill_level]
	if not skill then
		print("[ERROR] Skill Level Error !")
		skill = switch[1]
	end
	return skill
end

function Attributes.buff_filter( buffs, type )
--[[ 筛选BUFF 只保存对应buff的value值
buff效果类型号:
1,DOT;2,免伤;3,移动速度;4,攻击速度;5.生命值上限;
6,攻击力;7,暴击率;8,技能触发几率;9,眩晕;10,变形;
11,击退;12,牵引;13,石化;14,印记传送;15,DOT_HP%
]]
	if buffs == nil or tolua.type(buffs) ~= "CCArray" then return {} end
	local cnt = buffs:count()
	if cnt == 0 then return {} end
	local buffs_ = {}
	for i=0,cnt-1 do
		local object = buffs:objectAtIndex(i)
		if object~=nil and ( not tolua.isnull(object) ) and object:getType() == type then
			table.insert(buffs_, object:getValue())
		end
	end
	return buffs_
end

function Attributes.get_real_primary( primary, passive_skill_id )
--[[ 被动技能的一级属性加成  仅PVP使用
args:
	primary          一级属性
	passive_skill_id 辅助技能ID
]]
	if passive_skill_id > 48008 or passive_skill_id < 48001 then return primary end
	local real_primary = clone(primary)
	local switch = {
		["48001"] = function() real_primary.armor = real_primary.armor * (1 + hero_skill_list["48001"].percent) end,
		["48002"] = function() real_primary.resist = real_primary.resist * (1 + hero_skill_list["48002"].percent) end,
		["48003"] = function() real_primary.health_point = real_primary.health_point * (1 + hero_skill_list["48003"].percent) end,
		["48004"] = function() real_primary.willpower = real_primary.willpower * (1 + hero_skill_list["48004"].percent) end,
		["48005"] = function() real_primary.toughness = real_primary.toughness * (1 + hero_skill_list["48005"].percent) end,
		["48006"] = function() real_primary.attack_power = real_primary.attack_power * (1 + hero_skill_list["48006"].percent) end,
		["48007"] = function() real_primary.crit = real_primary.crit * (1 + hero_skill_list["48007"].percent) end,
		["48008"] = function() real_primary.accuracy = real_primary.accuracy * (1 + hero_skill_list["48008"].percent) end,
	}
	local skill_id = tostring(passive_skill_id)
	switch[skill_id]()
	return real_primary
end

function Attributes.get_real_redamage_percent( redamage_percent, passive_skill_id )
--[[ 被动技能加成 反伤百分比  仅PVP使用
args:
	redamage_percent 反伤百分比
	passive_skill_id 辅助技能ID
]]
	if passive_skill_id ~= 48010 then return redamage_percent end
	return redamage_percent/100 + hero_skill_list["48010"].percent
end

function Attributes.get_real_damage( damage, passive_skill_id, heath_point )
--[[ 被动技能加成 额外伤害  仅PVP使用
args:
	damage           伤害
	passive_skill_id 辅助技能ID
	heath_point      对方生命值
]]
	if passive_skill_id ~= 48009 then return damage end
	return damage + heath_point * hero_skill_list["48009"].percent
end

function Attributes.get_real_heal_hp( damage, passive_skill_id )
--[[ 被动技能加成 吸血攻击  仅PVP使用
args:
	damage           伤害
	passive_skill_id 辅助技能ID
]]
	-- if passive_skill_id ~= 48011 then return 0 end
	return damage * hero_skill_list["48011"].percent
end

--===============================
--			计算二级属性
--===============================
function Attributes.cal_secondary( primary, level, class )
--[[ 统一计算无buff二级属性
args:
	primary		一级属性
	level 		玩家等级
	class 		仙将职业
]]
	assert(type(primary) == "table", "The type of param #1: primary must be table")
	assert(type(level) == "number" and level > 0, "Param #2: level" .. level .. "must be a number and great then 0")
	assert(type(class) == "number" and class > 0 and class < 5, "Param #3: class" .. class .. " must be a number and between 1 and 4")

	local attr = {}

	-- 攻击力
	attr.attack_power = primary.attack_power
	-- 生命值
	attr.health_point = primary.health_point
	-- 暴击率
	attr.crit_proc = primary.crit/(primary.crit + param_tmpl.factor_crit_proc*level + param_tmpl.constant_crit_proc)
	-- 暴击伤害倍数
	attr.crit_mul = primary.crit/(primary.crit + param_tmpl.factor_crit_mul*level + param_tmpl.constant_crit_mul)
	-- 攻击速度
	local base_spd = Attributes.base_speed(class)
	attr.attack_speed = base_spd/(1 + primary.agility/(primary.agility + param_tmpl.constant_attack_speed))
	-- 命中率
	attr.hit_proc = primary.accuracy/(primary.accuracy + param_tmpl.factor_hit_proc*level + param_tmpl.constant_hit_proc)
	-- 伤害下限常数
	attr.damage_lower_proc = primary.lucky/(primary.lucky + param_tmpl.constant_damage_lower_proc)

	-- 破甲率
	attr.sunder = primary.accuracy/(primary.accuracy + param_tmpl.factor_sunder*level + param_tmpl.constant_sunder)
	-- 免暴击率 免暴击伤害倍数
	if primary.toughness then
		attr.necrit_proc = primary.toughness/(primary.toughness + param_tmpl.factor_necrit_proc*level + param_tmpl.constant_necrit_proc)
		attr.necrit_mul = primary.toughness/(primary.toughness + param_tmpl.factor_necrit_mul*level + param_tmpl.constant_necrit_mul)
	else
		attr.necrit_proc = 0
		attr.necrit_mul = 0
	end
	-- 技能触发几率 区间[0.05, 1)
	local skill_proc = primary.lucky/(primary.lucky + param_tmpl.factor_skill_proc*level + param_tmpl.constant_skill_proc)
	attr.skill_proc = skill_proc <= 0.05 and 0.05 or (skill_proc > 1 and 0.99 or skill_proc)
	-- 物理伤害减免 现已删除
	-- attr.indamage_reduce = primary.armor*(1 - attr.sunder) / (primary.armor + param_tmpl.factor_armor*level + param_tmpl.constant_armor)
	-- 法术伤害减免 因数常数同上 现已删除
	-- attr.outdamage_reduce = primary.resist*(1 - attr.sunder) / (primary.resist + param_tmpl.factor_armor*level + param_tmpl.constant_armor)

	-- 反伤几率 反射几率 斗法伤害比率
	if not primary.willpower then
		attr.redamage_proc = 0
		attr.redebuff_proc = 0
		attr.damage_rate = 0.15
	else
		attr.redamage_proc = primary.willpower/(primary.willpower + param_tmpl.factor_redamage_proc*level + param_tmpl.constant_redamage_proc)
		attr.redebuff_proc = primary.willpower/(primary.willpower + param_tmpl.factor_redebuff_proc*level + param_tmpl.constant_redebuff_proc)
		local rate = 0.1 * (primary.willpower / 50)
		attr.damage_rate = rate <= 0.15 and 0.15 or (rate >= 1 and 1 or rate)
	end

	return attr
end

--===============================
--			计算真实属性
-- 注：真实属性为加上Buff的二级属性
--===============================
function Attributes.get_buff_atk_power( atk_power, buffs, skill_id, is_beauty_skill)
--[[ 计算真实攻击力
公式: 攻击力 = 攻击力_character ×（1 + 攻击力加成_beauty）× ∏（1 + 攻击力加成_buff_n）× 技能伤害因数 + 技能伤害常数
	  普通攻击的技能伤害因数=1 技能伤害常数=0
args:
	atk_power 	二级属性攻击力
	skill_id 	技能ID (触发技能则为技能id,否则为nil)
	buffs 		增减益效果
]]
	local buff = Attributes.buff_filter( buffs, 6 )
	local factor_skill = 1
	if skill_id ~= nil then
		if is_beauty_skill then
			local beauty_skill = Attributes.get_real_beauty_skill(skill_id)
			if beauty_skill.damage then
				factor_skill = beauty_skill.damage.damage_coeff
			else
				factor_skill = 0
			end
		else
			local hero_skill = Attributes.get_real_hero_skill(skill_id)
			if hero_skill.damage then
				factor_skill = hero_skill.damage.damage_coeff
			else
				factor_skill = 0
			end
		end
	end
	local power = atk_power * factor_skill
	for _,v in pairs(buff) do
		power = power * (1 + v)
	end
	return power
end

function Attributes.get_buff_hp( hp, buffs )
--[[ 计算真实生命值
公式: 生命值 = 生命值_character ×（1 + 生命值加成_beauty）× ∏（1+生命值加成_buff_n）
args:
	hp 			二级属性生命值
	buffs 		增减益效果
]]
	local buff = Attributes.buff_filter( buffs, 5 )
	local hp_ = hp
	for _,v in pairs(buff) do
		hp_ = hp_ * (1 + v)
	end
	return hp_
end

function Attributes.get_buff_atk_spd( atk_spd, buffs )
--[[ 计算实际攻击速度 【注：最小值0.50】
args:
	atk_spd  	二级属性攻击速度
	buffs 		增减益效果
]]
	local buff = Attributes.buff_filter( buffs, 4 )
	local aspd = atk_spd
	for _,v in pairs(buff) do
		aspd = atk_spd / (1 + v)
	end
	return (aspd < 0.5) and 0.5 or aspd
end

function Attributes.get_buff_crit_proc( crit_proc, buffs )
--[[ 计算真实暴击率
公式: 真实暴击率 = 暴击率_attacker + ∑暴击率加成_buff_n
args:
	crit_proc 	二级属性暴击率
	buffs 		增减益效果
]]
	local buff = Attributes.buff_filter( buffs, 7 )
	local proc = crit_proc
	for _,v in pairs(buff) do
		proc = proc + v
	end
	return proc
end

function Attributes.get_buff_crit_mul( crit_mul, buffs )
--[[ 计算真实暴击伤害倍数 
公式: 真实暴击倍数 = 暴击伤害倍数_character + ∑暴击倍数加成_buff_n
args:
	crit_mul 	二级属性暴击伤害倍数
	buffs 		增减益效果
]]
	-- local buffs = Attributes.buff_filter( buffs, 4 )
	-- local mul = crit_mul
	-- for _,v in pairs(buffs) do
	-- 	mul = mul + v
	-- end
	-- return mul
	return crit_mul
end

function Attributes.get_buff_necrit_proc( necrit_proc, buffs )
--[[ 计算真实免暴击率 
公式: 真实免暴击率 = 二级属性免暴击率
args:
	necrit_proc 二级属性免暴击率
	buffs 		增减益效果
]]
	return necrit_proc
end

function Attributes.get_buff_necrit_mul( necrit_mul, buffs )
--[[ 计算真实免暴击伤害倍数 
公式: 真实免暴击伤害倍数 = 二级属性免暴击伤害倍数
args:
	necrit_mul 	二级属性免暴击伤害倍数
	buffs 		增减益效果
]]
	return necrit_mul
end

function Attributes.get_buff_skill_proc( skill_proc, buffs )
--[[ 计算真实技能触发几率
公式: 真实技能触发几率 = 技能触发几率_attacker + ∑技能触发几率_buff_n
args:
	skill_proc 	二级属性技能触发几率
	buffs 		增减益效果
]]
	local buff = Attributes.buff_filter( buffs, 8 )
	local proc = skill_proc
	for _,v in pairs(buff) do
		proc = proc + v
	end
	return proc
end

function Attributes.get_buff_hit_proc( hit_proc, buffs )
--[[ 计算真实命中率
公式: 真实命中率 = 二级属性命中率
args:
	hit_proc 	二级属性命中率
	buffs 		增减益效果
]]
	return hit_proc
end

function Attributes.get_buff_sunder( sunder, buffs )
--[[ 计算真实破甲率
公式: 真实破甲率 = 二级属性破甲率
args:
	sunder 	二级属性破甲率
	buffs 	增减益效果
]]
	return sunder
end

function Attributes.get_buff_damage_lower_proc( damage_lower_proc, buffs )
--[[ 计算真实伤害下限加成
公式: 真实伤害下限加成 = 二级属性伤害下限加成
args:
	damage_lower_proc 二级属性伤害下限加成
	buffs 		      增减益效果
]]
	return damage_lower_proc
end

function Attributes.get_buff_redamage_proc( redamage_proc, buffs )
--[[ 计算真实反伤几率
公式: 真实反伤几率 = 二级属性反伤几率
args:
	redamage_proc 二级属性反伤几率
	buffs 		  增减益效果
]]
	return redamage_proc
end

function Attributes.get_buff_redebuff_proc( redebuff_proc, buffs )
--[[ 计算真实反射几率
公式: 真实反射几率 = 二级属性反射几率
args:
	redamage_proc 二级属性反射几率
	buffs 		  增减益效果
]]
	return redebuff_proc
end

--===============================
--			计算实际属性
-- 注：PVP或PVE中使用到的实际属性
--===============================
function Attributes.get_atk_power( atk_power, skill_id, atker_buffs, dfcer_buffs )
--[[ 计算实际攻击力
公式: 实际攻击力 = 真实攻击力
args:
	atk_power 	二级属性攻击力
	skill_id 	技能ID (触发技能则为技能id,否则为nil)
	atker_buffs 攻击者所有增减益效果
	dfcer_buffs 防守者所有增减益效果
]]
	return Attributes.get_buff_atk_power(atk_power, atker_buffs, skill_id, false) -- 仙将的 非妖姬
end

function Attributes.get_atk_spd( atk_spd, atker_buffs, dfcer_buffs )
--[[ 计算实际攻速(实际攻速 = 真实攻速)
args:
	atk_spd 	二级属性攻击速度
	atker_buffs 攻击者所有增减益效果
	dfcer_buffs 防守者所有增减益效果
]]
	return Attributes.get_buff_atk_spd(atk_spd, atker_buffs)
end

function Attributes.get_hp( hp, atker_buffs, dfcer_buffs )
--[[ 计算实际攻速(实际攻速 = 真实攻速)
args:
	hp 			二级属性生命值
	atker_buffs 攻击者所有增减益效果
	dfcer_buffs 防守者所有增减益效果
]]
	return Attributes.get_buff_hp(hp, atker_buffs)
end

function Attributes.get_crit_proc( atker_crit_proc, dfcer_necrit_proc, atker_buffs, dfcer_buffs )
--[[ 计算实际暴击率 
公式:实际暴击率 = 真实暴击率_attacker - 真实免暴击率_defencer
args:
	atker_crit_proc 	攻击者二级属性暴击率
	dfcer_necrit_proc	防守者二级属性免暴率
	atker_buffs 		攻击者所有增减益效果
	dfcer_buffs 		防守者所有增减益效果
]]
	local crit_proc = Attributes.get_buff_crit_proc( atker_crit_proc, atker_buffs )
	local necrit_proc = Attributes.get_buff_necrit_proc( dfcer_necrit_proc, dfcer_buffs)
	local proc = crit_proc - necrit_proc
	return proc < 0.1 and 0.1 or (proc > 0.5 and 0.5 or proc)
end

function Attributes.get_crit_mul( atker_crit_mul, dfcer_necrit_mul, atker_buffs, dfcer_buffs )
--[[ 计算实际暴击伤害倍数 
公式:实际暴击伤害倍数 = 2 + 真实暴击伤害倍数_attacker - 真实免暴击伤害倍数_defencer
args:
	atker_crit_mul 		攻击者二级属性暴击伤害倍数
	dfcer_necrit_mul	防守者二级属性免暴击伤害倍数
	atker_buffs 		攻击者所有增减益效果
	dfcer_buffs 		防守者所有增减益效果
]]
	local crit_mul = Attributes.get_buff_crit_mul( atker_crit_mul, atker_buffs )
	local necrit_mul = Attributes.get_buff_necrit_mul( dfcer_necrit_mul, dfcer_buffs )
	return 2 + crit_mul - necrit_mul
end

function Attributes.get_skill_proc( atker_skill_proc, dfcer_skill_proc, atker_buffs, dfcer_buffs )
--[[ 计算实际技能触发几率
公式: 实际技能触发几率 = 真实技能触发几率_attacker * (真实技能触发几率_attacker / (真实技能触发几率_attacker + 真实技能触发几率_defencer))
args:
	atker_skill_proc 	攻击者二级属性技能触发几率
	dfcer_skill_proc 	防守者二级属性技能触发几率
	atker_buffs 		攻击者所有增减益效果
	dfcer_buffs 		防守者所有增减益效果
]]
	local a_skill_proc = Attributes.get_buff_skill_proc( atker_skill_proc, atker_buffs )
	local d_skill_proc = Attributes.get_buff_skill_proc( dfcer_skill_proc, dfcer_buffs )
	if a_skill_proc == 0 or d_skill_proc == 0 then return 0.1 end
	local proc = a_skill_proc * a_skill_proc / (a_skill_proc + d_skill_proc)
	return proc < 0.1 and 0.1 or (proc > 0.5 and 0.5 or proc)
end

function Attributes.get_hit_proc( atker_hit_proc, dfcer_hit_proc, atker_buffs, dfcer_buffs )
--[[ 计算实际命中率
公式: 实际命中率 = 100% + 真实命中率_attacker - 真实命中率_defencer
args:
	atker_hit_proc 攻击者二级属性命中率
	dfcer_hit_proc 防守者二级属性命中率
	atker_buffs    攻击者所有增减益效果
	dfcer_buffs    防守者所有增减益效果
]]
	return 1 + Attributes.get_buff_hit_proc(atker_hit_proc, atker_buffs) - Attributes.get_buff_hit_proc(dfcer_hit_proc, dfcer_buffs)
end

function Attributes.get_redamage_proc( atker_redamage_proc, dfcer_redamage_proc, atker_buffs, dfcer_buffs )
--[[ 计算实际反伤几率
公式: 实际反伤几率 = 真实反伤几率_attacker * (真实反伤几率_attacker / (真实反伤几率_attacker + 真实反伤几率_defencer))
args:
	atker_redamage_proc 攻击者二级属性反伤几率
	dfcer_redamage_proc 防守者二级属性反伤几率
	atker_buffs 		攻击者所有增减益效果
	dfcer_buffs 		防守者所有增减益效果
]]
	local a_redamage_proc = Attributes.get_buff_redamage_proc( atker_redamage_proc, atker_buffs )
	local d_redamage_proc = Attributes.get_buff_redamage_proc( dfcer_redamage_proc, dfcer_buffs )
	if a_redamage_proc == 0 or d_redamage_proc == 0 then return 0.1 end
	local proc = a_redamage_proc * a_redamage_proc / (a_redamage_proc + d_redamage_proc)
	return proc < 0.1 and 0.1 or (proc > 0.5 and 0.5 or proc)
end

function Attributes.get_redebuff_proc( atker_redebuff_proc, dfcer_redebuff_proc, atker_buffs, dfcer_buffs )
--[[ 计算实际反射几率
公式: 实际反射几率 = 真实反射几率_attacker * (真实反射几率_attacker / (真实反射几率_attacker + 真实反射几率_defencer))
args:
	atker_redebuff_proc 攻击者二级属性反射几率
	dfcer_redebuff_proc 防守者二级属性反射几率
	atker_buffs 	    攻击者所有增减益效果
	dfcer_buffs 	    防守者所有增减益效果
]]
	local a_redebuff_proc = Attributes.get_buff_redebuff_proc( atker_redebuff_proc, atker_buffs )
	local d_redebuff_proc = Attributes.get_buff_redebuff_proc( dfcer_redebuff_proc, dfcer_buffs )
	if d_redebuff_proc == 0 or d_redebuff_proc == 0 then return 0.1 end
	local proc = a_redebuff_proc * a_redebuff_proc / (a_redebuff_proc + d_redebuff_proc)
	return proc < 0.1 and 0.1 or (proc > 0.5 and 0.5 or proc)
end

function Attributes.get_damage( args )
--[[ 计算实际伤害
公式: 见excel
args:
	atker_atk_power			攻击者二级属性攻击力
	atker_sunder			攻击者二级属性破甲
	atker_damage_lower_proc 攻击者二级属性伤害下限加成
	atker_crit_mul 			攻击者二级属性暴击伤害倍数
	atker_lvl 				攻击者玩家等级
	atker_class				攻击者职业
	atker_skill_id			攻击者技能(is_beauty_attack为true时,此处为妖姬技能)
	dfcer_armor 			防守者一级属性护甲
	dfcer_resist            防守者一级属性抗性
	dfcer_necrit_mul		防守者二级属性免暴击伤害倍数
	is_crit 				是否暴击
	atker_buffs 			攻击者的增减益效果
	dfcer_buffs 			防守者的增减益效果
	is_beauty_attack 		是否妖姬大招(为妖姬大招时,攻击者为攻击方战力最高的仙将)
]]
	-- 防守者免伤buff table
	local buff = Attributes.buff_filter(args.dfcer_buffs, 2)
	local bf_proc = 0
	for _,v in pairs(buff) do
		bf_proc = bf_proc + v
	end
 
 	local beauty_atk
	if args.is_beauty_attack == nil then -- 兼容之前的接口
		beauty_atk = false
	else
		beauty_atk = args.is_beauty_attack
	end

	local armor_resist
	if beauty_atk then -- 妖姬技能分物理法术伤害
		local damage_type = Attributes.get_real_beauty_skill(args.atker_skill_id).damage.damage_type
		armor_resist = damage_type == 1 and args.dfcer_armor or args.dfcer_resist
	else
		armor_resist = args.atker_class <= 2 and args.dfcer_armor or args.dfcer_resist
	end
	
	local avg = Attributes.get_buff_atk_power(args.atker_atk_power, args.atker_buffs, args.atker_skill_id, beauty_atk) * 
				Attributes.base_speed(args.atker_class) * 
				(1 - 
					(armor_resist * (1 - Attributes.get_buff_sunder(args.atker_sunder, args.atker_buffs))) /
					(armor_resist + args.atker_lvl * param_tmpl.factor_armor + param_tmpl.constant_armor) -
					bf_proc
				)
	local min_proc = 0.8 + Attributes.get_buff_damage_lower_proc(args.atker_damage_lower_proc, args.atker_buffs)
	min_proc = min_proc > 1.2 and 1.2 or min_proc
	local min = avg * min_proc
	local max = avg * 1.2
	local rd = math.random()
	local damage = rd * (max - min) + min
	damage = args.is_crit and (damage * Attributes.get_crit_mul( args.atker_crit_mul, args.dfcer_necrit_mul, args.atker_buffs )) or damage
	return damage
end

return Attributes