--[[
功能：对外提供的接口]]
local BusInterface ={}

--[[
功能：派驻仙将接口
输入parameter为table
parameter={
    heroType = 0,  --英雄类型
    pos_x = 0,     --塔的X坐标
    pos_y = 0,     --塔的Y坐标
    callback=func(para)  --回调函数,para为返回值,根据实际需要更改
        para={
            ret = 0, 返回值
            pos_x=0,
            pox_y=0,
            hero_id=0
        }
}
]]
function BusInterface.ReplaceHero(parameter, node)

    local para = totable(parameter)
    local specHero = gHero:getPlaceTowerHero()

    local successCallBack = function(data)
        para.callback(data)
    end
    local callback1 = function( para )
        if parameter.callback1 then
            parameter.callback1(para)
        end
    end

    local args = {
                    callback = successCallBack,
                    callback1 = callback1,
                    towerPos = ccp(para.pos_x, para.pos_y),
                    position = parameter.position,
                    data = specHero,
                }

    local PlaceHero = require('app.views.secondMenu.friend.PlaceHero').new(args)
    display.getRunningScene():addChild(PlaceHero,1000) 
end


--充值成功或失败状态弹出框
--[[para = {
    content,
}]]
function BusInterface.rechargeWin(para)
    local MallRechargeWinS = require("app.views.secondMenu.mall.MallRechargeWinS").new(para)
    display:getRunningScene():addChild(MallRechargeWinS, SECOND_MENU_Z_ORDER)
end


return BusInterface