--[[
android, ios平台差异性导致的特殊处理]]

local DeviceUtil = {}

--取得设备唯一码
function DeviceUtil.getUUID()
  if (device.platform == 'android') then
    --[[ yangdx modify  源码没有 
      local javaClassName = "org.cocos2dx.lib.Function"
      local javaMethodName = "getUUID"
      local javaParams = {}
      local javaMethodSig = "()Ljava/lang/String;"
      local ok, ret = luaj.callStaticMethod(javaClassName,javaMethodName,javaParams,javaMethodSig)
      if ok then 
        -- print('调用取得UUID正常 ret=',ret)
        return ret 
      end
    --]]
    return ''
  end
end

--yangdx modify  payflag 0:标准 1：退出 2：抽奖 3：战斗  
-- 14212 一键顶 14207 复活 14208 唐僧 
function DeviceUtil.xiYouPay(payCode1,payCode2, payCode3, payCode4, callback,payflag) 
    payflag=payflag or 0  --yangdx  add

    if (DEF_SPECIAL_PAY_PROCESS ) then   --yangdxtest  DEF_SPECIAL_PAY_PROCESS
        local pnglist ={"14211", "14214", "14215", "14217", "14219","14218","14220","14221","14222","14210","14109","14110","14111"}
        local found = false
        for i,v in pairs(pnglist) do
            if (v == payCode4) then
                found = true
            end
        end
        if (found) then --yangdx modify礼包类计费点
                require("app.views.UnlinePayPanel").new(payCode4,payCode2,callback,payflag)     
                :addTo(CURSCENE,1000002)  --yangdx修改
            -- end 
        else  ---yangdx 非礼包类（如砖石 升级、复活） 没有礼包界面
            DeviceUtil.xiYouPay2(-98, payCode4, payCode2, callback)
        end   
    else 
        DeviceUtil.xiYouPay2(payCode1, payCode2, payCode3, callback)
    end
end


function DeviceUtil.xiYouPay2(payCode1, payCode2, payCode3, callback)
    if  (device.platform ~= 'android') then
        callback('success')
        return
    end
    --
    if (not XIYOUPAY) then
        callback('success')
        return
    end

    local function xiYouCall( call_result )
        local jtable =  json.decode(call_result)
        if type(jtable) == "table" then
            -- if jtable.result == "success" then
            --     CommUtil.sendDataToServ({req_type="pay", money=jtable.price })
            -- end
            callback( jtable.result )
        else
            callback('fail')
        end
        audio.resumeMusic()
    end
    if  (device.platform == 'android') then
        audio.pauseMusic()

        if (payCode1=='-98') then
           DEF_CURPAYCODE=payCode3
        else
           DEF_CURPAYCODE=payCode2
        end 
        
        local javaClassName = "org.cocos2dx.lib.Function"
        local javaMethodName = "xiYouPayMM"
        local javaParams = {payCode1, payCode2, payCode3,'0',xiYouCall}
        local javaMethodSig = "(Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;I)V"
        local ok, ret = luaj.callStaticMethod(javaClassName, javaMethodName, javaParams, javaMethodSig)
        if not ok then
            print('luaj err ret= ', ret)
            callback('fail')
            print("mobi2us fail2")
            audio.resumeMusic()
        end
    else
        if (XIYOUPAY) then
            callback('fail')
            print("mobi2us fail1")
        else
            callback('success')
        end
    end
end

function DeviceUtil.showJiFen() 
     if  (device.platform == 'android') then
        local javaClassName = "org.cocos2dx.lib.Function"
        local javaMethodName = "showOffers"
        local javaParams = {}
        local javaMethodSig = "()V"
        local ok, ret = luaj.callStaticMethod(javaClassName, javaMethodName, javaParams, javaMethodSig)
        if not ok then
            print('luaj err ret= ', ret)
        end
    end
end
function DeviceUtil.getTotalJifen(callback) 
    --
     if  (device.platform == 'android') then
        local callbackI = function(str)
            print('mobi2us getTotalJifen= ', str)
            gPlayer.data.ingot_cnt:set(tonumber(str))
            print('mobi2us getTotalJifen1= ', str)
            callback(1)
            print('mobi2us getTotalJifen2= ', str)
        end  
        local javaClassName = "org.cocos2dx.lib.Function"
        local javaMethodName = "getTotalJifen"
        local javaParams = {}
        local javaMethodSig = "()V"
        local ok, ret = luaj.callStaticMethod("org/cocos2dx/lib/Function", javaMethodName, {callbackI},"(I)V")
        if not ok then
            print('mobi2us err ret= ', ret)
        end
    else
        gPlayer.data.ingot_cnt:set(10)
        callback(10)

    end
    --
end

function DeviceUtil.spendMoney(callback) 
    --
     if  (device.platform == 'android') then
      
        local javaClassName = "org.cocos2dx.lib.Function"
        local javaMethodName = "spendMoney"
        local javaParams = {}
        local ok, ret = luaj.callStaticMethod("org/cocos2dx/lib/Function", javaMethodName, {callback},"(I;I)V")
        if not ok then
            print('luaj err ret= ', ret)
        end
    else
        callback("ok")
    end
    --
end


--退出应用,有提示框
function DeviceUtil.ExitApp(node) 
    local func = function()
        audio.stopMusic(true)
        CCTextureCache:sharedTextureCache():removeAllTextures()
        app.exit()
    end
    local windows = require("app.views.ExitWindow").new({
             onConfirm = func,
             onCancel = function() return end
         })
    :addTo(node, GUIDE_PAGE_Z_ORDER)
    return windows
end
--[[
    -1 : 无网络 
    0：WIFI
    1：GPRS
    2：3G
    以回调方式传递
]]
function DeviceUtil.getNetWorkStatus(callback)
    if  (device.platform == 'android') then
        local ok, ret = luaj.callStaticMethod("org/cocos2dx/lib/Function", "getNetwork",{callback},"(I)V")
         if not ok then
                print("luaj error: ", ret)
               return callback("0")
        end
    elseif device.platform=="ios" or device.platform=="mac" then
        if network.isInternetConnectionAvailable() then
            return callback("0")
        else
            return callback("-1")
        end
    else
        return callback("0")
    end
end
--获得机器唯一码
--使用方法：
--[[
local func = function(str)
    --str为获得的唯一码
end
DeviceUtil.getUniqueCode(func)

]]
function DeviceUtil.getUniqueCode(callback)
    local unique_code = LocalDataUtil.getUniqueCodeMobile() 
    --找不到唯一码
    if unique_code == 0 then
        if  (device.platform == 'android') then
            local callbackI = function(str)
                local unique = str ..  os.time()
                LocalDataUtil.writeUniqueCodeMobile(unique)
                callback(unique)
            end  --模拟器直接用时间
            local unique_id = os.time()
    --
            if  (device.platform == 'android') then
                local ok, ret = luaj.callStaticMethod("org/cocos2dx/lib/Function", "getDeviceId",{callbackI},"(I)V")
                if not ok then
                print("luaj error: ", ret)
               return callback(unique_id)
                end
            else
                LocalDataUtil.writeUniqueCodeMobile(unique_id)
                callback(unique_id)
            end
        else
            --模拟器, ios
            local unique_id = os.time()
            LocalDataUtil.writeUniqueCodeMobile(unique_id)
            callback(unique_id)
        end
    else
        callback(unique_code)
    end
end

function DeviceUtil.LoginAccount(request)
    local loginStr ="loginBaidu"
    for k, v in ipairs(gAppVersion.platform_list) do
        if (v[1] == gAppVersion.current_app_operator) then
            loginStr = v[2]
        end
    end

    local args = {request.rmb, request.ingot, request.orderCallback}
    local sig = "(III)V"
    if  (device.platform == 'android') then
        local ok, ret = luaj.callStaticMethod("org/cocos2dx/lib/Function", loginStr, args, sig)
        if not ok then
            return request.orderCallback("error")
        end
    end
end


function DeviceUtil.Pay(request)
    local payStr ="pay"
    --传出参数顺序：1.角色 2.分服名称 3.角色id 4.角色等级 5.分区id 6.元宝数量
    --7.vip等级 8.充值rmb数量 9.充值获取的元宝数 10.回调接口
    local args = {gPlayer.data.name, gPlayer:getRealmName(), gPlayer.data.player_id, gPlayer.data.ingot_cnt:get(), 
    gPlayer.data.account_id, gPlayer.data.realm_id, gPlayer.data.level:get(), gPlayer.data.vip_level:get(), request.rmb, request.ingot, 
    request.real_ingot, request.payCallback}
    local sig = "(Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;IIIIIII)V"
    if  (device.platform == 'android') then
        local ok, ret = luaj.callStaticMethod("org/cocos2dx/lib/Function", payStr, args, sig)
        if not ok then
            
            return request.payCallback("error")
        end
    end
end


function DeviceUtil.getServiceProvider()
    print("RELEASE_PLATFORM=getServiceProvider1")
    if  (device.platform == 'android') then
        print("RELEASE_PLATFORM=getServiceProvider2")
        local javaClassName = "org.cocos2dx.lib.Function"
        local javaMethodName = "getBillModeStr"
        local javaParams = {}
        local javaMethodSig = "()Ljava/lang/String;"
        print("RELEASE_PLATFORM=getServiceProvider2")
        local ok, ret = luaj.callStaticMethod(javaClassName, javaMethodName, javaParams, javaMethodSig)
        print("RELEASE_PLATFORM=getServiceProvider4")
        if ok then
            print("RELEASE_PLATFORM=getServiceProviderret=", ret)
            if (ret == "0") then
                NETTYPE = 'ChinaMobile'
            elseif (ret == "1") then
                NETTYPE = 'ChinaUnicom'
            elseif (ret == "2") then
                NETTYPE = 'ChinaTelecom'
            else
                NETTYPE = 'ChinaMobile'
            end
            print("RELEASE_PLATFORM=getServiceProviderNETTYPE=", NETTYPE)
        else
            print("RELEASE_PLATFORM=getServiceProvider3err")
            NETTYPE = 'ChinaMobile'
        end
        -- print(ok,NETTYPE)
    else
        NETTYPE = 'ChinaMobile'
    end
    print('RecordItem para NETTYPE=', NETTYPE)
end

--电信更多游戏
function DeviceUtil.moreGame()
    if  (device.platform == 'android') then
        local javaClassName = "org.cocos2dx.lib.Function"
        local javaMethodName = "moreGame"
        local javaParams = {}
        local javaMethodSig = "()V"
        local ok, ret = luaj.callStaticMethod(javaClassName, javaMethodName, javaParams, javaMethodSig)
        if not ok then
            print("luaj error ret=", ret)
        end
    end
end



return DeviceUtil