require "lfs"


--function io.writefile(path, content, mode)
--function io.readfile(path)

local FileUtil = {}
--[[
exp: 
local currentFolder = "xxx"
local input_table = 
findindir(currentFolder, "%.cpp", input_table, true)
]]
function FileUtil.findindir (path, wefind, r_table, intofolder) 
    for file in lfs.dir(path) do 
        if file ~= "." and file ~= ".." then 
            local f = path..'/'..file 
            --print ("\t "..f) 
            if string.find(f, wefind) ~= nil then 
                -- print("\t "..f) 
                table.insert(r_table, f) 
            end 
            local attr = lfs.attributes (f) 
            assert (type(attr) == "table") 
            if attr.mode == "directory" and intofolder then 
                FileUtil.findindir (f, wefind, r_table, intofolder) 
            else 
                for name, value in pairs(attr) do 
                    print (name, value) 
                end 
            end 
        end 
    end 
end
--写入指定路径内容
function FileUtil.writeFile(path, content)
    -- print("a",path,content)
   mode = mode or "w+b"
   -- print("b")
    local file = io.open(path, mode)
    -- print("c")
    if file then
        if file:write(content) == nil then return false end
        io.close(file)
        return true
    else
        return false
    end
    -- print("d")
end

--读出文件全部内容
function FileUtil.readFile(srcFile)
    -- print("FileUtil.readFile(srcFile)1")
    if (FileUtil.isFileExist(srcFile)) then
        -- print("FileUtil.readFile(srcFile)2")
        local file = io.open(srcFile, "r")
        -- print("FileUtil.readFile(srcFile)3")
        if file then
            local content = file:read("*a")
            io.close(file)
            -- print("FileUtil.readFile(srcFile)4")
            return content
        end
        -- print("FileUtil.readFile(srcFile)5")
        return nil
    else
        return nil
    end
end

--判断是否路径
function FileUtil.isPathExist(path)
    for file in lfs.dir(path) do 
        if file == "." or file == ".." then
            return true
        end
    end     
    return false
end

--判断文件是否存在
-- function FileUtil.isFileExist(filePath)
--     local file_name
--     string.gsub(filePath, "[^/]+$", function(w) file_name=w end)
--     local file_dir = string.sub(filePath, 1, string.find(filePath, file_name)-1)

--     for file in lfs.dir(file_dir) do
--         if file ~= "." and file ~= ".." then
--             if file == file_name then
--                 return true
--             end
--         end
--     end
--     return false
-- end

--判断文件是否存在 
function FileUtil.isFileExist(filePath) --经安卓真机验证，可以找到包含resx的文件 如："resx/hero_card/hero_10041.png" 
    if CCFileUtils:sharedFileUtils():isFileExist(filePath) then
        return true
    end
    return false
end
--可创建多级目录
function FileUtil.createDir(filePath, isFile)
    if FileUtil.isPathExist(filePath)  then--已经存在目录
        return false
    end
    --文件也可创建目录
    if not isFile then
        filePath = filePath .. "/"
    end
    --
    local pathname=""
    local len= string.len(filePath)
    for i = 1, len, 1 do
        local c_str = string.sub(filePath, i,i)
        pathname = pathname .. c_str
        if c_str == "/" or c_str == "\\" then
            lfs.mkdir(pathname)
        end
    end
    return true
end

--拷贝文件到指定目录
function FileUtil.copyfileto(srcFile, destFile)
    --判断是否源文件存在
    if not io.exists(srcFile) then
        return
    end
    --
    local file = FileUtil.open(srcFile, "rb")
    local dest_file= FileUtil.open(destFile,"wb")
    local content = file:read("*a")
    dest_file:write(content)
    file:close()
    dest_file:close()
end

--目录拷贝
function FileUtil.copydirto(srcPath, destPath)
    FileUtil.createDir(destPath, false)
    --
    for file in lfs.dir(srcPath) do 
        if file ~= "." and file ~= ".." then 
            local f = srcPath.."/"..file 
            local dest_f = destPath .. "/" ..file
            local attr = lfs.attributes (f) 
            if attr.mode == "directory" then
                FileUtil.createDir(dest_f, false)
                FileUtil.copydirto (f, dest_f) 
            else
                --拷贝文件
                FileUtil.copyfileto(f, dest_f)
            end
        end
    end
end

return FileUtil