--
-- Author: hejiangcheng
-- Date: 2014-12-02 10:53:58
--
local GameState = require(cc.PACKAGE_NAME .. ".api.GameState")
local secretKey = "mobi2us"
local stateFileName = "ec135bfc0cf099b0c56c5645ef07219e" --md5(mobi2usdata.txt)

local GameStateUtil = {} --gGameData

--进入主城之前进行初始化
function GameStateUtil.init()
	GameState.init(function(param)
	    local returnValue=nil
	    if param.errorCode then
			echoError("GameState error " .. param.errorCode)
	    else
	        if param.name=="save" then
	            local str=json.encode(param.values)
	            --print(str,"save localdata===============")
	            str=crypto.encryptXXTEA(str, secretKey)
	            returnValue={data=str}
	        elseif param.name=="load" then
	            local str=crypto.decryptXXTEA(param.values.data, secretKey)
	            returnValue=json.decode(str)
	        end	
	    end	
	    return returnValue	
	end, stateFileName, secretKey)
	
	GameStateUtil.load()
end

--加载本地数据
function GameStateUtil.load()
	local gamedata
	if io.exists(GameState.getGameStatePath()) then
	    gamedata = GameState.load()
	end

	if type(gamedata) == 'table' then
		if device.platform == 'android' then
			if (not gamedata.unique_id) or gamedata.unique_id == '' then
				--print('本地信息中没有保存设备唯一码！')
			else
				--print("保存的设备码是：",gamedata.unique_id)
				if gPlayer.data.device_id == '' then gPlayer.data.device_id = DeviceUtil.getUUID() end
				if gamedata.unique_id ~= gPlayer.data.device_id then
					--print("设备唯一码校验失败")
					--print("java中取得设备码是：",gPlayer.data.device_id)
					return
				end
			end
		end

		gPlayer.data.ingot_cnt:set(gamedata.ingot_cnt)
		gPlayer.data.copper_cnt:set(gamedata.copper_cnt)
		if tonum(gamedata.climbNum)>5 then
			gPlayer.data.climbNum:set(5)
		else
			gPlayer.data.climbNum:set(gamedata.climbNum)
		end
		gPlayer.data.isBuyMysGift = tobool(gamedata.isBuyMysGift)
		if toint(gamedata.pass_id) >=60001 then
			gPlayer:setPassId(gamedata.pass_id)
		end

		---[[yangdx  add 

		if toint(gamedata.free_pay_count) >=0 then
			gPlayer.data.free_pay_count=gamedata.free_pay_count
		end

		if toint(gamedata.pay_hit_count) >=0 then
			gPlayer.data.pay_hit_count=gamedata.pay_hit_count
		end

		--]]
		--todo 初始化英雄列表
		if type(gamedata.hero_list)=="table" and #gamedata.hero_list > 0 then
			gHero:initLocalData(gamedata.hero_list)
		end

		if type(gamedata.map_star)=="table" and #gamedata.map_star > 0 then
			gPlayer:initLocalStarData(gamedata.map_star)
		end

		if type(gamedata.skill_list)=="table" and #gamedata.skill_list > 0 then
			gSkill:initLocalData(gamedata.skill_list)
		end

		--todo 初始化道具列表
		if type(gamedata.item_list)=="table" and #gamedata.item_list > 0 then
			gItem:initLocalData(gamedata.item_list)
		end
	else
		if device.platform == 'android' then
			gPlayer.data.device_id = DeviceUtil.getUUID()
		end
		--print("读取本地数据错误！")
	end
end

--保存数据到本地
function GameStateUtil.save()
	local gamedata = {}
	gamedata.ingot_cnt = gPlayer.data.ingot_cnt:get()
	gamedata.copper_cnt = gPlayer.data.copper_cnt:get()
	gamedata.climbNum	= gPlayer.data.climbNum:get()
	gamedata.pass_id = gPlayer.data.pass_id
	gamedata.free_pay_count = gPlayer.data.free_pay_count --yangdx add 
	gamedata.pay_hit_count = gPlayer.data.pay_hit_count --yangdx add 
	gamedata.isBuyMysGift = gPlayer.data.isBuyMysGift
	if device.platform == 'android' then
		if gPlayer.data.device_id == '' then
			--print("保存gPlayer.data.device_id为空")
			gPlayer.data.device_id = DeviceUtil.getUUID()
		end
		gamedata.unique_id = gPlayer.data.device_id
	end

	--英雄数据保存
	gamedata.hero_list = {}
	for i,v in pairs(gHero.data) do
		table.insert(gamedata.hero_list, {v[1], v[2]:get()}) --id,star
	end

	--技能 
	gamedata.skill_list = {}
	for i,v in pairs(gSkill.data) do
		table.insert(gamedata.skill_list, {v[1], v[2]:get()}) --id,star
	end



	--保存关卡星星数据
	gamedata.map_star={}
	for i,v in pairs(gPlayer.data.map_stars) do
		table.insert(gamedata.map_star,{i,v:get()})
	end

	--保存道具数据
	gamedata.item_list = {}
	for i,v in pairs(gItem.data) do
		table.insert(gamedata.item_list, {v.item_id, v.num:get()})
	end


	GameState.save(gamedata)
end

return GameStateUtil