local MathShapeUtil = {}

function MathShapeUtil.getHitTargetsWithShape(releasePoint,shape,maxNum)
	local targets = {}

	local shapeType = shape.shape_type--这个值决定打击范围

	if shapeType==0 then--0,全屏幕
	elseif shapeType==1 then--1,自身为圆心的圆形
	    return targets
	elseif shapeType==2 then--2,目标为圆心的圆形
		for i = 0, GameInstance:sharedInstance().monsters:count()-1 do
	        local v = GameInstance:sharedInstance().monsters:objectAtIndex(i)
	        local distance = ccpDistance(ccp(v:getPositionX(),v:getPositionY()),releasePoint)
	        if #targets>maxNum then
	        	return targets
	        end
	        if distance<shape.radius then
	        	targets[#targets+1] = v
	        end 
		end
	    return targets
	elseif shapeType==3 then--3,自身到目标连线为中轴的矩形length = 200,--矩形长度width = 60,--矩形宽度
	    return targets
	elseif shapeType==4 then--4,目标所在横坐标轴为中轴的矩形
	elseif shapeType==5 then--5,目标所在纵坐标为中轴的矩形
	elseif shapeType==6 then--6,自身到目标连线为中轴的扇形;
	    return targets
	elseif shapeType==7 then--7,指定点为圆心的圆形
		for i = 0, GameInstance:sharedInstance().monsters:count()-1 do
	        local v = GameInstance:sharedInstance().monsters:objectAtIndex(i)
	        local distance = ccpDistance(ccp(v:getPositionX(),v:getPositionY()),releasePoint)
	        if #targets>maxNum then
	        	return targets
	        end
	        if distance<shape.radius then
	        	targets[#targets+1] = v
	        end 
		end
	    return targets
	else
	end
end


function MathShapeUtil.getHitTargetsWithShape(owner,target,shape,maxNum)
	local targets = {}
	targets[#targets+1] = target

	local shapeType = shape.shape_type--这个值决定打击范围

	if shapeType==0 then--0,全屏幕

	elseif shapeType==1 then--1,自身为圆心的圆形
		for i = 0, GameInstance:sharedInstance().monsters:count()-1 do
	        local v = GameInstance:sharedInstance().monsters:objectAtIndex(i)
	        local distance = ccpDistance(ccp(v:getPositionX(),v:getPositionY()),ccp(owner:getPositionX(),owner:getPositionY()))
	        if #targets>maxNum then
	        	return targets
	        end
	        if distance<owner:getRange() then
	        	targets[#targets+1] = v
	        end 
		end
	    return targets
	elseif shapeType==2 then--2,目标为圆心的圆形
		for i = 0, GameInstance:sharedInstance().monsters:count()-1 do
	        local v = GameInstance:sharedInstance().monsters:objectAtIndex(i)
	        local distance = ccpDistance(ccp(v:getPositionX(),v:getPositionY()),ccp(target:getPositionX(),target:getPositionY()))
	        if #targets>maxNum then
	        	return targets
	        end
	        if distance<shape.radius then
	        	targets[#targets+1] = v
	        end 
		end
	    return targets
	elseif shapeType==3 then--3,自身到目标连线为中轴的矩形length = 200,--矩形长度width = 60,--矩形宽度


		local collisionNode = display.newSprite()
		--collisionNode:setAnchorPoint(ccp(0,0))
		collisionNode:setContentSize(CCSize(shape.length,shape.width))
		local posX,posY = target:getPosition()
		collisionNode:setPosition(posX,posY)
		local shootVector = ccpSub(ccp(target:getPositionX(),target:getPositionY()),ccp(owner:getPositionX(),owner:getPositionY()))
	    local shootAngle = -1*ccpToAngle(shootVector)*57.29577951
	    collisionNode:setRotation(shootAngle)

		--self.gameScene:addChild(collisionNode)

		for i = 0, GameInstance:sharedInstance().monsters:count()-1 do
	        local v = GameInstance:sharedInstance().monsters:objectAtIndex(i)
	        if #targets>maxNum then
	        	return targets
	        end
	        if collisionNode:getBoundingBox():containsPoint(ccp(v:getPositionX(),v:getPositionY())) then
	        	targets[#targets+1] = v
	        	print(collisionNode:getBoundingBox().origin.x,collisionNode:getBoundingBox().origin.y)
	        else
	        	print(collisionNode:getBoundingBox().origin.x,collisionNode:getBoundingBox().origin.y)
	        end 
		end

		--collisionNode:removeSelf()

	    return targets

	elseif shapeType==4 then--4,目标所在横坐标轴为中轴的矩形

	elseif shapeType==5 then--5,目标所在纵坐标为中轴的矩形

	elseif shapeType==6 then--6,自身到目标连线为中轴的扇形;
		for i = 0, GameInstance:sharedInstance().monsters:count()-1 do
	        local v = GameInstance:sharedInstance().monsters:objectAtIndex(i)
	        local distance = ccpDistance(ccp(v:getPositionX(),v:getPositionY()),ccp(target:getPositionX(),target:getPositionY()))
	        if #targets>maxNum then
	        	return targets
	        end
	        if distance<shape.radius then
	        	targets[#targets+1] = v
	        end 
		end
	    return targets
	elseif shapeType==7 then--7,指定点为圆心的圆形

	else
	end
end

return MathShapeUtil