SUNDER_FACTOR = 1 --破甲因素
ARMOR_FACTOR = 1 --护甲因素
ARMOR_CONSTANT = 1 --护甲常数
RESIST_FACTOR = 1 --抗性因素
RESIST_CONSTANT = 1 --抗性常数

SKILL_CRIT_PROC_ADDING = 1 --技能固有暴击率加成

SKILL_PROC_FACTOR = 1 --技能触发几率因数
SKILL_PROC_CONSTANT = 1 --技能触发几率常数

SKILL_CRIT_PROC_ADDING = 1 --技能固有暴击倍数加成

local PveAttackLogic = {}


--计算实际暴击率 真实暴击几率 = 暴击几率_character×（1 + 暴击率加成_buff1）×（1 + 暴击率加成_buff2）×…×（1 + 暴击率加成_buffn) + 技能固有暴击率加成 - 免暴击率_defenser
--【注：最小值10%，最大50%】
function PveAttackLogic.get_crit_proc(crit_proc_attacker,necrit_proc_defencer)
    local crit_proc = crit_proc_attacker + SKILL_CRIT_PROC_ADDING - necrit_proc_defencer

    if crit_proc < 0.1 then
        crit_proc = 0.1
    elseif crit_proc >0.5 then
        crit_proc = 0.5
    end
    return crit_proc
end

--计算实际的技能触发几率 真实技能触发几率 = 20% + （幸运值_attacker - 幸运值_defencer）/（技能触发几率因数×等级_character + 技能触发几率常数
--[注：最小值10%，最大值50%]
function PveAttackLogic.get_skill_proc(skill_proc_attacker,skill_proc_defencer)
    --老版本，根据幸运值来计算
    --local skill_proc = 0.2 + (lucky_attacker - lucky_defencer)/(SKILL_PROC_FACTOR * level_attacker + SKILL_PROC_CONSTANT)
    local skill_proc = 0.2 + skill_proc_attacker - skill_proc_defencer

    if skill_proc < 0.1 then
        skill_proc = 0.1
    elseif skill_proc >0.5 then
        skill_proc = 0.5
    end
    return skill_proc
end

--计算实际命中率 命中率计算公式 真实命中率 = 100% + 命中率_attacker - 命中率_defencer
function PveAttackLogic.get_hit_proc(hit_proc_attacker,hit_proc_defencer)
    local hit_proc = 1 + hit_proc_attacker - hit_proc_defencer
    return hit_proc
end

--破甲值计算公式 破甲值 = 精准值_characte×破甲因数
function PveAttackLogic.get_sunder(accuracy)
    local sunder = accuracy * SUNDER_FACTOR
    return sunder
end

--计算总生命  生命值 = 生命值_character×（1 + 生命值加成_beauty）×（1+生命值加成_buff1）×（1 + 生命值加成_buff2）×…×（1 + 生命值加成_buffn）
function PveAttackLogic.get_total_health_point(health_point)
    local total_health_point = health_point
    return total_health_point
end

--外功伤害减免计算公式 外功伤害减免 = （护甲_defencer - 破甲值_attacker）/（护甲 + 等级_attacker×护甲因数 + 护甲常数）
function PveAttackLogic.get_outdamage_reduce(armor_defencer,sunder_attacker,level_attacker)
    local outdamage_reduce = (armor_defencer - sunder_attacker)/(armor_defencer + level_attacker * ARMOR_FACTOR + ARMOR_CONSTANT)
    return outdamage_reduce
end

--内功伤害减免计算公式   内功伤害减免 = （抗性_defencer - 破甲值_attacker）/（抗性 + 等级_attacker×抗性因数 + 抗性常数）
function PveAttackLogic.get_indamage_reduce(resist_defencer,sunder_attacker,level_attacker)
    local indamage_reduce = (resist_defencer - sunder_attacker)/(resist_defencer + level_attacker * RESIST_FACTOR + RESIST_CONSTANT)
    return indamage_reduce
end
---------------------------------更改的公式------------------------------------------------------------------------------------------
--计算实际攻击速度 攻击速度             攻击速度 = 攻击速度_attacker /  ∏（1 + 攻击速度加成_buff_n）(连乘)
function PveAttackLogic.get_attack_speed(attack_speed)
    --local speed = attack_speed /(1+buff1)*(1+buff2)
    local speed = attack_speed
    return speed
end

--真实暴击倍数 = 暴击伤害倍数_character + ∑暴击倍数加成_buff_n
--实际暴击伤害倍数 = 2 + 真实暴击伤害倍数_attacker - 真实免暴击伤害倍数_defencer
function PveAttackLogic.get_crit_mul(crit_mul_attacker,necrit_mul_defencer)
    --local crit_mul = 2 + crit_mul_attacker - necrit_mul_defencer + (buff)
    local crit_mul = 2 + crit_mul_attacker - necrit_mul_defencer
    return crit_mul
end

--普通攻击伤害
function PveAttackLogic.get_normal_damage(attack_power,attack_speed,damage_reduce,damage_lower_proc)
    --平均伤害 = 攻击力_attacker × 标准攻击速度_attacker ×（1 - 伤害减免_defenser + 伤害减免加成_buff）
    --local average = attack_power*attack_speed*(1-damage_reduce+伤害减免加成_buff)
    --伤害减免加成_buff暂时为1
    local average = attack_power*attack_speed*(1-damage_reduce+1)
    local minDamage = average * (0.8+damage_lower_proc)
    local maxDamage = average * 1.2

    local damage = math.random(minDamage,maxDamage)--伤害

    return damage
end

function PveAttackLogic.get_crit_damage(attack_power,attack_speed,damage_reduce,damage_lower_proc,crit_mul)
    --平均伤害 = 攻击力_attacker × 标准攻击速度_attacker ×（1 - 伤害减免_defenser + 伤害减免加成_buff）
    --local average = attack_power*attack_speed*(1-damage_reduce+伤害减免加成_buff)
    --伤害减免加成_buff暂时为1
    local average = attack_power*attack_speed*(1-damage_reduce+1)
    local minDamage = average * (0.8+damage_lower_proc)
    local maxDamage = average * 1.2

    local crit = math.random(minDamage,maxDamage) * crit_mul--暴击伤害

    return crit
end

--------------------------------------------------------------------------------------------------------------------------------------
---------------------------新公式已经舍弃---------------------------------------------------------------------------------------------
--计算总护甲  护甲 = 护甲_character×（1 + 护甲加成_buff1）×（1 + 护甲加成_buff2）×...×（1 + 护甲加成_buffn）
function PveAttackLogic.get_total_armor(armor)
    local total_armor = armor
    return total_armor
end

--计算总抗性  抗性 = 抗性_character×（1 + 抗性加成_buff1）×（1 + 抗性加成_buff2）×...×（1 + 抗性加成_buffn）
function PveAttackLogic.get_total_resist(resist)
    local total_resist = resist
    return total_resist
end
---------------------------------------------------------------------------------------------------------------------------------------

return PveAttackLogic
