local AnimationFactory = require("app.factory.AnimationFactory")
local scheduler = require("framework.scheduler")
local ResourceManagerLayer = class("ResourceManagerLayer", function()
    return display.newLayer()
end)

function ResourceManagerLayer:ctor(toScene,callback,guide)
	GameInstance:sharedInstance():cleanSceneData()
	CCTextureCache:sharedTextureCache():removeAllTextures()
	local lastSceneName = runningSceneName
	runningSceneName = toScene.name
	print(lastSceneName,"场景>>>  go to >>>>>>场景",runningSceneName)
	self.callback = callback
	self.startCount = false
	
	CCDirector:sharedDirector():getScheduler():setTimeScale(math.random(1)+1)  --2倍速度玩游戏

	--self.heroIds = {10341,10241,10201,10221}
	self.heroIds = {}
	local ids = {10361,10371,10381,10391,10001,10261,10281,10291,10351,10241,10081,10091,10101,10111,10121,10131,10141,10151,10161,10171,10181,10191,10201,10231,10301,10311,10331,10341,10211,10221,10251,10321,10271}
	local ifExists = function(id)
		for i=1,#self.heroIds do
			if self.heroIds[i]==id then
				return true
			end
		end
		return false
	end
	while #self.heroIds <4 do
		local id = ids[math.random(1,#ids)]
		if not ifExists(id) then
			self.heroIds[#self.heroIds+1] = id
		end
	end
	CCTextureCache:sharedTextureCache():removeUnusedTextures()
	self.loadComplete = false

	--print("guide的值是",guide)
	--guide = false
	if guide then
		--require("app.common.ResourceUtil").releaseResource(lastSceneName)
		require("app.common.ResourceUtil").loadResource(runningSceneName)
		self.loadComplete = true
		if self.loadComplete then
			self:clean()
			self.callback()
		end
		return
	end

	if lastSceneName=="BattleScene" and runningSceneName=="BattleScene" then
		--require("app.common.ResourceUtil").releaseResource(lastSceneName)
		require("app.common.ResourceUtil").loadResource(runningSceneName)
		self.loadComplete = true
		if self.loadComplete then
			self:clean()
			self.callback()
		end
		return
	end

	if runningSceneName=="LoginScene" or runningSceneName=="UpdateScene" or runningSceneName=="MILoginScene" or runningSceneName=="AnySdkLoginScene" or runningSceneName=="IOSLoginScene" then
		--require("app.common.ResourceUtil").releaseResource(lastSceneName)
		require("app.common.ResourceUtil").loadResource(runningSceneName)
		self.loadComplete = true
		if self.loadComplete then
			self:clean()
			self.callback()
		end
		return
	elseif lastSceneName=="NPCScene" and runningSceneName=="BattleScene" then
		--require("app.common.ResourceUtil").releaseResource(lastSceneName)
		require("app.common.ResourceUtil").loadResource(runningSceneName)
		self.loadComplete = true
		if self.loadComplete then
			self:clean()
			self.callback()
		end
		return
	elseif lastSceneName=="NPCScene" and runningSceneName=="NPCScene" then
		--require("app.common.ResourceUtil").releaseResource(lastSceneName)
		require("app.common.ResourceUtil").loadResource(runningSceneName)
		self.loadComplete = true
		if self.loadComplete then
			self:clean()
			self.callback()
		end
		return
	else
		self.heros={}
		--display.addSpriteFramesWithFile("monster/monster_70053.plist","monster/monster_70053.pvr.ccz")
		local path = "#hero_10341_walk_front_1.png"

		for i=1,#self.heroIds do 
			local heroId = self.heroIds[i]
			local frames,animation = AnimationFactory.getHeroAnimation(heroId,"walk","front")
			local hero = display.newSprite(frames[1],display.cx-350+i*30,display.cy-25):addTo(self,3)
		    hero:playAnimationForever(animation)
		    self.heros[#self.heros+1] = hero
		end
		self:heroSayWord()

		self.startCount = true
		self:performWithDelay(function()
			self.heros[4]:removeAllChildrenWithCleanup(true)
		end,2)

		self:performWithDelay(function()
			self.canMove = true
		end,0.2)

		--[[]]
		local animation,frames = AnimationFactory.getMonsterLoadingAnimation(false,"front",70053,0.5)
		self.monster = display.newSprite(frames[1],display.cx-350+6*40,display.cy+10):addTo(self,2)
		self.monster:playAnimationForever(animation)
		self:initProgressBar()
		self.tipLabel = ui.newTTFLabel({
		    text = "加载本地资源,不耗费流量............",
		    font = "Marker Felt",
		    x=display.cx,
		    y=display.cy-135,
		    color = ccc3(255, 230, 230), -- 使用纯红色
		    size = 15,
		    align = ui.TEXT_ALIGN_CENTER -- 文字内部居中对齐
		}):addTo(self,20)

		if lastSceneName=="LoginScene" and runningSceneName=="NPCScene" then
			local bg =  display.newSprite("ui/home/home_excessive_scene.png", display.cx, display.cy):addTo(self,1)
		else
			local bg =  display.newSprite("ui/home/home_excessive_scene.png", display.cx, display.cy):addTo(self,1)
		end
		require("app.common.ResourceUtil").loadResource(runningSceneName)
		self.loadComplete = true
	end
	
	self.percentage = 0

	self.perCentageLabel = ui.newTTFLabel({
	    text = "",
	    font = "Marker Felt",
	    x=display.cx,
	    y=display.cy-120,
	    color = ccc3(255, 230, 230), -- 使用纯红色
	    size = 15,
	    align = ui.TEXT_ALIGN_CENTER -- 文字内部居中对齐
	}):addTo(self)

	local callBackTime = 0
	local onSchedule = function()
		if not self.startCount then return end
		if  callBackTime==1 then
			self:clean()
			return
		end
		self.percentage = self.percentage + 1
		if self.percentage>100 then
			self.percentage = 100
		end
		if self.percentage==50 or self.percentage==1 then
			self:updateGuideWords()
		end
		self:setPercentage(self.percentage)
		local percentageText = self.percentage.."%"
		self.perCentageLabel:setString(percentageText)
		if self.canMove then
			for i =1,#self.heros do
				local hero = self.heros[i]
				hero:setPosition(ccp(display.cx-350+i*30+self.percentage/100*(250+i*15),display.cy-25))
			end
			self.monster:setPosition(ccp(display.cx-350+6*40+350*self.percentage/100,display.cy+10))
		end
		if self.loadComplete and self.percentage==100 then
			callBackTime = 1
			self:clean()
			self.callback()
		end
	end

	if runningSceneName=="NPCScene" or runningSceneName=="BattleScene" then
		self:schedule(onSchedule,1/200)
	end
end

function ResourceManagerLayer:clean()
	CCDirector:sharedDirector():getScheduler():setTimeScale(1)  --2倍速度玩游戏
	self:stopAllActions()
	CCTextureCache:sharedTextureCache():removeUnusedTextures()
	self:removeFromParentAndCleanup(true)
	CCTextureCache:sharedTextureCache():removeTextureForKey("res/ui/home/home_experience.png")
	CCTextureCache:sharedTextureCache():removeTextureForKey("ui/home/home_excessive_scene.png")
	--display.removeSpriteFramesWithFile("monster/monster_70053.plist","monster/monster_70053.pvr.ccz")
end

function ResourceManagerLayer:heroSayWord()
	local words = {"妖怪，别跑·········","站住，妖怪·········","等等，别跑·········","呼哧，呼哧·········","你的鞋子·········","兄弟，跟上·········","抓住它·········"}
	local bubble = display.newSprite("ui/public/public_dialog_box.png",-20,105)
		local words = ui.newTTFLabel({
		    	text = words[math.random(1,#words)],
		    	font = "Arial",
		    	color = ccc3(0, 0,0),
		    	x = -40,
		   		y = 10,
		    	size = 14,
		    	dimensions = CCSize(135,120),
		    	align = ui.TEXT_ALIGN_LEFT
		})
		words:setAnchorPoint(ccp(0,0))
		bubble:addChild(words)
		bubble:setFlipX(true)
		self.heros[4]:addChild(bubble,60000)
end

function ResourceManagerLayer:updateGuideWords()
	local guide_words = require("app.client.desc.guide_words")[1]
	local randomWord = guide_words[math.random(1,#guide_words)]
	self.tipLabel:setString(randomWord)
end

function ResourceManagerLayer:initProgressBar()
  local len = 44
  local con_len = 31
  local bg_len = 300
  local prgs_len = 260

  local progressNode = display.newNode():addTo(self,2)

  self.prgs = display.newSprite("ui/public/public_progressbar_graduation.png"):pos(display.cx - 600/2-2+3,display.cy-100+3):addTo(self,0)
  self.prgs:setAnchorPoint(CCPoint(0,0))
  self.prgs:setScaleX(0)

  self.prgs_effect = display.newSprite("ui/public/public_progressbar_effect.png"):pos(-15,-8):addTo(progressNode,2)
  self.prgs_effect:setAnchorPoint(CCPoint(0,0))


  self.prgs_scaleX = (620-18) / prgs_len
  self.percentage = 0

  progressNode:setPosition(ccp(display.cx - 600/2-2,display.cy-100))
end

function ResourceManagerLayer:setPercentage(percentage)
  local prgs_scale = self.prgs_scaleX * percentage / 100

  --计算进度点x坐标
  local effect_start_x = -10
  local effect_end_x = effect_start_x+615-25
  local effect_len = effect_end_x - effect_start_x
  local effect_pos_x = effect_len * percentage / 100 + effect_start_x

  self.prgs:setScaleX(prgs_scale)
  self.prgs_effect:setPositionX(effect_pos_x)
  
end

function ResourceManagerLayer:checkFrameExist(frame_str)
	 if string.byte(frame_str) == 35 then -- first char is #
	 	frame_str =  string.sub(frame_str, 2)
	 end
	-- print("frame_str=", frame_str)
	local frame = CCSpriteFrameCache:sharedSpriteFrameCache():spriteFrameByName(frame_str)
       if frame then
       	return true
  	end
  return false
end

return ResourceManagerLayer