local scheduler = require("framework.scheduler")
local ResourceUtil = {}

function ResourceUtil.loadResource(sceneName)
    if sceneName=="UpdateScene" then
        print("加载UpdateScene资源")
    elseif sceneName=="LoginScene" then
        print("加载LoginScene资源")
    elseif sceneName=="MILoginScene" then
        print("加载LoginScene资源")
    elseif sceneName=="IOSLoginScene" then
        print("加载IOSLoginScene资源")
    elseif sceneName=="NPCScene" then
        print("加载NPCScene资源")
        local resourceList = {
            --UI相关
            {"ui/home_drum.plist","ui/home_drum.pvr.ccz"},--打鼓
            {"ani/ui/seart_fight.plist","ani/ui/seart_fight.pvr.ccz"},
            {"npc.plist","npc.pvr.ccz"},
        }
        for i=1,#resourceList do
            addRes(sceneName,resourceList[i][1],resourceList[i][2])
        end
    elseif sceneName=="BattleScene" then
        print("加载BattleScene资源")
        local resourceList = {
            {"monster_effect.plist","monster_effect.pvr.ccz"},
            {"buff_effect.plist","buff_effect.png"},
            {"battle_ui.plist","battle_ui.pvr.ccz"},
            {"monster_appear.plist","monster_appear.pvr.ccz"},
            {"bullet.plist","bullet.png"},
            {"frozen.plist","frozen.pvr.ccz"},
            {"bomb.plist","bomb.pvr.ccz"},
            {"focus.plist","focus.pvr.ccz"},
            {"test.plist","test.pvr.ccz"},
            {"cat.plist","cat.pvr.ccz"},
            {"Skill_Box_Selected_Ani.plist","Skill_Box_Selected_Ani.png"},
        }
        local sceneId = gBattle.data.home_scene_id
        local worldId = CommUtil.getWorld(sceneId)
        
        local heroSkillList = CommUtil.getSkillResource()
        local resourceNum = #heroSkillList
        for i=1,resourceNum do
            local resourceName = heroSkillList[i]
            addRes(sceneName,resourceName..".plist",resourceName..".pvr.ccz")
        end

        if sceneId==700 then
            resourceList[#resourceList+1]={"ani/pve/skill/skill_41016.plist","ani/pve/skill/skill_41016.pvr.ccz"}--要预先加载，龙王的技能
            resourceList[#resourceList+1]={"ani/pve/skill/skill_40012.plist","ani/pve/skill/skill_40012.pvr.ccz"}--要预先加载，龙王的技能
            resourceList[#resourceList+1]={"ani/pve/skill/skill_40008.plist","ani/pve/skill/skill_40008.pvr.ccz"}--要预先加载，龙王的技能
            resourceList[#resourceList+1]={"ani/pve/skill/skill_40016.plist","ani/pve/skill/skill_40016.pvr.ccz"}--要预先加载，龙王的技能
            resourceList[#resourceList+1]={"ani/pve/skill/skill_40015.plist","ani/pve/skill/skill_40015.pvr.ccz"}--要预先加载，龙王的技能
            resourceList[#resourceList+1]={"res/ani/pve/skill/skill_41005.plist","res/ani/pve/skill/skill_41005.pvr.ccz"}--要预先加载，龙王的技能

            local first_battle_template = require("app.client.template.first_battle_template")
            local hero_template = require("app.client.template.hero_template")
            for i=1,#first_battle_template do
                local heroData = first_battle_template[i]
                local heroId = heroData[1]
                for j=1,#hero_template do
                    local hTemplate = hero_template[j]
                    local skillId = hTemplate[19]
                    if heroId==hTemplate[1] then
                       resourceList[#resourceList+1]={"ani/pve/skill/skill_"..skillId..".plist","ani/pve/skill/skill_"..skillId..".pvr.ccz"}  
                    end
                end
            end
        elseif sceneId==702 then
            resourceList[#resourceList+1]={"ani/pve/skill/skill_41016.plist","ani/pve/skill/skill_41016.pvr.ccz"}--要预先加载，龙王的技能
        end
        for i=1,#resourceList do
            addRes(sceneName,resourceList[i][1],resourceList[i][2])
        end
    elseif sceneName=="PVPBattleScene" then
        print("加载PVPBattleScene资源")
    elseif sceneName=="PVPScene" then
        print("加载PVPScene资源")
    end
end

function ResourceUtil.releaseResource(sceneName)
    if sceneName=="UpdateScene" then
        print("释放UpdateScene资源")
    elseif sceneName=="LoginScene" then
        print("释放LoginScene资源")
        CCTextureCache:sharedTextureCache():removeTextureForKey("ui/account/account_bg.jpg")
    elseif sceneName=="MILoginScene" then
        print("释放LoginScene资源")
        CCTextureCache:sharedTextureCache():removeTextureForKey("ui/account/account_bg.jpg")
    elseif sceneName=="IOSLoginScene" then
        print("释放IOSLoginScene资源")
        CCTextureCache:sharedTextureCache():removeTextureForKey("ui/account/account_bg.jpg")
    elseif sceneName=="NPCScene" then
        print("释放NPCScene资源")
        if runningSceneName=="NPCScene" then--通天塔
            local resourceList = {
            }
            for i=1,#resourceList do
                display.removeSpriteFramesWithFile(resourceList[i][1],resourceList[i][2])
            end
        elseif runningSceneName=="PVPScene" then
            local resourceList = {
                --UI相关
                {"ui/home_drum.plist","ui/home_drum.pvr.ccz"},                  --打鼓
            }
            if runningSceneName~="BattleScene" then
                resourceList[#resourceList+1] = {"grass.plist","grass.png"}
            end
            for i=1,#resourceList do
                display.removeSpriteFramesWithFile(resourceList[i][1],resourceList[i][2])
            end
        else
            local resourceList = {
                --UI相关
                {"ui/home_drum.plist","ui/home_drum.pvr.ccz"},                  --打鼓
                {"ani/ui/seart_fight.plist","ani/ui/seart_fight.pvr.ccz"},
                --{"ani/ui/fight_door.plist","ani/ui/fight_door.pvr.ccz"},
            }
            for i=1,#resourceList do
                display.removeSpriteFramesWithFile(resourceList[i][1],resourceList[i][2])
            end
        end
    elseif sceneName=="BattleScene" then
        print("释放BattleScene资源")
        local resourceList = {
            {"monster_effect.plist","monster_effect.pvr.ccz"},
            {"buff_effect.plist","buff_effect.png"},
            {"monster_appear.plist","monster_appear.pvr.ccz"},
            {"ani/pve/skill/skill_41016.plist","ani/pve/skill/skill_41016.pvr.ccz"},  --要预先加载，龙王的技能
            {"battle_ui.plist","battle_ui.pvr.ccz"},
        }
        local heroSkillList = CommUtil.getSkillResource()
        local resourceNum = #heroSkillList
        for i=1,resourceNum do
            local resourceName = heroSkillList[i]
            display.removeSpriteFramesWithFile(resourceName..".plist",resourceName..".pvr.ccz")
        end
        scheduler.performWithDelayGlobal(function()
            --for i=1,#monsterBodyIdArray ,1 do
            --    display.removeSpriteFramesWithFile("ani/pve/monster/monster_"..monsterBodyIdArray[i]..".plist","ani/pve/monster/monster_"..monsterBodyIdArray[i]..".pvr.ccz")
            --end
        end,2)
        local skills = gBeauty:getBeautySkills()
        for i=1,#skills do
            display.removeSpriteFramesWithFile("ani/pve/skill/skill_"..skills[i]..".plist","ani/pve/skill/skill_"..skills[i]..".pvr.ccz")
        end
        local sceneId = gBattle.data.home_scene_id
        local worldId = CommUtil.getWorld(sceneId)
        if sceneId~=700 then
            resourceList[#resourceList+1]={"ani/pve/skill/skill_40012.plist","ani/pve/skill/skill_40012.pvr.ccz"}
            resourceList[#resourceList+1]={"ani/pve/skill/skill_40008.plist","ani/pve/skill/skill_40008.pvr.ccz"}
            resourceList[#resourceList+1]={"ani/pve/skill/skill_40016.plist","ani/pve/skill/skill_40016.pvr.ccz"}
            resourceList[#resourceList+1]={"ani/pve/skill/skill_40015.plist","ani/pve/skill/skill_40015.pvr.ccz"}
        end
        for i=1,#addSkillIds do
            display.removeSpriteFramesWithFile("ani/pve/skill/skill_"..addSkillIds[i]..".plist","ani/pve/skill/skill_"..addSkillIds[i]..".pvr.ccz")
        end
        addSkillIds={}
        scheduler.performWithDelayGlobal(function()
            for i=1,#resourceList do
                display.removeSpriteFramesWithFile(resourceList[i][1],resourceList[i][2])
            end
        end,2)
    elseif sceneName=="PVPBattleScene" then
        print("释放PVPBattleScene资源")
    elseif sceneName=="PVPScene" then
        print("释放PVPScene资源")
    end
   --CCTextureCache:sharedTextureCache():removeUnusedTextures()
end

return ResourceUtil