local scheduler = require("framework.scheduler")
local CommUtil = require("app.common.CommUtil")
local AnimationFactory = require("app.factory.AnimationFactory")
local DebugUtil = require("app.common.DebugUtil")
local NPC = require("app.actor.NPC")
local HeroSkill = require("app.bullet.HeroSkill")

local BattleStoryPlay = class("BattleStoryPlay",function()
		return display.newNode()
end)

function BattleStoryPlay:ctor(gameScene)
	--gameScene.storyOver = true
	--if true then return end
	
	lastHelpSceneId = gBattle.data.home_scene_id
	
	self.countTime = 0--计时器
	self.currentIndex = 1 --记录遍历当前事件的索引
	self.gameScene = gameScene
	self.gameScene.storyOver = false

	self.storys = require("app.client.desc.StoryOfBattle")[gBattle.data.home_pass_id]

	if self.storys==nil then
		--print("故事情节为空",gBattle.data.home_pass_id)
		self.gameScene.storyOver = true
		return
	else
		self.eventsNumber = #self.storys
	end
	
	------------------------------------------预加载资源----------------------------------------------------
	addRes(self.gameScene.parent.name,"ui/altar/crane.plist","ui/altar/crane.pvr.ccz")
	
	local hero_template = require("app.client.template.hero_template")

	local getSkillId = function(roleId)
		for j=1,#hero_template do
        	local hTemplate = hero_template[j]
            local skillId = hTemplate[19]
            if roleId==hTemplate[1] then
            	return skillId
            	--resourceList[#resourceList+1]={"ani/pve/skill/skill_"..skillId..".plist","ani/pve/skill/skill_"..skillId..".pvr.ccz"}  
            end
        end
	end
	local skillIds = {}
	for i = self.currentIndex,self.eventsNumber, 1 do
		local roleType = self.storys[i][5]
		local roleId = self.storys[i][6]
		if roleType==1 then
			skillIds[#skillIds+1] = getSkillId(roleId)
		end
	end

	for i=1,#skillIds do
		addRes(self.gameScene.parent.name,"ani/pve/skill/skill_"..skillIds[i]..".plist","ani/pve/skill/skill_"..skillIds[i]..".pvr.ccz")
	end

	if gBattle.data.home_pass_id<=60010 and gPlayer.data.pve_pass_id==gBattle.data.home_pass_id then
		addRes(self.gameScene.parent.name,"ani/pve/skill/skill_41001.plist","ani/pve/skill/skill_41001.pvr.ccz")
	end

	------------------------------------------预加载资源----------------------------------------------------

	self:init()

	-----------------------------------找出空的塔位点----------------------------------------
	local findEmptyTower = function()
		local emptyTowers = {}
		for i=0,GameInstance:sharedInstance().towers:count()-1 do
	    	local tower = GameInstance:sharedInstance().towers:objectAtIndex(i)
	    	if not tower:ifBuild() and i~=0 then
	    		emptyTowers[#emptyTowers+1] = i
	    	end
	    end
	    return emptyTowers
	end
	-----------------------------------找出空的塔位点----------------------------
	self.emptyTowers = findEmptyTower()
	self:schedule(handler(self, self.onSchedule),0.1)
	helpTowerPositions = {}


	--[[
	if gBattle.data.home_pass_id==60001 and gPlayer.data.pve_pass_id==gBattle.data.home_pass_id then---必须请猴哥来出战
		self.ifHougeComeing = false
		local getHelp = function()
			if self.ifHougeComeing then return end
			if 20-totalHP>=1 then
				self:houGeComing("俺老孙来了")
				self.ifHougeComeing = true
			end
		end
		self:schedule(getHelp,1)
		self:performWithDelay(function()
			if self.ifHougeComeing then return end
			self:houGeComing("俺老孙来了")
			self.ifHougeComeing = true
		end,90)
	end

	if gBattle.data.home_pass_id==60002 and gPlayer.data.pve_pass_id==gBattle.data.home_pass_id then
		self.gameScene:softGuide(1)
	end

	if gBattle.data.home_pass_id<=60009 and gPlayer.data.pve_pass_id==gBattle.data.home_pass_id and gBattle.data.home_pass_id~=60001 then---必须请猴哥来出战
		local texts = {"俺老孙又来了","休想抢走补天石"}
		self:houGeComing(texts[math.random(1,#texts)])
	end]]


end

function BattleStoryPlay:houGeComing(txt)
	self.gameScene:pause()
	local towerIndex = 0
	local tower = GameInstance:sharedInstance().towers:objectAtIndex(towerIndex)
	helpTowerPositions[#helpTowerPositions+1] = tower:getIdInTileMap()
	tower:heroRideBirdToScene(10201,txt)
	self:performWithDelay(function()
		self.gameScene:resume()
		local releaseSkill = function()
			if GameInstance:sharedInstance().towers:count()<=0 then return end
			local tower = GameInstance:sharedInstance().towers:objectAtIndex(towerIndex)
			local monster = self.gameScene.gameLogicLayer:getTargetForTower(tower)
	        	if monster~=nil then
	        		self:seecialFire(tower,monster)
	        		tower.damaged = true
	        		tower:stopAllActions()
	        		tower.cooldown = false
	        		scheduler.performWithDelayGlobal(function()
	        			tower.damaged = false
    				end,2)
	        	else
	        		--print("附近没有怪物或者怪物已经死了")
	        	end
		end
		self:schedule(releaseSkill,3)
	end,1.5)
end

function BattleStoryPlay:init()
	self:newCat()
end

function BattleStoryPlay:newCat()
	local npcData = {coolDownTime=100,npcType=5,body_id="npc_1026",move_speed = 10,walk_animation_time=0.5,scale = 0.6,name="猫叔"}
	local npcProperties = {
	        npcType = npcData.npcType,
	        move_speed = npcData.move_speed,
	        body_id = npcData.body_id,
	        position = ccp(display.cx,display.cy),
	        move_speed = npcData.move_speed,
	        walk_animation_time = npcData.walk_animation_time,
	        scale = npcData.scale,
	        offset = 0,
	        words = word,
	        coolDownTime = npcData.coolDownTime,
	}

	if gBattle.data.home_pass_id==60001 then
		local zorder = GameInstance:sharedInstance():zorderForPosition(ccp(display.cx,display.cy))
		local path = tolua.cast(GameInstance:sharedInstance().paths:objectAtIndex(0),"CCArray")
		local npc = NPC.new(self.gameScene,npcProperties,path,true,false,false,true)
		self.gameScene.npc = npc
		npc.curWaypoint = 5
		local waypoint = tolua.cast(npc._waypoints:objectAtIndex(npc.curWaypoint+1),"WayPoint")
		npc:setPosition(waypoint.position.x,waypoint.position.y)
		self.gameScene:addChild(npc,zorder)
		npc.mainSprite:setFlipX(true)
	else
		local path = tolua.cast(GameInstance:sharedInstance().paths:objectAtIndex((GameInstance:sharedInstance().paths:count()-1)),"CCArray")
		local spawnPoint = tolua.cast(path:objectAtIndex(1),"WayPoint")
		local xPos = spawnPoint.position.x + CommUtil.getBlankWidth()
	    local yPos = spawnPoint.position.y

		local zorder = GameInstance:sharedInstance():zorderForPosition(ccp(xPos,yPos))
		
	    local npc = NPC.new(self.gameScene,npcProperties,path,true,false,false,true)
	    npc:setPosition(xPos,yPos)
		self.gameScene:addChild(npc,zorder)
		npc:stopAllActions()
		npc.mainSprite:stopAllActions()
		local imageName = "npc_1026_jump_front_%d.png"
	    local frames = display.newFrames(imageName, 1,8)
	    local animation = display.newAnimation(frames, 1 / 8)
        npc.mainSprite:playAnimationForever(animation)
        npc.mainSprite:setFlipX(true)
		self.gameScene.npc = npc
	end
	
	
end

function BattleStoryPlay:onSchedule()
	if pauseStatus then 
		return
	end

	if self.gameScene.storyOver then
		return
	end

	if theLastMonster and GameInstance:sharedInstance().monsters:count()<=0 then--胜利
        if self.currentIndex<self.eventsNumber then
        	self.currentIndex=self.eventsNumber
        end
    end

	if  self.currentIndex==self.eventsNumber and self.storys[self.currentIndex][3]==-1 and theLastMonster and GameInstance:sharedInstance().monsters:count()<=0 and self.confirmBtn==nil then
		local time = self.storys[self.currentIndex][3]
		local ifPause = self.storys[self.currentIndex][4]==1 and true or false
		local roleType = self.storys[self.currentIndex][5]
		local roleId = self.storys[self.currentIndex][6]
		local px = self.storys[self.currentIndex][7]
		local py = self.storys[self.currentIndex][8]
		local text = self.storys[self.currentIndex][9]
		local toDoAction = self.storys[self.currentIndex][10]

		if ifPause then
			self.gameScene:pause()
		end
		if toDoAction==4 then--弹出一张图片
			local tipSprite = display.newSprite("ui/guide/guide_occupation.png",display.cx,display.cy):addTo(display.getRunningScene(),6000)
			self.confirmBtn = display.newSprite("ui/guide/guide_button_know_normal.png",display.cx-90,-3):addTo(tipSprite)
			self.confirmBtn:setTouchEnabled(true)
			self.gameScene.storyOver = true
			self.confirmBtn:addTouchEventListener(function(event, x, y)
			if event == "began" then
				tipSprite:removeSelf()
				self.gameScene:resume()

				return true
			end
			end)
		elseif toDoAction==11 then----------弹出图片
			local tipSprite = display.newSprite("ui/guide/guide_raremonster.png",display.cx,display.cy):addTo(display.getRunningScene(),6000)
			self.confirmBtn = display.newSprite("ui/guide/guide_button_know_normal.png",display.cx-90,-3):addTo(tipSprite)
			self.confirmBtn:setTouchEnabled(true)
			self.gameScene.storyOver = true
			self.confirmBtn:addTouchEventListener(function(event, x, y)
			if event == "began" then
				tipSprite:removeSelf()
				self.gameScene:resume()

				return true
			end
			end)
		elseif toDoAction==0 then
			self.gameScene.storyOver = true
			self:performWithDelay(function()
				self.gameScene:resume()
			end,2)

			if roleType==1 then--英雄
				self:doHeroAction(roleId,text,toDoAction)
			elseif roleType==2 then--怪物
				self:doMonsterAction(roleId,text,toDoAction)
			elseif roleType==3 then--npc
				self:doNpcAction(text,toDoAction)
			elseif roleType==4 then--妖姬
				self:doBeautyAction(text,toDoAction)
			end
		end


		return
	end

	self.countTime = self.countTime  + 0.1

	for i = self.currentIndex,self.eventsNumber, 1 do

		local desc = self.storys[i][1]
		local func = self.storys[i][2]
		local time = self.storys[i][3]
		local ifPause = self.storys[i][4]==1 and true or false
		local roleType = self.storys[i][5]
		local roleId = self.storys[i][6]
		local px = self.storys[i][7]
		local py = self.storys[i][8]
		local text = self.storys[i][9]
		local toDoAction = self.storys[i][10]

		--local countTimeStr = string.format("%.0f",self.countTime)
		--print("countTimeStr",countTimeStr)

		local diff = time-self.countTime

		if diff>=0 and diff<0.1 then
			--print("第几个",i,countTimeStr,time)
			if ifPause then
				self.gameScene:pause()
				self:performWithDelay(function()
					self.gameScene:resume()
				end,2)
			end
			if roleType==1 then--英雄
				self:doHeroAction(roleId,text,toDoAction)
			elseif roleType==2 then--怪物
				self:doMonsterAction(roleId,text,toDoAction)
			elseif roleType==3 then--npc
				self:doNpcAction(text,toDoAction)
			elseif roleType==4 then--妖姬
				self:doBeautyAction(text,toDoAction)
			end
			self.currentIndex = self.currentIndex + 1
			if self.currentIndex>self.eventsNumber then
				self.gameScene.storyOver = true
			end
			return
		end
	end
end

function BattleStoryPlay:doBeautyAction(txt,toDoAction)

	if self.bubble then
		self.bubble:removeSelf()
    	self.bubble = nil
	end
	local beautyPoint = tolua.cast(GameInstance:sharedInstance().beautyPoint,"WayPoint")
	local posX = 0
	local posY = 0
	local flipY = false
	if gBattle.data.home_scene_id == 603 then
        posX = beautyPoint.position.x+CommUtil.getBlankWidth()-50
        posY = beautyPoint.position.y-50
        flipY = true
      else
        posX = beautyPoint.position.x+CommUtil.getBlankWidth()-50
        posY = beautyPoint.position.y+45
      end
	self.bubble = display.newSprite("ui/public/public_dialog_box.png",posX,posY)
	self.bubble:setFlipX(true)
	self.bubble:setFlipY(flipY)
   	self:addChild(self.bubble,50001)
    self.words = ui.newTTFLabel({
                text = txt,
                font = "Arial",
                color = ccc3(0, 0, 0),
                x = -40,
                y = 10,
                size = 14,
                dimensions = CCSize(135,120),
                align = ui.TEXT_ALIGN_LEFT
    })
    self.words:setAnchorPoint(ccp(0,0))
    self.bubble:addChild(self.words)
    self:performWithDelay(function()
    	if self.bubble then
    		self.bubble:removeSelf()
    		self.bubble = nil
    	end
    end,2)

	if toDoAction==5 then--解锁勾魂野
		self.gameScene.forceGuide = false
		self:performWithDelay(function()
			self.gameScene:unLockSkill(3)
		end,2)
	elseif toDoAction==6 then
		self.gameScene.forceGuide = false
        self:performWithDelay(function()
			self.gameScene:unLockSkill(2)
		end,2)
	elseif toDoAction==7 then
		self.gameScene.forceGuide = false
        self:performWithDelay(function()
			self.gameScene:unLockSkill(1)
		end,2)
	elseif toDoAction==8 then
		self.gameScene.forceGuide = false
        self:performWithDelay(function()
			self.gameScene:unLockSkill(4)
		end,2)
    end
end

function BattleStoryPlay:doHeroAction(roleId,text,toDoAction)
    if toDoAction==3 then--入驻英雄
	    self:sendHeroToTower(roleId,text)
	elseif toDoAction==0 then--只是普通的说话
		for i=0,GameInstance:sharedInstance().towers:count()-1 do
	    	local tower = GameInstance:sharedInstance().towers:objectAtIndex(i)
	    	if tower:getHeroId()==roleId then
	    		tower:addBubbleAndWords(text)
	    		self:performWithDelay(function()
	    			tower:removeBubble()
	    		end,2)
	    	end
	    end
	elseif toDoAction==9 then--禁止英雄释放技能
		for i=0,GameInstance:sharedInstance().towers:count()-1 do
	        local tower = GameInstance:sharedInstance().towers:objectAtIndex(i)
	        tower.forbidSkill = true
	    end
	elseif toDoAction==10 then--恢复英雄释放技能
		for i=0,GameInstance:sharedInstance().towers:count()-1 do
	        local tower = GameInstance:sharedInstance().towers:objectAtIndex(i)
	        if tower:getHeroId()==roleId then
	        	local monster = self.gameScene.gameLogicLayer:getTargetForTower(tower)
	        	if monster~=nil then
	        		self:seecialFire(tower,monster)
	        		tower.damaged = true
	        		tower:stopAllActions()
	        		tower.cooldown = false
	        		scheduler.performWithDelayGlobal(function()
	        			tower.damaged = false
    				end,2)
	        	else
	        		--print("附近没有怪物或者怪物已经死了")
	        	end
	    		return
	    	end
	    end
    end
end

function BattleStoryPlay:seecialFire(tower,monster)
	tower.target = monster
    local frontOrBack = nil
    local leftOrRight = nil

    if monster:getPositionX()<tower:getPositionX() then
        if monster:getPositionY()<tower:getPositionY() then
            frontOrBack = "front"
            leftOrRight = "l"
        else
            frontOrBack = "back"
            leftOrRight = "l"
        end
    else
        if monster:getPositionY()<tower:getPositionY() then
            frontOrBack = "front"
            leftOrRight = "r"
        else
            frontOrBack = "back"
            leftOrRight = "r"
        end
    end
    local attack_speed = Attributes.get_atk_spd(tower:getAttackSpeed(),true)
    self:fire(tower,monster,attack_speed,frontOrBack,leftOrRight)
    local imageName = "hero_"..tower:getHeroId().."_".."attack".."_"..frontOrBack.."_1.png"
    local spriteFrame = display.newSpriteFrame(imageName)
    tower.hero:setDisplayFrame(spriteFrame)
    if leftOrRight=="r" then
        tower.hero:setFlipX(false)
    else
        tower.hero:setFlipX(true)
    end
end


function BattleStoryPlay:fire(tower,monster,attack_speed,frontOrBack,leftOrRight)
	tower:addSkillWord(function()
   	local checkSpecialZorder = function(sid)
    local skills = {"41009","41002","41003","41007","41008","41010","41011","41012","41015","41016","42016","42019"}
    for i=1,#skills do
    	if tostring(sid)==skills[i] then
        	return true
        end
    end
    	return false
    end
                        local zorder = nil
                        if checkSpecialZorder(tower:getSkillId()) then
                            zorder = 5000
                        elseif tostring(tower:getSkillId())=="42017" then
                            zorder = 1
                        elseif tostring(tower:getSkillId())=="42002" then
                            zorder = GameInstance:sharedInstance():zorderForPosition(ccp(monster:getPositionX(),monster:getPositionY()))
                        else
                            zorder = GameInstance:sharedInstance():zorderForPosition(ccp(monster:getPositionX(),monster:getPositionY()-30))
                        end
                        self.gameScene:addChild(HeroSkill.new(self.gameScene,tower:getSkillId(),tower,monster),zorder)
    end)
end

function BattleStoryPlay:sendHeroToTower(heroId,text)
	local towerIndex = self.emptyTowers[1]
	table.remove(self.emptyTowers,1)
	local tower = GameInstance:sharedInstance().towers:objectAtIndex(towerIndex)
	helpTowerPositions[#helpTowerPositions+1] = tower:getIdInTileMap()
	tower:heroRideBirdToScene(heroId,text)
end

function BattleStoryPlay:doMonsterAction(roleId,text,toDoAction)
	for i=0,GameInstance:sharedInstance().monsters:count()-1 do
		local monster = GameInstance:sharedInstance().monsters:objectAtIndex(i)
        if monster.attackerProperties.id==roleId then
        	monster:addBubbleAndWords(text)
        	return
        end
    end
end

function BattleStoryPlay:doNpcAction(text,toDoAction)
	if toDoAction==1 then
		self.gameScene.npc:addBubbleAndWords(text)
		if gBattle.data.home_pass_id==60001 then
			self.gameScene.npc:aGoodWeather()
		else
			self.gameScene.npc:leftToRightCycle()
		end
	elseif toDoAction==2 then
		self.gameScene.npc:addBubbleAndWords(text)
		self.gameScene.npc:runToDestionation()
	elseif toDoAction==12 then
		self.gameScene:guideFocus(1)
	end
end


return BattleStoryPlay