
local DebugUtil = require("app.common.DebugUtil")
local CommUtil = require("app.common.CommUtil")
local HeroSkill = require("app.bullet.HeroSkill")
local AnimationFactory = require("app.factory.AnimationFactory")
local BulletFactory = require("app.factory.BulletFactory")
local scheduler = require(cc.PACKAGE_NAME .. ".scheduler")
local MathUtil = require("app.common.MathUtil")
local Rect = require("app.quadTree.Rect")
local GameLogic = require("app.controllers.GameLogic")


local BossGameLogic = class("BossGameLogic",GameLogic)


function BossGameLogic:checkWinOrLose()
end

function BossGameLogic:onSchedule()
    if pauseStatus or self.gameOver or self.gameScene.quadTree==nil then return end
    --self:updateMonsterGridIndexs()
    self.countTime = self.countTime + 0.5
    local t1,t2 = math.modf(self.countTime/2)
    if t2==0 then
        --print("可以更新怪物的gridIndex")
        --[[
        if self.gameScene.skillPanel then
            self.gameScene.skillPanel.touchable = true
        end
        if self.gameScene.parent.resumeBtn then
            self.gameScene.parent.resumeBtn:setVisible(false)
            self.gameScene.parent.pauseBtn:setVisible(true)
        end]]
        for i=0,GameInstance:sharedInstance().monsters:count()-1 do
            local monster = GameInstance:sharedInstance().monsters:objectAtIndex(i)
            monster:updateGridIndex()
        end
    end
    for i=0,GameInstance:sharedInstance().towers:count()-1 do
        local tower = GameInstance:sharedInstance().towers:objectAtIndex(i)
        if (not tower.damaged) and (not tower.cooldown) and (not tower.frozened)then
            --print("gameScene.rects的大小是",#self.gameScene.rects)
            local targetMonster = self:getTargetForTower(tower)
            if targetMonster~=nil then
                self:playAttackAnimation(tower,targetMonster)
            else
                --print("没有找到目标")
            end
        else
            --print("cd时间中")
        end
    end
end

return BossGameLogic