local MonsterFactory = require("app.factory.MonsterFactory")
local scheduler = require("framework.scheduler")
local CommUtil = require("app.common.CommUtil")
local AnimationFactory = require("app.factory.AnimationFactory")

local monster_template = nil


local DebugUtil = require("app.common.DebugUtil")
local CommUtil = require("app.common.CommUtil")
local ColorTxt = import("app.ui.ColorText")


local CycleWaveManager = class("CycleWaveManager",function()
		return display.newNode()
end)

function CycleWaveManager:ctor(gameScene)
	pauseStatus = false
	monster_template = require("app.client.template.monster_template")
	self.gameScene = gameScene
	currentDiDa = gParameterTemplate.data.initial_energy--技能面板初始能量值
    
    local world = require("app.client.template.map_557_template")
    if gBoss.data.boss_type==1 then
    	self.sceneData = world[702][71001]
    elseif gBoss.data.boss_type==0 then
    	self.sceneData = world[702][71002]
    end
    bossDecreaseTotalHP = 0

    self.totalMonsterNums = #self.sceneData
    --预加载怪物资源--------------------------------------------------------------------------------------------
    self.monsterProperties = {}
    monsterBodyIdArray = {}
    for i = 1,self.totalMonsterNums, 1 do
    	local monsterid = self.sceneData[i][5]
    	local bodyId = self:getBodyId(monsterid)
    	self:initMonsterProperties(monsterid)
    	if self:ifExistsInTable(monsterBodyIdArray,bodyId) then
    	else
    		monsterBodyIdArray[#monsterBodyIdArray+1]=bodyId
    	end
	end
	--for i=1,#monsterBodyIdArray ,1 do
	--	addRes(self.gameScene.parent.name,"ani/pve/monster/monster_"..monsterBodyIdArray[i]..".plist","ani/pve/monster/monster_"..monsterBodyIdArray[i]..".pvr.ccz")
	--end
    -------------------------------------------------------------------------------------------------------------
    local bg = display.newSprite("ui/public/public_evil_bg.png",display.left+170,display.top-20):addTo(self,50001)
	self.timeText = ui.newBMFontLabel({
        text= "",
        x= 150,
        y= 22,
        font = "fonts/number1.fnt",
    }):addTo(bg)
    display.newSprite("ui/public/public_evil_text_3.png",60,20):addTo(bg)


    self.damageText = CommUtil.addBossTodayData(self.gameScene,5000)

    --[[local textBg = display.newSprite("ui/public/public_edit.png",display.left+200,display.top-40):addTo(self.gameScene,50001)
    self.timeText1 = ui.newTTFLabel({
		text = "本关剩余时间:",
		font = "Arial",
		size = 20,
		color = ccc3(255, 0, 0),
		x = 70,
		y=14
	}):addTo(textBg)]]
	--[[
	self.timeText = ui.newTTFLabel({
        text = "",
        font = "Arial",
        size = 20,
		color = ccc3(255, 0, 0),
        x= 150,
        y= 22,
    }):addTo(bg)
	self.timeText1 = ui.newBMFontLabel({
		text = "本关剩余时间:",
		font = "fonts/bossCountDown.fnt",
		x = display.cx+130,
		y = display.top-20
	}):addTo(self.gameScene,50001)
    self.timeText = ui.newBMFontLabel({
        text = "",
        font = "fonts/bossCountDown.fnt",
        x = 255,
        y=13
    }):addTo(textBg)]]
	self.currentWave = 1 -- 当前波数
	self.currentWaveMonsterNum = 1--当前的波数已经出现的怪物数
	self:schedule(handler(self, self.onSchedule),0.1)
	self.seconds = 0
	self:schedule(handler(self, self.frozenTower),1)
	--self:schedule(handler(self, self.deleteTower),30)

	self.countTime = 0--计时器
	self.currentWave = 1
	self.currentWaveMonsterNum = 1
	
	theLastMonster = false
	
	self.currentIndex = 1 --记录当前场景的已经出场怪物的顺序标志

	totalWaveNum = self.sceneData[self.totalMonsterNums][1]
	currentWaveNum = self.sceneData[1][1]
	totalHP = 10
	havePlayedTime = 0
	
	self:onSchedule()

	self.coolDown = false

	self.isBoss = self.sceneData[1][7]==1 and true or false

end

function CycleWaveManager:initMonsterProperties(monsterid)
	for i = 1,#monster_template, 1 do
		if monster_template[i][1]==monsterid then
			self.monsterProperties[monsterid] = monster_template[i]
			return
		end
	end
end

function CycleWaveManager:getMonsterProperties(monsterid)
	--[[
	for i = 1,#monster_template, 1 do
		if monster_template[i][1]==monsterid then
			return  monster_template[i]
		end
	end
	local bodyId = self:getBodyId(monsterid)
	--print("没有取到怪物属性的bodyId和monsterId是",monsterid,bodyId)]]
	return self.monsterProperties[monsterid]
end

function CycleWaveManager:getBodyId(monsterid)
	for i = 1,#monster_template, 1 do
		if monster_template[i][1]==monsterid then
			return  monster_template[i][13]
		end
	end
end

function CycleWaveManager:ifExistsInTable(bodyIdArray,bodyId)
	for i = 1,#bodyIdArray, 1 do
		if bodyIdArray[i]==bodyId then
			return true
		end
	end
	return false
end

function CycleWaveManager:deleteTower() 
	if pauseStatus then 
		return
	end
	if self.gameScene.gameLogicLayer and self.gameScene.gameLogicLayer.gameOver then
		return
	end
	self.gameScene:deleteOneTowerByBoss()
end

function CycleWaveManager:frozenTower()
	self.seconds = self.seconds + 1
	if self.seconds==25 or self.seconds==55 or self.seconds==85 then
		self.gameScene:frozenTower()
	end
end

function CycleWaveManager:onSchedule() 
	if pauseStatus then 
		return
	end
	if self.gameScene.gameLogicLayer and self.gameScene.gameLogicLayer.gameOver then
		return
	end

	if (self.damageText~=nil) then
		self.damageText:setString(gBoss.data.me_damage+math.ceil(bossDecreaseTotalHP))
	end


	havePlayedTime = havePlayedTime + 0.1

	local savedTime = 120-havePlayedTime
	local minutes,seconds = math.modf(savedTime/60)
	self.timeText:setString(string.format("%02d:%02d",minutes,math.floor(seconds*60)))
	if savedTime<=0 then
		self.timeText:setString(string.format("%02d:%02d",0,0))
		self.gameScene.gameLogicLayer.gameOver = true
		self.gameScene:bossActitiesOver()
		return
	end
	if self.coolDown then 
		return
	end
	
	self.countTime = self.countTime  + 0.1

	for i = self.currentIndex,self.totalMonsterNums, 1 do
		local round = self.sceneData[i][1]
		local born = self.sceneData[i][4]
		local monsterid = self.sceneData[i][5]
		local way = self.sceneData[i][6]
		local specialFlag = self.sceneData[i][8]
		if CommUtil.isMoreHarderPass() and way==self.selectReorderedWay then
			way = GameInstance:sharedInstance().paths:count()
		end
		local num = self.sceneData[i][2]

		local j = i + 1
		local nextMonsterData = self.sceneData[j]
		if nextMonsterData~=nil then

			local nextMonsterRound = nextMonsterData[1]

			if nextMonsterRound==currentWaveNum+1 then

				--print("++++++++++++++++",self.currentIndex,nextMonsterRound,currentWaveNum)
				--print("----------------",self.currentIndex,j,i)

				local totalWayCount = GameInstance:sharedInstance().paths:count()
				if way>totalWayCount then way=1 end

				if tostring(self.countTime)== tostring(born) and round==currentWaveNum then
					--print("born2",born,self.countTime,i,self.currentIndex)
					local monsterProperties = self:getMonsterProperties(monsterid)
					if monsterProperties~=nil then
						--print("第几波",round,self.currentIndex)
						MonsterFactory.produceMonsterInCycleWay(self.gameScene,monsterProperties,way,self.isBoss,specialFlag)
						self.isBoss = false
						local nextMonsterIndex = self.currentIndex + 1
						if nextMonsterIndex<=self.totalMonsterNums then
							local isBoss = self.sceneData[nextMonsterIndex][7]==1 and true or false
							self.isBoss = isBoss
						end
					end
					self.currentIndex = self.currentIndex + 1

					--print("5秒钟后下一波了")
					if self.speedUpSprite~=nil then
						self.speedUpSprite:setVisible(true)
						self.coolDown = true
						local nextMonsterWay = nextMonsterData[6]
						local path = tolua.cast(GameInstance:sharedInstance().paths:objectAtIndex((nextMonsterWay-1)),"CCArray")
						local speedUpSpriteWayPoint = tolua.cast(path:objectAtIndex(0),"WayPoint")
						local xPos = speedUpSpriteWayPoint.position.x + CommUtil.getBlankWidth()
	    				local yPos = speedUpSpriteWayPoint.position.y + 20
	    				self.speedUpSprite:setPosition(xPos,yPos)
					end

					local tempWaveNum = currentWaveNum
					self:performWithDelay(function()
						if currentWaveNum> tempWaveNum then
							--print("已经通过按钮实现了")
						else
							--print("还是通过我来生成下一波吧")
							currentWaveNum = currentWaveNum + 1
							self.gameScene:updateWave()
							self.countTime= 0
							self.coolDown = false
							if self.speedUpSprite~=nil then self.speedUpSprite:setVisible(false) end
						end
					end,5)
					return
				end
				
			elseif nextMonsterRound<currentWaveNum+1 then
				local totalWayCount = GameInstance:sharedInstance().paths:count()
				if way>totalWayCount then way=1 end
				if tostring(self.countTime)== tostring(born) and round==currentWaveNum then
					--print("born1",born,self.countTime,i,self.currentIndex)
					local monsterProperties = self:getMonsterProperties(monsterid)
					if num==1 then
						--print("鸽子，更新薄叔了")
						currentWaveNum = self.sceneData[self.currentIndex][1]
						self.gameScene:updateWave()
						if currentWaveNum==1 then
							if self.guideSkill then
								self:performWithDelay(function()
									self.gameScene:releaseSkill(currentWaveNum)
								end,2)
							end
						end
					end
					if monsterProperties~=nil then
						MonsterFactory.produceMonsterInCycleWay(self.gameScene,monsterProperties,way,self.isBoss,specialFlag)
						self.isBoss = false
						local nextMonsterIndex = self.currentIndex + 1
						if nextMonsterIndex<=self.totalMonsterNums then
							local isBoss = self.sceneData[nextMonsterIndex][7]==1 and true or false
							self.isBoss = isBoss
						end
						--print("第几波",round,self.currentIndex)
					end
					self.currentIndex = self.currentIndex + 1
				end
			else
				--print("越界了")
			end

		else
			--print("本波最后一个怪物最后一个了阿")
			local totalWayCount = GameInstance:sharedInstance().paths:count()
			if way>totalWayCount then way=1 end

			if tostring(self.countTime)== tostring(born) and round==currentWaveNum then
				local monsterProperties = self:getMonsterProperties(monsterid)
				if self.sceneData[self.currentIndex][1] > currentWaveNum then
					currentWaveNum = self.sceneData[self.currentIndex][1]
					self.gameScene:updateWave()
				end
				if monsterProperties~=nil then
					MonsterFactory.produceMonsterInCycleWay(self.gameScene,monsterProperties,way,self.isBoss,specialFlag)
					self.isBoss = false
					--print("第几波",round,self.currentIndex)
					local nextMonsterIndex = self.currentIndex + 1
					if nextMonsterIndex<=self.totalMonsterNums then
						local isBoss = self.sceneData[nextMonsterIndex][7]==1 and true or false
						self.isBoss = isBoss
					end
				end
				self.currentIndex = self.currentIndex + 1
			end
		end
	end
	if self.currentIndex>self.totalMonsterNums then
		theLastMonster = true
	end
end

return CycleWaveManager