
local DebugUtil = require("app.common.DebugUtil")
local CommUtil = require("app.common.CommUtil")
local HeroSkill = require("app.bullet.HeroSkill")
local AnimationFactory = require("app.factory.AnimationFactory")
local BulletFactory = require("app.factory.BulletFactory")
local scheduler = require(cc.PACKAGE_NAME .. ".scheduler")
local MathUtil = require("app.common.MathUtil")
local Rect = require("app.quadTree.Rect")
local GameLogic = require("app.controllers.GameLogic")


local PVEGameLogic = class("PVEGameLogic",GameLogic)

function PVEGameLogic:getTargetForTower(tower)
    --print("tower的rangeIndex是",#tower.gridIndexs)
    if not tolua.isnull(self.gameScene.focusMonster) and self.gameScene.focusMonster~=nil and not self.gameScene.focusMonster.dead then
        if self:towerCanAttackMonster(tower,self.gameScene.focusMonster) then--必须能够攻击此怪物才可以,地怪，飞行怪
            local curx,cury,size = self.gameScene.focusMonster:getCenterPointInWorld(self.gameScene.focusMonster:getPositionX(),self.gameScene.focusMonster:getPositionY())
            local distance = ccpDistance(ccp(curx,cury),ccp(tower:getPositionX(),tower:getPositionY()))
            local range = tower:getRange()
            if distance<range then
                return self.gameScene.focusMonster
            end
        end
    end
    local everTarget = tower.target
    if not tolua.isnull(everTarget) and everTarget~=nil and not everTarget.dead then
        local curx,cury,size = everTarget:getMonsterPositionAfterTowerAnimation(0.4)
        local distance = ccpDistance(ccp(curx,cury),ccp(tower:getPositionX(),tower:getPositionY()))
        local range = tower:getRange()
        if distance<range then
            return everTarget
        end
    end
    local targetMonster = nil
    local lastDistance = 0--此前的最短距离
    local num = 0
    for i=1,#tower.gridIndexs do
        local gridIndex = tower.gridIndexs[i]
        local monsters = self.gameScene.quadTree.grids[gridIndex]
        for k, v in ipairs(monsters) do
            num = num + 1 
            if not tolua.isnull(v) and v~=nil and not v.dead and self:towerCanAttackMonster(tower,v) then
                local curx,cury,size = v:getMonsterPositionAfterTowerAnimation(0.4)
                if targetMonster~=nil then
                    local distance = ccpDistance(ccp(curx,cury),ccp(tower:getPositionX(),tower:getPositionY()))
                    local range = tower:getRange()
                    if distance<range then
                        --local dist1 = v.curWaypoint
                        --local dist2 = targetMonster.curWaypoint
                        local waypoint = tolua.cast(v._waypoints:objectAtIndex(v._waypoints:count()-1),"WayPoint")
                        tolua.cast(waypoint.position,"CCPoint")
                        local dist = ccpDistance(ccp(curx,cury),waypoint.position)
                        if dist < lastDistance then
                            targetMonster = v
                            lastDistance = dist
                        end 
                    end
                else
                    local distance = ccpDistance(ccp(curx,cury),ccp(tower:getPositionX(),tower:getPositionY()))
                    local range = tower:getRange()
                    if distance<range then
                        targetMonster = v
                        local waypoint = tolua.cast(targetMonster._waypoints:objectAtIndex(targetMonster._waypoints:count()-1),"WayPoint")
                        tolua.cast(waypoint.position,"CCPoint")
                        lastDistance = ccpDistance(ccp(curx,cury),waypoint.position)
                    end
                end
            end
        end
    end
    --print("检测了多少个怪物",num,GameInstance:sharedInstance().monsters:count())
    return targetMonster
end

return PVEGameLogic