local MonsterFactory = require("app.factory.MonsterFactory")
local scheduler = require("framework.scheduler")
local CommUtil = require("app.common.CommUtil")
local AnimationFactory = require("app.factory.AnimationFactory")
local BattleUtil = require("app.new.BattleUtil")

local monster_template = nil


local DebugUtil = require("app.common.DebugUtil")
local CommUtil = require("app.common.CommUtil")
local ColorTxt = import("app.ui.ColorText")


local PveWaveManager = class("PveWaveManager",function()
		return display.newNode()
end)

function PveWaveManager:ctor(gameScene,activityName)
	--if true then return end
	pauseStatus = false
	if CommUtil.isMoreHarderPass() then
		monster_template = require("app.client.template.monster_h_template")
		
		local getTheReorderWay = function()
			local wayCount = GameInstance:sharedInstance().paths:count()
			local reorderedWay = math.random(1,wayCount-1)--选定的乱路
			while reorderedWay==4 or reorderedWay==8 or reorderedWay==12 or reorderedWay==16 do--不能反着的路
				reorderedWay = math.random(1,wayCount-1)--选定的乱路
			end
			return reorderedWay
		end
		self.selectReorderedWay = getTheReorderWay()
	else
		monster_template = require("app.client.template.monster_template")
	end
	
	--print("这个的乱路是",self.selectReorderedWay)
	self.isBoss = false
	self.gameScene = gameScene
	
	

	self.guideSkill = false
	self.activityName = activityName

	print("+++++++++++++++++++++++++++++++++++++++++++++")
   		print("gBattle.data.home_scene_id",self.gameScene.args.worldId,self.gameScene.args.sceneId,self.gameScene.args.passId)
    print("+++++++++++++++++++++++++++++++++++++++++++++")
    --display.replaceScene(require("app.scenes.BattleScene").new(nil,{worldId=501,sceneId=601,passId=60001})
    local world = require("app.client.template.map_"..self.gameScene.args.worldId.."_template")
    self.sceneData = world[self.gameScene.args.sceneId][self.gameScene.args.passId]
    
    if self.sceneData == nil then
   		--self.sceneData = world[611][60056]
    end

    self.totalMonsterNums = #self.sceneData

    --预加载怪物资源--------------------------------------------------------------------------------------------
    self.monsterProperties = {}
    monsterBodyIdArray = {}
    for i = 1,self.totalMonsterNums, 1 do
    	local monsterid = self.sceneData[i][5]
    	local bodyId = self:getBodyId(monsterid)
    	self:initMonsterProperties(monsterid)
    	if self:ifExistsInTable(monsterBodyIdArray,bodyId) then
    	else
    		monsterBodyIdArray[#monsterBodyIdArray+1]=bodyId
    	end
	end
	--for i=1,#monsterBodyIdArray ,1 do
	--	addRes(self.gameScene.parent.name,"monster/monster_"..monsterBodyIdArray[i]..".plist","monster/monster_"..monsterBodyIdArray[i]..".pvr.ccz")
	--end
    -------------------------------------------------------------------------------------------------------------
	self.currentWave = 1 -- 当前波数
	self.currentWaveMonsterNum = 1--当前的波数已经出现的怪物数
	self:schedule(handler(self, self.onSchedule),0.5)

	--self.batchNode = CCSpriteBatchNode:create("ani/pve/monster/monster1.pvr.ccz")
	--gameScene:addChild(self.batchNode,4000)

	self.countTime = 0--计时器
	self.currentWave = 1
	self.currentWaveMonsterNum = 1
	killYellowMonsterNum = 0
	
	self.currentIndex = 1 --记录当前场景的已经出场怪物的顺序标志

	totalWaveNum = self.sceneData[self.totalMonsterNums][1]
	currentWaveNum = self.sceneData[1][1]
	havePlayedTime = 0
	self:onSchedule()
	self.coolDown = false

	self.speedUpSprite = display.newSprite("ui/fighting/guaiwulaile.png",display.cx,display.top-10):addTo(self.gameScene,60000)
	--self.speedUpSprite:setScale(0.5)
	self.speedUpSprite:setTouchEnabled(true)
	self.speedUpSprite:setVisible(false)
	self.speedUpSprite:addTouchEventListener(function(event, x, y, prevX, prevY)
		currentWaveNum = currentWaveNum + 1
		if currentWaveNum>totalWaveNum then currentWaveNum=totalWaveNum end
		self.countTime= 0
		self.coolDown = false
		self.speedUpSprite:setVisible(false)
		return true
	end)

	local actionBy = CCJumpBy:create(2, ccp(0,3), 3, 2)
	local actionByBack = actionBy:reverse()
	local array = CCArray:create()
	array:addObject(actionBy)
	array:addObject(actionByBack)
	local action = CCSequence:create(array)
	self.speedUpSprite:runAction(CCRepeatForever:create(action))


end

function PveWaveManager:getThiefIndexs()
	local ifExistsIntable = function(thiefIndexs,index)
		for i=1,#thiefIndexs do
			if thiefIndexs[i]==index then
				return true
			end
		end
		return false
	end
	local thiefIndexs = {}
	while #thiefIndexs<3 do
        local newIndex = math.random(1,self.totalMonsterNums-2)
        if not ifExistsIntable(thiefIndexs,newIndex) then
        	thiefIndexs[#thiefIndexs+1] = newIndex
        end
    end
    return thiefIndexs
end

function PveWaveManager:getReverseWays()
	local reverseWays = {}
	local wayCount = GameInstance:sharedInstance().paths:count()
    local path4 = tolua.cast(GameInstance:sharedInstance().paths:objectAtIndex((4-1)),"CCArray")
    reverseWays[#reverseWays+1] = path4
    if wayCount>=8 then
    	local path8 = tolua.cast(GameInstance:sharedInstance().paths:objectAtIndex((8-1)),"CCArray")
    	if path8:count()>0 then
	    	reverseWays[#reverseWays+1] = path8
	    end
    end
    if wayCount>=12 then
    	local path12 = tolua.cast(GameInstance:sharedInstance().paths:objectAtIndex((12-1)),"CCArray")
    	if path12:count()>0 then
	    	reverseWays[#reverseWays+1] = path12
	    end
    end
    return reverseWays
end

function PveWaveManager:initMonsterProperties(monsterid)
	for i = 1,#monster_template, 1 do
		if monster_template[i][1]==monsterid then
			self.monsterProperties[monsterid] = monster_template[i]
			return
		end
	end
	--print("怪物属性为空",monsterid)
end

function PveWaveManager:getMonsterProperties(monsterid)
	--[[
	for i = 1,#monster_template, 1 do
		if monster_template[i][1]==monsterid then
			return  monster_template[i]
		end
	end
	--print("怪物属性为空",monsterid)]]
	return self.monsterProperties[monsterid]
end


function PveWaveManager:getBodyId(monsterid)
	for i = 1,#monster_template, 1 do
		if monster_template[i][1]==monsterid then
			return  monster_template[i][10]
		end
	end
end

function PveWaveManager:ifExistsInTable(bodyIdArray,bodyId)
	for i = 1,#bodyIdArray, 1 do
		if bodyIdArray[i]==bodyId then
			return true
		end
	end
	return false
end


function PveWaveManager:onSchedule()

	if pauseStatus then 
		return
	end

	if self.coolDown then 
		return
	end
	
	self.countTime = self.countTime  + 0.5

	--print("self.countTime",self.countTime)

	
	--print("currentDiDa",currentDiDa)
	--print("当前总时间",havePlayedTime)
	--print("当前场景怪物的总数"..self.totalMonsterNums)

	--print("++++++++++++++++",self.currentIndex,self.totalMonsterNums)
	for i = self.currentIndex,self.totalMonsterNums, 1 do

		local round = self.sceneData[i][1]
		local born = self.sceneData[i][4]
		local monsterid = self.sceneData[i][5]
		local way = self.sceneData[i][6]
		local specialFlag = self.sceneData[i][8]
		local fuWenFlag = self.sceneData[i][9]

		if CommUtil.isMoreHarderPass() and way==self.selectReorderedWay then
			way = GameInstance:sharedInstance().paths:count()
		end
		local num = self.sceneData[i][2]

		local j = i + 1
		local nextMonsterData = self.sceneData[j]
		if nextMonsterData~=nil then

			local nextMonsterRound = nextMonsterData[1]

			if nextMonsterRound==currentWaveNum+1 then

				--print("++++++++++++++++",self.currentIndex,nextMonsterRound,currentWaveNum)
				--print("----------------",self.currentIndex,j,i)

				local totalWayCount = GameInstance:sharedInstance().paths:count()
				if way>totalWayCount then way=1 end

				local diff = born-self.countTime
				if diff>=0 and diff<0.1 and round==currentWaveNum then
					--print("born2",born,self.countTime,i,self.currentIndex)
					local monsterProperties = self:getMonsterProperties(monsterid)
					if monsterProperties~=nil then
						--print("第几波",round,self.currentIndex)
						MonsterFactory.produceMonster(self.gameScene,monsterProperties,way,self.currentIndex,self.isBoss,specialFlag,fuWenFlag)
						self.isBoss = false
						local nextMonsterIndex = self.currentIndex + 1
						if nextMonsterIndex<=self.totalMonsterNums then
							local isBoss = self.sceneData[nextMonsterIndex][7]==1 and true or false
							self.isBoss = isBoss
						end
					end
					self.currentIndex = self.currentIndex + 1

					--print("5秒钟后下一波了")
					if self.speedUpSprite~=nil then
						self.speedUpSprite:setVisible(true)
						self.coolDown = true
						local nextMonsterWay = nextMonsterData[6]
						local path = tolua.cast(GameInstance:sharedInstance().paths:objectAtIndex((nextMonsterWay-1)),"CCArray")
						local speedUpSpriteWayPoint = tolua.cast(path:objectAtIndex(0),"WayPoint")
						local xPos = speedUpSpriteWayPoint.position.x + CommUtil.getBlankWidth()
	    				local yPos = speedUpSpriteWayPoint.position.y + 20
	    				if gBattle.data.home_scene_id==618  then
	    					self.speedUpSprite:setPosition(xPos-70,yPos+15)
	    				else
	    					self.speedUpSprite:setPosition(xPos,yPos)
	    				end
					end

					local tempWaveNum = currentWaveNum
					self:performWithDelay(function()
						if currentWaveNum> tempWaveNum then
							--print("已经通过按钮实现了")
						else
							--print("还是通过我来生成下一波吧")
							currentWaveNum = currentWaveNum + 1
							self.gameScene:updateWave()
							self.countTime= 0
							self.coolDown = false
							if self.speedUpSprite~=nil then self.speedUpSprite:setVisible(false) end
						end
					end,5)
					return
				end
			elseif nextMonsterRound<currentWaveNum+1 then
				local totalWayCount = GameInstance:sharedInstance().paths:count()
				if way>totalWayCount then way=1 end

				local diff = born-self.countTime
				if diff>=0 and diff<0.1 and round==currentWaveNum then
					--print("born1",born,self.countTime,i,self.currentIndex)
					local monsterProperties = self:getMonsterProperties(monsterid)
					if num==1 then
						--print("鸽子，更新薄叔了")
						currentWaveNum = self.sceneData[self.currentIndex][1]
						self.gameScene:updateWave()
						if currentWaveNum==1 then
							if self.guideSkill then
								self:performWithDelay(function()
									self.gameScene:guideSkill()
								end,0.001)
							end
						end
					end
					if monsterProperties~=nil then
						MonsterFactory.produceMonster(self.gameScene,monsterProperties,way,self.currentIndex,self.isBoss,specialFlag,fuWenFlag)
						self.isBoss = false
						local nextMonsterIndex = self.currentIndex + 1
						if nextMonsterIndex<=self.totalMonsterNums then
							local isBoss = self.sceneData[nextMonsterIndex][7]==1 and true or false
							self.isBoss = isBoss
						end
						--print("第几波",round,self.currentIndex)
					end
					self.currentIndex = self.currentIndex + 1
				end

			else
				--print("越界了")
			end

		else
			--print("本波最后一个怪物最后一个了阿")
			local totalWayCount = GameInstance:sharedInstance().paths:count()
			if way>totalWayCount then way=1 end

			local diff = born-self.countTime
			if diff>=0 and diff<0.1 and round==currentWaveNum then
				local monsterProperties = self:getMonsterProperties(monsterid)
				if self.sceneData[self.currentIndex][1] > currentWaveNum then
					currentWaveNum = self.sceneData[self.currentIndex][1]
					self.gameScene:updateWave()
				end
				if monsterProperties~=nil then
					MonsterFactory.produceMonster(self.gameScene,monsterProperties,way,self.currentIndex,self.isBoss,specialFlag,fuWenFlag)
					self.isBoss = false
					--print("第几波",round,self.currentIndex)
					local nextMonsterIndex = self.currentIndex + 1
					if nextMonsterIndex<=self.totalMonsterNums then
						local isBoss = self.sceneData[nextMonsterIndex][7]==1 and true or false
						self.isBoss = isBoss
					end
				end
				self.currentIndex = self.currentIndex + 1
			end
		end
		

	end

	if self.currentIndex>self.totalMonsterNums then
		theLastMonster = true
	end
	
end

function PveWaveManager:produceChildCat()
	local oneToTwo = function(monster)
		local path,curwayPoint = monster:getChildCatPathAndCurWayPoint()
		    if path~=nil and curwayPoint~=nil then
		    	local frames,animation = AnimationFactory.getOneToTwoAnimation()
		        local appearSprite = display.newSprite(frames[1],monster:getPositionX()+10,monster:getPositionY()+100)
		        self.gameScene:addChild(appearSprite)
		        transition.execute(appearSprite,CCAnimate:create(animation),{
		        onComplete = function()
		            appearSprite:removeSelf()
		          	local zorder = GameInstance:sharedInstance():zorderForPosition(ccp(monster:getPositionX(),monster:getPositionY()))
			        local childAttacker = require("app.actor.Cat").new(monster.attackerProperties,self.gameScene,path)
			        self.gameScene:addChild(childAttacker,zorder)
			        CommUtil.playSound("music/soundeffect/music_kitty.mp3")
			        GameInstance:sharedInstance().monsters:addObject(childAttacker)
			        childAttacker:setPosition(monster:getPositionX(),monster:getPositionY())
			        childAttacker.degree = monster.degree + 1
			        monster.degree = monster.degree + 1
			        childAttacker.curWaypoint = curwayPoint
			        local hpFirst = monster.attackerProperties.hp/math.pow(0.5,monster.degree-1)
			        childAttacker.attackerProperties.hp = hpFirst*math.pow(0.5,childAttacker.degree)
			        monster.attackerProperties.hp = childAttacker.attackerProperties.hp
			        --print("分身之前的血量是",hpFirst,childAttacker.attackerProperties.hp)
			        childAttacker.fCurLifeValue = childAttacker.attackerProperties.hp
			        childAttacker:walk()
		        end})
				local tip = display.newSprite("ui/skill_word/skill_word_kitty.png",monster:getPositionX(),monster:getPositionY()+100)
				self.gameScene:addChild(tip,5000)
				self:performWithDelay(function()
					tip:removeSelf()
				end,0.5)
		    end
	end
	for i=0,GameInstance:sharedInstance().monsters:count()-1 do
        local monster = GameInstance:sharedInstance().monsters:objectAtIndex(i)
        local hpPercentage =monster.fCurLifeValue/monster.attackerProperties.hp
        if hpPercentage<0.8 and (not monster.oneToTwoDegrees[1]) then
        	oneToTwo(monster)
        	monster.oneToTwoDegrees[1]=true
        elseif hpPercentage<0.6 and (not monster.oneToTwoDegrees[2]) then
        	oneToTwo(monster)
        	monster.oneToTwoDegrees[1]=true
        	monster.oneToTwoDegrees[2]=true
        elseif hpPercentage<0.4 and (not monster.oneToTwoDegrees[3]) then
        	oneToTwo(monster)
        	monster.oneToTwoDegrees[1]=true
        	monster.oneToTwoDegrees[2]=true
        	monster.oneToTwoDegrees[3]=true
        elseif hpPercentage<0.2 and (not monster.oneToTwoDegrees[4]) then
        	oneToTwo(monster)
        	monster.oneToTwoDegrees[1]=true
        	monster.oneToTwoDegrees[2]=true
        	monster.oneToTwoDegrees[3]=true
        	monster.oneToTwoDegrees[4]=true
        elseif hpPercentage<=0 and (not monster.oneToTwoDegrees[5]) then
        	oneToTwo(monster)
        	monster.oneToTwoDegrees[1]=true
        	monster.oneToTwoDegrees[2]=true
        	monster.oneToTwoDegrees[3]=true
        	monster.oneToTwoDegrees[4]=true
        	monster.oneToTwoDegrees[5]=true
        end
    end
	--[[
	local path,curwayPoint = self:getChildCatPathAndCurWayPoint()
    if path~=nil and curwayPoint~=nil then
        local zorder = GameInstance:sharedInstance():zorderForPosition(ccp(self:getPositionX(),self:getPositionY()))
        local childAttacker = Attacker.new(self.attackerProperties,self.gameScene,path)
        self.gameScene:addChild(childAttacker,zorder)
        childAttacker:setPosition(self:getPositionX(),self:getPositionY())
        childAttacker.curWaypoint = curwayPoint
        childAttacker:startWalk()
    end]]
end

function PveWaveManager:decreaseDrinkNum()
	if catchTheCatDrinkNum<=0 then
		return
	end
	catchTheCatDrinkNum = catchTheCatDrinkNum - GameInstance:sharedInstance().monsters:count()
	if catchTheCatDrinkNum<=0 then
		catchTheCatDrinkNum = 0
	end
	local num1 = math.floor(catchTheCatDrinkNum/100)
	local num2 = math.floor(catchTheCatDrinkNum/10)
	local num3 = catchTheCatDrinkNum -num1*100 - num2*10
	if num3<0 then num3 = 0 end
	self.num1:setString(num1.."")
	self.num2:setString(num2.."")
	self.num3:setString(num3.."")
end

return PveWaveManager