
local CommUtil = require("app.common.CommUtil")
local AnimationFactory = require("app.factory.AnimationFactory")


local SceneDecorateManager = class("SceneDecorateManager",function()
    local node = display.newNode()
	return node
end)

function SceneDecorateManager:ctor(gameScene,inBattle)
	self.gameScene = gameScene
    if gBattle.data.home_scene_id==601 then
        display.addSpriteFramesWithFile("fish.plist","fish.pvr.ccz")
        display.addSpriteFramesWithFile("dog.plist","dog.pvr.ccz")

        local fish = display.newSprite("#fish1.png",CommUtil.getBlankWidth()+display.left+200,display.bottom+130):addTo(self,3000)
        local frames = display.newFrames("fish%d.png", 1, 12)
        local animation = display.newAnimation(frames, 2 / 12)
        transition.execute(fish,CCAnimate:create(animation),{
        onComplete = function()
            self:doFishActivities(fish)
        end,
        })
        if not inBattle then
            local dogFrames,dogAnimation = AnimationFactory.getDogSitAniamtion("front")
            self.dog = display.newSprite(dogFrames[1],display.left+130,display.cy+140):addTo(self,3000)
            self:doDogActivities(600,20)
        else
            local dogFrames,dogAnimation = AnimationFactory.getDogSitAniamtion("front")
            self.dog = display.newSprite(dogFrames[1],display.left+130,display.cy+90):addTo(self,3000)
            self.dog:setFlipX(true)
            self:doDogActivitiesInBattle()
        end
    elseif gBattle.data.home_scene_id==602 then
        display.addSpriteFramesWithFile("dog.plist","dog.pvr.ccz")
        if not inBattle then
            local dogFrames,dogAnimation = AnimationFactory.getDogSitAniamtion("front")
            self.dog = display.newSprite(dogFrames[1],display.cx+30,display.cy+115):addTo(self,3000)
            self:doDogActivities(200,20)
        else
            local dogFrames,dogAnimation = AnimationFactory.getDogSitAniamtion("front")
            self.dog = display.newSprite(dogFrames[1],display.cx-120,display.cy+120):addTo(self,3000)
            self.dog:setFlipX(true)
            self:doDogActivitiesInBattle()
        end
    elseif gBattle.data.home_scene_id==606 then
        display.addSpriteFramesWithFile("particle/fire.plist","particle/fire.png")
        local wood = display.newSprite("particle/wood.png",display.left+200,display.bottom+170):addTo(self,3000)
        local fire = display.newSprite("#fire_1.png",40,40):addTo(wood,2)
        local frames = display.newFrames("fire_%d.png", 1, 8)
        local animation = display.newAnimation(frames, 0.8 / 8)
        fire:playAnimationForever(animation)
        wood:setScale(0.7)
        fire:setScale(0.7)
    elseif gBattle.data.home_scene_id==607 then
        display.addSpriteFramesWithFile("particle/fire.plist","particle/fire.png")
        local wood = display.newSprite("particle/wood.png",display.cx+150,display.bottom+150):addTo(self,3000)
        local fire = display.newSprite("#fire_1.png",40,40):addTo(wood,2)
        local frames = display.newFrames("fire_%d.png", 1, 8)
        local animation = display.newAnimation(frames, 0.8 / 8)
        fire:playAnimationForever(animation)
        wood:setScale(0.7)
        fire:setScale(0.7)
    elseif gBattle.data.home_scene_id==608 then
        display.addSpriteFramesWithFile("particle/fire.plist","particle/fire.png")
        local wood = display.newSprite("particle/wood.png",display.left+200,display.bottom+150):addTo(self,3000)
        local fire = display.newSprite("#fire_1.png",40,40):addTo(wood,2)
        local frames = display.newFrames("fire_%d.png", 1, 8)
        local animation = display.newAnimation(frames, 0.8 / 8)
        fire:playAnimationForever(animation)
        wood:setScale(0.7)
        fire:setScale(0.7)
    elseif gBattle.data.home_scene_id==609 then
        display.addSpriteFramesWithFile("particle/fire.plist","particle/fire.png")
        local wood = display.newSprite("particle/wood.png",display.cx+80,display.bottom+120):addTo(self,3000)
        local fire = display.newSprite("#fire_1.png",40,40):addTo(wood,2)
        local frames = display.newFrames("fire_%d.png", 1, 8)
        local animation = display.newAnimation(frames, 0.8 / 8)
        fire:playAnimationForever(animation)
        wood:setScale(0.7)
        fire:setScale(0.7)
    elseif gBattle.data.home_scene_id==610 then
        display.addSpriteFramesWithFile("particle/fire.plist","particle/fire.png")
        local wood = display.newSprite("particle/wood.png",display.cx+100,display.top-150):addTo(self,3000)
        local fire = display.newSprite("#fire_1.png",40,40):addTo(wood,2)
        local frames = display.newFrames("fire_%d.png", 1, 8)
        local animation = display.newAnimation(frames, 0.8 / 8)
        fire:playAnimationForever(animation)
        wood:setScale(0.7)
        fire:setScale(0.7)
    elseif gBattle.data.home_scene_id==700 then
        display.addSpriteFramesWithFile("fish.plist","fish.pvr.ccz")

        local fish = display.newSprite("#fish1.png",display.left+50,display.cy):addTo(self,3000)
        local frames = display.newFrames("fish%d.png", 1, 12)
        local animation = display.newAnimation(frames, 2 / 12)
        transition.execute(fish,CCAnimate:create(animation),{
        onComplete = function()
            self:doFishActivities(fish)
        end,
        })

        local fish2 = display.newSprite("#fish1.png",display.left+230,display.bottom+190):addTo(self,3000)
        local frames2 = display.newFrames("fish%d.png", 1, 12)
        local animation2 = display.newAnimation(frames2, 2 / 12)
        fish2:setFlipX(true)
        transition.execute(fish2,CCAnimate:create(animation2),{
        onComplete = function()
            self:doFishActivities(fish2)
        end,
        })

        local fish3 = display.newSprite("#fish1.png",display.cx,display.bottom+230):addTo(self,3000)
        local frames3 = display.newFrames("fish%d.png", 1, 12)
        local animation3 = display.newAnimation(frames3, 2 / 12)
        transition.execute(fish3,CCAnimate:create(animation3),{
        onComplete = function()
            self:doFishActivities(fish3)
        end,
        })

        local fish4 = display.newSprite("#fish1.png",display.right-80,display.bottom+180):addTo(self,3000)
        local frames4 = display.newFrames("fish%d.png", 1, 12)
        local animation4 = display.newAnimation(frames4, 2 / 12)
        fish2:setFlipX(false)
        transition.execute(fish4,CCAnimate:create(animation4),{
        onComplete = function()
            self:doFishActivities(fish4)
        end,
        })
    elseif gBattle.data.home_scene_id==gPlayer.data.world_boss_scene_id then
        if gPlayer.data.level:get()<=1 then

        else
            display.newSprite("ui/boss/boss_sarcophagus.png",display.cx-25,display.cy+25):addTo(self)
            display.addSpriteFramesWithFile("particle/fire.plist","particle/fire.png")

            local makeFire = function(scale,posX,posY)
                local fire = display.newSprite("#fire_1.png",posX,posY):addTo(self,3)
                local frames = display.newFrames("fire_%d.png", 1, 8)
                local animation = display.newAnimation(frames, 0.8 / 8)
                fire:playAnimationForever(animation)
                fire:setScale(scale)
            end
            makeFire(0.4,display.cx+3,display.cy+46)  
            makeFire(0.4,display.cx-67,display.cy+68)
        end
    end
    if self.dog then self.dog:setScale(0.7) end
end

function SceneDecorateManager:doFishActivities(fish)
    local randomNum = math.random(10)
    local time = 0.2
    local frames = display.newFrames("fish%d.png",1,12)
    local animation = display.newAnimation(frames,time)
    if randomNum>5 then
        fish:setFlipX(true)
    else
        fish:setFlipX(false)
    end
    transition.execute(fish,CCAnimate:create(animation),{
        onComplete = function()
            self:doFishActivities(fish)
        end,
    })
end

function SceneDecorateManager:doDogActivities(xKilometers,yKilometers)
    self.dog:stopAllActions()
    local randomNum = math.random(10)
    if randomNum>5 then--stand and walk
        local dogFrames,dogAnimation = AnimationFactory.getDogStandAniamtion("front")
        self.dog:playAnimationForever(dogAnimation)
        transition.moveBy(self.dog, {x = xKilometers, y = yKilometers, time = xKilometers/40,onComplete=function()
            self.dog:setFlipX(true)
            transition.moveBy(self.dog, {x = -xKilometers, y = -yKilometers, time = xKilometers/40,onComplete=function()
                self.dog:setFlipX(false)
                self:doDogActivities(xKilometers,yKilometers)
            end})
        end})
        
    elseif randomNum>2 then--sit
        local dogFrames,dogAnimation = AnimationFactory.getDogSitAniamtion(math.random(1,2)==1 and "front" or "back")
        transition.execute(self.dog, CCAnimate:create(dogAnimation),{
            onComplete = function()
                self:doDogActivities(xKilometers,yKilometers)
            end,
        })
    else--shout
        local dogFrames,dogAnimation = AnimationFactory.getDogShoutAniamtion(math.random(1,2)==1 and "front" or "back")
        transition.execute(self.dog, CCAnimate:create(dogAnimation),{
            onComplete = function()
                self:doDogActivities(xKilometers,yKilometers)
            end,
        })
    end
end

function SceneDecorateManager:doDogActivitiesInBattle()
    self.dog:stopAllActions()
    local randomNum = math.random(10)
    if randomNum>5 then--sit
        local dogFrames,dogAnimation = AnimationFactory.getDogSitAniamtion("front")
        transition.execute(self.dog, CCAnimate:create(dogAnimation),{
            onComplete = function()
                self:doDogActivitiesInBattle()
            end,
        })
    else--shout
        local dogFrames,dogAnimation = AnimationFactory.getDogShoutAniamtion("front")
        transition.execute(self.dog, CCAnimate:create(dogAnimation),{
            onComplete = function()
                self:doDogActivitiesInBattle()
            end,
        })
    end
end

return SceneDecorateManager