
local DebugUtil = require("app.common.DebugUtil")
local CommUtil = require("app.common.CommUtil")
local HeroSkill = require("app.bullet.HeroSkill")
local AnimationFactory = require("app.factory.AnimationFactory")
local BulletFactory = require("app.factory.BulletFactory")


local ZorderManager = class("ZorderManager",function()
		return display.newNode()
end)

function ZorderManager:ctor(gameScene)
	self:schedule(handler(self, self.onSchedule),1)
	self.gameScene = gameScene

    self:updateTowerZorder()
	
end

function ZorderManager:onSchedule()
   self:updateMonsterZorder()
end

function ZorderManager:updateTowerZorder()
    for i = 0, GameInstance:sharedInstance().towers:count()-1 do
        local tower = GameInstance:sharedInstance().towers:objectAtIndex(i)
        local zorder = GameInstance:sharedInstance():zorderForPosition(ccp(tower:getPositionX(),tower:getPositionY()))
        self.gameScene:reorderChild(tower,zorder)
    end
end

function ZorderManager:updateMonsterZorder()
    for i = 0, GameInstance:sharedInstance().monsters:count()-1 do
        local monster = GameInstance:sharedInstance().monsters:objectAtIndex(i)
        local x,y,size = monster:getTextureCenterPointInWorld(monster:getPositionX(),monster:getPositionY())
        local zorder = GameInstance:sharedInstance():zorderForPosition(ccp(x,y))
        self.gameScene:reorderChild(monster,zorder)
    end
end

return ZorderManager