local HeroClass =  class("HeroClass")
HeroClass.__index = HeroClass
local HeroTemplateClass = require("app.data.template.HeroTemplateClass").new()
local scheduler =  require(cc.PACKAGE_NAME .. ".scheduler")

function HeroClass:ctor()
	self.inBattle={}--保存处于战斗中的英雄，--todo 结束战斗需要清空此表 gHero:setAllHeroOutBattle()
	self.countDownLimit = 10

	self.data = {{10001,Number.new(0)},{10002,Number.new(0)}} --id,star,exp
	self.lackHeros={10003,10004,10005,10006} --目前自己不具有的英雄

	-- self.data = {{10001,Number.new(0)},{10002,Number.new(0)},{10003,Number.new(0)},{10004,Number.new(0)},{10005,Number.new(0)},{10006,Number.new(0)}} --id,star
	-- self.lackHeros={} --目前自己不具有的英雄
end

function HeroClass:initLocalData(data)
	self.data={}
	for i,v in pairs(data) do
		table.insert(self.data, {v[1], Number.new(v[2])})
		self:resetLackHeros(v[1])
	end
end

--重置目前自己不具有的英雄
function HeroClass:resetLackHeros(hero_id)
	if #self.lackHeros==0 or (not hero_id) then return end
	for i,v in pairs(self.lackHeros) do
		if v==hero_id then
			table.remove(self.lackHeros, i)
			break
		end
	end
end

--购买英雄后插入英雄
function HeroClass:insertHero(hero_id, star)
	if self:isHeroExists(hero_id) then return end
	star = star or 0
	table.insert(self.data, {hero_id, Number.new(toint(star))})
	table.sort(self.data, function(a,b) return a[1]<b[1] end)
	self:resetLackHeros(hero_id)
	gGameStateUtil.save()
end

--英雄升星
function HeroClass:upHeroStar(hero_id, star)
	if tonum(star) < 1 then return end
	if not self:isHeroExists(hero_id) then return end
	for i,v in pairs(self.data) do
		if v[1] == hero_id then
			v[2]:set(tonum(star))
			break
		end
	end
	gGameStateUtil.save()
end

--取得派驻英雄
function HeroClass:getPlaceTowerHero()
	local tb={}
	for i,v in pairs(self.data) do
		-- if not self:isInBattle(v[1]) then
			table.insert(tb, self:getHeroData(v))
		-- end
	end

	--增加自己没有的仙将
	if (DEF_SPECIAL_PROCESS) then
		if #self.lackHeros>0 then
			for i,v in pairs(self.lackHeros) do
				table.insert(tb, {id=v, needBuy=true})
				break  --只显示一个仙将
			end
		end
	end
	return tb
end

--取得英雄页面显示英雄
function HeroClass:getHeroMenuData()
	local tb={}
	for i,v in pairs(self.data) do
		table.insert(tb, v)
	end

	--增加自己没有的仙将
	if #self.lackHeros>0 then
		for i,v in pairs(self.lackHeros) do
			table.insert(tb, {v, Number.new(0), needBuy=true})
		end
	end
	table.sort(tb,function(a,b) return a[1]<b[1] end)
	return tb
end

--根据hero_id判断英雄是否已经存在
function HeroClass:isHeroExists(hero_id)
	for i,v in pairs(self.data) do
		if v[1] == hero_id then return true end
	end
	return false
end

--取得当前英雄CD时间
function HeroClass:getHeroCD(hero_id)
	for i,v in pairs(self.inBattle) do
		if v[1] == hero_id then return v[2] end
	end
	return 0
end

function HeroClass:isInBattle(hero_id)
	if #self.inBattle>0 then
		for i,v in pairs(self.inBattle) do
			if v[1] == hero_id then
				v[2] = self.countDownLimit --如果已经出战，直接加6秒
				return true
			end
		end
	end
	return false
end

function HeroClass:setHeroInBattle(hero_id)
	if self:isInBattle(hero_id) then return end
	table.insert(self.inBattle, {hero_id, self.countDownLimit})

	--添加定时器
	if not self.cdPerSecond then
		self.cdPerSecond = scheduler.scheduleGlobal(function() 
			for i,v in pairs(self.inBattle) do
				if v[2] > 0 then v[2] = v[2] - 1 end 
			end
		end, 1)
	end
end

--设置某个英雄未出战
function HeroClass:setHeroOutBattle(hero_id)
	if #self.inBattle>0 then
		for i,v in pairs(self.inBattle) do
			if v[1] == hero_id then
				table.remove(self.inBattle,i)
				return
			end
		end
	end
end

--设置所有英雄未出战
function HeroClass:setAllHeroOutBattle()
	if self.cdPerSecond then --解除定时器
		scheduler.unscheduleGlobal(self.cdPerSecond)
		self.cdPerSecond = nil
	end
	self.inBattle = {}
end

function HeroClass:reachMaxLvl(para)
	return para[2]:get() == 3
end

function HeroClass:getHeroData(para)
	if type(para) == 'table' then
		return HeroTemplateClass:getData(para[1],para[2]:get())
	else
		return HeroTemplateClass:getData(para,0)
	end
end

function HeroClass:getHeroDataNextLvl(para)
	return HeroTemplateClass:getData(para[1], para[2]:get()+1)
end
return HeroClass