--道具信息存储
local scheduler = require(cc.PACKAGE_NAME .. ".scheduler")
local ItemClass =  class ("ItemClass")
ItemClass.__index = ItemClass

function ItemClass:ctor()
	self.detail = 	{
		item_id=1,
		num=0, --Number(0)
	}
	self.data = {}
end

function ItemClass:initLocalData(data)
	for i,v in pairs(data) do
		table.insert(self.data,{item_id=v[1], num=Number.new(v[2])})
	end
end

--购买道具
function ItemClass:addItem(item_id, num)
	if tonum(num) <= 0 then return end
	if item_id==30004 or item_id==30013 then item_id=30006 end--将3种经验石保存为一个ID
	if self:isItemExist(item_id) then
		for i,v in pairs(self.data) do
			if item_id == v.item_id then 
				v.num:set(tonum(num) + v.num:get())
				break
			end
		end
	else
		table.insert(self.data, {item_id=item_id, num=Number.new(num)})
	end
	gGameStateUtil.save()
end

--使用道具
function ItemClass:cutItem(item_id, num)
	if tonum(num) <= 0 or self:getItemNum(item_id) < tonum(num) then return end
	for i,v in pairs(self.data) do
		if item_id == v.item_id then
			if v.num:get() <= num then
				table.remove(self.data, i)
			else
				v.num:set(v.num:get() - num)
			end
			break
		end
	end
	gGameStateUtil.save()
end

--获取道具数量
function ItemClass:getItemNum(item_id)
	if self:isItemExist(item_id) then
		for i,v in pairs(self.data) do
			if item_id == v.item_id then 
				return v.num:get()
			end
		end
	else
		return 0
	end
end

--设置道具数量
function ItemClass:setItemNum(item_id,num)
	if tonum(num) <= 0 then return end
	if self:isItemExist(item_id) then
		for i,v in pairs(self.data) do
			if item_id == v.item_id then 
				v.num:set(num)
				break
			end
		end
	else
		table.insert(self.data, {item_id=item_id, num=Number.new(num)})
	end
	gGameStateUtil.save()
end

--某个道具是否存在
function ItemClass:isItemExist(item_id)
	for i,v in pairs(self.data) do
		if item_id == v.item_id then return true end
	end
	return false
end


------------------------取得唐僧的次数
function ItemClass:getTangSengTimes()
	return self:getItemNum(30008)
end

function ItemClass:useTangSeng()
	self:cutItem(30008,1)
end

return ItemClass