--塔数据存储
local NTowerClass =  class ("NTowerClass")
local NpcUtil = require("app.common.NpcUtil")
NTowerClass.__index = NTowerClass
function NTowerClass:ctor()
	self.scene_info_template={
		position = 			0, 		--位置ID
		hero_id			=   0, 		--是否放置了武将,空塔填充为0空,朋友塔填为空
		friend_player_id =  0, 		--好友player_id，不是好友填充为0
		hero_data_point = {}		--英雄数据指针
	}
	--
	self.tower_friend_detail={
		friend_player_id = 0,
		is_recommend_friend = 0,  	--是否是推荐好友
		today_fight_times = 0,     --当日可助攻的次数
		name='',					--好友姓名
		friend_level = 0, 			--好友level
		-----------------好友英雄信息
		hero = {
			level = Number.new(0), 						--英雄等级		
			hero_template_id = 0, 			--英雄template_id
			hero_template={},				--静态属性
			hero_power = 0, 				--英雄战斗力
			tower_level = Number.new(1), 				--出战塔的等级
			real_power_detail = {},			--战斗一级属性,从服务端取的
			real_second_power_detail = {} 			--战斗二级属性,战斗用到的战斗力属性
		}
	}
	--
	self.tower_friend_data={}		--塔里的好友信息
	--
	self.detail={
		scene_id = 0,			--场景id
		scene_info = {},		--场景信息
	}
	self.data = {}
end
--初始化数据
function NTowerClass:getDetail(vv)
	local detail ={}
		detail.position = tonumber(vv.position)
		--首次进入
		if (tonumber(vv.friend_player_id) > 0) then
			detail.friend_player_id = tonumber(vv.friend_player_id)
			detail.hero_id  = 0
			detail.is_recommend_friend = 0
			self:setTowerFriend(vv)
			detail.hero_data_point = self:getTowerFriend(tonumber(detail.friend_player_id))
		else
			detail.hero_id = tonumber(vv.hero_id)
			detail.friend_player_id = 0
			detail.hero_data_point = gHero:getData(tonumber(detail.hero_id))
		end
	return detail
end
--获得好友相关数值
function  NTowerClass:getTowerFriend(friend_player_id)
	for k, v in ipairs(self.tower_friend_data) do
		if (v.friend_player_id ~= 0 and v.friend_player_id == friend_player_id ) then
			return v
		end
	end
	self.tower_friend_data[#self.tower_friend_data+1] = clone(self.tower_friend_detail)
	return self.tower_friend_data[#self.tower_friend_data]
end

--设置好友的信息
function  NTowerClass:setTowerFriend(friendData, is_recommend_friend)
	local vFriend = self:getTowerFriend(tonumber(friendData.friend_player_id))

	--填充好友信息
	if (is_recommend_friend) then
		vFriend.is_recommend_friend = is_recommend_friend
	end

	vFriend.friend_player_id = tonumber(friendData.friend_player_id)
	vFriend.today_fight_times = tonumber(friendData.today_fight_times)     --当日可助攻的次数
	if (friendData.friend_name == "牛魔王") then
		vFriend.name= friendData.friend_name		
	else
		vFriend.name=string.urldecode(friendData.friend_name)					--好友姓名
	end
	-----------------英雄信息
	vFriend.friend_level= tonumber(friendData.friend_level) 				--等级	
	vFriend.hero.level:set(tonumber(friendData.friend_hero_level)) 				--等级		
	vFriend.hero.hero_template_id =  tonumber(friendData.friend_hero_template_id)--英雄template_id
	--
	if (tonumber(friendData.friend_tower_level) == 0) then
		friendData.friend_tower_level =  1
	end
	--
	vFriend.hero.tower_level:set(tonumber(friendData.friend_tower_level))
	vFriend.hero.hero_template=	gHeroTemplate:getData(tonumber(friendData.friend_hero_template_id))	
		--静态属性
	vFriend.hero.hero_power = Number.new(tonumber(friendData.friend_hero_power))			--英雄战斗力

	------------------------调整为塔的数据一致性
	vFriend.level   = vFriend.hero.level
	vFriend.real_equipment_power = 0
	vFriend.all_power  = vFriend.hero.hero_power
	--
	vFriend.real_power_detail    ={}
	vFriend.real_second_power_detail  ={}
	vFriend.class  = vFriend.hero.hero_template.class
	vFriend.quality = Number.new(vFriend.hero.hero_template.quality)
	vFriend.tower_level  = vFriend.hero.tower_level
	vFriend.skill_id = vFriend.hero.hero_template.skillid
	vFriend.bornid = vFriend.hero.hero_template.bornid
end

--
function NTowerClass:initServDataPass(body)

	print("初始化塔位数据了1.")
	if (body == nil or body == "") then
		return
	end
	--
	self.data = {}
	for k, v in ipairs(body) do
		self.data[k] = {}
		self.data[k].scene_id=tonumber(v.scene_id)
		self.data[k].scene_info={}
		--
		if (v.tower =="") then
			v.tower ={}
		end
		--
		for kk,vv in ipairs(v.tower) do
			self.data[k].scene_info[kk]= self:getDetail(vv)
		end
	end
	--新手引导的塔位信息
	if (gPlayer.data.pve_pass_id == gBattle.data.home_pass_id
		and HELP_FIGHT_HERO[gPlayer.data.pve_pass_id]) then
		NpcUtil.geneNiuMoWang(gPlayer.data.pve_pass_id, false)
	end
	--
	if ( gPlayer.data.tower701) then
		self:initServData(gPlayer.data.tower701)
	end
end
--

function NTowerClass:initServData(towers)
	if (towers == nil or towers == "") then
		return
	end
	print("初始化塔位数据了2.")
	for k, v in ipairs(towers) do
		local pos = #self.data+1
		self.data[pos] = {}
		self.data[pos].scene_id=tonumber(v.scene_id)
		self.data[pos].scene_info={}
		if (v.scene_info ~= "") then
			for kk,vv in ipairs(v.scene_info) do
				self.data[pos].scene_info[kk]= self:getDetail(vv)
			end
		end
	end
	print("--------------------------------------------------------")
	DebugUtil.print_table(towers)
	print("--------------------------------------------------------")

end

--返回某一个点的塔位信息
function NTowerClass:getScenePosition(scene_id, position)
	local A = self:getSceneInfo(scene_id)
	if (A) then
		for k, v in ipairs(A.scene_info) do
			if (v.position == position) then
				return v
			end
		end
	end
	A.scene_info[#A.scene_info + 1] = clone(self.scene_info_template)
	A.scene_info[#A.scene_info].position = position
	return A.scene_info[#A.scene_info]
end


--删除塔
function NTowerClass:DeleteTowerPosition(scene_id, position)

	local A = self:getSceneInfo(scene_id)
	if (A) then
		for k, v in ipairs(A.scene_info) do
			if (v.position == position) then
				table.remove(A.scene_info, k)
			end
		end
	end
end
--
--填充入某项塔的相关战斗力数据,包括了一级属性
function NTowerClass:fillFriendTowerPower(friendData)
	--设置最新的值
	self:setTowerFriend(friendData)
	local VFriend = self:getTowerFriend(tonumber(friendData.friend_player_id))
	--更新一二级属性
	VFriend.real_power_detail.attack_power = Number.new(tonumber(friendData.attack_power))
	--我方妖姬影响
	VFriend.real_power_detail.health_point = Number.new(tonumber(friendData.health_point))
	VFriend.real_power_detail.agility = Number.new(tonumber(friendData.agility))
	VFriend.real_power_detail.crit = Number.new(tonumber(friendData.crit))
	VFriend.real_power_detail.accuracy = Number.new(tonumber(friendData.accuracy))
	VFriend.real_power_detail.lucky = Number.new(tonumber(friendData.lucky))
	--
	VFriend.today_fight_times = tonumber(friendData.today_fight_times)
	if (tonumber(friendData.relationship) == -1) then
		VFriend.is_recommend_friend = 1
	else
		VFriend.is_recommend_friend = 0
	end
	--
	--计算二级属性
	VFriend.real_second_power_detail = PowerUtil.transToEncryptSecondPower(
		Attributes.cal_secondary( PowerUtil.transToNormalPower(VFriend.real_power_detail), 
		VFriend.hero.level:get(), VFriend.hero.hero_template.class))
end
--
--返回某一个场景的数据
function NTowerClass:getSceneInfo(scene_id)
	for k,v in ipairs(self.data) do
		if (v.scene_id == scene_id) then
			return v
		end
	end
	local pos = #self.data+1
	self.data[pos] = clone(self.detail)
	self.data[pos].scene_id = scene_id
	return self.data[pos]
end
--删除这一个关卡的推荐好友塔
function NTowerClass:deleteRecommendFriend(scene_id)

	local vvT = self:getSceneInfo(scene_id)
	for kb, vb in ipairs(vvT.scene_info) do
        if (vb.friend_player_id ~=0) then
        	local vFriend = self:getTowerFriend(vb.friend_player_id)
        	if (vFriend.is_recommend_friend==1) then
            	table.remove(vvT.scene_info, kb)
            end
        end
    end     
end

--[[
接口功能:  拆塔
输入参数：
	scene_id :场景id
	x: 塔位置x
	y: 塔位置y
返回值:无
]]
function NTowerClass:tearTower(scene_id, position, callback)
	local node = display:getRunningScene()

	--
	local v = self:getScenePosition(scene_id, position)

	--
	local func=function(cmd, body)
		if (body.ret == "0" ) then 
			if (v.hero_id ~= 0) then
				if (v.hero_id ~= 0 and scene_id == gPlayer.data.pve_scene_id) then 		  
					--有英雄在塔并且是当前场景的情况
					gHero:releaseHero(node, v.hero_id)
				end
			end
			self:DeleteTowerPosition(scene_id, position)--拆塔
			callback(0)
		else
			CommUtil.errService(node)
			callback(-1)
		end
	end

	
	local new_player_power = 0
	local update_hero_id = 0
	if (gPlayer.data.pve_scene_id == gBattle.data.home_scene_id) then
		--如果是好友塔
		if (v.friend_player_id ~= 0) then
			update_hero_id = 0
		else
			local heroData = gHero:getData(v.hero_id)
		 	new_player_power = gHero:realGetPlayerPower() - heroData.all_power:get()
		end
		update_hero_id = v.hero_id
	else
		new_player_power = gHero:realGetPlayerPower()
		update_hero_id = 0
	end
	require("app.sock.SockNode").new({
        cmd = gSockCmd.BUILD_TOWER,    --拆塔
        body = {player_id=gPlayer.data.player_id, 
        		scene_id=scene_id, 
        		position = position,
        		hero_id = update_hero_id,
        		new_player_power = new_player_power,
        		build_type = 1},
        freeze = true,
        callback =func
        }):addTo(node,TOP_BLACK_Z_ORDER)
end
--新增加一个好友塔
function NTowerClass:insertTowerFriend(scene_id, position, friendData, is_recommend_friend)
	assert(position ~= nil)

	local vData = self:getScenePosition(tonumber(scene_id), tonumber(position))
	vData.friend_player_id = tonumber(friendData.friend_player_id)
	vData.hero_id = 0
	self:setTowerFriend(friendData, is_recommend_friend)
	vData.hero_data_point = self:getTowerFriend(tonumber(friendData.friend_player_id))
end
--增加一个普通塔
function NTowerClass:insertTowerHero(scene_id, position, hero_id)
	local vData = self:getScenePosition(tonumber(scene_id), tonumber(position))
	vData.hero_id = tonumber(hero_id)
	vData.hero_data_point = gHero:getData(tonumber(hero_id))
	--
	--对其它模块影响
	local heroData = gHero:getData(hero_id)
	 if (gPlayer.data.pve_scene_id == gBattle.data.home_scene_id) then
    	heroData.in_battle = 1
    end
    --
end


--[[
功能：入驻英雄
输入： 
	node: 当前scene
	request：封装的请求包
	callback：回调函数
输出：
	ret = 0，成功
		= -1， 失败
--]]
function  NTowerClass:placeTowerHero(scene_id,position, hero_id, callback)
	local node = display:getRunningScene()
	local heroData = gHero:getData(hero_id)

    local func=function(cmd, body)
        if (body.ret == "0" ) then 
        	gTask:reLoadTaskData()
        	self:insertTowerHero(scene_id, position, hero_id)
            callback(0)
        else
        	callback(-1)
        end
    end
    local in_battle = 0
    local new_player_power = 0
    if (gPlayer.data.pve_scene_id == gBattle.data.home_scene_id) then
    	in_battle = 1
    	new_player_power =  gHero:realGetPlayerPower() + heroData.all_power:get()
    end
    require("app.sock.SockNode").new({
        cmd = gSockCmd.PLACE_HERO_TOWER,
        body = {player_id = gPlayer.data.player_id,
                scene_id = scene_id,       --场景id
                position = position,          --X坐标
                hero_id = hero_id,    --新的武将id
                new_player_power = new_player_power,
                in_battle = in_battle
                 },
        freeze = true,
        freeze_no_show = true,
        callback =func
        }):addTo(node,TOP_BLACK_Z_ORDER)	
end

--

return NTowerClass