--玩家存储信息
local PassClass = class("PassClass")
PassClass.__index = PassClass
local SockNode = require("app.sock.SockNode")

function PassClass:ctor()
	self.detail = {
		scene_id = xx,   		 --scene_id
		have_reward_bag=0,  	-- 是否已领过奖励
		have_reward_bag_hell=0,  -- 是否已领过奖励，困难模式
		star  = {
			{
				pass_id = 0, 
				star = 0,   --星级
			}
		}
	}
	self.data = {}
	self.scene_pass_template = {}
end


function PassClass:getScene(scene_id)
	for k, v in ipairs(self.data) do
		if (v.scene_id == scene_id) then
			return v
		end
	end
	self.data[#self.data+1] ={}
	self.data[#self.data].scene_id=scene_id
	self.data[#self.data].have_reward_bag=0
	self.data[#self.data].have_reward_bag_hell=0
	self.data[#self.data].star={}
	return self.data[#self.data]
end

--检查是否有可显示的未领取的3星奖励
function PassClass:checkIfAward()
	gPlayer.data.hint_map = false

	for k, v in ipairs(self.data) do
		--总关卡数量
		local template = gPassTemplate.data[v.scene_id]
		if (template == nil ) then
			break
		end
		--普通模式
		local star = template.pass_normal_num  * 3
		local get_star = self:getWholeStar(v.scene_id, 0)
		--
		if (star == get_star and v.have_reward_bag == 0) then
			gPlayer.data.hint_map = true
			break
		end
		--困难模式
		star = template.pass_hell_num  * 3
		get_star = self:getWholeStar(v.scene_id, 1)
		if (v.scene_id == 601) then
			print("template.pass_hell_num = ", template.pass_hell_num)
			print("get_star = ", get_star)
		end
		
		--
		if (star == get_star and v.have_reward_bag_hell == 1) then
			gPlayer.data.hint_map = true
			break
		end
	end
end

function PassClass:checkIfAwardScene(scene_id)
	for k, v in ipairs(self.data) do
		--总关卡数量
		if (v.scene_id==scene_id) then
			local template = gPassTemplate.data[v.scene_id]
			if (template == nil ) then
				break
			end
			--普通模式
			local star = template.pass_normal_num  * 3
			local get_star = self:getWholeStar(v.scene_id, 0)
			--
			if (star == get_star) then
				return true
			end
			--
			return false
		end
	end
	return false
end


function PassClass:acceptedReward(scene_id)
	for k, v in ipairs(self.data) do
		if (v.scene_id == scene_id) then
			if (gVar.data.curr_sele_pattern == 0) then
				v.have_reward_bag = 1
			else
				v.have_reward_bag_hell = 1
			end
		end
	end
end
--初始化服务端数据
function PassClass:initServData(body)
	if (body == nil or body == "") then
		return
	end
	self.data = {}

	for k, v in ipairs(body) do
		local detail = {}
		detail.scene_id = tonumber(v.scene_id)
		detail.have_reward_bag = tonumber(v.have_reward_bag)
		detail.have_reward_bag_hell = tonumber(v.have_reward_bag_hell)
		detail.star = {}
		if (v.star and v.star ~= "") then
			for kk, vv in ipairs(v.star) do
				local star_detail = {}
				star_detail.pass_id = tonumber(vv.pass_template_id)
				star_detail.star = tonumber(vv.star)
				detail.star[#detail.star+1] = star_detail
			end
		end
		self.data[#self.data+1] = clone(detail)
	end
end

function PassClass:getData(scene_id, pass_id)
	local v = self:getScene(scene_id)
			for kk, vv in ipairs(v.star) do
				if (vv.pass_id == pass_id) then
					return vv
				end
			end
	--
	local detail = {}
	detail.pass_id = pass_id
	detail.star = 0
	v.star[#v.star+1]=detail

	return v.star[#v.star]
	--
end

function PassClass:getWholeStar(scene_id, pattern)
	assert(pattern ~= nil)

	local star = 0
	for k, v in ipairs(self.data) do
		if (v.scene_id == scene_id) then
			for kk, vv in ipairs(v.star) do
				if (pattern == 0) then
					if (vv.pass_id < 80001) then
						star = star + vv.star
					end
				else
					if (vv.pass_id >= 80001) then
						star = star + vv.star
					end
				end
			end
		end
	end

	return star
end
function PassClass:getStar(scene_id, pass_id)
	local v = self:getData(scene_id, pass_id)
	if (v) then
		return v.star
	end
	return 0
end

--更新星级,返回能否掉落
function PassClass:updatePassStar(scene_id, pass_id, star)
	local v = self:getData(scene_id, pass_id)
	if (v) then
		if (star >v.star) then
			v.star = star
		end
	else
		local str = "更新星级失败" .. scene_id .. ":" .. pass_id .. ":" .. star
		cclog(str)
	end
end


return PassClass