--玩家存储信息
local PlayerClass =class ("PlayerClass")
PlayerClass.__index = PlayerClass

function PlayerClass:ctor()
	self.data={
		level               = Number.new(0),          --级别
		ingot_cnt           = Number.new(0),	      --元宝数
		star_cnt 			= Number.new(0),
		copper_cnt 			= Number.new(100),		--铜钱数量 新玩家送100
		climbNum			= Number.new(1),		--最小为1，最大为10
		isBuyMysGift		= false,				--是否购买神秘礼包

		map_stars			= {},--发关卡ID作索引-1表示未开启
		pass_id        = 60001,
		scene_id       = gPassTemplate:getSceneidByPassid(60001),--当前场景id
		map_id         = gPassTemplate:getMapidByPassid(60001),--当前地图id
		new_map_unlock = false,--有新地图解锁
		free_pay_count =0, --免费次数  --yangdx add 
		pay_hit_count =0,  --计费点击次数  --yangdx add 
		device_id	   ='',--设
		--
	}
end

function PlayerClass:refreshData()
	self.data.refreshData = true
end

function PlayerClass:initLocalStarData(data)
	local star=0
	for i,v in pairs(data) do
		self.data.map_stars[v[1]]=Number.new(v[2])
		star=star+v[2]
	end
	self.data.star_cnt:set(star)
end

--设置pass_id,传入是否保存参数 
function PlayerClass:setPassId(pass_id, save)
	self.data.pass_id = pass_id
	self.data.scene_id= gPassTemplate:getSceneidByPassid(self.data.pass_id)
	self.data.map_id= gPassTemplate:getMapidByPassid(self.data.pass_id)

	if save then gGameStateUtil.save() end
end

--[[
  --设置用户类型  --yangdxadd
  1:关闭定势型  2：取消定势型  4：细心型   
--]]
function PlayerClass:setPayFree(paycount,save)
	if  paycount==1 then 
		if self.data.free_pay_count==1 or  self.data.free_pay_count==3 or self.data.free_pay_count==5 
			or self.data.free_pay_count==7  then 
		   return 
		else
		   self.data.free_pay_count= self.data.free_pay_count+paycount
		end 
	elseif  paycount==2 then
		if self.data.free_pay_count==2 or  self.data.free_pay_count==3 or self.data.free_pay_count==6 
			or self.data.free_pay_count==7  then 
		   return 
		else
		   self.data.free_pay_count= self.data.free_pay_count+paycount
		end
	elseif  paycount==4 then
		if self.data.free_pay_count==4 or  self.data.free_pay_count==5 or self.data.free_pay_count==6 
			or self.data.free_pay_count==7  then 
		   return 
		else
		   self.data.free_pay_count= self.data.free_pay_count+paycount
		end
	end 

	if save then gGameStateUtil.save() end
end

--设置各种点击次数  AABB  BB表示返回支付成功  AA 免费支付成功  --yangdxadd 
function PlayerClass:setPayHit(flag,save)
	self.data.pay_hit_count = self.data.pay_hit_count+flag
	if save then gGameStateUtil.save() end
end


--通过场景取得星星总数
function PlayerClass:getStarNum(scene_id)
	local star_num=0
	for _,v in pairs(gPassTemplate:getPassidBySceneid(scene_id)) do
		if self.data.map_stars[v] and self.data.map_stars[v].get then
			star_num = star_num+self.data.map_stars[v]:get()
		end
	end
	return toint(star_num) --每关3个最多6个。界面只能显示3个。
end

function PlayerClass:getPassidAndStar(scene_id)
	local tb = {}
	for i,v in pairs(gPassTemplate:getPassidBySceneid(scene_id)) do
		if self.data.map_stars[v] and self.data.map_stars[v].get then
			table.insert(tb,{v,self.data.map_stars[v]:get()})
		else
			table.insert(tb,{v,0})
		end
	end

	table.sort(tb, function(a,b) return a[1]<b[1] end)
	return tb
end

--保存星星数目
function PlayerClass:setStarNum(pass_id, star_num)
	gHero:setAllHeroOutBattle()
	if (not star_num) or (star_num <= 0) then return end
	if (not pass_id) or toint(pass_id) <= 0 then return end
	if star_num > 3 then star_num = 3 end
	CommUtil.sendDataToServ({req_type="pass", pass_id=pass_id}) --保存星星时向服务器发送关卡信息
	if self.data.map_stars[pass_id] and self.data.map_stars[pass_id].get then
		if self.data.map_stars[pass_id]:get()<star_num then
			self.data.star_cnt:set((star_num-self.data.map_stars[pass_id]:get())+self.data.star_cnt:get())
			self.data.map_stars[pass_id]:set(star_num)
		else return end
	else
		self.data.map_stars[pass_id]=Number.new(star_num)
		self.data.star_cnt:set(star_num+self.data.star_cnt:get())
	end

	if gPassTemplate:getMapidByPassid(pass_id) == self.data.map_id then --当前场景战斗 判断是否进入下一个sceneid
		local tb=gPassTemplate:getAllSceneidByPassid(self.data.pass_id)
		if tb[5] == self.data.scene_id then
			local passid = gPassTemplate:getPassidBySceneid(self.data.scene_id)
			if self.data.pass_id ~= passid[2] then
				if pass_id == self.data.pass_id then
					self.data.pass_id = self.data.pass_id+1
				end
			end
		elseif tb[4] == self.data.scene_id then
			local passid = gPassTemplate:getPassidBySceneid(self.data.scene_id)
			if pass_id >= self.data.pass_id and pass_id==passid[1] then
				self.data.scene_id = tb[5]
				self.data.pass_id = gPassTemplate:getPassidBySceneid(self.data.scene_id)[1]
			end
		elseif tb[3] == self.data.scene_id then
			local passid = gPassTemplate:getPassidBySceneid(self.data.scene_id)
			if pass_id >= self.data.pass_id and pass_id==passid[1] then
				self.data.scene_id = tb[4]
				self.data.pass_id = gPassTemplate:getPassidBySceneid(self.data.scene_id)[1]
			end
		elseif tb[2] == self.data.scene_id then
			local passid = gPassTemplate:getPassidBySceneid(self.data.scene_id)
			if pass_id >= self.data.pass_id and pass_id==passid[1] then
				self.data.scene_id = tb[3]
				self.data.pass_id = gPassTemplate:getPassidBySceneid(self.data.scene_id)[1]
			end
		elseif tb[1] == self.data.scene_id then
			local passid = gPassTemplate:getPassidBySceneid(self.data.scene_id)
			if pass_id >= self.data.pass_id and pass_id==passid[1] then
				self.data.scene_id = tb[2]
				self.data.pass_id = gPassTemplate:getPassidBySceneid(self.data.scene_id)[1]
			end
		end
	end

	if self.data.star_cnt:get() >= self:calUnlockMapStar(self.data.map_id + 1) then --每个地图超过14个星星解锁下一地图
		if gPassTemplate:isMapidExists(self.data.map_id + 1) then
			self.data.map_id = self.data.map_id + 1
			self.data.pass_id = gPassTemplate:getPassidByMapid(self.data.map_id)
			self.data.scene_id = gPassTemplate:getSceneidByPassid(self.data.pass_id)
			self.data.new_map_unlock = true --有新地图解锁
		end
	end

	self:refreshData()
	gGameStateUtil.save()
end

--加元宝
function PlayerClass:addIngot(ingot)
	ingot = tonum(ingot)
	if ingot <= 0 then return end
	self.data.ingot_cnt:set(self.data.ingot_cnt:get()+ingot)
	self:refreshData()
	gGameStateUtil.save()
	CommUtil.toastNoGuide(display.getRunningScene(), "获得元宝"..ingot.."个!")
end

--使用元宝
function PlayerClass:useIngot(ingot)
	ignot = tonum(ingot)
	if tonum(ingot) <= 0 then return end
	if self.data.ingot_cnt:get() >= ingot then
		self.data.ingot_cnt:set(self.data.ingot_cnt:get()-ingot)
	else
		self.data.ingot_cnt:set(0)
	end
	self:refreshData()
	gGameStateUtil.save()
end

--加铜钱
function PlayerClass:addCopper(copper)
	copper = tonum(copper)
	if copper <= 0 then return end
	self.data.copper_cnt:set(self.data.copper_cnt:get()+copper)

	self:refreshData()
	gGameStateUtil.save()
end

--使用铜钱
function PlayerClass:useCopper(copper)
	copper = tonum(copper)
	if copper <= 0 then return end
	if self.data.copper_cnt:get() >= copper then
		self.data.copper_cnt:set(self.data.copper_cnt:get()-copper)
	else
		self.data.copper_cnt:set(0)
	end

	self:refreshData()
	gGameStateUtil.save()
end

--购买神秘礼包
function PlayerClass:saveMysGiftStatus(isBuy)
	if isBuy ~= true then return end
	if self.data.isBuyMysGift == true then return end
	self.data.isBuyMysGift = true

	self:refreshData()
	gGameStateUtil.save()
end

--保存爬塔数目
function PlayerClass:saveClimbNum(climbNum)
	climbNum = tonum(climbNum)
	if climbNum < 1 or climbNum > 5 then return end
	if climbNum - self.data.climbNum:get() ~= 1 then return end
	self.data.climbNum:set(climbNum)

	gGameStateUtil.save()
end

--计算解锁需要星星数量
function PlayerClass:calUnlockMapStar(map_id)
	if (map_id == 502 ) then
		return 10
	elseif (map_id == 503) then
		return 25
	else
		return (map_id-501)*20
	end
end

--手动解锁地图
function PlayerClass:unLockMap(map_id)
	if map_id <= self.data.map_id then 
		echoError("unlock map error! map_id="..map_id .."gPlayer.data.map_id="..self.data.map_id)
		return
	end
	if (map_id-self.data.map_id) ~= 1 then 
		echoError("unlock map error! map_id-self.data.map_id~=1, map_id="..map_id .."gPlayer.data.map_id="..self.data.map_id)
		return
	end

	self.data.pass_id = gPassTemplate:getPassidByMapid(map_id)
	self:setPassId(self.data.pass_id, true)
end

return PlayerClass