--
-- Author: hejiangcheng
-- Date: 2015-01-20 15:37:32
--
local pass_hidden_template = import("app.client.template.pass_hidden_template")
local HiddenPassTemplateClass =  class ("HiddenPassTemplateClass")
HiddenPassTemplateClass.__index = HiddenPassTemplateClass

function HiddenPassTemplateClass:ctor()
	--id,name,scene,difficulty,bosshead,specialtips,gold_1star,gold_2star,gold_3star
	self.data={}
	for i,v in pairs(pass_hidden_template) do
		local detail={}
		detail.id 			=v[1]
		detail.name 		=v[2]
		detail.scene 		=v[3]
		detail.difficulty 	=v[4]
		detail.bosshead 	=v[5]
		detail.specialtips  =v[6]
		detail.copper_1star =Number.new(v[7])
		detail.copper_2star =Number.new(v[8])
		detail.copper_3star =Number.new(v[9])

		table.insert(self.data, detail)
	end
	table.sort(self.data,function(a,b) return a.id < b.id end)
end

function HiddenPassTemplateClass:getData(order)
	return self.data[order]
end

function HiddenPassTemplateClass:getDataByPassid(pass_id)
	for i,v in pairs(self.data) do
		if v.id == pass_id then return v end
	end
	
	echoError('hidden mode pass_id = '..pass_id)
end

function HiddenPassTemplateClass:getAwdCopper(pass_id, star)
	if not (star==1 or star==2 or star==3) then return 0 end
	for i,v in pairs(self.data) do
		if v.id == pass_id then
			return v['copper_'..star..'star']:get()
		end
	end

	echoError("find hidden awdCopper error, pass_id = %d ", pass_id)
end

function HiddenPassTemplateClass:isPassIdExists(pass_id)
	for i,v in pairs(self.data) do
		if v.id == pass_id then return true end
	end
	return false
end

return HiddenPassTemplateClass