local pass_template = import("app.client.template.pass_template")
local PassTemplateClass =  class ("PassTemplateClass")
PassTemplateClass.__index = PassTemplateClass

function PassTemplateClass:ctor()
	--id,name,scene,difficulty,bosshead,specialtips,gold_1star,gold_2star,gold_3star
	self.detail={
				id=60001,--passid
				name=501,--mapid
				scene=601,--sceneid
				difficulty=1,
				itemsproc1=100,
			}
	self.data={}
	for i,v in pairs(pass_template) do
		local detail={}
		detail.id 			=v[1]
		detail.name 		=v[2]
		detail.scene 		=v[3]
		detail.difficulty 	=v[4]
		detail.bosshead 	=v[5]
		detail.specialtips  =v[6]
		detail.copper_1star =Number.new(v[7])
		detail.copper_2star =Number.new(v[8])
		detail.copper_3star =Number.new(v[9])

		table.insert(self.data, detail)
	end
end

function PassTemplateClass:getPassidBySceneid(scene_id)
	local passid={}
	for i,v in pairs(self.data) do
		if v.scene==scene_id then
			table.insert(passid, v.id)
		end
		if #passid==2 then return passid end
	end
	echoError("find pass table error, pass_id = %d ", scene_id)
end

function PassTemplateClass:getAllSceneidByPassid(pass_id)
	local scendid={}
	local mapid = self:getMapidByPassid(pass_id)
	function isExist(scene)
		if #scendid==0 then return false end
		for _,m in pairs(scendid) do
			if scene == m then return true end
		end
		return false
	end
	for i,v in pairs(self.data) do
		if v.name == mapid and (not isExist(v.scene)) then
			table.insert(scendid, v.scene)
		end
		if #scendid == 5 then break end
	end
	table.sort(scendid, function(a,b) return a<b end)
	return scendid
end

function PassTemplateClass:getMapidByPassid(pass_id)
	for i,v in pairs(self.data) do
		if v.id == pass_id then
			return v.name
		end
	end
	echoError("find mapId error, pass_id = %d ", pass_id)
end

function PassTemplateClass:getSceneidByPassid(pass_id)
	for i,v in pairs(self.data) do
		if v.id == pass_id then
			return v.scene
		end
	end
	echoError("find scene_id error, pass_id = %d ", pass_id)
end

--通过地图id取得第一关卡id
function PassTemplateClass:getPassidByMapid(map_id)
	local passid={}
	for i,v in pairs(self.data) do
		if v.name == map_id then
			table.insert(passid, v.id)
		end
		if #passid == 10 then break end
	end
	table.sort(passid, function(a,b) return a<b end)
	if #passid == 10 then 
		return passid[1] 
	else
		echoError("find passid error, map_id = %d ", map_id)
	end
end

function PassTemplateClass:isMapidExists(map_id)
	for i,v in pairs(self.data) do
		if v.name == map_id then return true end
	end
	return false
end

--取得不同星级奖励铜钱数量
function PassTemplateClass:getAwdCopper(pass_id, star)
	if not (star==1 or star==2 or star==3) then return 0 end
	for i,v in pairs(self.data) do
		if v.id == pass_id then
			return v['copper_'..star..'star']:get()
		end
	end

	echoError("find awdCopper error, pass_id = %d ", pass_id)
end

return PassTemplateClass