local Attacker = require("app.actor.Attacker")
local MonsterRunCycleWay = require("app.actor.MonsterRunCycleWay")
local WorldBoss = require("app.actor.WorldBoss")
local Thief = require("app.actor.Thief")
local Cat = require("app.actor.Cat")
local WorldMiniBoss = require("app.actor.WorldMiniBoss")
local Boss = require("app.actor.Boss")
local BossThief = require("app.actor.BossThief")
local SwimMonster = require("app.actor.SwimMonster")
local SwimThief = require("app.actor.SwimThief")
local RedMonster = require("app.actor.RedMonster")
local WhiteMonster = require("app.actor.WhiteMonster")
local BlueMonster = require("app.actor.BlueMonster")
local YellowMonster = require("app.actor.YellowMonster")
local AnimationFactory = require("app.factory.AnimationFactory")
local Rect = require("app.quadTree.Rect")
require("app.data.MonsterData")

local MonsterFactory={}

--根据当前波数和怪物类型生成怪并添加到gameScene中便于管理
--function MonsterFactory.produceMonster(gameScene,monsterType,i,j)
--function MonsterFactory.produceMonster(gameScene,batchNode,catProperties,way)
function MonsterFactory.produceMonster(gameScene,catProperties,way,currentIndex,isBoss,specialFlag,fuWenFlag)
    --way = 10
    if isBoss then
        local args = {
            node = display.getRunningScene(),
            image = "ui/fighting/pvp_skill_cat.png",
            title = "ui/fighting/pvp_skill_name_11.png",
            sound = "music/flash.mp3",
            callback = function() end,
            is_hero = nil,
        }
        CommUtil.glitter(args)
    end

    if fuWenFlag==1 then
        gameScene.fuWenManager:produceFuWen()
    end

    --print("specialFlag",specialFlag)

    if specialFlag~=nil and specialFlag~="" and specialFlag~=0 then
        local tipSprite = display.newSprite("ui/fighting/fighting_mosterhead_1.png",display.left+30,display.top-100):addTo(gameScene,6000)
        tipSprite:setScale(0.5)
        tipSprite:setTouchEnabled(true)
        tipSprite:addTouchEventListener(function(event, x, y)
        if event == "began" then
            local infoPanel = display.newSprite("ui/setting/setting_base_1.png",display.left+160,display.top-80):addTo(gameScene,6000)
            infoPanel:setScaleX(0.7)
            infoPanel:setScaleY(0.3)
            local infoLabel = ui.newTTFLabel({
                    text = specialFlag.."",
                    font = "Marker Felt",
                    size = 14,
                    x = display.left+160,
                    y = display.top-90,
                    color = ccc3(255,255,255),
                    align = ui.TEXT_ALIGN_CENTER
            }):addTo(gameScene,6000)
            display.getRunningScene():performWithDelay(function()
                infoPanel:removeSelf()
                infoLabel:removeSelf()
            end,5)
            return true
        end
    end)
        local questionSprite = display.newSprite("ui/fighting/fighting_surprise.png",50,50):addTo(tipSprite)
        local sequence = transition.sequence({
                CCMoveBy:create(0.3, ccp(0, 10)),
                CCMoveBy:create(0.3, ccp(0, -10)),
        })
        questionSprite:runAction(CCRepeatForever:create(sequence))
        display.getRunningScene():performWithDelay(function()
            tipSprite:removeSelf()
        end,5)
    end


    local path = gameScene:getActorPath(way)

    if path==nil then return end
    --print("走的第几条路",way)
    local spawnPoint = tolua.cast(path:objectAtIndex(0),"WayPoint")--怪物的出生点第一个点
    --local offset = 20*catProperties[19]
    local offset = 20*0.5
    
    local xPos = spawnPoint.position.x + CommUtil.getBlankWidth()
    local yPos = spawnPoint.position.y

    local blood = catProperties[7]
    local scale = catProperties[16]
    

    local attackerProperties = {
        hp = blood,
        fullHp = blood,
        elite = catProperties[3],
        level = catProperties[4],
        body_id = catProperties[10],
        id = catProperties[1],
        name = catProperties[2],
        air = catProperties[13],
        underground = catProperties[14],
        stealth = catProperties[15],
        scale = scale,
        walk_animation_time = catProperties[17],
        blood_offset = catProperties[18],
        death_effect = catProperties[19],
        death_sound = catProperties[20],
        dida = catProperties[21],
        swim = catProperties[22],
        damage = catProperties[23],
        wood = catProperties[24],
        water = catProperties[25],
        fire = catProperties[26],
        soil = catProperties[27],
        --monsterType = catProperties[1],
        move_speed = catProperties[8],
        position = ccp(xPos,yPos),
        necrit_proc = catProperties[9],
        --hit_proc = catProperties[11],
        --skill_proc = catProperties[12],
        armor = catProperties[6],
        resist = catProperties[5],
        --necrit_mul = catProperties[10],
        offset = offset,
        way = way,
        index = currentIndex,
    }
    
    local zorder = GameInstance:sharedInstance():zorderForPosition(ccp(xPos,yPos))
    local monster = nil
    
    if attackerProperties.body_id==70042 or attackerProperties.body_id==70045 or attackerProperties.body_id==70046 or attackerProperties.body_id==70053 or attackerProperties.body_id==70050 then
        monster = Boss.new(attackerProperties,gameScene,path)
    elseif attackerProperties.body_id==70051 then
        monster = require("app.actor.NewBoss").new(attackerProperties,gameScene,path)
    else
        if attackerProperties.swim == 1 then
            monster = SwimMonster.new(attackerProperties,gameScene,path)
        else
            monster = Attacker.new(attackerProperties,gameScene,path)
        end
    end

    gameScene:addChild(monster,zorder)
    GameInstance:sharedInstance().monsters:addObject(monster)
    monster:walk()
    if pauseStatus then monster:pause() end
end

return MonsterFactory
