local Tower = require("app.actor.Tower")
local UserDefault = require("app.common.UserDefault")
local MathUtil = require("app.common.MathUtil")
local UserDefault = require("app.common.UserDefault")
local DebugUtil = require("app.common.DebugUtil")
local AnimationFactory = require("app.factory.AnimationFactory")
local TowerUpgradeView = require("app.views.TowerUpgradeView")

local TowerFactory= class("TowerFactory",function(gameScene,scene_info,args,dropFromSkyCallBacks)
    --local node = display.newNode()
    --node:setCascadeBoundingBox(CCRect(100, 130, display.width-160, display.height-160))
    --return node
    local layer = display.newLayer()
    return layer
end)

function TowerFactory:ctor(gameScene,scene_info,args,dropFromSkyCallBacks,guide)
    self.sceneInfo = scene_info

    if dropFromSkyCallBacks~=nil then
        self.dropFromSkyCallBacks = dropFromSkyCallBacks
    end
    
    self.items = {}
    self.towers = {}
    
    self.gameScene = gameScene
    self:setTouchSwallowEnabled(false)
    if args.npc == true then
        self.sceneInfo = gNTower:getSceneInfo(gBattle.data.home_scene_id)["scene_info"]
        self:initNPCTowers(gameScene,args)
        self.ifNpc = true
        self:setTouchEnabled(true)
        self:registerScriptTouchHandler(handler(self,self.onTouch))
    else
        if guide then
            self:initGuideTowers(gameScene,self.sceneInfo,args)
            self.ifNpc = false
            self:setTouchEnabled(true)
            self:registerScriptTouchHandler(handler(self,self.onTouch))
        else
            self:initTowers(gameScene,self.sceneInfo,args)
            self.ifNpc = false
            self:setTouchEnabled(true)
            self:registerScriptTouchHandler(handler(self,self.onTouch))
        end
    end
    self.canTouch = false
end

function TowerFactory:disableTouch()
    self:setTouchEnabled(false)
end

function TowerFactory:enableTouch()
    self:setTouchEnabled(true)
end

function TowerFactory:clearToolBar()
    self:performWithDelay(function()
        self:setBuildFlag(false)
    end,1.5)
    if not tolua.isnull(self.propertiesLabel) and self.propertiesLabel~=nil then self.propertiesLabel:removeSelf() self.propertiesLabel=nil end
    if self.toolBar~=nil and not tolua.isnull(self.toolBar) then
        self.toolBar:removeSelf()
    end
    self.toolBar=nil
    self.range = nil
    self.items = {}
    --self.gameScene.skillPanel:runAction(CCMoveTo:create(0.2,ccp(0,0)))
    self.gameScene:resume()
    if self:getChildByTag(98)~=nil then
        self:getChildByTag(98):removeSelf()
    end
    if self:getChildByTag(99)~=nil then
        self:getChildByTag(99):removeSelf()
    end
end


function TowerFactory:getOneMonsterInTouchPoint(x,y)
    for i=0,GameInstance:sharedInstance().monsters:count()-1 do
        local monster = GameInstance:sharedInstance().monsters:objectAtIndex(i)
        if monster~=nil and not tolua.isnull(monster) and (monster.mainSprite:getCascadeBoundingBox():containsPoint(ccp(x,y))) then
           return monster
        end
    end
    return nil
end

function TowerFactory:onTouch(event, x, y)
    if event == "began" then
        if not self.canTouch then
            --print("不可以触摸")
            return false
        else
            --print("可以触摸")  
        end
        if CCDirector:sharedDirector():isPaused() then
            return false
        end


        --[[
        local monster = self:getOneMonsterInTouchPoint(x,y)
        if monster~=nil then
            local actionByTag = monster:getActionByTag(99)
            print("monster信息",monster.move_speed,monster.attackerProperties.move_speed,monster.ifPause,actionByTag:isDone())
        end]]



        for k, v in ipairs (display.getRunningScene().fuWens) do
            local fuWdnSprite = v
            local boundingBox = v:getBoundingBox()
            if boundingBox:containsPoint(ccp(x,y)) then
                fuWdnSprite:setScale(1.2)
                self.gameScene.freeItemItems[fuWdnSprite.type] = self.gameScene.freeItemItems[fuWdnSprite.type] + 1
                table.remove(display.getRunningScene().fuWens,k)


                local destionNation = self.gameScene.skillPanel:getSkillViewsCenterPointArray()[fuWdnSprite.type]
                local distance = ccpDistance(ccp(x,y),destionNation)
                local time = distance/400


                local action = transition.sequence({
                    CCMoveTo:create(time,destionNation),
                    CCCallFunc:create(function()
                        self.gameScene.skillPanel:updateItem()
                        fuWdnSprite:removeFromParentAndCleanup(true)

                        if self.gameScene.skillPanel.bg[fuWdnSprite.type]:isVisible() then
                            local frames = display.newFrames("guide_%02d.png", 1,8)
                            local animation = display.newAnimation(frames,1/8)
                            local effect = display.newSprite(frames[1],destionNation.x-27,destionNation.y+3):addTo(self.gameScene,60001)
                            effect:setScale(0.4*4)
                            transition.execute(effect,CCAnimate:create(animation),{
                            onComplete = function()
                                effect:removeSelf()
                            end,
                            })
                        end
                    end),
                    })
                fuWdnSprite:runAction(action)
                --[[
                fuWdnSprite:performWithDelay(function()
                    fuWdnSprite:removeSelf()
                end,0.5)]]
                local tower,tag = self:checkWhickTowerClicked(x,y)
                if tower~=nil and tower:ifSendHero() and tower.angerNum>=100 then
                else
                    return true
                end
            end
        end
        
        if self.propertiesLabel~=nil then
            self.propertiesLabel:removeSelf()
            self.propertiesLabel = nil
        end

        if self.toolBar~=nil then
            local tower,tag = self:checkWhickTowerClicked(x, y)
                --战斗场景点击显示范围
                self:clearToolBar()
                if tower~=nil then
                    tower:doClick()
                    if tower:ifSendHero() and tower.angerNum>=100 then
                        tower:releaseSkill()
                        return true
                    end
                    self.toolBar = self:makeToolBar(tower:ifBuild(),tower:ifSendHero(),tower:ifFriendTower(),tower:ifRecommendFriendTower(),tag):pos(tower:getPositionX(),tower:getPositionY())
                    self.toolBar:setScale(0.3)
                    self.gameScene:addChild(self.toolBar,2000)
                    transition.scaleTo(self.toolBar,{scale = 1, time = 0.2})
                end
        else
            --print("正在添加bar")
            local tower,tag = self:checkWhickTowerClicked(x, y)
            --if self.ifNpc and tower~=nil then
            if tower~=nil then
                tower:doClick()
                if tower:ifSendHero() and tower.angerNum>=100 then
                    tower:releaseSkill()
                    return true
                end
                self.toolBar = self:makeToolBar(tower:ifBuild(),tower:ifSendHero(),tower:ifFriendTower(),tower:ifRecommendFriendTower(),tag):pos(tower:getPositionX(),tower:getPositionY())
                self.toolBar:setScale(0.3)
                self.gameScene:addChild(self.toolBar,2000)
                transition.scaleTo(self.toolBar,{scale = 1, time = 0.2})
            end     
        end
    end
    return false
end

function TowerFactory:checkWhickTowerClicked(x, y)
    local pos = CCPoint(x, y)
    --for i = 1, GameInstance:sharedInstance().towers:count() do
    local children = self:getChildren()
    --print("孩子的大小是"..self:getChildrenCount())
    --for i = 1, self:getChildrenCount() do
    for i = 1, #self.towers do
        local child = self.towers[i]
        --local tower = GameInstance:sharedInstance().towers:objectAtIndex(i-1)
        --local boundingBox = tower:getBox()
        --local child = tolua.cast(children:objectAtIndex(i-1), "CCNode")
        local offset = 25
        local checkRangeX = 60
        local checkRangeY = 60
        if child:ifBuild() then
            checkRangeX = 80
            checkRangeY = 120
            offset = 35
        end
        local boundingBox = CCRect(child:getPositionX()-checkRangeX/2,child:getPositionY()+offset-checkRangeY/2,checkRangeX,checkRangeY)
        --print(boundingBox.origin.x, boundingBox.origin.y)
        if towerRectDebug and child:ifBuild() then
            local rect = display.newRect(checkRangeX,checkRangeY)
            rect:pos(child:getPositionX(),child:getPositionY()+offset)
            rect:addTo(display.getRunningScene())
        else
            --local rect = display.newRect(checkRangeX,checkRangeY)
            --rect:pos(child:getPositionX(),child:getPositionY()+offset)
            --rect:addTo(display.getRunningScene())
        end

        if boundingBox:containsPoint(pos) then
            --print("child.tag__is__"..child.tag)
            return child,child:getTag()
        else
            --print("child.tag__is__"..child.tag)
        end

    end
    return nil,-1
end

function TowerFactory:isBuilding()
    if self.toolBar~=nil then
        return true
    else
        return false
    end
end

function TowerFactory:makeTowerRange(index)
    if true then return end
    local tower = self.gameScene:getChildByTag(index)
    local range = display.newSprite("#fighting_ring.png")
    range.clickedTowerIndex = index
    local towerRange = tower:getRange()
    range:setScale(towerRange/tower_base_radius)
    --local size = range:getBoundingBox().size
    --print("tower:getRange()",tower:getRange(),size.width/2,size.height/2)
    return range
end

function TowerFactory:getBuildTowerNum()
    local num = 0
    for i = 0, GameInstance:sharedInstance().towers:count()-1 do
        local tower = GameInstance:sharedInstance().towers:objectAtIndex(i)
        if tower:ifBuild() and (not tower:ifFriendTower()) then
            num = num + 1
        end
    end
    return num
end

function TowerFactory:getFriendTowerNum()
    local num = 0
    --yx修改，新手引导强制在有牛魔王塔的时候要强制建一个好友塔
    if (gPlayer.data.pve_pass_id <= 60005) then
        return 0
    end
    --
    --
    for i = 0, GameInstance:sharedInstance().towers:count()-1 do
        local tower = GameInstance:sharedInstance().towers:objectAtIndex(i)
        if tower:ifBuild() and tower:ifFriendTower() then
            num = num + 1
        end
    end
    return num
end

function TowerFactory:enableTouch()
    self.canTouch = true
end

function TowerFactory:setBuildFlag(flag)
    self.ifSendingHero = flag
end

function TowerFactory:disableTouch()
    self.canTouch = false
end
function TowerFactory:makeToolBar(ifBuild,ifSendHero,ifFriendTower,ifRecommendFriendTower,index)

    --self:getParent():hideMenu()

    --local toolBarBg = display.newSprite("ui/home/home_towermarquee.png")
    --local toolBarBg = display.newSprite("ui/public/fighting_ring_2.png")
    local toolBarBg = display.newSprite()
    toolBarBg:setVisible(false)

    toolBarBg.clickedTowerIndex = index

    local tower = self.gameScene:getChildByTag(index)
    --self:refreshTowerInfo(tower)
    
    local w = toolBarBg:getContentSize().width
    local h = toolBarBg:getContentSize().height

    local left_bottorm_x = 12   
    local left_bottorm_y = 1/6*h+25
    local right_bottorm_x = w-12   
    local right_bottorm_y = 1/6*h+255

    if ifBuild==false then

        toolBarBg:setVisible(false)

        local para={}
        para.callback1=function()
            CommUtil.playSound("music/intower.mp3")
        end
        para.position=ccp(display.cx,display.cy)
        para.pos_x=display.cx
        para.pos_y=display.cy
        para.callback=function(selectData)
            CommUtil.playSound("music/hero_music_"..selectData.id..".mp3")
            self:performWithDelay(function()
                tower:addHeroDropFromSkyEffect(function()
                    --self.gameScene:resume()
                    tower:setTowerProperties(selectData)
                    tower:addHeroView(false)
                    CommUtil.checkShunHave()
                    gPlayer:useCopper(buildTowerCooper)
                    self.gameScene.gameHud:updateCooper()
                    self.gameScene.quadTree:updateTowerRect(tower)
                    self:performWithDelay(function()
                        self:setBuildFlag(false)
                    end,1.5)
                end)
            end,0.5)
        end
        if gPlayer.data.copper_cnt:get() - buildTowerCooper>=0 then
            --self.gameScene:pause()
           
            self:setBuildFlag(true)
            require("app.common.BusInterface").ReplaceHero(para,display.getRunningScene())

        else
            CommUtil.toastNode(display.getRunningScene(),"金币不足",0)
        end
        
        --self.gameScene.skillPanel:runAction(CCMoveTo:create(0.2,ccp(0,-100)))
    else
     

        toolBarBg:setVisible(false)
        tower:doClick()
        --self.gameScene.skillPanel:runAction(CCMoveTo:create(0.2,ccp(0,-100)))

        local circleBg = display.newSprite("ui/fighting/fighting_ring.png",tower:getPositionX(),tower:getPositionY())
        circleBg:setTag(98)
        self:addChild(circleBg)
        circleBg:setScale(tower:getRange()/110)
        --[[
        local deleteTower = self:newItem(1,-1)
        deleteTower:pos(tower:getPositionX(),tower:getPositionY())
        deleteTower:setTag(99)
        self:addChild(deleteTower)
        deleteTower.tag = "deleteTower"
        deleteTower.confirm = false--是否选中
        self.items[#self.items + 1] = deleteTower
        ui.newTTFLabel({
            text = deleteTowerReturnCooper,
            font = "Marker Felt",
            size = 18,
            x = 0,
            y = -20,
            color = ccc3(0,0,0),
            align = ui.TEXT_ALIGN_CENTER
        }):addTo(deleteTower)
                
        deleteTower:setTouchEnabled(true)
        deleteTower:addTouchEventListener(function(event, x, y, prevX, prevY)
            if event=="began" then
                self:doItemClick(deleteTower,index)
            end
            return true
        end)
]]
        --[[
        if tower:ifCanUpgrade() then-------------------猪八戒和沙和尚不能升级
            local upgrade = self:newItem(2,tower:getHeroId())
            upgrade:pos(w,h/2)
            toolBarBg:addChild(upgrade)
            upgrade.tag = "upgrade"
            upgrade.confirm = false--是否选中
            self.items[#self.items + 1] = upgrade
            ui.newTTFLabel({
                text = upgradeTowerCooper,
                font = "Marker Felt",
                size = 18,
                x = 0,
                y = -20,
                color = ccc3(0,0,0),
                align = ui.TEXT_ALIGN_CENTER
            }):addTo(upgrade)
                    
            upgrade:setTouchEnabled(true)
            upgrade:addTouchEventListener(function(event, x, y, prevX, prevY)
                if event=="began" then
                    self:doItemClick(upgrade,index)
                end
                return true
            end)
        end]]
        
    end
    self.clickFlag = false
    self:performWithDelay(function()
        self.clickFlag = true
    end,0.5)
    return toolBarBg
end

function TowerFactory:refreshTowerInfo(tower)
    self.sceneInfo = nil
    self.sceneInfo = gNTower:getSceneInfo(gBattle.data.home_scene_id)["scene_info"]
    local towerInfo = self:getTowerInfo(self.sceneInfo,tower:getIdInTileMap())
    tower:setTowerProperties(towerInfo)
end

function TowerFactory:canBuildFriendTower()
    local canBuildNum = gPlayer.data.friend_tower_limit - self:getFriendTowerNum()
    if canBuildNum<=0 then
        return false
    else
        if gPlayer.data.pve_pass_id <DEF_OPEN_FRIEND_PASS_ID then
            return false
        else
            return true
        end
    end
end

function TowerFactory:canBuildTower()
    local towerLimit = gExpTemplate:getTowerLimit()
    if gBattle.data.home_scene_id == gPlayer.data.world_boss_scene_id then--斩妖除魔可以8个塔
        towerLimit = 8
    end
    local canBuildNum = towerLimit - self:getBuildTowerNum()
    if canBuildNum<=0 then
        --print("不可以修塔",towerLimit,canBuildNum)
        return false
    else
        --print("可以修塔",towerLimit,canBuildNum)
        return true
    end
end

function TowerFactory:getTowerLimit()
    local towerLimit = gExpTemplate:getTowerLimit()
    if gBattle.data.home_scene_id == gPlayer.data.world_boss_scene_id then--斩妖除魔可以8个塔
        towerLimit = 8
    end
    return towerLimit
end

function TowerFactory:doItemClick(item,index)
    if not self.clickFlag then return end
    local tower = self.gameScene:getChildByTag(index)
    local itemName = item.tag
    if item.tag == "deleteTower" then
        --self.gameScene.skillPanel:runAction(CCMoveTo:create(0.2,ccp(0,0)))
        local hId = tower:getHeroId()
        gHero:setHeroOutBattle(tower:getHeroId())
        tower:setTowerProperties(nil)
        tower:removeHero()
        CommUtil.checkShunHave()
        gPlayer.data.copper_cnt:set(gPlayer.data.copper_cnt:get()+deleteTowerReturnCooper)
        self.gameScene.gameHud:updateCooper()

        --[[
        local ifExists = function(hId)
            for i = 0, GameInstance:sharedInstance().towers:count()-1 do
                local tower = GameInstance:sharedInstance().towers:objectAtIndex(i)
                if tower:getHeroId()==hId then
                    return true
                end
            end
            return false
        end
        if not ifExists(hId) then self.gameScene.skillPanel:lockSkill(hId) end]]
        
        if not tolua.isnull(self.propertiesLabel) and self.propertiesLabel~=nil then self.propertiesLabel:removeSelf() self.propertiesLabel=nil end
        if self.toolBar~=nil and not tolua.isnull(self.toolBar) then
            self.toolBar:removeSelf()
        end
        self.toolBar=nil
        self.range = nil
        self.items = {}
    elseif item.tag == "upgrade" then
        --print("变身")
        if not tolua.isnull(self.propertiesLabel) and self.propertiesLabel~=nil then self.propertiesLabel:removeSelf() self.propertiesLabel=nil end
        if self.toolBar~=nil and not tolua.isnull(self.toolBar) then
            self.toolBar:removeSelf()
        end
        if gPlayer.data.copper_cnt:get()-upgradeTowerCooper<0 then
            CommUtil.toastNode(display.getRunningScene(),"金币不足",0)
            return
        end
        tower:upgradeTower()
        self.toolBar=nil
        self.range = nil
        self.items = {}
        gPlayer.data.copper_cnt:set(gPlayer.data.copper_cnt:get()-upgradeTowerCooper)
        self.gameScene.gameHud:updateCooper()
        --self.gameScene.skillPanel:runAction(CCMoveTo:create(0.2,ccp(0,0)))
    elseif item.tag == "fenShen" then
        --print("分身")
    end
    self:getChildByTag(98):removeSelf()
    self:getChildByTag(99):removeSelf()
end

function TowerFactory:getTowerTemplateInfo(towerType,level)
    local tower_manual_template = require("app.client.template.tower_manual_template")
    for i=1,#tower_manual_template do
        local curRow = tower_manual_template[i]
        if curRow[3]==CommUtil.getTowerTypeValve(towerType) and curRow[5]==level then return curRow end
    end
end

function TowerFactory:displayTowerInfoBar(towerType,level)

    if self.propertiesLabel~=nil then 
        self.propertiesLabel:removeSelf() 
        self.propertiesLabel = nil
    end

    local bg = display.newSprite("ui/home/home_tower_state_2.png"):pos(display.cx,display.bottom+30):addTo(self,80)

    local info = self:getTowerTemplateInfo(towerType,level)

    local typeName = nil

    if info[3]==1 then
        typeName="狂战"      
    elseif info[3]==2 then
        typeName="神射"
    elseif info[3]==3 then
        typeName="方士"
    else
        typeName="法师"
    end

    local rangeName = nil
    if info[6]==1 then
        rangeName="近"      
    elseif info[6]==2 then
        rangeName="中"
    elseif info[6]==3 then
        rangeName="远"
    else
        rangeName="超远"
    end

    local special = ""

    if info[7]==1 then
        special = special.."反隐"
    end

    if info[8]==1 then
        special = special..",对空"
    end

    if info[9]==1 then
        special = special..",对地"
    end


                
    ui.newTTFLabel({
        text = info[2],
        font = "Marker Felt",
        x=60,
        y=25,
        color = display.COLOR_WHITE,
        size = 15,
        align = ui.TEXT_ALIGN_CENTER
        }):addTo(bg)

    ui.newTTFLabel({
        text = typeName,
        font = "Marker Felt",
        x=170,
        y=25,
        color = display.COLOR_WHITE,
        size = 15,
        align = ui.TEXT_ALIGN_CENTER
    }):addTo(bg)
                
    ui.newTTFLabel({
        text = rangeName,
        font = "Marker Felt",
        x=270,
        y=25,
        color = display.COLOR_WHITE,
        size = 15,
        align = ui.TEXT_ALIGN_CENTER
    }):addTo(bg)
                
    ui.newTTFLabel({
        text = special,
        font = "Marker Felt",
        x=375,
        y=25,
        color = display.COLOR_WHITE,
        size = 15,
        align = ui.TEXT_ALIGN_CENTER
    }):addTo(bg)

    return bg

end

function TowerFactory:newItem(type,heroId)
    local parent = display.newSprite()
    local itemImageName = nil
    local heroTypeImage = nil
    if type==1 then
        itemImageName = "ui/fighting/fighting_new_tower_out.png"
        return parent
    else
        itemImageName = "ui/fighting/fighting_new_tower_change.png"
        if heroId==10003 then
            heroTypeImage = "ui/fighting/frighting_new_change_stone.png"
        elseif heroId==10004 then
            heroTypeImage = "ui/fighting/frighting_new_change_fire.png"
        elseif heroId==10005 then
            heroTypeImage = "ui/fighting/frighting_new_change_tree.png"
        elseif heroId==10006 then
            heroTypeImage = "ui/fighting/frighting_new_change_water.png"
        end
    end
    local item = display.newSprite(itemImageName)
    if heroTypeImage~=nil then
        local bb = display.newSprite(heroTypeImage,33,37)
        bb:setScale(0.6)
        item:addChild(bb)
    end
    local checkSprite = display.newSprite()
    checkSprite:setVisible(false)

    --parent:addChild(itemBg)
    parent:addChild(item)
    parent:addChild(checkSprite)
    local cooper = display.newSprite("ui/public/copper.png",10,10)
    cooper:setScale(0.5)
    item:addChild(cooper)

    --parent.canClick = true

    item:setContentSize(CCSize(65,65))
    checkSprite:setContentSize(CCSize(65,65))

    return parent
end

function TowerFactory:getTowerInfo(scene_info,id)
    if scene_info ==nil then
        return nil
    end
    for i=1,#scene_info do
        local towerInfo = scene_info[i]
        if towerInfo~=nil and id==tonumber(towerInfo["position"]) then
            return towerInfo
        end
    end
    return nil
end

function TowerFactory:refreshAllTowers()
    self.sceneInfo = gNTower:getSceneInfo(gBattle.data.home_scene_id)["scene_info"]
    local towerCount = GameInstance:sharedInstance().towerPoints:count()
    for i=1,towerCount,1 do
        local tower = self.towers[i]
        self:refreshTowerInfo(tower)
    end
end

function TowerFactory:initNPCTowers(gameScene,args)
    local towerCount = GameInstance:sharedInstance().towerPoints:count()

    --bossEmptyTowerIndex = -1
    local heroCount = 0
    for i=1,towerCount,1 do
        local towerPosition = tolua.cast(GameInstance:sharedInstance().towerPoints:objectAtIndex(i-1),"WayPoint")
        --local z = towerPosition.z
        local position = towerPosition.position
        
        local xPos = CommUtil.getBlankWidth() + position.x
        local yPos = position.y

        
        local towerInfo = self:getTowerInfo(self.sceneInfo,i)
        --[[
        if (gBattle.data.home_scene_id == gPlayer.data.world_boss_scene_id) and heroCount==6 then
            towerInfo = nil
            bossEmptyTowerIndex = i
        end]]

        local properties = {
            x=xPos,
            y=yPos,
            direction = towerPosition.direction,
            designX = position.x,--tile地图坐标x
            designY = position.y,--tile地图坐标y
            id = i,--id标识在tilemap中的塔位点顺序 结合sceneId和id可以唯一确定一张地图的一个塔位点
            towerInfo = towerInfo
        }
        tolua.cast(position,"CCPoint")
        local zorder = GameInstance:sharedInstance():zorderForPosition(position)
        local tower = Tower.new(properties,args,gameScene)
        :pos(xPos,yPos)
        tower:setTag(i)
        gameScene:addChild(tower,zorder)
        --空塔时才能够生成这个值
        if (properties.towerInfo == nil) then
            CommUtil.setBtnGuide(tower, GUIDE_BUILD_TOWER_TAKI)
            CommUtil.setBtnGuide(tower, GUIDE_BUILD_TOWER_TAKI_FRIEND)
            GUIDE_BUILD_TOWER_TAKI_FRIEND[0].y = GUIDE_BUILD_TOWER_TAKI_FRIEND[0].y+75
            if (i == 3) then
                 CommUtil.setBtnGuide(tower, GUIDE_BUILD_TOWER_SPE_TAKI)
            elseif (i == 4) then
                 CommUtil.setBtnGuide(tower, GUIDE_BUILD_TOWER_SPE4_TAKI)
            end
        end
        --
        local xxid = tower:getIdInTileMap()
        if (xxid <= 6) then
            CommUtil.setBtnGuide(tower, TOWER_BTN_POSITION[xxid])
        end
        --
        self.towers[#self.towers + 1] = tower
        GameInstance:sharedInstance().towers:addObject(tower)
        if (towerInfo~=nil and towerInfo.hero_data_point~=nil and towerInfo.hero_data_point.bornid~=nil and towerInfo.hero_data_point.bornid~=0) then
            heroCount = heroCount + 1
        end
    end
    --print("CommUtil.getBlankWidth()",CommUtil.getBlankWidth())
end


function TowerFactory:initTowers(gameScene,scene_info,args)

    local towerCount = GameInstance:sharedInstance().towerPoints:count()
    --[[
    if scene_info~=nil then
        print("场景scene_info得大小是___"..#scene_info)
        print("+++++++++++++++++++++++++++++++++++")
        DebugUtil.print_table2(scene_info,10)
        print("+++++++++++++++++++++++++++++++++++")
    else
        print("攻击数据都是为0")
    end]]
    for i=1,towerCount,1 do
        
        local towerPosition = tolua.cast(GameInstance:sharedInstance().towerPoints:objectAtIndex(i-1),"WayPoint")
        --local z = towerPosition.z

        local position = towerPosition.position

        local towerInfo = self:getTowerInfo(scene_info,i)
        --[[
        if bossEmptyTowerIndex==i then
            towerInfo = nil
        end]]

        if towerInfo~=nil and towerInfo.friend_player_id~=nil and towerInfo.friend_player_id~=0 and gameScene.activityName=="stopThiefRun" then--抓小偷好友不助战
            towerInfo = nil
        end

    --if (towerInfo~=nil and towerInfo.hero_data_point.bornid~=nil and towerInfo.hero_data_point.bornid~=0) then
        local xPos = CommUtil.getBlankWidth() + position.x
        local yPos = position.y
        local properties = {
            x=xPos,
            y=yPos,
            direction = towerPosition.direction,
            designX = position.x,--tile地图坐标x
            designY = position.y,--tile地图坐标y
            id = i,--id标识在tilemap中的塔位点顺序 结合sceneId和id可以唯一确定一张地图的一个塔位点
            towerInfo = towerInfo
        }
        tolua.cast(position,"CCPoint")
        local zorder = GameInstance:sharedInstance():zorderForPosition(position)
        local tower = Tower.new(properties,args,gameScene)
        tower:setTag(i)
        self.gameScene:addChild(tower,zorder)
        self.towers[#self.towers + 1] = tower
        --if (towerInfo~=nil and towerInfo.hero_data_point.bornid~=nil and towerInfo.hero_data_point.bornid~=0) then
            GameInstance:sharedInstance().towers:addObject(tower)
        --end
        
        tower:setPosition(ccp(xPos,yPos))
        if self.dropFromSkyCallBacks~=nil then
            tower:setVisible(false)

            if tower:getIdInTileMap()>6 then
                return
            end

            local frames = display.newFrames("intower_%02d.png", 1, 10)
            local animation = display.newAnimation(frames, 1 / 10)
            local towerEffect = display.newSprite(frames[1],xPos-10,yPos+60)
            towerEffect:setScale(1)
            self.gameScene:addChild(towerEffect,zorder)
            
            CommUtil.playSound("music/intower.mp3")
            transition.execute(towerEffect,CCAnimate:create(animation),{
                onComplete = function()
                    towerEffect:removeSelf()
                    local imageName = string.format("#tower_%s_lv%d.png",tower:getTowerType(),tower:getTowerLevel())
                    local progressTimer = CCProgressTimer:create(display.newSprite(imageName))
                    progressTimer:setType(kCCProgressTimerTypeBar)
                    local to1 = CCProgressTo:create(0.3, 100)
                    progressTimer:setMidpoint(CCPointMake(0,0))
                    progressTimer:setBarChangeRate(CCPointMake(0, 1))
                    progressTimer:setPosition(CCPointMake(xPos,yPos))
                    self.gameScene:addChild(progressTimer)
                    transition.execute(progressTimer,to1,{
                        onComplete = function()
                            tower:setVisible(true)
                            self.gameScene:removeChild(progressTimer) 
                        end
                    })
                end,
            })
        else
        end
        local xxid = tower:getIdInTileMap()
        if (xxid <= 6) then
            CommUtil.setBtnGuide(tower, TOWER_BTN_POSITION[xxid])
            TOWER_BTN_POSITION[xxid][0].x = TOWER_BTN_POSITION[xxid][0].x - 18
            TOWER_BTN_POSITION[xxid][0].y = TOWER_BTN_POSITION[xxid][0].y + 30
        end
    end

    if self.dropFromSkyCallBacks~=nil then
        self:performWithDelay(function()
            self.dropFromSkyCallBacks.onDropFromSky()
        end,2)
    end
--end
end



function TowerFactory:initGuideTowers(gameScene,scene_info,args)
    for i=1,3,1 do
        
        local towerPosition = tolua.cast(GameInstance:sharedInstance().towerPoints:objectAtIndex(i-1),"WayPoint")
        local position = towerPosition.position

        local towerInfo = self:getTowerInfo(scene_info,i)

        if towerInfo~=nil and towerInfo.friend_player_id~=nil and towerInfo.friend_player_id~=0 and gameScene.activityName=="stopThiefRun" then--抓小偷好友不助战
            towerInfo = nil
        end

        local xPos = CommUtil.getBlankWidth() + position.x
        local yPos = position.y
        local properties = {
            x=xPos,
            y=yPos,
            direction = towerPosition.direction,
            designX = position.x,--tile地图坐标x
            designY = position.y,--tile地图坐标y
            id = i,--id标识在tilemap中的塔位点顺序 结合sceneId和id可以唯一确定一张地图的一个塔位点
            towerInfo = towerInfo
        }
        tolua.cast(position,"CCPoint")
        local zorder = GameInstance:sharedInstance():zorderForPosition(position)
        local tower = Tower.new(properties,args,gameScene)
        tower:setTag(i)
        self.gameScene:addChild(tower,zorder)
        self.towers[#self.towers + 1] = tower
        if (towerInfo~=nil and towerInfo.hero_data_point.bornid~=nil and towerInfo.hero_data_point.bornid~=0) then
            GameInstance:sharedInstance().towers:addObject(tower)
        end
        tower:setPosition(ccp(xPos,yPos))
        tower:setVisible(false)
        tower.cooldown = true
    end

--end
end

function TowerFactory:getPropertiesLabel(tower)
    if true then return end
    tower:doClick()

    local towerPropertiesBg = display.newSprite("ui/home/home_tower_state_3.png")
    towerPropertiesBg:setOpacity(0)
                
    if not tower:ifFriendTower()  then
        ui.newTTFLabel({
        text = tower:getTowerName(),
        font = "Marker Felt",
        x=60,
        y=25,
        color = display.COLOR_WHITE,
        size = 15,
        align = ui.TEXT_ALIGN_CENTER
        }):addTo(towerPropertiesBg)
    else
        ui.newTTFLabel({
        text = tower:getTowerName(),
        font = "Marker Felt",
        x=60,
        y=25,
        color = display.COLOR_WHITE,
        size = 15,
        align = ui.TEXT_ALIGN_CENTER
        }):addTo(towerPropertiesBg)
    end

    ui.newTTFLabel({
        text = tower:getHeroName(),
        font = "Marker Felt",
        x=170,
        y=25,
        color = display.COLOR_WHITE,
        size = 15,
        align = ui.TEXT_ALIGN_CENTER
    }):addTo(towerPropertiesBg)
                
    ui.newTTFLabel({
        text = tower:getPower(),
        font = "Marker Felt",
        x=270,
        y=25,
        color = display.COLOR_WHITE,
        size = 15,
        align = ui.TEXT_ALIGN_CENTER
    }):addTo(towerPropertiesBg)
                
    ui.newTTFLabel({
        text = tower:getHeroLevel()~=nil and tower:getHeroLevel().."级" or "1级",
        font = "Marker Felt",
        x=375,
        y=25,
        color = display.COLOR_WHITE,
        size = 15,
        align = ui.TEXT_ALIGN_CENTER
    }):addTo(towerPropertiesBg)


    return towerPropertiesBg
end

return TowerFactory