local PveWaveManager = require("app.controllers.PveWaveManager")
local CycleWaveManager = require("app.controllers.CycleWaveManager")
local Attacker = require("app.actor.Attacker")
local TowerFactory = require("app.factory.TowerFactory")
local MathUtil = require("app.common.MathUtil")
local BlockRoadSkill = require("app.bullet.BlockRoadSkill")
local SkillPanel = require("app.views.SkillPanel")
local SkillPanelBeauty = require("app.views.SkillPanelBeauty")
local BattleHud = require("app.views.BattleHud")
local BeautySkill = require("app.bullet.BeautySkill")
local DebugUtil = require("app.common.DebugUtil")
local HeroSkill = require("app.bullet.HeroSkill")
local GameLogic = require("app.controllers.GameLogic")
local PVEGameLogic = require("app.controllers.PVEGameLogic")
local BossGameLogic = require("app.controllers.BossGameLogic")
local ThiefGameLogic = require("app.controllers.ThiefGameLogic")
local CatGameLogic = require("app.controllers.CatGameLogic")
local BattleStoryGameLogic = require("app.controllers.BattleStoryGameLogic") 
local FirstGameLogic = require("app.controllers.FirstGameLogic") 
local ZorderManager = require("app.controllers.ZorderManager")
local BossOverWord = require("app.views.BossOverWord")
local scheduler = require("framework.scheduler")
local MonsterInfoLayer = require("app.controllers.MonsterInfoLayer")
local CommUtil = require("app.common.CommUtil")
local AnimationFactory = require("app.factory.AnimationFactory")
local ParticleManager = require("app.controllers.ParticleManager")
local Rect = require("app.quadTree.Rect")
local Text = require("app.ui.Text")

local BaseScene = class("BaseScene", function(parent,scene_info,args)
    --print("__________________战斗____________________________")
    --local worldId = CommUtil.getWorld(home_scene_id)
    --print("gBattle.data.home_scene_id",worldId,home_scene_id,gBattle.data.home_pass_id)
    --print("__________________战斗____________________________")
    --display.replaceScene(require("app.scenes.BattleScene").new({worldId=501,sceneId=601,passId=60001},true,nil))
    GameInstance:sharedInstance():cleanSceneData()
    --print("场景id",args.sceneId)
    local gameScene = GameScene:create(args.sceneId)
    local suffix = ".jpg"
    if args.sceneId==701 then suffix=".png" end
    local mapBg = display.newSprite("map/map"..tostring(args.sceneId)..suffix,display.cx,display.cy):addTo(gameScene)
    parent:markAutoCleanupImage("map/map"..tostring(args.sceneId)..suffix)
    gameScene.args = args
    return gameScene
end)

function BaseScene:ctor(parent,scene_info,args)
    if not CCUserDefault:sharedUserDefault():getBoolForKey("ifFirstBattle") then
                                CCUserDefault:sharedUserDefault():setBoolForKey("ifFirstBattle",true)
                                gItem:addItem(1+300,200)
                                gItem:addItem(2+300,200)
                                gItem:addItem(3+300,200)
                                gItem:addItem(4+300,200)
                                --print("第一次战斗时候所以技能加200点能量值")
    end

    if (not SKILL_ATTACKPOWER) then
        SKILL_ATTACKPOWER = 100
    end
    self:resetFreeItemTimes()
    self.ifUseTangSeng = args.ifUseTangSeng
    self.floorNO = args.floorNO
    self.parent = parent
    self:makeBeauty()
    self:initScene()
    --self.sceneDecorateManager = require("app.controllers.SceneDecorateManager").new(self,true):addTo(self,2)
    self.deleteTowers = {}
    self.resumeTowerTimes = 1
    self.enhance = false
    self.particleManager = ParticleManager.new(self,args.sceneId):addTo(self,1000)
    --require("app.views.ExitPanel").new():addTo(self,6000)
    --self:softGuide(6)
end

function BaseScene:resetFreeItemTimes()
    self.freeItemItems = {0,0,0}--每次进入战斗时可以使用的免费的道具次数,刚开始的时候次数为零
end

function BaseScene:softGuide(index)
    if self.hand then self.hand:removeSelf() self.hand=nil end
 --   self:initGuideDialog("#7点击技能框中的技能，#9#7选中需要释放的技能！")
    local skillIndex = 1
    if gBattle.data.home_pass_id==60002 then
       skillIndex = 1
    elseif gBattle.data.home_pass_id==60003 then
        skillIndex = 2
    elseif gBattle.data.home_pass_id==60004 then
        skillIndex = 3
    elseif gBattle.data.home_pass_id==60005 then
        skillIndex = 4
    end

    if index~=nil then
        skillIndex = index
    end

    scheduler.performWithDelayGlobal(function()
        self.guideSkillIndex = skillIndex
        local skillPanel = self.beautyPanel
        local pointArray = self.beautyPanel:getSkillViewsCenterPointArray()
        local positions={
            {pointArray[skillIndex].x+30-140,pointArray[skillIndex].y+25+100},
            {pointArray[skillIndex].x+30-140,pointArray[skillIndex].y+25+100},
            {pointArray[skillIndex].x+30-140,pointArray[skillIndex].y+25+100},
            {pointArray[skillIndex].x+30-140,pointArray[skillIndex].y+25+100},
            {pointArray[skillIndex].x+30-140,pointArray[skillIndex].y+25+100},
            {pointArray[skillIndex].x+30-140,pointArray[skillIndex].y+25+100},
        }
        self.positions=clone(positions)
        self.skillIndex = skillIndex
        self:addHand(1)
        self.beautyPanel:setVisible(true)        
    end,1)
end 

function BaseScene:hideSkillPanel()
    if self.skillPanel then
        self.skillPanel:setVisible(false)
    end
end


function BaseScene:getGuideSkillIndex()
    return self.guideSkillIndex
end

function BaseScene:isForceGuide()--是否强制引导技能
    return self.forceGuide
end

function BaseScene:initGuideDialog(word)
    CommUtil.addDialog({
        node = self ,
        direct =0,
        name='引导仙子',
        arrow=true,
        content ='#7' .. word,
    }, 500002)
end
function BaseScene:addHand(type)
  --  if true then return end
    if (self.hand) then
        self.hand:removeFromParentAndCleanup(true)
        self.hand = nil
    end
    self.hand = display.newSprite("ui/guide/guide_arrow_skill_" .. type .. ".png",
    self.positions[self.skillIndex][1]+10,self.positions[self.skillIndex][2]+50):addTo(self,40001)
    self.hand:setContentSize(CCSize(300,300))
    self.hand.flag = 1
    self.hand:setRotation(-90)
    local sequence = transition.sequence({
        CCMoveBy:create(0.3, ccp(0, 20)),
        CCMoveBy:create(0.3, ccp(0, -20)),
    })
    local action = CCRepeatForever:create(sequence)
    self.hand:runAction(action)
end

function BaseScene:forceGuide()
    self:initGuideDialog("#7点击技能框中的技能，#9#7选中需要释放的技能！")
    local skillIndex = 1
    if gBattle.data.home_pass_id==60002 then
       skillIndex = 1
    elseif gBattle.data.home_pass_id==60003 then
        skillIndex = 2
    elseif gBattle.data.home_pass_id==60004 then
        skillIndex = 3
    elseif gBattle.data.home_pass_id==60005 then
        skillIndex = 4
    end

    scheduler.performWithDelayGlobal(function()
        self.guideSkillIndex = skillIndex
        local skillPanel = self.skillPanel
        local pointArray = self.skillPanel:getSkillViewsCenterPointArray()
        local positions={
            {pointArray[skillIndex].x+30-140,pointArray[skillIndex].y+25+100},
            {pointArray[skillIndex].x+30-140,pointArray[skillIndex].y+25+100},
            {pointArray[skillIndex].x+30-140,pointArray[skillIndex].y+25+100},
            {pointArray[skillIndex].x+30-145,pointArray[skillIndex].y+25+100},
        }
        self.positions=clone(positions)
        self.skillIndex = skillIndex
        self:addHand(1)
        self.skillPanel:setVisible(true)
        self:pause()
    end,1)
end

function BaseScene:guideAfterSelectSkill(skillIndex)
    self:addHand(2)
    --
    local skillPanel = self.beautyPanel

    self.guideSkillView = display.newLayer():addTo(self)
    self.guideSkillView:setTouchEnabled(true)
    self.guideSkillView:addTouchEventListener(function(event, x, y)
        if event=="began" then
            if self.hand==nil then return false end
            local touchRect = CCRect(self.hand:getPositionX()-100,self.hand:getPositionY()-300,300,300)
            if touchRect:containsPoint(ccp(x,y)) then
                scheduler.unscheduleGlobal(self.handler)--释放技能之后取消
                self.hand:removeSelf()
                self.guideSkillView:removeFromParentAndCleanup(true)
                self.hand = nil
                self.handler = nil 
                self.guideSkillView = nil
                self.guideSkillIndex = nil
                skillPanel:releaseSkillAuto(skillIndex,x,y)
                skillPanel:removeSelectSkill()
                skillPanel:setTouchable(true)
                return true
            end
        end
        return false
    end)

    self:resume()
    
    local function onInterval(dt)
        if (not self.hand) then
            return
        end
                        local monsterX,monsterY = 0
                        local monster = nil
                        if GameInstance:sharedInstance().monsters:count()>1 then
                            monster = GameInstance:sharedInstance().monsters:objectAtIndex(0)
                            monsterX = monster:getPositionX()
                            monsterY = monster:getPositionY()
                        else
                            monsterX=display.left+50
                            monsterY = display.cy+10
                        end
                        self.hand:setPosition(ccp(monsterX-125,monsterY+200))
    end
    onInterval()
    self.handler = scheduler.scheduleGlobal(onInterval,1)
    --[[self.txt_content:setString("在需要释放技能的地方，点击即可完成技能释放！")
    self.dialog:performWithDelay(function()
        self.dialog:removeFromParentAndCleanup(true)
        self.cat:removeFromParentAndCleanup(true)
        self.txt_name:removeFromParentAndCleanup(true)
        self.txt_content:removeFromParentAndCleanup(true)
    end,1.5)]]

end


function BaseScene:guideSkill()
    if gBattle.data.home_pass_id==60002 then
       self.forceGuide = false
        self:softGuide()
    else
        self.forceGuide = false
        self:softGuide()
    end
end 


function BaseScene:helpBeauty(flag)
    if not false and self.beauty then
        local imageName = nil
        imageName = "ui/fighting/fighting_hint_helpme.png"
        local helpSprite = display.newSprite(imageName,-10,100):addTo(self.beauty)
        display.getRunningScene():performWithDelay(function()
            self.beauty:removeChild(helpSprite)
        end,0.8)
    end
end

function BaseScene:makeBeauty()
    local id = 10000
    
    local beautyImageName = "hero_"..id.."_stand_front_"
    local beautyPoint = tolua.cast(GameInstance:sharedInstance().beautyPoint,"WayPoint")
    --local zorder = GameInstance:sharedInstance():zorderForPosition(ccp(beautyPoint.position.x + CommUtil.getBlankWidth(),beautyPoint.position.y))
    self.beauty = display.newSprite("#"..beautyImageName.."1.png",beautyPoint.position.x + CommUtil.getBlankWidth(),beautyPoint.position.y):addTo(self,39999)
    local frames = display.newFrames(beautyImageName.."%d.png", 1, 8)
    local animation = display.newAnimation(frames, 1 / 8)
    self.beauty:playAnimationForever(animation)

    self.beautybg =display.newSprite("#guide_01.png",beautyPoint.position.x+CommUtil.getBlankWidth(),beautyPoint.position.y-30):addTo(self,1)
      local frames = display.newFrames("guide_%02d.png", 1, 8)
      local animation = display.newAnimation(frames, 1 / 8)
      self.beautybg:playAnimationForever(animation)
      --10
      self.beautybg:setScaleY(0.6)
      self.beautybg:setScaleX(1)
      
    if self.ifUseTangSeng then 
        local btn=display.newSprite("ui/fighting/frighting_new_shield.png",55,55):addTo(self.beauty)
        btn:setScale(0.6)
    end
end


function BaseScene:changeBeauty()
    local id = 10000
    local beautyImageName = "hero_"..id.."_stand_front_"
    self.beauty:stopAllActions()
    self.beauty:setDisplayFrame(display.newSpriteFrame(beautyImageName.."1.png"))
    local frames = display.newFrames(beautyImageName.."%d.png", 1, 8)
    local animation = display.newAnimation(frames, 1 / 8)
    self.beauty:playAnimationForever(animation)
end

function BaseScene:findTheTopPositionTower()
    local returnTower = GameInstance:sharedInstance().towers:objectAtIndex(0)
    for i=1,GameInstance:sharedInstance().towers:count()-1 do
        local tower = GameInstance:sharedInstance().towers:objectAtIndex(i)
        if tower:getPositionY()>=returnTower:getPositionY() then
            returnTower = tower
        end
    end
    return returnTower
end

function BaseScene:releaseTowSkill()
    --print("这里播放两个大招的同时，除了猪八戒的塔，其它的塔都损坏了")
    local skill1Frames = display.newFrames("channel_41016_%02d.png", 1, 35)
    local skill1Animation = display.newAnimation(skill1Frames, 1.5 / 35)
    skill1 = display.newSprite(skill1Frames[1],display.cx/2,display.cy+130):addTo(self,5000)
    skill1:setScale(2)

    local skill2Frames = display.newFrames("channel_41016_%02d.png", 1, 35)
    local skill2Animation = display.newAnimation(skill2Frames, 1.5 / 35)
    skill2 = display.newSprite(skill2Frames[1],display.cx+150,display.cy+150):addTo(self,5000)
    skill2:setScale(2)

    scheduler.performWithDelayGlobal(function()
        CommUtil.vibrator(self.parent)
        CommUtil.playSound("music/soundeffect/music_41016.mp3")
    end,1.2)

    transition.execute(skill1,CCAnimate:create(skill1Animation),{
        onComplete = function()
            skill1:removeSelf()
        end
    })
    transition.execute(skill2,CCAnimate:create(skill2Animation),{
        onComplete = function()
            skill2:removeSelf()
            for i=0,GameInstance:sharedInstance().towers:count()-1 do
                local tower = GameInstance:sharedInstance().towers:objectAtIndex(i)
                tower:setVisible(false)
            end
            for i=0,GameInstance:sharedInstance().monsters:count()-1 do
                local monster = GameInstance:sharedInstance().monsters:objectAtIndex(i)
                monster:setPosition(ccp(2000,2000))
            end
            self.seaGuide:makeDialog(false)
            self:pause()
        end
    })
end

function BaseScene:frozenTower()
    local targetTower = nil
    local lastDistance = 0

    local towerIndex = -1
    for i=1,GameInstance:sharedInstance().towers:count() do
        local tower = GameInstance:sharedInstance().towers:objectAtIndex(i-1)
        if (not tower.frozened) then
            if targetTower~=nil then
                local distance = ccpDistance(ccp(self.bigBoss:getPositionX(),self.bigBoss:getPositionY()),ccp(tower:getPositionX(),tower:getPositionY()))
                if distance<lastDistance then
                    targetTower = tower
                    towerIndex = i
                    lastDistance = distance
                end
            else
                local distance = ccpDistance(ccp(self.bigBoss:getPositionX(),self.bigBoss:getPositionY()),ccp(tower:getPositionX(),tower:getPositionY()))
                targetTower = tower
                towerIndex = i
                lastDistance = distance
            end
        end
    end

    if targetTower~=nil then
        self.bigBoss:stopBossAction()
        self.bigBoss:stopWalkForce()
        
        local ifFront = nil

        local destPosition = nil

        local bossCenterX,bossCenterY,size = self.bigBoss:getTextureCenterPoint(self.bigBoss:getPositionX(),self.bigBoss:getPositionY())
        local towerPoint = targetTower:getCenterPoint()

        if bossCenterX>towerPoint.x then
            self.bigBoss.mainSprite:setFlipX(true)
        else
            self.bigBoss.mainSprite:setFlipX(false)
        end

        if bossCenterY>towerPoint.y then
            ifFront = true
            destPosition = targetTower:getTopPoint()
        else
            ifFront = false
            destPosition = targetTower:getBottomPoint()
        end

        self.bigBoss:playWalkToTowerAnimation(ifFront)
        
        local dist = ccpDistance(destPosition,ccp(self.bigBoss:getPositionX(),self.bigBoss:getPositionY()))
        local runTime = dist/(self.bigBoss.attackerProperties.move_speed*2)
        
        transition.execute(self.bigBoss,CCMoveTo:create(runTime,destPosition),{
            onComplete = function()
                    self.bigBoss.mainSprite:stopAllActions()
                    local animation = AnimationFactory.getBossAttackAnimation(ifFront,self.bigBoss.attackerProperties.body_id,self.bigBoss.attackerProperties.walk_animation_time)
                    self.bigBoss.mainSprite:playAnimationForever(animation)
                    CommUtil.playSound("music/boss_attack.mp3")
                    CommUtil.playSound("music/boss_attack.mp3")
                    scheduler.performWithDelayGlobal(function()
                        self.bigBoss.mainSprite:stopAllActions()
                        targetTower:frozen()
                        self.bigBoss:continueWalk()
                        self.gamePropsPanel:updateStatus(2)
                        --self.gamePropsPanel:updateStatus(2)
                    end,2)
            end,
        })
        --targetTower:frozen()
        --self.gamePropsPanel:updateStatus(2)
    end
end

function BaseScene:deleteOneTowerByBoss()

    local targetTower = nil
    local lastDistance = 0

    local towerIndex = -1
    for i=1,GameInstance:sharedInstance().towers:count() do
        local tower = GameInstance:sharedInstance().towers:objectAtIndex(i-1)
        if (not tower.damaged) and (not tower.ifHelper) then
            if targetTower~=nil then
                local distance = ccpDistance(ccp(self.bigBoss:getPositionX(),self.bigBoss:getPositionY()),ccp(tower:getPositionX(),tower:getPositionY()))
                if distance<lastDistance then
                    targetTower = tower
                    towerIndex = i
                    lastDistance = distance
                end
            else
                local distance = ccpDistance(ccp(self.bigBoss:getPositionX(),self.bigBoss:getPositionY()),ccp(tower:getPositionX(),tower:getPositionY()))
                targetTower = tower
                towerIndex = i
                lastDistance = distance
            end
        end
    end

    if targetTower~=nil then

        self.deleteTowers[#self.deleteTowers+1] = towerIndex

        self.bigBoss:stopBossAction()
        self.bigBoss:stopWalkForce()
        
        local ifFront = nil

        local destPosition = nil

        local bossCenterX,bossCenterY,size = self.bigBoss:getTextureCenterPointInWorld(self.bigBoss:getPositionX(),self.bigBoss:getPositionY())
        local towerPoint = targetTower:getCenterPoint()

        if bossCenterX>towerPoint.x then
            self.bigBoss.mainSprite:setFlipX(true)
        else
            self.bigBoss.mainSprite:setFlipX(false)
        end

        if bossCenterY>towerPoint.y then
            ifFront = true
            destPosition = targetTower:getTopPoint()
        else
            ifFront = false
            destPosition = targetTower:getBottomPoint()
        end

        self.bigBoss:playWalkToTowerAnimation(ifFront)
        
        local dist = ccpDistance(destPosition,ccp(self.bigBoss:getPositionX(),self.bigBoss:getPositionY()))
        local runTime = dist/(self.bigBoss.attackerProperties.move_speed*2)
        
        transition.execute(self.bigBoss,CCMoveTo:create(runTime,destPosition),{
            onComplete = function()
                    local smokeFrames,smokeAnimation = AnimationFactory.getDeleteTowerAnimation()
                    self.smokeSprite = display.newSprite(smokeFrames[1],targetTower:getPositionX(),targetTower:getPositionY()+30)
                    self:addChild(self.smokeSprite,50003)
                    self.smokeSprite:playAnimationForever(smokeAnimation)
                    self.bigBoss.mainSprite:stopAllActions()
                    local animation = AnimationFactory.getBossAttackAnimation(ifFront,self.bigBoss.attackerProperties.body_id,self.bigBoss.attackerProperties.walk_animation_time)
                    self.bigBoss.mainSprite:playAnimationForever(animation)
                    CommUtil.playSound("music/boss_attack.mp3")
                    CommUtil.playSound("music/boss_attack.mp3")
                    scheduler.performWithDelayGlobal(function()
                        self.smokeSprite:removeFromParentAndCleanup(true)
                        self.bigBoss.mainSprite:stopAllActions()
                        targetTower:deleteByBoss()
                        self.bigBoss:continueWalk()
                        --self.gamePropsPanel:updateStatus(2)
                    end,2)
            end,
        })
    end

end

function BaseScene:produceHelpTower()
    local towerIndexs = {}
    for i=1,#self.towerFactory.towers do
        local tower = self.towerFactory.towers[i]
        if not tower:ifBuild() then
            towerIndexs[#towerIndexs+1] = i
        end
    end

    local randomTowerIndex = towerIndexs[math.random(#towerIndexs)]
    local tower = self.towerFactory.towers[randomTowerIndex]

    if tower==nil then self:resume() return end

    local towerType = 0
    require("app.common.BusInterface").ReplaceHero({
        heroType = towerType,
        pos_x = tower.designX,
        pos_y = tower.designY,
        position = tower:getIdInTileMap(),
        callback1 = function(para)
            tower:addHeroDropFromSkyEffect()
            CommUtil.guideStepDelay(70)
            CommUtil.playSound("music/intower.mp3")
        end,
        callback = function(para)
            --print("入住新英雄成功",para.hero_id)
            self.sendHelper = true
            tower.ifHelper = true
            --self.gamePropsPanel:updateStatus(1)
            scheduler.performWithDelayGlobal(function()
                tower:removeHeroDropFromSkyEffect()
                self:refreshTowerInfo(tower)
                local newSkillId = tower:getSkillId()
                addRes(self.parent.name,"ani/pve/skill/skill_"..newSkillId..".plist","ani/pve/skill/skill_"..newSkillId..".pvr.ccz")
                tower:addHeroView(false)
                GameInstance:sharedInstance().towers:addObject(tower)
                self.quadTree:updateTowerRect(tower)
                self:resume()
                tower:performWithDelay(function()
                    --print("30秒钟之后将自己删除")
                    self:pause()
                    gNTower:tearTower(gBattle.data.home_scene_id,tower:getIdInTileMap(),function()
                        self:resume()
                        tower.ifHelper = false
                        self.sendHelper = false
                        --self.gamePropsPanel:updateStatus(1)
                        --display.removeSpriteFramesWithFile("ani/pve/skill/skill_"..newSkillId..".plist","ani/pve/skill/skill_"..newSkillId..".pvr.ccz")
                        tower:disappear()
                        GameInstance:sharedInstance().towers:removeObject(tower)
                    end)
                end,30)
            end,0.2)
        end
    },self)
end

function BaseScene:resumeDeletedTower()
    local towerIndex = self.deleteTowers[#self.deleteTowers]
    local tower = GameInstance:sharedInstance().towers:objectAtIndex(towerIndex-1)
    CommUtil.playSound("music/intower.mp3")
    tower:addHeroDropFromSkyEffect()
    tower:performWithDelay(function()
        tower:removeHeroDropFromSkyEffect()
        tower:resumeTower()
        self.resumeTowerTimes = self.resumeTowerTimes + 1
        table.remove(self.deleteTowers,#self.deleteTowers)
        --self.gamePropsPanel:updateStatus(2)
    end,0.3)
end

function BaseScene:produceTowers()
    local towerPointsArray = {}
    local towerCount = GameInstance:sharedInstance().towerPoints:count()
    for i=1,towerCount,1 do
        local towerPosition = tolua.cast(GameInstance:sharedInstance().towerPoints:objectAtIndex(i-1),"WayPoint")
        local position = towerPosition.position
        towerPointsArray[#towerPointsArray+1] = {x=position.x,y=position.y}
    end

    self:initTower(CommUtil.generatorHero(towerPointsArray),{onDropFromSky=function()
        --self.seaGuide:sayWord(1)
    end},false)

    for i=0,GameInstance:sharedInstance().towers:count()-1 do
        local tower = GameInstance:sharedInstance().towers:objectAtIndex(i)
        self.quadTree:updateTowerRect(tower)
    end

    display:getRunningScene():performWithDelay(function()
        self:resume()
    end,0.5)

    display:getRunningScene():performWithDelay(function()
        self.seaGuide:makeDialog(false)
        self:pause()
    end,3)
    
end

function BaseScene:play4Skills()
    self:addGuideSkillPanel()
    --出现大BOSS
    display:getRunningScene():performWithDelay(function()
        self.seaGuide:makeDialog(false)
        self:pause()
    end,24)
end

function BaseScene:playSkill(index)
    local releasePoints={
        {300,150},
        {280,130},
        {210,130},
        {200,400},
    }
    local zorder = GameInstance:sharedInstance():zorderForPosition(ccp(releasePoints[index][1],releasePoints[index][2]))
    self:addChild(BeautySkill.new(self,self.skills[index],ccp(releasePoints[index][1],releasePoints[index][2])),zorder)
end

function BaseScene:addGuideSkillPanel()
    self:initSkillPanel(false)
    --self:updateDiDaPercentage(false,-1)
    self:playSkill(1)
    scheduler.performWithDelayGlobal(function()
        self:playSkill(2)
    end,4)
    scheduler.performWithDelayGlobal(function()
        self:playSkill(3)
    end,12) 
    scheduler.performWithDelayGlobal(function()
        self:playSkill(4)
    end,10) 
end


function BaseScene:refreshTowerInfo(tower)
    local sceneInfo = gNTower:getSceneInfo(gBattle.data.home_scene_id)["scene_info"]
    local towerInfo = self:getTowerInfo(sceneInfo,tower:getIdInTileMap())
    tower:setTowerProperties(towerInfo)
end

function BaseScene:getTowerInfo(scene_info,id)
    if scene_info ==nil then
        return nil
    end
    for i=1,#scene_info do
        local towerInfo = scene_info[i]
        if towerInfo~=nil and id==tonumber(towerInfo["position"]) then
            return towerInfo
        end
    end
    return nil
end

function BaseScene:startGame()
    --print("战斗开始了....................")
    self:initWaveManager()
    if (gBattle.data.home_scene_id==702) then
        CommUtil.playBgMusic("music/battle4.mp3")
    else
        CommUtil.playBgMusic("music/battle3.mp3")
    end
    self.seaGuide:performWithDelay(function()
        self.seaGuide:monsterIsComeing()
    end,2)
end

function BaseScene:pauseGmaeWhenGirlReachEnd()
    self.seaGuide:initTouch()
    self:pause()    
end

function BaseScene:whoCanHelpTheGirl()
    local word1 = display.newProgressTimer("ui/guide/guide_words_5.png",display.PROGRESS_TIMER_BAR)
  word1:setMidpoint(CCPointMake(0, 0))
  word1:setBarChangeRate(CCPointMake(1, 0))
  word1:setPosition(CCPointMake(display.cx-150,display.cy+50))
  word1:setPercentage(0)
  self:addChild(word1,6000)

  local action = transition.sequence({
    CCProgressTo:create(2, 100),
    CCCallFunc:create(function()
      local word2 = display.newProgressTimer("ui/guide/guide_words_6.png",display.PROGRESS_TIMER_BAR)
      word2:setMidpoint(CCPointMake(0, 0))
      word2:setBarChangeRate(CCPointMake(1, 0))
      word2:setPosition(CCPointMake(display.cx+100,display.cy-50+50))
      word2:setPercentage(0)
      self:addChild(word2,6000)
      local action = transition.sequence({
        CCProgressTo:create(2, 100),
        CCDelayTime:create(0.3),
        CCCallFunc:create(function()
          word2:removeSelf()
          word1:removeSelf()
          self:pause()
          self.seaGuide:makeDialog(false)
        end),
      })

      local to1 = CCProgressTo:create(2, 100)
      word2:runAction(action)
    end),
  })
  word1:runAction(action)
end

function BaseScene:initScene()
    theLastMonster = false
    if self.args.worldId==702 then
        totalHP = require("app.common.Number").new(2)
    else
        totalHP = require("app.common.Number").new(10)
    end
    
    if self.ifUseTangSeng then
        --print("使用唐僧了")
        addingBlood = require("app.common.Number").new(5)
    else
        --print("不使用唐僧了")
        addingBlood = require("app.common.Number").new(0)
    end
    self:initMap()
    self:initParticle()
    self.quadTree = require("app.quadTree.QuadTree").new(0,Rect.new(0,0,display.width,display.height),nil,-1,self):addTo(self) 
    self:initTower(self.scene_info,nil,false)
    self.gameHud = BattleHud.new(self):addTo(self,6000)
    self:initSkillPanel(true)
    self:initWaveManager()
    self.monsterInfoLayer = MonsterInfoLayer.new(self):addTo(self)
    CommUtil.playBgMusic("music/battle3.mp3")
    --self.commonSkillCoolDown = false--控制公共的技能cd时间控制
end

function BaseScene:cleanMonsterInfoBars()
    if self~=nil and (not tolua.isnull(self)) and self.monsterInfoLayer~=nil and (not tolua.isnull(self.monsterInfoLayer)) then
        self.monsterInfoLayer:cleanMonsterInfoBars()
    end
end

function BaseScene:cleanTowerProperties()
    self.towerFactory:clearToolBar()
end

--更新战斗是波数总波数
function BaseScene:updateWave(waveNum)
    if self.gameHud then
        self.gameHud:updateWave(waveNum)
    end
end

function BaseScene:ifBuilding()
    return self.towerFactory:isBuilding()
end

function BaseScene:setTowerLayerTouchable(touchable)
    self.towerFactory.canTouch=touchable
end

function BaseScene:onTowerClick()
    --print("场景中的塔被点击了")
end

function BaseScene:initWaveManager()
    --初始化波数控制
    currentDiDa = require("app.common.Number").new(100)--技能面板初始能量值
    local num3 = display.newSprite("#public_number_3.png",display.width/2,display.height/2):addTo(self,60000)
    transition.execute(num3,CCScaleTo:create(0.5,2), {
        onComplete = function()
            num3:removeSelf()
            local num2 = display.newSprite("#public_number_2.png",display.width/2,display.height/2):addTo(self,60000)
            transition.execute(num2,CCScaleTo:create(0.7,2), {
                onComplete = function()
                    num2:removeSelf()
                    local num1 = display.newSprite("#public_number_1.png",display.width/2,display.height/2):addTo(self,60000)
                    transition.execute(num1,CCScaleTo:create(0.5,2), {
                        onComplete = function()
                            if(gPlayer.data.pass_id == 60001) then
                                self:pause()
                                local guide = require("app.views.GuideNode").new()
                                :addTo(display.getRunningScene(), GUIDE_PAGE_Z_ORDER)
                                --guide:forceGuide("guide_battle_1")
                            end

                            num1:removeSelf()
                            self.fuWenManager = require("app.controllers.FuWenManager").new(self):addTo(self,600000)
                            self.quadTree = require("app.quadTree.QuadTree").new(0,Rect.new(0,0,display.width,display.height),nil,-1,self):addTo(self)
                            self.waveManager = PveWaveManager.new(self,self.activityName):addTo(self)
                            self.gameHud:updateTotalWave()
                            self.gameLogicLayer = PVEGameLogic.new(self):addTo(self)
                            self.zorderManager = ZorderManager.new(self):addTo(self)
                            self.towerFactory.canTouch = true
                            --
                            if (self.args.passId==60001 or self.args.passId == 60005) then
                                self:pause()
                                require("app.views.BattleGuide").new():addTo(self,600001)
                            end
                        end,
                    })
                end,
            })
        end,
    })
end


function BaseScene:clean()
    if self.ifUseTangSeng then-------------------------如果选择了使用唐僧,则可以使用唐僧一次
        gItem:useTangSeng()
    end
    if self.waveManager and ( not tolua.isnull(self.waveManager)) then
        self.waveManager:stopAllActions()
    end
    --self.gameLogicLayer:removeSelf()
    if self.guideSkillView and ( not tolua.isnull(self.guideSkillView)) then
        self.guideSkillView:removeFromParentAndCleanup(true)
    end
    if self.hand and ( not tolua.isnull(self.hand))  then
        self.hand:removeFromParentAndCleanup(true)
    end
    if self.handler and ( not tolua.isnull(self.handler)) then
        scheduler.unscheduleGlobal(self.handler)--释放技能之后取消
    end
    for i=1,GameInstance:sharedInstance().towers:count() do
        local tower = GameInstance:sharedInstance().towers:objectAtIndex(i-1)
        tower:unEnhance()
    end
end

--提供给怪物的接口，主要用于给怪物分配5条道路中的一条
function BaseScene:getActorPath(way)
    if GameInstance:sharedInstance().paths:count()==0 then return nil end
    local paths = GameInstance:sharedInstance().paths
    local path = tolua.cast(GameInstance:sharedInstance().paths:objectAtIndex((way-1)),"CCArray")
    --local wp = tolua.cast(path:objectAtIndex(0),"WayPoint")
    --print("测试坐标是"..wp.position.x.."__"..wp.position.y)
    return path
end

function BaseScene:initMap()
    --print("GameScene子类初始化地图")
end

function BaseScene:ifSkillPanelSkillRelease()
    return self.skillPanel:ifSkillPanelSkillRelease()
end

function BaseScene:updateDiDaPercentage(ifUpdateAll,noChangeSkillIndex)
    if self.skillPanel~=nil then
        self.skillPanel:updateDiDaPercentage(ifUpdateAll,noChangeSkillIndex)
    end
end

--[[
function BaseScene:getSkillPanelTopLeftPoint()
    if self.skillPanel~=nil and self.skillPanel:isVisible() then
        return self.skillPanel:getTopLeftPoint()
    end
    return nil
end]]

function BaseScene:getWeatherInfo()
  local world_template = require("app.client.template.world_template")
  for i=1,#world_template do
    if world_template[i][2]==gBattle.data.home_scene_id then
      return world_template[i][4]
    end
  end
  return nil
end

function BaseScene:initParticle()
    --[[
    if self.activityName=="stopThiefRun" then--小偷场景带有随机性必须重新处理
        local weatherInfo = self:getWeatherInfo()
        if weatherInfo==nil then return end
        local mabeWeather = CommUtil.split(weatherInfo,"#",10)
        weathIndex = mabeWeather[math.random(1,#mabeWeather)]
    end
    self.particleManager = ParticleManager.new(self):addTo(self,1000)]]
end

function BaseScene:pause()
    pauseStatus = true
    if self.npc then
        --self.npc:pause()
    end
    transition.pauseTarget(self)
    for i = 0, GameInstance:sharedInstance().monsters:count()-1 do
        local monster = GameInstance:sharedInstance().monsters:objectAtIndex(i)
        monster:pause(true)
    end
    for i=1,GameInstance:sharedInstance().towers:count() do
        local tower = GameInstance:sharedInstance().towers:objectAtIndex(i-1)
        transition.pauseTarget(tower)
    end
    if self.skillPanel then
        for i=1,#self.skillPanel.skills do
            local skill = self.skillPanel.skills[i]
            transition.pauseTarget(skill)
        end
        for i=1,#self.skillPanel.timers do
            local timer = self.skillPanel.timers[i]
            transition.pauseTarget(timer)
        end
    end
    if self.gamePropsPanel then
       transition.pauseTarget(self.gamePropsPanel) 
    end
end

function BaseScene:resume()
    pauseStatus = false
    if self.npc then
        --self.npc:resume()
    end
    transition.resumeTarget(self)
    for i = 0, GameInstance:sharedInstance().monsters:count()-1 do
        local monster = GameInstance:sharedInstance().monsters:objectAtIndex(i)
        monster:resume()
    end
    for i=1,GameInstance:sharedInstance().towers:count() do
        local tower = GameInstance:sharedInstance().towers:objectAtIndex(i-1)
        transition.resumeTarget(tower)
    end
    if self.skillPanel then
        for i=1,#self.skillPanel.skills do
            local skill = self.skillPanel.skills[i]
            transition.resumeTarget(skill)
        end
        for i=1,#self.skillPanel.timers do
            local timer = self.skillPanel.timers[i]
            transition.resumeTarget(timer)
        end
    end
    if self.gamePropsPanel then
       transition.resumeTarget(self.gamePropsPanel) 
    end
end

function BaseScene:initSkillPanel(touchable)
    local skillPanelStartX = nil
    self.skills = {1,2,3}
    local panelWidth = display.left + 30
    local skillPanelRect = CCRect(0, display.bottom,display.width,display.height)
    self.skillPanel = SkillPanel.new(touchable,self.parent,self,skillPanelRect,self.skills):addTo(self,40000)
    self.skillPanel:addEventListener("onSkillRelease", function(event)
        local skillId = tonumber(event.skillId)
        --skillId = 40006
        scheduler.performWithDelayGlobal(function()
            self:setTowerLayerTouchable(true)
        end,0.2)
        if (gPlayer.data.pass_id == 60001 and not self.skill_guided) then
            scheduler.performWithDelayGlobal(function()
               local guide = require("app.views.GuideNode").new()
               :addTo(display.getRunningScene(), GUIDE_PAGE_Z_ORDER)
               --guide:forceGuide("guide_battle_2")
            end,2)
            self.skill_guided = true
        end
        if skillId~=nil and self.targetPoint~=-1 and self.targetPoint~="" then
            require("app.bullet.FullScreenSkill").new(self,skillId,5):addTo(self,5000)
        end
    end)

    --
    currentDiDa = 1000
    -----------------------------------------------------------------------------
    if (DEF_SPECIAL_PROCESS and gPlayer.data.pass_id >= 60003) then
    if ( gPlayer.data.pass_id ==  60003 ) then
        self:softGuide(1)
    end

    local panelPositionX = display.right-(4*85)+5
    local panelWidth =  display.width
     local skillPanelRect = CCRect(panelPositionX, display.bottom,panelWidth,200)
     self.skills={40008, 40004, 40016, 40020}
    self.beautyPanel = SkillPanelBeauty.new(touchable,self.parent,self,skillPanelRect,self.skills,panelType)
    self.beautyPanel:addEventListener("onSkillReleaseBeauty", function(event)
        if self.hand then self.hand:removeSelf() self.hand=nil end
        self.forceGuide = false
        self.guideSkillIndex = -1
        local skillId = event.skillId
        if skillId~=nil and self.targetPoint~=-1 and self.targetPoint~="" then
            local zorder = GameInstance:sharedInstance():zorderForPosition(ccp(event.x,event.y))
            if (skillId.."")=="40010" or (skillId.."")=="40011" or (skillId.."")=="40012" or (skillId.."")=="40015" then
                zorder = 1
            elseif (skillId.."")=="40008" then
                zorder = 2000
            elseif (skillId.."")=="40004" then
                zorder = 60000
            end
            if (skillId.."")=="40020" then
                self:addChild(BlockRoadSkill.new(self,skillId,ccp(event.x,event.y)),zorder)
            else
                self:addChild(BeautySkill.new(self,skillId,ccp(event.x,event.y)),zorder)
            end
        else
        end
        scheduler.performWithDelayGlobal(function()
            self:setTowerLayerTouchable(true)
        end,0.2)
        
    end)
    self:addChild(self.beautyPanel,40000)
    end
end

function BaseScene:bossActitiesOver()
    self.skillPanel:removeFromParentAndCleanup(true)
    self.skillPanel = nil
    self:pause()
    self.bossOverWord = BossOverWord.new(self):addTo(self,50002)
end


function BaseScene:releaseTowSkillByBoss()
    display.getRunningScene():performWithDelay(function()
        self.parent:displayBossOverPanel()
        for i=0,GameInstance:sharedInstance().towers:count()-1 do
            local tower = GameInstance:sharedInstance().towers:objectAtIndex(i)
            tower:disappear()
        end
    end,1.2)
    local skill1Frames = display.newFrames("channel_41016_%02d.png", 1, 35)
    local skill1Animation = display.newAnimation(skill1Frames, 1.5 / 35)
    skill1 = display.newSprite(skill1Frames[1],display.cx/2,display.cy+130):addTo(self,5000)
    skill1:setScale(2)

    local skill2Frames = display.newFrames("channel_41016_%02d.png", 1, 35)
    local skill2Animation = display.newAnimation(skill2Frames, 1.5 / 35)
    skill2 = display.newSprite(skill2Frames[1],display.cx+150,display.cy+150):addTo(self,5000)
    skill2:setScale(2)

    scheduler.performWithDelayGlobal(function()
        CommUtil.vibrator(self.parent)
        CommUtil.playSound("music/music_41016.mp3")
    end,1.2)

    skill1:playAnimationOnce(skill1Animation)
    skill2:playAnimationOnce(skill1Animation)
    
end

function BaseScene:initTower(scene_info,dropFromSkyCallBacks,guide)
    self.towerFactory = TowerFactory.new(self,scene_info,{npc=false},dropFromSkyCallBacks,guide):addTo(self,400001)
end

function BaseScene:hero1Comming()
    local towerPointsArray = {}
    local towerCount = GameInstance:sharedInstance().towerPoints:count()
    for i=1,3,1 do
        local towerPosition = tolua.cast(GameInstance:sharedInstance().towerPoints:objectAtIndex(i-1),"WayPoint")
        local position = towerPosition.position
        towerPointsArray[#towerPointsArray+1] = {x=position.x,y=position.y}
    end
    local sceneInfo = CommUtil.generateGuideHero(towerPointsArray)
    self:initTower(CommUtil.generateGuideHero(towerPointsArray),{onDropFromSky=function()
    end},true)

    local tower = GameInstance:sharedInstance().towers:objectAtIndex(0)
    tower.cooldown = false

    for i=0,2 do
        local tower = GameInstance:sharedInstance().towers:objectAtIndex(i)
        self.quadTree:updateTowerRect(tower)
    end

    local frames = display.newFrames("intower_%02d.png", 1, 10)
    local animation = display.newAnimation(frames, 1 / 10)
    local towerEffect = display.newSprite(frames[1],tower:getPositionX()-10,tower:getPositionY()+60)
    towerEffect:setScale(1)
    self:addChild(towerEffect,5000)
    
    CommUtil.playSound("music/intower.mp3")
    transition.execute(towerEffect,CCAnimate:create(animation),{
        onComplete = function()
            towerEffect:removeSelf()
            tower:setVisible(true)
             for i=0,GameInstance:sharedInstance().monsters:count()-1 do
                local monster = GameInstance:sharedInstance().monsters:objectAtIndex(i)
                if not monster:isBigBoss() then
                    monster:doWalkAnimation(true)
                    monster:walk()
                end
            end
            scheduler.performWithDelayGlobal(function()
                self:hero2Comming()
            end,4)
        end,
    })
end

function BaseScene:hero2Comming()
    local tower = GameInstance:sharedInstance().towers:objectAtIndex(1)
    --tower.cooldown = false
    local frames = display.newFrames("intower_%02d.png", 1, 10)
    local animation = display.newAnimation(frames, 1 / 10)
    local towerEffect = display.newSprite(frames[1],tower:getPositionX()-10,tower:getPositionY()+60)
    towerEffect:setScale(4)
    self:addChild(towerEffect,5000)
    
    CommUtil.playSound("music/intower.mp3")
    transition.execute(towerEffect,CCAnimate:create(animation),{
        onComplete = function()
            towerEffect:removeSelf()
            tower:setVisible(true)
            self:houyiSayWord(tower:getPositionX(),tower:getPositionY())
        end,
    })
end

function BaseScene:hero3Comming()
    local tower = GameInstance:sharedInstance().towers:objectAtIndex(2)
    local frames = display.newFrames("intower_%02d.png", 1, 10)
    local animation = display.newAnimation(frames, 1 / 10)
    local towerEffect = display.newSprite(frames[1],tower:getPositionX()-10,tower:getPositionY()+60)
    towerEffect:setScale(4)
    self:addChild(towerEffect,5000)
    
    CommUtil.playSound("music/intower.mp3")
    transition.execute(towerEffect,CCAnimate:create(animation),{
        onComplete = function()
            towerEffect:removeSelf()
            tower:setVisible(true)
            self:zhengyuanziSayWord(tower:getPositionX(),tower:getPositionY())
        end,
    })
end

function BaseScene:houyiSayWord(px,py)
  self.bubble = display.newSprite("ui/public/public_dialog_box.png",px+50,py+100)
  self:addChild(self.bubble,1000)
  self.words = ui.newTTFLabel({
          text = "老妖怪！放开我家小娥！！",
          font = "Arial",
          color = ccc3(0, 0, 0),
          x = -40,
          y = 10,
          size = 14,
          dimensions = CCSize(135,120),
          align = ui.TEXT_ALIGN_LEFT
  })
  self.words:setAnchorPoint(ccp(0,0))
  self.bubble:addChild(self.words)
  self.bubble:performWithDelay(function()
    self.bubble:removeSelf()
  end,1.5)
  local tower = GameInstance:sharedInstance().towers:objectAtIndex(1)
  tower.cooldown = false
  scheduler.performWithDelayGlobal(function()
    self:hero3Comming()
  end,4)
end

function BaseScene:zhengyuanziSayWord(px,py)
  self.bubble = display.newSprite("ui/public/public_dialog_box.png",px+50,py+80)
  self:addChild(self.bubble,1000)
  self.words = ui.newTTFLabel({
          text = "妖王你倒行逆施，天道不容！",
          font = "Arial",
          color = ccc3(0, 0, 0),
          x = -40,
          y = 10,
          size = 14,
          dimensions = CCSize(135,120),
          align = ui.TEXT_ALIGN_LEFT
  })
  self.words:setAnchorPoint(ccp(0,0))
  self.bubble:addChild(self.words)
  self.bubble:performWithDelay(function()
    self.bubble:removeSelf()
    self.boss:addBubbleAndWords("可恶，小的们，杀呀")
    self.boss:performWithDelay(function()
        self.boss:removeBubble()
        self.guideNode:sendMoreMonsters()
    end,2)
  end,1.5)
  local tower = GameInstance:sharedInstance().towers:objectAtIndex(2)
  tower.cooldown = false

end

function BaseScene:sayWord(px,py)
  self.bubble = display.newSprite("ui/public/public_dialog_box.png",px+50,py+80)
  self:addChild(self.bubble,1000)
  self.words = ui.newTTFLabel({
          text = "两位仁兄如此雅兴在这讨伐万妖之王，看来我镇元子也不能袖手旁观了。",
          font = "Arial",
          color = ccc3(0, 0, 0),
          x = -40,
          y = 10,
          size = 14,
          dimensions = CCSize(135,120),
          align = ui.TEXT_ALIGN_LEFT
  })
  self.words:setAnchorPoint(ccp(0,0))
  self.bubble:addChild(self.words)
  self.bubble:performWithDelay(function()
    self.bubble:removeSelf()
  end,1.5)
  local tower = GameInstance:sharedInstance().towers:objectAtIndex(2)
  tower.cooldown = false
end

-------------------------------------------PVE 特殊怪物死亡逻辑处理----------------------------------------------------------------------

function BaseScene:doRedMonsterDeadLogic(posX,posY)
    --print("死亡的坐标点是",posX,posY)
    local imageName = "bomb_%d.png"
    local frames = display.newFrames(imageName, 1,5)
    local animation = display.newAnimation(frames,0.5/5)
    local bomb = display.newSprite(frames[1],posX,posY):addTo(self,60001)
    bomb:setScale(0.8)
    bomb:setShaderProgram(CCShaderCache:sharedShaderCache():programForKey("red"))
    bomb:playAnimationOnce(animation)
    transition.execute(bomb,CCAnimate:create(animation),{
        onComplete = function()
            bomb:removeSelf()
    end})

    for i = 0, GameInstance:sharedInstance().monsters:count()-1 do
        local monster = GameInstance:sharedInstance().monsters:objectAtIndex(i)
        local x,y,size = monster:getTextureCenterPointInWorld(monster:getPositionX(),monster:getPositionY())
        if ccpDistance(ccp(posX,posY),ccp(x,y)) < 90 then
            monster:decreaseHpBySkill(monster.fullHP*0.2,false)
        end
    end

end

function BaseScene:doWhiteMonsterDeadLogic(index)
    display.getRunningScene():performWithDelay(function()
        local killAll = true--杀死所有得白色小怪物之后可以给英雄加奋斗
        for i=1,GameInstance:sharedInstance().monsters:count() do
            local monster = GameInstance:sharedInstance().monsters:objectAtIndex(i-1)
            if monster:isWhite() and monster.attackerProperties.index==index then
                killAll = false
            end
        end

        if not killAll then return end

        for i=1,GameInstance:sharedInstance().towers:count() do
            local tower = GameInstance:sharedInstance().towers:objectAtIndex(i-1)
            if tower:getHeroId()~=nil then
                tower:unEnhance()
            end
        end

        for i=1,GameInstance:sharedInstance().towers:count() do
            local tower = GameInstance:sharedInstance().towers:objectAtIndex(i-1)
            if tower:getHeroId()~=nil then
                tower:enhance()
            end
        end

        display.getRunningScene():performWithDelay(function()
            for i=1,GameInstance:sharedInstance().towers:count() do
                local tower = GameInstance:sharedInstance().towers:objectAtIndex(i-1)
                if tower:getHeroId()~=nil then
                    tower:unEnhance()
                end
            end
        end,12)

    end,1)
    -------------------------10秒钟后恢复----------------------------------------
end

function BaseScene:doYellowMonsterDeadLogic(posX,posY,height)
    killYellowMonsterNum = killYellowMonsterNum + 1
    CommUtil.playSound("music/gold.mp3")
    CommUtil.toastNode(display.getRunningScene(),"铜钱掉落增加20%",0)
    --[[
    local frames,animation = AnimationFactory.getGoldAnimation()
    local gold = display.newSprite(frames[1],posX,posY+height+50):addTo(self,60002)
    gold:setScale(0.8)
    transition.execute(gold,CCAnimate:create(animation),{
        onComplete = function()
            gold:removeSelf()
        end,
    })]]
end
-------------------------------------------PVE 特殊怪物死亡逻辑处理----------------------------------------------------------------------



--------------------------------------------------------解锁妖姬技能-------------------------------------------------------------------
function BaseScene:unLockSkill(index)
    skillIndex = index
    local skillId = self.skillPanel.skills[skillIndex].skillId
    local tempSkill = display.newSprite("icon_list/skill/skill_"..skillId..".png",self.beauty:getPositionX(),self.beauty:getPositionY()):addTo(self,60002)
    local outterBox = display.newSprite("ui/home/home_skill_select.png",-6,-7)
    outterBox:setAnchorPoint(ccp(0,0))
    tempSkill:addChild(outterBox)
    tempSkill:setScale(0.5)

    local destPosition = self.skillPanel:getSkillViewsCenterPointArray()[skillIndex]
    --local action = CCSpawn:createWithTwoActions(CCMoveTo:create(1,ccp(destPosition.x-10,destPosition.y-5)),CCScaleBy:create(1,720))

    local action = transition.sequence({
        CCSpawn:createWithTwoActions(CCMoveBy:create(0.4,ccp(-50,50)),CCScaleTo:create(0.4,1.2)),
        CCDelayTime:create(0.2),
        CCMoveTo:create(0.3,ccp(destPosition.x-10,destPosition.y-5)),
        CCCallFunc:create(function()
            tempSkill:removeSelf()
            self.skillPanel:addSkillSelectBox(skillIndex)
            local skillLock = self.skillPanel.locks[skillIndex]
            skillLock:removeSelf()
            self.skillPanel.locks[skillIndex] = nil

            self.skillPanel.locks[skillIndex] = nil

                self.guideSkillIndex = skillIndex
                local skillPanel = self.skillPanel
                local pointArray = self.skillPanel:getSkillViewsCenterPointArray()
                local positions={
                    {pointArray[skillIndex].x+30-140,pointArray[skillIndex].y+25+100},
                    {pointArray[skillIndex].x+30-160,pointArray[skillIndex].y+25+100},
                    {pointArray[skillIndex].x+30-160,pointArray[skillIndex].y+25+100},
                    {pointArray[skillIndex].x+30-165,pointArray[skillIndex].y+25+100},
                }
                self.positions=clone(positions)
                self.skillIndex = skillIndex
                self:addHand(1)
                self.skillPanel:setVisible(true)  


        end),
    })
    tempSkill:runAction(action)
end

function BaseScene:guideFocus(type)
    if type==1 then
        local tempSkill = display.newSprite("ui/fighting/fighting_collect_noemal.png",self.beauty:getPositionX(),self.beauty:getPositionY()):addTo(self,60002)
        local outterBox = display.newSprite("ui/home/home_skill_select.png",-6,-7)
        outterBox:setAnchorPoint(ccp(0,0))
        tempSkill:addChild(outterBox)
        tempSkill:setScale(0.5)

        local destPosition = ccp(self.focusNormalSprite:getPositionX(),self.focusNormalSprite:getPositionY())
        local action = transition.sequence({
            CCSpawn:createWithTwoActions(CCMoveBy:create(0.2,ccp(-30,30)),CCScaleTo:create(0.4,1.2)),
            CCDelayTime:create(0.1),
            CCMoveTo:create(0.5,ccp(destPosition.x-10,destPosition.y-5)),
            CCCallFunc:create(function()
                tempSkill:removeSelf()
                self.focusLock:removeSelf()
                self.focusLock = nil
                local frames,animation = require("app.factory.AnimationFactory").getSkillSelectAniamtion()
                self.focusLightingSprite = display.newSprite(frames[1],-18,-18):addTo(self.focusNormalSprite,30)
                self.focusLightingSprite:playAnimationForever(animation)
                self.focusLightingSprite:setAnchorPoint(CCPoint(0,0))

                local spriteX = display.right-150
                local spriteY = display.cy+70
                self.hand = display.newSprite("ui/guide/guide_arrow_skill_"..type..".png",spriteX,spriteY):addTo(self,40001)
                self.hand:setContentSize(CCSize(300,300))
                self.hand.flag = 1
                self.hand:setRotation(-90)
                local sequence = transition.sequence({
                    CCMoveBy:create(0.3, ccp(0, 20)),
                    CCMoveBy:create(0.3, ccp(0, -20)),
                })
                local action = CCRepeatForever:create(sequence)
                self.hand:runAction(action)
            end),
        })
        tempSkill:runAction(action)
    else
                local spriteX = display.right-150
                local spriteY = display.cy+70
                self.hand = display.newSprite("ui/guide/guide_arrow_skill_"..type..".png",spriteX,spriteY):addTo(self,40001)
                self.hand:setContentSize(CCSize(300,300))
                self.hand.flag = 1
                self.hand:setRotation(-90)
                local sequence = transition.sequence({
                    CCMoveBy:create(0.3, ccp(0, 20)),
                    CCMoveBy:create(0.3, ccp(0, -20)),
                })
                local action = CCRepeatForever:create(sequence)
                self.hand:runAction(action)
    end

end

function BaseScene:clickFocus()
    if self.hand and (not tolua.isnull(self.hand)) then
        self.hand:removeSelf()
        self.hand = nil
    end
    --self:guideFocus(2)
    local function onInterval(dt)
                        local monsterX,monsterY = 0
                        local monster = nil
                        if GameInstance:sharedInstance().monsters:count()>1 then
                            monster = GameInstance:sharedInstance().monsters:objectAtIndex(0)
                            monsterX = monster:getPositionX()
                            monsterY = monster:getPositionY()
                        else
                            monsterX=display.left+50
                            monsterY = display.cy+10
                        end
                        if self.hand then
                            self.hand:setPosition(ccp(monsterX-125,monsterY+200))
                        end
    end
    onInterval()
    self.handler = scheduler.scheduleGlobal(onInterval,1)
end

-------------------------------------PVE战斗集中活力控制逻辑----------------------------------------------------------------------
function BaseScene:pveFocusFireLogic()
    --self:addChild(self.gamePropsPanel,40000)

    self.canFocus = false
    self.focusMonster = nil
    
    local spriteX = display.right-50
    local spriteY = display.bottom+130
    --增加beauty
    self.beautySprite = display.newSprite("icon_list/beauty/beauty_"+gBeauty.battle_id+".png",spriteX,spriteY):addTo(self,40001)
    self.beautySprite:setScale(0.7)

    -------
    spriteY =  spriteY + 50
    self.focusNormalSprite = display.newSprite("ui/fighting/fighting_collect_noemal.png",spriteX,spriteY):addTo(self,40001)
    self.focusPressedSprite = display.newSprite("ui/fighting/fighting_collect_pressed.png",spriteX,spriteY):addTo(self,40001)
    self.focusTimer = display.newProgressTimer("ui/fighting/fighting_collect_noemal.png",display.PROGRESS_TIMER_RADIAL)
    self.focusTimer:setPosition(ccp(spriteX,spriteY))
    self.focusTimer:setPercentage(0)
    self:addChild(self.focusTimer,40000)

    if gPlayer.data.pve_pass_id == gBattle.data.home_pass_id
        and gBattle.data.home_pass_id ==60010 then
        self.focusLock = display.newSprite("ui/public/public_mask.png",spriteX,spriteY+3):addTo(self,40002)
    end

    

    self.focusPressedSprite:setVisible(false)
    self.focusTimer:setVisible(false)
    self.focusPressedSprite.canTouch = true

    self.focusNormalSprite:setTouchEnabled(true)
    self.focusNormalSprite:addTouchEventListener(function(event, x, y)
        if event == "began" then
            if CCDirector:sharedDirector():isPaused() then
                return false
            end
            if self.focusLock then
                CommUtil.toastNode(display.getRunningScene(),"未解锁", 0)
                return true
            end
            if self.hand and (gBattle.data.home_pass_id==gPlayer.data.pve_pass_id 
                and gBattle.data.home_pass_id==60010) then
                self:clickFocus()
            end
            self.focusNormalSprite:setVisible(false)
            self.focusPressedSprite:setVisible(true)
            self.focusTimer:setVisible(false)
            self.canFocus = true
            --点击后如果5秒内不释放，则自动回复
            display.getRunningScene():performWithDelay(function()
                   self.focusNormalSprite:setVisible(true)
                    self.focusPressedSprite:setVisible(false)
                    self.focusTimer:setVisible(false)
                    self.focusPressedSprite.canTouch = true
                    self.focusTimer:setPercentage(0)
            end,6)
            return true -- catch touch event, stop event dispatching
        end
    end)

    self.focusPressedSprite:setTouchEnabled(true)
    self.focusPressedSprite:addTouchEventListener(function(event, x, y)
        if event == "began" and self.focusPressedSprite.canTouch then
            if CCDirector:sharedDirector():isPaused() then
                return false
            end
            self.focusNormalSprite:setVisible(true)
            self.focusPressedSprite:setVisible(false)
            self.focusTimer:setVisible(false)
            self.canFocus = false

            return true  --catch touch event, stop event dispatching
        end
    end)
end

function BaseScene:startFocusFireOneTime()
    self.focusTimer:setVisible(true)
    self.canFocus = false
    self.focusPressedSprite.canTouch = false
    self.focusTimer:runAction(CCProgressTo:create(2,100))

    self:reorderChild(self.focusTimer,40002)
    display.getRunningScene():performWithDelay(function()
        self:reorderChild(self.focusTimer,40000)
        self.focusNormalSprite:setVisible(true)
        self.focusPressedSprite:setVisible(false)
        self.focusTimer:setVisible(false)
        self.focusPressedSprite.canTouch = true
        self.focusTimer:setPercentage(0)
    end,2)
end

-------------------------------------PVE战斗集中活力控制逻辑----------------------------------------------------------------------

--------------------------------------------------------解锁妖姬技能-------------------------------------------------------------------

return BaseScene
