require ("config")
local BaseScene = require("app.scenes.BaseScene")
local PveAttackLogic = require("app.common.PveAttackLogic")
local Buff = require("app.actor.Buff")
local scheduler = require(cc.PACKAGE_NAME .. ".scheduler")
local Text = require("app.ui.Text")
local NpcUtil = require("app.common.NpcUtil")
local BattleUtil = require("app.new.BattleUtil")
local BattleScene = class("BattleScene", function(scene_info,guide,activityName)
    return display.newScene("BattleScene")
end)

function BattleScene:pageReresh()
    if (not self.move_speed) then
    self.move_speed = 1
  end
    if (self.ares and self.ares[1] and self.ares[2]) then
       if (self.status ~= 0 and self.dida) then
        self.dida = self.dida + 1
        if (self.dida == 60) then
          self.status = 0
          self.move_speed=1
        end
      end
        for i=1, 2 do
            if (self.move_speed > 0 and self.ares[i]:getPositionY() <= -240) then
                self.ares[i]:setPositionY(240+480)
            end
            if (self.move_speed < 0 and self.ares[i]:getPositionY() >= 240+480) then
                self.ares[i]:setPositionY(-240)
            end
            self.ares[i]:setPositionY(self.ares[i]:getPositionY()-self.move_speed)
        end
    end
end

function BattleScene:resetBg()
  if (self.ares) then
      self.ares[1]:removeFromParentAndCleanup(true)
      self.ares[2]:removeFromParentAndCleanup(true)
      self.ares = nil
  end
   self.ares={} 
         self.ares[1] = display.newSprite("ui/public/pve_gossip_background.jpg", display.cx, display.cy)
         :addTo(self, 0)
         self.ares[2] = display.newSprite("ui/public/pve_gossip_background.jpg", display.cx, 240+480)
         :addTo(self, 0)
end

function BattleScene:ctor(scene_info,args)

    runningSceneName = "BattleScene"
    CURSCENE=self


    addRes("BattleScene","guide_image.plist","guide_image.png")

    self.fuWens = {}

    if args==nil then args = {worldId=501,sceneId=601,passId=60001} end
    self.args = args

    if (args.sceneId == 701) then
        self:resetBg()
            self:schedule(handler(self, self.pageReresh), 0.01)
    end



    self.passId = args.passId
    runningPassId = args.passId
        
        CCDirector:sharedDirector():getScheduler():setTimeScale(1.3)

        self:addChild(import("app.views.BlackTopView").new(),TOP_BLACK_Z_ORDER)


        --rgs.sceneId = 607
        --args.passId = 60019
        --args.worldId = 502


        self.baseScene = BaseScene.new(self,scene_info,args)
        self:addChild(self.baseScene)
        
        local function onButtonClicked(tag)
            GameInstance:sharedInstance():cleanSceneData()
            local nextScene = import("app.scenes.NPCScene").new()
            display.replaceScene(nextScene, "splitRows", 0.5, ccc3(0, 0, 0))
        end
        CommUtil.addTipBuy(self, display.right-165, display.top-30)

          
            self.resumeBtn = cc.ui.UIPushButton.new({
            normal = "ui/fighting/fighting_button_begin.png",
            pressed = "ui/fighting/fighting_button_begin.png",
            })
            :pos(display.right-90,display.top-50)
            :onButtonRelease(function(event)
                --self.baseScene.skillPanel.touchable = true
                if self.baseScene.gamePropsPanel then self.baseScene.gamePropsPanel.touchable = true end
                if self.exitPanel then self.exitPanel:removeSelf() self.exitPanel=nil end
                display.resume()
                CommUtil.resumeMusic()
                self.resumeBtn:setVisible(false)
                self.pauseBtn:setVisible(true)
                if (device.platform == 'ios') then
                  local javaClassName = "org.cocos2dx.lib.Function"
                  local javaMethodName = "resumeGame"
                  local javaParams = {}
                  local javaMethodSig = "()V"
                  local ok, ret = luaj.callStaticMethod(javaClassName,javaMethodName,javaParams,javaMethodSig)
                end
            end)
            :addTo(self, FIRST_MENU_Z_ORDER)
            :align(display.LEFT_BOTTOM)


            self.resumeBtn:setVisible(false)
            self.resumeBtn:setScale(0.9)
            
            self.pauseBtn = cc.ui.UIPushButton.new({
            normal = "ui/fighting/fighting_button_stop.png",
                pressed = "ui/fighting/fighting_button_stop.png",
            })
            :pos(display.right-90,display.top-50)
            :onButtonRelease(function(event)
                if not self.checkWinOrLoseFlag then
                    --百度的特殊处理
                if  (device.platform == 'android' and DEF_SHOW_ADVER_PROCESS) then
                    luaj.callStaticMethod("org/cocos2dx/lib/Function", "showAd", {},"()V")
                else
                    if (device.platform == 'android') then
                      if (CHANNEL_ID=="baidu") then
                        local javaClassName = "org.cocos2dx.lib.Function"
                        local javaMethodName = "pauseBaidu"
                        local javaParams = {}
                        local javaMethodSig = "()V"
                        local ok, ret = luaj.callStaticMethod(javaClassName,javaMethodName,javaParams,javaMethodSig)
                        end
                    end
                end
                    --
                    --self.baseScene.skillPanel.touchable = false
                    if self.baseScene.gamePropsPanel then self.baseScene.gamePropsPanel.touchable = false end
                    self.exitPanel = require("app.views.ExitPanel").new():addTo(self,6000)
                    display.pause()
                    audio.pauseBackgroundMusic()
                    self.resumeBtn:setVisible(true)
                    self.pauseBtn:setVisible(false)
                    if (device.platform == 'android') then
                      local javaClassName = "org.cocos2dx.lib.Function"
                      local javaMethodName = "pauseGame"
                      local javaParams = {}
                      local javaMethodSig = "()V"
                      local ok, ret = luaj.callStaticMethod(javaClassName,javaMethodName,javaParams,javaMethodSig)
                    end
                    --
                end
            end)
            :addTo(self, FIRST_MENU_Z_ORDER)
            :align(display.LEFT_BOTTOM)
            self.pauseBtn:setScale(0.9)


            self.speedNormal = cc.ui.UIPushButton.new({
                normal = "ui/fighting/fighting_twotime_normal.png",
                pressed = "ui/fighting/fighting_twotime_pressed.png",
            })
            :pos(display.right-45,display.top-50)
            :onButtonRelease(function(event)
                CCDirector:sharedDirector():getScheduler():setTimeScale(1.3)
                self.speedNormal:setVisible(false)
                self.speedUpper:setVisible(true)
            end)
            :addTo(self, FIRST_MENU_Z_ORDER)
            :align(display.LEFT_BOTTOM)

            self.speedUpper = cc.ui.UIPushButton.new({
                normal = "ui/fighting/fighting_onetime_normal.png",
                pressed = "ui/fighting/fighting_onetime_pressed.png",
            })
            :pos(display.right-45,display.top-50)
            :onButtonRelease(function(event)
                self.speedNormal:setVisible(true)
                self.speedUpper:setVisible(false)
                CCDirector:sharedDirector():getScheduler():setTimeScale(1.6)
            end)
            :addTo(self, FIRST_MENU_Z_ORDER)
            :align(display.LEFT_BOTTOM)

            self.speedNormal:setScale(0.9)
            self.speedUpper:setScale(0.9)

            self.speedNormal:setVisible(false)
            self.speedUpper:setVisible(true)


            self.start_guide = false


             if self.resumeBtn then self.resumeBtn:setScale(0.7) end
             if self.pauseBtn then self.pauseBtn:setScale(0.7) end 
             self.speedNormal:setScale(0.7)
             self.speedUpper:setScale(0.7)
           --[[ local data = require("app.client.guide2.guide_words")
    if (data[gPlayer.data.pve_pass_id] and gPlayer.data.pve_pass_id == BattleUtil.getPassId()) then 
    local callback =  function()
        display.resume()
        self.start_guide = true
        --
        self.showOver = false
        self.black_mask = display.newSprite("ui/public/public_mask.png", display.cx, display.cy)
        :addTo(self, 500002)
        self.black_mask:setScale(40)
        self.mask = cc.ui.UIPushButton.new({
            normal = "ui/public/public_mask_blank.png",
            pressed = "ui/public/public_mask_blank.png",
            })
             :pos(display.cx, display.cy)
            :addTo(self, 500002)
            :onButtonRelease(function(event)
               --if (self.showOver and gPlayer.data.pve_pass_id ~= 60001) then
                    display.resume()
                    CommUtil.dispearMove(self.dialog, 0)
                    self.dialog:removeFromParentAndCleanup(true)
                    self.dialog = nil
                    self.mask:removeFromParentAndCleanup(true)
                    self.mask =nil
                    self.black_mask:removeFromParentAndCleanup(true)
                    self.black_mask =nil
                --end
            end)
        self.mask:setScale(20)    
        self.dialog= CommUtil.addDialog({
        node = self ,
        direct =0,
        name = gHeroTemplate:getData(HELP_FIGHT_HERO[gPlayer.data.pve_pass_id]).name,
        head_type = 2, 
        head_id = HELP_FIGHT_HERO[gPlayer.data.pve_pass_id],
        content =require("app.client.guide2.guide_words")[gPlayer.data.pve_pass_id],
        movein=true,
        callback = function()
            self.showOver =  true
        end
    }, 500002)
    end
    local sleeptime = 12
    if (gPlayer.data.pve_pass_id == 60001) then
        sleeptime= 15
    end
   scheduler.performWithDelayGlobal(function()
            if (self.dialog) then
                 display.resume()
                CommUtil.dispearMove(self.dialog, 0)
            end
            if (self.mask) then
                self.mask:removeFromParentAndCleanup(true)
                self.mask =nil
            end
            if (self.black_mask) then
                    self.black_mask:removeFromParentAndCleanup(true)
                    self.black_mask =nil
            end
        end,sleeptime)
        NpcUtil.addTipPng(self, callback)

        scheduler.performWithDelayGlobal(function()
            if (not self.start_guide) then
                display.pause()
            end
        end,4)
    end]]

end

function BattleScene:clean()
    audio.pauseBackgroundMusic()
    self.baseScene:clean()
    if self.baseScene.gameHud then self.baseScene.gameHud:setVisible(false) end 
    for i = 0, GameInstance:sharedInstance().monsters:count()-1 do
        local monster = GameInstance:sharedInstance().monsters:objectAtIndex(i)
        if monster:isWhite() then monster:cancelLogic() end
        monster:removeFromParentAndCleanup(true)
    end
    GameInstance:sharedInstance():cleanSceneData()
end

function BattleScene:displayWinPanel()
    --gPlayer:saveClimbNum(climbNum)
    CCDirector:sharedDirector():getScheduler():setTimeScale(1)
    self.baseScene:hideSkillPanel()
    self:clean()
    if self.baseScene.floorNO~=nil then
        -- gPlayer.data.climbNum:set(self.baseScene.floorNO+1)
        gPlayer:saveClimbNum(self.baseScene.floorNO+1)
        --print("å•?,self.baseScene.floorNO,gPlayer.data.climbNum:get())
    end
    local star = 1
    if totalHP:get()>=10 then
        star = 3
    elseif totalHP:get()>5 then
        star = 2
    else
        star = 1
    end
    require("app.views.FightResult").new({star=star,pass_id=self.args.passId,scene_id=self.args.sceneId,map_id=self.args.worldId}):addTo(self,60001)
    CommUtil.playSound("music/victory.mp3")
end

function BattleScene:displayLosePanel()

    --CCDirector:sharedDirector():getScheduler():setTimeScale(1)
    --self.baseScene:hideSkillPanel()
    --self:clean()
    self.baseScene:pause()
    require("app.views.FightResult").new({star=0,pass_id=self.args.passId,scene_id=self.args.sceneId,map_id=self.args.worldId}):addTo(self,60001)
    --CommUtil.playSound("music/failure.mp3")
    
end

function BattleScene:releaseBeautySkill()
    local mask = CommUtil.addMaskLayer(self)
    local blue = display.newSprite("ani/pve/skill/beauty_blue.png",display.cx,display.cy):addTo(self)
    local beauty = display.newSprite("ani/pve/skill/beauty_1_skill.png",-display.cx,display.cy):addTo(self)

    transition.execute(beauty, CCMoveTo:create(0.3, CCPoint(display.cx+50, display.cy)),{
    easing = "exponentialIn",
    onComplete = function()
        self:performWithDelay(function()
            transition.execute(beauty, CCMoveTo:create(0.5, CCPoint(display.right+300, display.cy)),{
            easing = "exponentialIn",
            onComplete = function()
                mask:removeSelf()
                blue:removeSelf()
                beauty:removeSelf()
            end,
            })
        end, 1)
    end,
    })
end

function BattleScene:onEnter()
    if device.platform == "android" then
        self:performWithDelay(function()
            -- keypad layer, for android
            local layer = display.newLayer()
            layer:addKeypadEventListener(function(event)
                if event == "back" then
                    --if (gPlayer.data.pass_id == 60001 and gPlayer.data.is_guiding) then
                      --  return
                    --end

                    if  (device.platform == 'android' and DEF_SPECIAL_PROCESS) then
                        luaj.callStaticMethod("org/cocos2dx/lib/Function", "showAd", {},"()V")
                    else
                     if (CHANNEL_ID=="oppo") then  
                         if device.platform == 'android' then
                        local javaClassName = "org.cocos2dx.lib.Function"
                        local javaMethodName = "ExitApp"
                        local javaParams = {}
                        local javaMethodSig = "()V"
                        local ok, ret = luaj.callStaticMethod(javaClassName,javaMethodName,javaParams,javaMethodSig)
                        if not ok then
                            print('call java exit err = ',ret)
                            app.exit() 
                        end
                        end
                    end
                    
                     if (CHANNEL_ID == "baidu") then
                    if device.platform == 'android' then
                        local javaClassName = "org.cocos2dx.lib.Function"
                        local javaMethodName = "pauseBaidu"
                        local javaParams = {}
                        local javaMethodSig = "()V"
                        local ok, ret = luaj.callStaticMethod(javaClassName,javaMethodName,javaParams,javaMethodSig)
                        if not ok then
                            print('call java exit err = ',ret)
                        end
                    end
                end
            end
                    if (not self.showExit) then
                        self.showExit = true
                        --self.exitWindows = DeviceUtil.ExitApp(self)
                        if self.baseScene.gamePropsPanel then self.baseScene.gamePropsPanel.touchable = false end
                        self.exitWindows = require("app.views.ExitPanel").new():addTo(self,6000)
                        display.pause()
                        audio.pauseBackgroundMusic()
                        if self.resumeBtn then self.resumeBtn:setVisible(true) end
                        if self.pauseBtn then self.pauseBtn:setVisible(false) end 
                        if (device.platform == 'android') then
                          local javaClassName = "org.cocos2dx.lib.Function"
                          local javaMethodName = "pauseGame"
                          local javaParams = {}
                          local javaMethodSig = "()V"
                          local ok, ret = luaj.callStaticMethod(javaClassName,javaMethodName,javaParams,javaMethodSig)
                        end
                    else
                        self.showExit = false
                        self.exitWindows:removeFromParentAndCleanup()  
                    end
                end
            end)
            self:addChild(layer, GUIDE_PAGE_Z_ORDER)
            layer:setKeypadEnabled(true)
        end, 0.5)
    end
end

function BattleScene:onExit()
    delRes(self.name)
    tolua.fullgc()
end


function BattleScene:cleanScene()
end

return BattleScene
