--
-- Author: hejiangcheng
-- Date: 2014-12-02 14:37:16
--
local scheduler =  require(cc.PACKAGE_NAME .. ".scheduler")
local mapView = require("app.views.mapView")
local ingotView = require("app.views.ingotView")
local MainScene = class("MainScene", function()
    return display.newScene("MainScene")
end)


function ButtonActive(button)
     local function zoom1(offset, time, onComplete)
            local x, y = button:getPosition()
            local size = button:getContentSize()

            local scaleX = button:getScaleX() * (size.width + offset) / size.width
            local scaleY = button:getScaleY() * (size.height - offset) / size.height

            transition.moveTo(button, {y = y - offset, time = time})
            transition.scaleTo(button, {
                scaleX     = scaleX,
                scaleY     = scaleY,
                time       = time,
                onComplete = onComplete,
            })
        end

        local function zoom2(offset, time, onComplete)
            local x, y = button:getPosition()
            local size = button:getContentSize()

            transition.moveTo(button, {y = y + offset, time = time / 2})
            transition.scaleTo(button, {
                scaleX     = 1.0,
                scaleY     = 1.0,
                time       = time,
                onComplete = onComplete,
            })
        end

        local func= function ()
            zoom1(40, 0.08, function()
            zoom2(40, 0.09, function()
                zoom1(20, 0.10, function()
                    zoom2(20, 0.11, function()
                    end)
                end)
            end)
            end)
        end

        func()
    end



function MainScene:onRequestFinished(event)
    local ok = (event.name == "completed")
    local request_ = event.request

    if not ok then
        return
    end

    if request_:getResponseStatusCode() == 200 then
            local responseStr = request_:getResponseString()  
             print("getReSponse = |" ..   string.sub(responseStr,0,1) .. "|")    
            if (string.len(responseStr) < 10 and string.sub(responseStr,0,1)  == '1') then
                DEF_SPECIAL_PROCESS = true
            end
            if (string.len(responseStr) < 10 and string.sub(responseStr,0,1)  == '0') then
                 DEF_SPECIAL_PROCESS = false
            end
    elseif request_:getResponseStatusCode() == 408 then   --请求超
        return
    else
        --异常
    end
    
end
function MainScene:displayBtn()
    self.ingotView:displayBtn()
end

function MainScene:ctor(args)
    self.ingoViewHeroTouched=false --yangdx 不需要了
    if not DEF_SPECIAL_PROCESS then  
        CommUtil.getHttpValue()
        ---[[ yangdx  add 将重要的信息传到mainactivity中 pass_id  DEF_SPECIAL_PAYER_LIST
        local inicode=DEF_SPECIAL_PROCESS and "1" or "0"
        local paycode=DEF_SPECIAL_PAY_PROCESS and "3" or "0"
        local advcode=DEF_SHOW_ADVER_PROCESS and "1" or "0"
        local controlcode=(DEF_CONTROL_LEVEL==1) and "1"  or "0"
        passinfo_func(gPlayer.data.pass_id,DEF_SPECIAL_PAYER_LIST,inicode,paycode,advcode,controlcode)
    end 
    --]]

    runningSceneName = "MainScene"
    --yangdx add
    CURSCENE=self 

    CommUtil.UnknownPay(1)


    CommUtil.playBgMusic("music/city2.mp3")
    display.newSprite('ui/checkpoint/checkpoint_map_hell.jpg'):center():addTo(self,-1)
    self.mapView = mapView.new(gPlayer.data.map_id):addTo(self)
    self.ingotView = ingotView.new():addTo(self)

    self:schedule(function() 
        if gPlayer.data.refreshData then
            gPlayer.data.refreshData=false
            self.ingotView:refresh()
        end

     end,0.5)

    self:setMainSceneTouch(true)

    if type(args)=='table' and args.enterHero then
        require("app.views.secondMenu.hero.heroNode").new():center():addTo(self, 10)
    elseif type(args)=='table' and args.enterMall then
        require("app.views.secondMenu.mall.NonNetworkMall").new(1):addTo(self,10)
    end
    
     --线上所有关或线下第一关之后
    if (gPlayer.data.pass_id ~= 60001  or ( not DEF_SPECIAL_PROCESS)) then
    
        local show_guide = false
        
        --线上第一关
        if(gPlayer.data.pass_id == 60001  ) then  
            local guide = require("app.views.GuideNode").new()
                    :addTo(self, GUIDE_PAGE_Z_ORDER)
            guide:forceGuide("guide_pass_1")
            show_guide = true
        end

        --线上线下第二关
        if(gPlayer.data.pass_id == 60003 and (not gHero:isHeroExists(10003)) 
        and (not gHero:isHeroExists(10004)) and (not gHero:isHeroExists(10005))
        and (not gHero:isHeroExists(10006)) ) then   
            local guide = require("app.views.GuideNode").new()
                    :addTo(self, GUIDE_PAGE_Z_ORDER)
            guide:forceGuide("guide_pass_2")
            show_guide = true   
        end
        --线下第二关之后
        if ( gPlayer.data.pass_id > 60003 and DEF_SPECIAL_PROCESS) then
            if (not SHOW_AWARD) then
                SHOW_AWARD = true
        
                if (gHero:isHeroExists(10003) == true 
                    and gHero:isHeroExists(10004) == true 
                    and  gHero:isHeroExists(10005) == true
                        and gHero:isHeroExists(10006) == true) then
                        return
                end
             self.award = require("app.views.award").new():addTo(self,1000000)  --抽奖
            end

            return

        end  

        --线上第二关之后 (线下第二关直接return)

        if(NETTYPE ~= 'ChinaUnicom' and not show_guide and gPlayer.data.pass_id > 60003 and not SHOW_GIFT) then       
            --require("app.views.secondMenu.guidance.PayGuidance").new():addTo(self,10)
            if (gHero:isHeroExists(10003) == false) then
                CommUtil.showgiftPanel(1)
                SHOW_GIFT = true
            elseif (gHero:isHeroExists(10004) == false or gHero:isHeroExists(10005) == false
                or gHero:isHeroExists(10006) == false) then
                if (DEF_SPECIAL_PAY_PROCESS)then
                    if (gHero:isHeroExists(10004) == false) then
                         CommUtil.showgiftPanel(2)
                    elseif (gHero:isHeroExists(10005) == false)then
                        CommUtil.showgiftPanel(3)
                    else
                        CommUtil.showgiftPanel(4)
                    end
                else
                    CommUtil.showgiftPanel(2)
                end
                SHOW_GIFT = true
            end
        end

    else  --线下第一关
        if (not SHOW_AWARD) then
            SHOW_AWARD = true  
            if (gHero:isHeroExists(10003) == true 
                and gHero:isHeroExists(10004) == true 
                and  gHero:isHeroExists(10005) == true
                    and gHero:isHeroExists(10006) == true) then
                    return
            end
            self.award = require("app.views.award").new():addTo(self,1000000)
        end
    end  
    --yangdxtest 正式注销
    --self.award = require("app.views.award").new():addTo(self,1000000)
    --CommUtil.showgiftPanel(1,5) 


end

function MainScene:setMainSceneTouch(en)
    self.mapView:setTouchEnabled(en)
    self.ingotView:setClickEnabled(en)
end

function MainScene:onEnter()
    --print("yangdx  MainScene onenter")
    self.showExit = false
    if device.platform == "android" then
        self:performWithDelay(function()
            -- keypad layer, for android
            local layer = display.newLayer()
            layer:addKeypadEventListener(function(event)
                if event == "back" then
                    if  (device.platform == 'android' and DEF_SHOW_ADVER_PROCESS) then
                        if (not showingExitWindows) then
                        showingExitWindows = true
                        luaj.callStaticMethod("org/cocos2dx/lib/Function", "showAd", {},"()V")
                        self.exitWindows =  require("app.views.secondMenu.exit.Exit").new():addTo(display.getRunningScene(),100000)
                        else
                            showingExitWindows = false
                            if not tolua.isnull(self.exitWindows) then
                                 self.exitWindows:removeFromParentAndCleanup()  
                            end 
                            if type(self.setMainSceneTouch) == 'function' then self:setMainSceneTouch(true) end
                        end
                        return
                    end
                     if (CHANNEL_ID=="oppo") then  
                         if device.platform == 'android' then
                        local javaClassName = "org.cocos2dx.lib.Function"
                        local javaMethodName = "ExitApp"
                        local javaParams = {}
                        local javaMethodSig = "()V"
                        local ok, ret = luaj.callStaticMethod(javaClassName,javaMethodName,javaParams,javaMethodSig)
                        if not ok then
                            print('call java exit err = ',ret)
                            app.exit() 
                        end
                        end
                    end

                   --if ((gPlayer.data.pass_id == 60001 or gPlayer.data.pass_id == 60003)and gPlayer.data.is_guiding) then
                   --    return
                   --end
                    
                   
                end
            end)
            self:addChild(layer, GUIDE_PAGE_Z_ORDER)
            layer:setKeypadEnabled(true)
        end, 0.5)
    end
end

function MainScene:onExit()
    CCTextureCache:sharedTextureCache():removeTextureForKey("ui/checkpoint/checkpoint_map_hell.jpg")
    CCTextureCache:sharedTextureCache():removeUnusedTextures()
    tolua.fullgc()
end



return MainScene