--
-- Author: hejiangcheng
-- Date: 2014-12-17 10:25:28
--
local points_template = require("app.client.template.points_template")
local Text = require("app.ui.Text")
local scheduler =  require(cc.PACKAGE_NAME .. ".scheduler")
local storyScene = class("storyScene", function()
    return display.newScene("storyScene")
end)

function storyScene:ctor()

	runningSceneName = "storyScene"
	CURSCENE=self
	CommUtil.playBgMusic("music/city2.mp3")

	display.newSprite('ui/checkpoint/checkpoint_map_hell.jpg'):center():addTo(self,-1)
	self:moveMapRight()
	self:addCloudAndHero()
	self:addSkipButton()
	-- self:dragonApper()
end

function storyScene:addSkipButton()

	self.skipBtn=cc.ui.UIPushButton.new({normal="ui/checkpoint/skip_story.png"})
			   	:addTo(self,20):pos(display.left+100,display.top-40)
			   	:onButtonClicked(function(event)
			   		event.target:setButtonEnabled(false)
			   		local nextScene = import("app.scenes.MainScene").new()
			   		display.replaceScene(nextScene, "fade", 0.2, ccc3(0, 0, 0))

			   	end)
	self.skipBtn:setScale(1.5)
end

function storyScene:moveMapRight()
	self.map = display.newNode():addTo(self)
	local bg = display.newSprite("ui/checkpoint/checkpoint_cloud_1.png")
	self.cloud_height=bg:getContentSize().height/2 + display.bottom
	local map = display.newSprite("ui/checkpoint/checkpoint_map.png",display.cx, display.cy-33):addTo(self.map)
	--display.newSprite("ui/checkpoint/checkpoint_cloud_1.png",display.cx,self.cloud_height):addTo(self.map)

	self.map_width = map:getContentSize().width
	-- display.newSprite("ui/checkpoint/checkpoint_map.png",display.cx+self.map_width,display.cy-33):addTo(self.map)
	-- display.newSprite("ui/checkpoint/map_501.png",display.cx+self.map_width,display.cy-33):addTo(self.map)

	display.newSprite("ui/checkpoint/checkpoint_map.png",display.cx-self.map_width,display.cy-33):addTo(self.map)
	--display.newSprite("ui/checkpoint/checkpoint_cloud_1.png",display.cx-self.map_width,self.cloud_height):addTo(self.map)

	self.cloud=display.newNode():addTo(self,4)
	display.newSprite("ui/checkpoint/checkpoint_cloud_1.png",display.cx,self.cloud_height):addTo(self.cloud)
	display.newSprite("ui/checkpoint/checkpoint_cloud_1.png",display.cx-self.map_width,self.cloud_height):addTo(self.cloud)

	self.map:runAction(CCRepeatForever:create(CCMoveBy:create(3, ccp(self.map_width,0))))
	self.cloud:runAction(CCRepeatForever:create(CCMoveBy:create(3, ccp(self.map_width,0))))

	self.mapAction=self:schedule(function() 
		if self.map:getPositionX() >= self.map_width then
			self.map:setPositionX(0)
		end

		if self.cloud:getPositionX() >= self.map_width then
			self.cloud:setPositionX(0)
		end
    end,0.0001)
end

function storyScene:addCloudAndHero()
	self.heroNode = display.newNode():addTo(self,1)

	local frames,animation=self:getAnimation(10002)
	self.shasheng = display.newSprite(frames[1], display.cx + 50, display.cy):addTo(self.heroNode,1):flipX(true)
	self.shasheng:playAnimationForever(animation)
	self:addCloud(self.shasheng)

	local frames,animation=self:getAnimation(10001)
	self.bajie = display.newSprite(frames[1], display.cx, display.cy+20):addTo(self.heroNode):flipX(true)
	self.bajie:playAnimationForever(animation)
	self:addCloud(self.bajie)

	local frames,animation=self:getAnimation(10003)
	self.wukong = display.newSprite(frames[1], display.cx-90, display.cy):addTo(self.heroNode):flipX(true)
	self.wukong:playAnimationForever(animation)
	self:addCloud(self.wukong)

	self.tangsheng = display.newSprite("ui/checkpoint/hero_10000_body.png", display.cx+120, display.cy):addTo(self.heroNode,1)
	self:addCloud(self.tangsheng)

	self.center = display.newSprite("ui/checkpoint/checkpoint_text_1.png",display.cx,display.bottom+30):addTo(self,10)
	
	self:performWithDelay(function() 
			self.wukongTalk = display.newSprite("ui/checkpoint/checkpoint_text_2.png"):pos(0,150):addTo(self.wukong,10)
			self:performWithDelay(function() 
					self.wukongTalk:hide()
					local x,y=self.wukongTalk:getPositionX(),self.wukongTalk:getPositionY()
					self.wukongTalk:removeSelf()
					self.wukongTalk = display.newSprite('ui/checkpoint/checkpoint_text_3.png', x+60, y):addTo(self.wukong,10):hide()

					local x,y=self.center:getPositionX(),self.center:getPositionY()
					self.center:removeSelf()
					self.center = display.newSprite('ui/checkpoint/checkpoint_text_4.png', x, y):addTo(self,10)

					self:grabMaster()
				end, 2)
		end, 2)
end

function storyScene:grabMaster()
	local frames = display.newFrames('monster_70043_walk_front_%d.png', 1,8)
	local animation = display.newAnimation(frames,1.5/9)

	self.wuya1 = display.newSprite(frames[1], display.right + 40, display.top - 60):addTo(self.heroNode,2):flipX(true)
	self.wuya1:playAnimationForever(animation)

	self.wuya2 = display.newSprite(frames[1], display.right + 40, display.top - 130):addTo(self.heroNode,2):flipX(true)
	self.wuya2:playAnimationForever(animation)

	local actionMoveTo1=CCMoveTo:create(2, ccp(self.tangsheng:getPositionX()-20, self.tangsheng:getPositionY()+40))
	-- local actionMoveTo2=CCMoveTo:create(2, ccp(self.tangsheng:getPositionX()+20, self.tangsheng:getPositionY()+40))

	self.wuya1:runAction(actionMoveTo1)
	-- self.wuya2:runAction(actionMoveTo2)
	transition.moveTo(self.wuya2, {x = self.tangsheng:getPositionX()+20, y = self.tangsheng:getPositionY()+40, time = 2,
		onComplete=function() 
			self.wukongTalk:pos(60,100):scale(0.01):show()
			local pAction = transition.sequence({CCSpawn:createWithTwoActions(CCScaleTo:create(0.5, 1), CCMoveBy:create(0.5, ccp(-10,50))),
				CCDelayTime:create(0.5),
				CCFadeOut:create(0.5),
				CCCallFunc:create(function() self.wukongTalk:scale(0.01):pos(60,100):opacity(255); end)
				})
			self.wukongTalk:runAction(CCRepeatForever:create(pAction))

			self:monsterRunAway()
		end})
end

function storyScene:monsterRunAway()
	local frames = display.newFrames('monster_70043_walk_back_%d.png', 1,8)
	local animation = display.newAnimation(frames,1.5/9)
	self.wuya1:stopAllActions()
	self.wuya1:removeSelf()
	self.wuya2:stopAllActions()
	self.wuya2:removeSelf()

	self.wuya1 = display.newSprite(frames[1], self.tangsheng:getPositionX()-20, self.tangsheng:getPositionY()+40):addTo(self.heroNode,2)
	self.wuya1:playAnimationForever(animation)

	self.wuya2 = display.newSprite(frames[1], self.tangsheng:getPositionX()+20, self.tangsheng:getPositionY()+40):addTo(self.heroNode,2)
	self.wuya2:playAnimationForever(animation)
	
	local sp_cache = CCTextureCache:sharedTextureCache():addImage("ui/checkpoint/hero_10000_body2.png")
	self.tangsheng:setTexture(sp_cache)
	CCTextureCache:sharedTextureCache():removeTexture(sp_cache)
	self.tangsheng:removeAllChildren()

	local actionMoveTo1=CCMoveTo:create(2, ccp(display.right + 50, display.top - 60))
	local actionMoveTo2=CCMoveTo:create(2, ccp(display.right + 50,  display.top - 70))

	self.wuya1:runAction(actionMoveTo1)
	self.tangsheng:runAction(actionMoveTo2)
	transition.moveTo(self.wuya2, {x = display.right + 50, y = display.top - 60, time = 2,
		onComplete=function() 
			self.tangshengTalk:removeSelf();self.center:removeSelf();
			self.wuya1:removeSelf();self.wuya2:removeSelf();self.tangsheng:removeSelf();
			self:performWithDelay(function() 
				self:threeManTalk()
			end, 1.5)
		end})

	self.tangshengTalk=display.newNode():addTo(self,10)
	display.newSprite("ui/checkpoint/checkpoint_text_5.png", display.cx+120,display.cy+50):addTo(self.tangshengTalk)
	self:performWithDelay(function() 
		display.newSprite("ui/checkpoint/checkpoint_text_6.png", display.cx+190,display.cy+70):addTo(self.tangshengTalk)
		display.newSprite("ui/checkpoint/checkpoint_text_7.png", display.cx+270,display.cy+110):addTo(self.tangshengTalk)
	end, 0.8)
end

function storyScene:threeManTalk()
	-- self:dragonApper()
	self.shashengTalk = display.newSprite("ui/checkpoint/checkpoint_text_8.png", 100, 170):addTo(self.shasheng)
	self:performWithDelay(function() 
		self.shasheng:flipX(false)
		self:dragonApper()
		self:performWithDelay(function() 
			self.shasheng:flipX(true)
			self.shashengTalk:removeSelf()
			self.shashengTalk = display.newSprite("ui/checkpoint/checkpoint_text_9.png", 100, 170):addTo(self.shasheng)

			self:performWithDelay(function() 
				self.shasheng:flipX(true)
				self.shashengTalk:hide()
				self.bajieTalk=display.newSprite("ui/checkpoint/checkpoint_text_10.png", 100, 170):addTo(self.bajie)

				self:performWithDelay(function()
					self.shasheng:flipX(false)
					self.bajie:flipX(false)
					self.bajieTalk:removeSelf()
					self.bajieTalk=display.newSprite("ui/checkpoint/checkpoint_text_11.png", 100, 170):addTo(self.bajie)

					self:performWithDelay(function() 
						self.bajieTalk:removeSelf()
						self.bajieTalk=display.newSprite("ui/checkpoint/checkpoint_text_12.png", 100, 170):addTo(self.bajie)

						self:performWithDelay(function() 
							self.bajieTalk:hide()
							self.shashengTalk:removeSelf()
							self.shashengTalk=display.newSprite("ui/checkpoint/checkpoint_text_13.png", 100, 170):addTo(self.shasheng)
							self:performWithDelay(function() 
								self:findMaster() 
							end, 1.5)
						end, 2)
					end, 2)
				end, 2)
			end, 2)
		end, 2)
	end, 1)
end

--被抓后寻找唐僧
function storyScene:findMaster()
	-- self.wukongTalk:removeSelf()
	self.shashengTalk:removeSelf()
	self.bajieTalk:removeSelf()
	self.shasheng:flipX(false)
	self.bajie:flipX(false)

	self.map:stopAllActions(); self.cloud:stopAllActions();
	self:stopAction(self.mapAction);
	display.newSprite("ui/checkpoint/checkpoint_map.png",display.cx+self.map_width,display.cy-33):addTo(self.map)
	display.newSprite("ui/checkpoint/map_501.png",display.cx+self.map_width,display.cy-70):addTo(self.map)
	display.newSprite("ui/checkpoint/checkpoint_cloud_1.png",display.cx+self.map_width,self.cloud_height):addTo(self.cloud)

	self.lockCloud = display.newSprite("ui/checkpoint/map_local_cloud.png",self.map:getPositionX()+self.map_width,display.cy-40):addTo(self,5) 
	self.lockCloud:setScaleX(1.2*display.width/self.lockCloud:getContentSize().width);self.lockCloud:setScaleY(1.4*display.height/self.lockCloud:getContentSize().height);

	transition.moveTo(self.wukong,{time=1,x=display.left-50,y=display.cy,onComplete=function() self.wukong:removeSelf() end})
	self.map:moveTo(4,-self.map_width,0)
	self.cloud:moveTo(4,-self.map_width,0)
	self.lockCloud:moveTo(4,display.cx,display.cy-40)
	self:performWithDelay(function() 
			-- self.bajie:moveTo(1,display.right+50, display.cy)
			-- self.shasheng:moveTo(1,display.right+50, display.cy)
			self.bajie:removeSelf();self.shasheng:removeSelf();
			self:addPoints(501):addTo(self,4)
			if not tolua.isnull(self.skipBtn) then self.skipBtn:setButtonEnabled(false) end

			local action = CCSpawn:createWithTwoActions(CCMoveTo:create(0.5, ccp(display.cx,display.top)), CCFadeOut:create(0.5))
			transition.execute(self.lockCloud, action, {onComplete=function()
					self.lockCloud:removeSelf()

					local nextScene = import("app.scenes.MainScene").new()
					display.replaceScene(nextScene, "fade", 0.2, ccc3(0, 0, 0))
				end})
		end, 4.5)

end

function storyScene:dragonApper()
	local dragon=display.newSprite("ui/checkpoint/checkpoint_long.png", display.cx-250, display.bottom-100):addTo(self,3):rotation(-45)
	local actionRota=CCRotateBy:create(7, 90)

	local bezier = ccBezierConfig()
	bezier.controlPoint_1 = ccp(display.cx-50, display.cy-100-50)
	bezier.controlPoint_2 = ccp(display.cx+50, display.cy-100-50)
	bezier.endPosition = ccp(display.cx+250, display.bottom-100)
	local bezierTo2 = CCBezierTo:create(7, bezier)
	transition.execute(dragon, CCSpawn:createWithTwoActions(bezierTo2, actionRota), {onComplete=function()
		dragon:removeSelf()
	end})
end

function storyScene:addPoints(map_id)
	self.allSceneId = gPassTemplate:getAllSceneidByPassid(gPassTemplate:getPassidByMapid(map_id))

	local node = display.newNode()
	for i,v in pairs(points_template[map_id]) do
		if gPlayer.data.scene_id >= self.allSceneId[i] then
			local path=gPlayer.data.scene_id > self.allSceneId[i] and "ui/home/home_point_win.png" or "ui/home/home_point_now.png"
			cc.ui.UIPushButton.new({normal=path}):addTo(node):pos(v.x, v.y)
			:onButtonRelease(function(event) end)
			if gPlayer.data.scene_id == self.allSceneId[i] then
				--local now = display.newSprite("ui/home/home_icon_fighting.png", v.x, v.y+45):addTo(node)
				--local action = CCScaleBy:create(0.3, 0.8, 0.3)
				--now:runAction(CCRepeatForever:create(CCSequence:createWithTwoActions(action, action:reverse())))
			end
		else
			display.newSprite("ui/home/home_point_not.png", v.x, v.y):addTo(node)
		end
	end
	-- local frames = display.newFrames('monster_70043_walk_front_%d.png', 1,8)
	-- local animations = display.newAnimation(frames,0.6/10)

	-- self.boss = display.newNode():addTo(node)
	-- local wuya1=display.newSprite(frames[1], points_template[map_id][5].x-15+60, points_template[map_id][5].y+40):addTo(self.boss,1):scale(0.65):flipX(true)
	-- wuya1:playAnimationForever(animations)
	-- local wuya2=display.newSprite(frames[1], points_template[map_id][5].x+15+60, points_template[map_id][5].y+40):addTo(self.boss,1):scale(0.65):flipX(true)
	-- wuya2:playAnimationForever(animations)
	-- display.newSprite("ui/checkpoint/hero_10000_body2.png", points_template[map_id][5].x+50, points_template[map_id][5].y+30):addTo(self.boss):scale(0.7)
	return node
end

function storyScene:addCloud(node)
	local cloud=display.newSprite("ui/checkpoint/map_local_cloud.png",85,20):addTo(node)
	cloud:setScaleX(0.55)
	cloud:setScaleY(0.28)
end

function storyScene:getAnimation(hero_id)
	local frames = display.newFrames('hero_' .. hero_id ..'_stand_front_%d.png', 1,8)
	local animation = display.newAnimation(frames,1.5/9)
	return frames,animation
end

function storyScene:onEnter()
	-- self.showExit = false
	if device.platform == "android" then
        self:performWithDelay(function()
            -- keypad layer, for android
            local layer = display.newLayer()
            layer:addKeypadEventListener(function(event)
        		-- if (not self.showExit) then
        		-- 	self.showExit = true
        	 --    	self.exitWindows = require("app.views.secondMenu.exit.Exit").new():addTo(self,100)
        	 --   	else
        	 --   		self.showExit = false
        	 --   		 if not tolua.isnull(self.exitWindows) then
        	 --                self.exitWindows:removeFromParentAndCleanup()  
        	 --         end 
        	 --   	end
            end)
            self:addChild(layer, GUIDE_PAGE_Z_ORDER)
            layer:setKeypadEnabled(true)
        end, 0.5)
    end
end

function storyScene:onExit()
	self:stopAllActions()
    CCTextureCache:sharedTextureCache():removeTextureForKey("ui/checkpoint/checkpoint_map_hell.jpg")
    --display.removeSpriteFramesWithFile("monster/monster_70043.plist", "monster/monster_70043.pvr.ccz")
    CCTextureCache:sharedTextureCache():removeUnusedTextures()
    tolua.fullgc()
end

return storyScene