local ColorText = {}
local Text = require('app.ui.Text')
local color_list={
	display.COLOR_RED,    --红#1
	display.COLOR_WHITE,   --白#2
	display.COLOR_GREEN,   --绿#3
	display.COLOR_BLUE,     --蓝#4
	ccc3(255, 255, 0),    --黄#5
	ccc3(204, 0, 204),    --紫#6
	display.COLOR_BLACK,    --黑#7
}

function ColorText.calRealWidth(content)
	if (string.len(content) == 0) then
		return 0
	end
	local len = 0
	local i = 1
	while(true) do
		local a = string.byte(content, i, i)
		--后三位是中文
		if (a > 127 or a < 0) then
			i = i+2
			len = len + 2
		else
			len = len + 1
		end
		i = i + 1
		if (i > string.len(content)) then
			break
		end
	end
	return len
end

function ColorText.split(content)
	local a = string.sub(content, 1,1)
	if (a ~= "#") then
		content = "#2" .. content
	end
	local result={}
	for i = 1, 100 do
		local data={}
		local a = string.sub(content, 1,1)
		if (a == "#") then
			local rest = string.sub(content, 3, string.len(content))
			if (string.sub(content, 2,2) == '9') then
				data.color = "n"
				content = rest
				result[#result+1] = data
			elseif (string.sub(content, 2,2) == '8') then
				data.color = "m"
				local a = string.find(rest, "#")
				if (a == nil) then
					data.content = rest
					data.width = ColorText.calRealWidth(data.content)
					result[#result+1] = data
					break
				else
					data.content = string.sub(rest, 1, tonumber(a)-1)
					data.width = ColorText.calRealWidth(data.content)
					result[#result+1] = data
					content = string.sub(rest, tonumber(a), string.len(rest))
				end
			else
				data.color = color_list[tonumber(string.sub(content, 2,2))]
				local a = string.find(rest, "#")
				if (a == nil) then
					data.content = rest
					data.width = ColorText.calRealWidth(data.content)
					result[#result+1] = data
					break
				else
					data.content = string.sub(rest, 1, tonumber(a)-1)
					data.width = ColorText.calRealWidth(data.content)
					result[#result+1] = data
					content = string.sub(rest, tonumber(a), string.len(rest))
				end
			end
			
			
		end
	end
	return result
end

--Paint Boy
function ColorText.new(args)
	local node  = display.newNode()
	local x = args.x
	local y = args.y
	local result = ColorText.split(args.text)
	local add_times = 1
	if not args.inter then
		args.inter = 0
	end
	for k, v in ipairs(result) do

		if (v.color == "n") then
			y = args.y - args.size*add_times -  args.inter
			x = args.x
			add_times = add_times + 1
		elseif (v.color == "m") then
			local tmp = display.newSprite("ui/home/home_ingot.png", x+12, y):addTo(node)
			tmp:setScale(0.8)
			x = x + 30
		else
			local txt = Text.new({
				            text=v.content,
				            x=x,
				            y=y, 
				            size=args.size,
				            color = v.color,
				            align = ui.TEXT_ALIGN_LEFT,
				        }):addTo(node)
			x = x + txt:getContentSize().width
		end
	end
	return node
end



function ColorText.spiltContent(content)
    local content_tb = {}
    local len = 0
    for i = 1 ,string.len(content) do
        local temp = string.sub(content,i,i)
        if temp <= string.char(127) and temp >= string.char(0) then
            content_tb[#content_tb + 1] = string.sub(content,i,i)
        else
            if len < i then
                len = i + 2
                content_tb[#content_tb + 1] = string.sub(content,i,i+2)
            end            
        end
    end
    return string.utf8len(content),content_tb
end


function ColorText.newWordNode(content, callback)
    -- local wordsPerLine = 12 --每行字数
    local wordsPerLine = 24 --每行字数
    local offsetx = 20+2 --一个字占用宽度
    local offsety = 20+4 --一个字占用高度
    local actionTime = 0.02 --一个字动车占用时间


    local len,word_tb = ColorText.spiltContent(content)
    local node = display.newNode()
   
    local color = color_list[2]
    -- local j = 1
    local k = 0
    local m = 1
    -- local nextline = false
    local num_of_spilt = 0
    -- if word_tb[1] == '#' then
    --     color = color_list[tonum(word_tb[2])]
    --     num_of_spilt = 1
    --     j = 3
    -- end

    for i = 1 , len do
        if word_tb[i] == '#' then
            local nextNum = tonum(word_tb[i+1])
            if nextNum ~= 9 then
                num_of_spilt = num_of_spilt + 1
                k = 1
                if nextNum > 7 or nextNum < 1 then
                    color = color_list[2]
                    printf('剧情配置的color有错,#%d',nextNum)
                else
                    color = color_list[nextNum] 
                end            
            else
                num_of_spilt = num_of_spilt + 1
                k = 1
                if m%wordsPerLine ~= 1 then --如果刚刚在行尾加了#9则不换行
                    m = (math.ceil(m/wordsPerLine))*wordsPerLine + 1 
                end
            end
        elseif k == 1 then
            k = 2 
        elseif k == 2 then
            k = 0
        end

        if k == 0 then
            -- if nextline then 
            --     m = (math.ceil(m/wordsPerLine))*wordsPerLine + 1 
            --     nextline = false
            -- end
            local x,y
            x = ((m%wordsPerLine == 0 and wordsPerLine or m%wordsPerLine) - 1) * offsetx
            -- x = ((i%wordsPerLine == 0 and wordsPerLine or i%wordsPerLine) - (wordsPerLine/2 + 0.5)) * offsetx
            y = (1-math.ceil(m/wordsPerLine))  * offsety

            local text = Text.new({
                            text= word_tb[i],
                            x= x,
                            y= y,
                            size= 20,
                            color = color,
                            align = ui.TEXT_ALIGN_CENTER,
                        }):addTo(node):opacity(0)

            local action = CCSequence:createWithTwoActions(CCDelayTime:create(actionTime*(i-num_of_spilt*2)), CCFadeIn:create(actionTime))
            transition.execute(text, action, {
                onComplete = function()
                    if i == len then 
                        --
                        if (callback) then
                        	callback()
                        end
                    end
                end})
            m = m +1     
        end   
    end

    return node
end

return ColorText