
local PageControl = require("app.ui.PageControl")
local SecondPageControl = class("SecondPageControl", PageControl)

SecondPageControl.INDICATOR_MARGIN = 30
--rect, direction)
function SecondPageControl:ctor(rect,num,cols_)
    PageControl.super.ctor(self, rect, PageControl.DIRECTION_HORIZONTAL)
    --
    local rows, cols = 1, 4
    if cols_ then
        cols = cols_
    end
    self.numPages = math.ceil(num / (rows * cols))
    --
    -- add indicators
    local x = (rect.size.width - SecondPageControl.INDICATOR_MARGIN * (self.numPages - 1)) / 2
    local y = self:getClippingRect().origin.y+8

    x = x + CommUtil.getBlankWidth() + SCROLL_LEFT_INTER_WIDTH

    self.indicator_ = display.newSprite("ui/public/public_selected.png")
    self.indicator_:setPosition(x, y)
    self.indicator_.firstX_ = x
    self.indicator_icon={}
    for pageIndex = 1, self.numPages do
        self.indicator_icon[#self.indicator_icon+1] = display.newSprite("ui/public/public_indicator.png")
        self.indicator_icon[#self.indicator_icon]:setPosition(x, y)
        self:addChild(self.indicator_icon[#self.indicator_icon])
        x = x + SecondPageControl.INDICATOR_MARGIN
    end
    self:addChild(self.indicator_)

    if num <= 0 then
        self:hideIndicator()
    end
end
function SecondPageControl:hideIndicator()
     self.indicator_:setVisible(false)
     for pageIndex = 1, self.numPages do 
        self.indicator_icon[pageIndex]:setVisible(false)
    end
end
function SecondPageControl:onExit()
end

function SecondPageControl:calData(data, numDef)
    local colum = 4
    if (numDef) then
        colum = numDef
    end
    local rows, cols = 1, colum   
    local numPages = (#data == 0) and 1 or math.ceil(#data / (rows * cols))
    local returnData={}
    local rnum = 1
    for pageIndex = 1, numPages do
        local cellData = {}
        for i=1,colum do 
            local index=i+(pageIndex-1)*cols
            if data[index] then
                cellData[i] = data[index]
            else
                break
            end
        end
        returnData[rnum] = cellData
        rnum = rnum + 1
    end
    if (numPages == 0) then
        numPages = 1
        returnData = {}
    end
    return numPages, returnData
end



function SecondPageControl:scrollToCell(index, animated, time, flag)
    SecondPageControl.super.scrollToCell(self, index, animated, time, nil, flag)
    transition.stopTarget(self.indicator_)
    local x = self.indicator_.firstX_ + (self:getCurrentIndex() - 1) * SecondPageControl.INDICATOR_MARGIN
    if animated then
        time = time or self.defaultAnimateTime
        transition.moveTo(self.indicator_, {x = x, time = time / 2})
    else
        self.indicator_:setPositionX(x)
    end
end

function SecondPageControl:onClickItem(event)
    self:dispatchEvent({SecondPageControl = "onClickItem", itemData = event.itemData})
end
function SecondPageControl:setContentOffset(offset, animated, time, easing)
    SecondPageControl.super.setContentOffset(self, offset, animated, time, easing)
end
return SecondPageControl
