local Text = {}

--[[
	local text1 = Text.new({
            text="测试一下字体文件",
            x=300,
            y=100,
            size=64,
            color = ccc3(0, 0, 0),
            outlineColor = ccc3(255,124, 255),
            shadowColor = ccc3(255,255, 255)
        })
    self:addChild(text1)
]]

--Paint Boy
function Text.new(args)
	local config = totable(args)

    local label = nil

    if config.shadowColor~=nil then
    	label = ui.newTTFLabelWithShadow({
		    text = config.text,
		    font = "Arial",
		    x = config.x,
		    y = config.y,
		    size = config.size,
		   align = config.align,
		    valign = config.valign,
		    color = config.color,
		    dimensions = config.dimensions,
		    shadowColor = config.shadowColor,
		})
	elseif config.outlineColor~=nil then
		label = ui.newTTFLabelWithOutline({
		    text = config.text,
		    font = "Arial",
		    x = config.x,
		    y = config.y,
		    size = config.size,
		    align = config.align,
		    valign = config.valign,
		    color = config.color,
		    dimensions = config.dimensions,
		    outlineColor = config.outlineColor
		})
    else
    	label = ui.newTTFLabel({
		    text = config.text,
		    font = "Arial",
		    x = config.x,
		    y = config.y,
		    align = config.align,
		    valign = config.valign,
		    dimensions = config.dimensions,
		    size = config.size,
		    color = config.color
		})
    end

    return label

end

function Text.setText( text, textAlign, str )
--[[ 解决setString方法不会自动排列的问题
args:
	text - newTTFLabel控件
	textAlign - 文字对齐方式
	str - 设置的文字
]]
	local size = text:getContentSize()
	text:setString(str)
	local x, y = text:getPosition()
	if textAlign == ui.TEXT_ALIGN_LEFT then
		text:setPosition(math.round(x + (text:getContentSize().width-size.width) / 2), y)
	elseif textAlign == ui.TEXT_ALIGN_RIGHT then
		text:setPosition(x - math.round((text:getContentSize().width-size.width) / 2), y)
	end
end

return Text