local Toast = class("Toast", function(args)
    local node = display.newNode()
    return node
end)

function Toast:ctor(args)
	gPlayer.data.clicking_main_button=false
	local config = totable(args)
	local moveDistance = 30

    self.sprite = display.newSprite("ui/public/public_edit.png",display.cx,display.cy - moveDistance):addTo(self):opacity(0)

    self.tip = require("app.ui.Text").new({
	    text = config.tip,
	    x = display.cx,
	    y = display.cy - moveDistance,
	    size = 14,
	    color = ccc3(255,255,0),
	    align = ui.TEXT_ALIGN_CENTER
	}):addTo(self):opacity(0)

	local time = 0.4
	local sequence = transition.sequence({
		CCSpawn:createWithTwoActions(CCMoveBy:create(time, ccp(0,moveDistance)), CCFadeIn:create(time)),
	    CCDelayTime:create(2*time),
	    CCSpawn:createWithTwoActions(CCMoveBy:create(time, ccp(0,moveDistance/2)), CCFadeOut:create(time)),
	})

	transition.execute(self.sprite, sequence:copy(), {
		easing = 'out'
		})
	transition.execute(self.tip, sequence:copy(), {
		easing = 'out',
		onComplete = function ()
			self:removeFromParent()
		end})	
end

return Toast