local UIScrollViewIndicator = class("UIScrollViewIndicator",function()
	return display.newNode()
end)

function UIScrollViewIndicator:ctor( args )
--[[
args:
	nums  = 10       指示器个数
	width = 200      显示长度
	direction = 1/2  显示方向 1水平 2垂直
	index = 1        指示器索引 默认为1
]]
	self.nums_ = args.nums
	self.width_ = args.width
	self.direction_ = (args.direction == nil) and 1 or args.direction
	self.index_ = (args.index == nil) and 1 or args.index

	self.scale_ = 1

	self.indicator_path_ = "ui/public/public_indicator.png"
	self.indicators_ = display.newNode():addTo(self)
	self.indicator_ = display.newBatchNode(self.indicator_path_):addTo(self.indicators_)

	self:makeIndicators()
	self.selecter_ = display.newSprite("ui/public/public_selected.png"):addTo(self.indicators_):pos(0,18)
	self.selecter_:setAnchorPoint(ccp(0,0.5))

	-- 设置指示器根据长度缩放
	local indicators_width = self.indicators_:getCascadeBoundingBox().size.width
	if indicators_width > 0.6*self.width_ then
		-- 缩放比设置
		self.scale_ = 0.7 * 0.6*self.width_ / indicators_width
	else
		self.scale_ = 0.7
	end
	self.scale_ = self.scale_ < 0.4 and 0.4 or self.scale_
	self.indicators_:setScale(self.scale_)

	-- 起始位置设置
	indicators_width = self.indicators_:getCascadeBoundingBox().size.width
	local d = (self.width_ - indicators_width)/2
	self.indicators_:pos(d,0)


	if self.direction_ == 2 then
		-- 垂直时 直接旋转
		self:setRotation(90)
		local x, y = self:getPosition()
		self:setPosition(x, y+self.width_)
	end

	self:setIndex(self.index_)
	-- 测试用的显示框
	-- self.frame_ = display.newRect(self.width_, 36*self.scale_):addTo(self)
	-- 	:pos(self.width_/2, 36*self.scale_/2)
	-- self.frame_:setLineColor(ccc4f(0.0, 1.0, 0.0, 1.0))
	-- self.frame_:setLineWidth(1)
end

function UIScrollViewIndicator:setIndex( index )
--[[ 设置指示器的索引
]]
	assert(type(index) == "number", "参数index类型错误 - 非数值类型")
	assert(index >= 1 and index <= self.nums_, "参数index错误 - 索引越界")

	self.index_ = index
	local x = (index - 1) * (24 + 6)
	self.selecter_:setPosition(x, 18)
end

function UIScrollViewIndicator:getIndex()
--[[ 获取指示器的索引
]]
	return self.index_
end

function UIScrollViewIndicator:makeIndicators()
--[[ 批量创建指示器
]]
	local x = 0
	local y = 12 + 6  -- 半径 + 上下间隔
	for i=1,self.nums_ do
		local icon = display.newSprite(self.indicator_path_):addTo(self.indicator_):pos(x,y)
		icon:setAnchorPoint(ccp(0,0.5))
		x = x + (24 + 6)
	end
end


return UIScrollViewIndicator