local BaseSecondMenu = require("app.views.secondMenu.BaseSecondMenu")
local WindowSecond = class("WindowSecond", BaseSecondMenu)

--[[
----args说明----
title="", 				标题
icon={
	image="xx.png" 		显示图片
	pos = {x, y}, 		图片的某个位置,默认为0,0
	scale = 1			图片缩放比例
	}
right_line={
	"line1",			 右边第一行
	"line1"				右边第二行
	"line3"},			右边第三行
bottorm_line=""			底部显示
button={
	{--左按钮，也可只有一个
	normal="" 			按钮图片
	pressed = ""	触摸按钮图片
	onButtonRelease=callback	触发按钮样子
	},
	{--右按钮
	normal="" 			按钮图片
	pressed = ""	触摸按钮图片
	onButtonRelease=callback	触发按钮样子
	}
}
]]
function WindowSecond:ctor(args)
	WindowSecond.super.ctor(self)
	local tipWindows = self
	tipWindows:setTitleTxt(args.title)
	 cc.ui.UIImage.new("ui/public/public_equipment.png")
            :pos(display.cx-132, display.cy+55)
             :align(display.CENTER)
            :addTo(tipWindows)
      cc.ui.UIImage.new(args.icon.image)
            :pos(display.cx-132, display.cy+55+3)
            :addTo(tipWindows)
            :align(display.CENTER)
      if (args.data and args.data.object_type == 2) then
        local  starxx = {star_lvl=args.data.star_lvl:get(), 
                                    star_step=args.data.star_step:get()}
                  local pos = {x=display.cx-132-48+24, y=display.cy+55+3+5-33+3}
                  CommUtil.addStarToNode(tipWindows, starxx, pos)
      end

    if args.object_type ~= 1 then   --类型为1表示英雄
       cc.ui.UIImage.new("ui/public/public_equipment2.png")
            :pos(display.cx-132, display.cy+55)
            :align(display.CENTER)
            :addTo(self)
    end
    for i=1, #args.right_line do
      cc.ui.UIImage.new("ui/public/public_text4.png")
            :pos(display.cx-50, display.cy+70 - (i-1)*45)
            :addTo(tipWindows)
    end
    --
    
        import("app.ui.Text").new({text = args.right_line[1], 
                size = 18,
                 align =  ui.TEXT_ALIGN_LEFT,
                color = display.COLOR_BLACK})
            :pos(display.cx-40, display.cy+90)
            :align(display.LEFT_CENTER)
            :addTo(tipWindows)
        import("app.ui.Text").new({text = args.right_line[2], 
                size = 18,
                 align =  ui.TEXT_ALIGN_LEFT,
                color = display.COLOR_BLACK})
            :pos(display.cx-40, display.cy+90-45)
            :align(display.LEFT_CENTER)
            :addTo(tipWindows)
        if (#args.right_line == 3) then
        	import("app.ui.Text").new({text = args.right_line[3], 
                size = 18,
                 align =  ui.TEXT_ALIGN_LEFT,
                color = display.COLOR_BLACK})
            :pos(display.cx-40, display.cy+90-90)
            :align(display.LEFT_CENTER)
            :addTo(tipWindows)
         end
      if (args.bottorm_line) then
        --hero_skill显示仙将技能
      	local bottomBg = cc.ui.UIImage.new("ui/public/public_text2.png")
            :pos(display.cx, args.hero_skill and (display.cy-72) or (display.cy-70))
            :align(display.CENTER)
            :addTo(tipWindows)
        if args.hero_skill then bottomBg:setScaleY(1.3) end
      	import("app.ui.Text").new({text = args.bottorm_line,
                size = 18,
                dimensions = CCSize(18 * 21, 18 * 6),
                 align =  ui.TEXT_ALIGN_LEFT,
                color = display.COLOR_BLACK})
            :pos(display.cx-195+4, display.cy-15)
            :align(display.LEFT_TOP)
            :addTo(tipWindows)  
      end
      ---初始化按钮
    if (#args.button == 2) then
       cc.ui.UIPushButton.new({
                normal = args.button[1].normal,
                pressed = args.button[1].pressed
                })
                :pos(display.cx-100, display.cy-135)
                :addTo(tipWindows)
                :onButtonRelease(function(event)
                       args.button[1].onButtonRelease()
                end)
        cc.ui.UIPushButton.new({
                normal = args.button[2].normal,
                pressed = args.button[2].pressed
                })
                :pos(display.cx+100, display.cy-135)
                :addTo(tipWindows)
                :onButtonRelease(function(event)
                       args.button[2].onButtonRelease()
                end)
    else    --hero_skill显示仙将技能
         cc.ui.UIPushButton.new({
                normal = args.button[1].normal,
                pressed = args.button[1].pressed
                })
                :pos(display.cx, args.hero_skill and (display.cy-140) or (display.cy-135))
                :addTo(tipWindows)
                :onButtonRelease(function(event)
                       args.button[1].onButtonRelease()
                end)
    end
end


return WindowSecond