local WindowThird = class("WindowThird", function()
    local node = require("app.views.MaskNode").new()

    return node
end)

local title_png = {
	{"礼包", "ui/public/public_2title_gift.png"},
	{"在线礼包", "ui/public/public_on_line_title.png"},
	{"提示", "ui/public/public_2title_tip.png"},
}

function WindowThird:ctor(args)

    local config = totable(args)
    local onConfirm = config.onConfirm
    local onCancel = config.onCancel

    self.sprite = display.newSprite("ui/public/public_prompt.png",display.cx,display.cy):addTo(self)
    local found = false
    local found_png = ""
	for k, v in ipairs(title_png) do
		if (v[1]==config.title) then
			found = true
			found_png = v[2]
			break
		end
	end
	if (found) then
		self.title = display.newSprite(found_png, 190, 170)
	else
		self.title = require("app.ui.Text").new({
	    text = config.title,
	    x = 190,
	    y = 170,
	    size = 16,
	     color = display.COLOR_BLACK,
         outlineColor = display.COLOR_WHITE,
	    align = ui.TEXT_ALIGN_CENTER
		})
	end
	self.content = require("app.ui.Text").new({
	    text = config.content,
	    x = 200,
	    y = 120,
	    size = 16,
	     color = display.COLOR_BLACK,
	    align = ui.TEXT_ALIGN_CENTER,
	     dimensions = CCSize(16 * 19, 16 * 3)
	})
	local YPos = 60
	if (config.specialPos) then
		YPos= 10
	end

    local function onItem1Click()
    	onConfirm()
    	--CommUtil.closeLayer(self)
    	self:removeFromParentAndCleanup(true)
    end

    local function onItem2Click()
    	onCancel()
    	self:removeFromParentAndCleanup(true)
    end
    if (config.leftBtn and config.rightBtn) then  --有二个按钮
    	local item1 = ui.newImageMenuItem({
	    image = config.leftBtn.normal,
	    imageSelected = config.leftBtn.pressed,
	    listener = onItem1Click,
	    x = 110,
	    y = YPos
		})
	
		local item2 = ui.newImageMenuItem({
	    image = config.rightBtn.normal,
	    imageSelected = config.rightBtn.pressed,
	    listener = onItem2Click,
	    x = 270,
	    y = YPos
		})

		self.menu = ui.newMenu({item1,item2})
		self.sprite:addChild(self.menu)

		CommUtil.setBtnGuide(item2, GUIDE_SOCKET_EXPIRE)
	elseif (config.leftBtn) then
		local item1 = ui.newImageMenuItem({
	    image = config.leftBtn.normal,
	    imageSelected = config.leftBtn.pressed,
	    listener = onItem1Click,
	    x = 190,
	    y = YPos
		})
		self.menu = ui.newMenu({item1})
		self.sprite:addChild(self.menu)

		CommUtil.setBtnGuide(item1, GUIDE_BAG_GET)
	end

	
	self.sprite:addChild(self.title)
	self.sprite:addChild(self.content)

	--[[self:performWithDelay(function()
    	transition.execute(self.sprite, CCMoveTo:create(1.5, CCPoint(display.cx,display.cy)),{
            easing = "bounceOut",
            onComplete = function()
    	end})
	end,0.3)]]
end

function WindowThird:exit()
     self:removeFromParentAndCleanup(true)
end

return WindowThird