local CommUtil = require("app.common.CommUtil")
local ColorTxt = import("app.ui.ColorText")


local AddSkillView = class("AddSkillView", function()
    local node = require("app.views.MaskNode").new()
    return node
end)


function AddSkillView:ctor(skillIds,callback,ingotOrCooper)
    local bg = display.newSprite("ui/vip/vip_frame_information.png",display.cx,display.cy):addTo(self)
    local size = bg:getContentSize()
    self.closeBtn = cc.ui.UIPushButton.new({
            normal = "ui/public/public_button_close_normal.png",
            pressed = "ui/public/public_button_close_pressed.png",
        })
    :pos(size.width, size.height)
    :addTo(bg,5000)
    :onButtonRelease(function(event)
        callback(-1)
    	self:removeFromParentAndCleanup(true)
    end)


    local hintText=nil
    local ingot = 0
    local copper = 0

    if ingotOrCooper==1 then--铜钱
        ingot = 0
        copper = 50000
        local skill = display.newSprite("ui/home/home_icon_copper.png",85,35):addTo(bg)
        hintText = "花费     "..copper.."可在本关卡增加一个技能"
    elseif ingotOrCooper==2 then--元宝
        ingot = 30
        copper = 0
        local skill = display.newSprite("ui/home/home_ingot.png",85,35):addTo(bg)
        hintText = "花费     "..ingot.."可在本关卡增加一个技能"
    end

    local hintText = ui.newTTFLabel({
        text = hintText,
        font = "Arial",
        size = 20,
        color = ccc3(255,255,255),
        x = 30,
        y = 30
    }):addTo(bg)

    local x = 55
    for i=1,10 do
        local r,c = math.modf((i-1)/5)
        local row = r
        local column = c*4

        local box = display.newSprite("ui/public/public_equipment2.png",x+85*column,size.height-60-row*80):addTo(bg)

        box:setScale(0.9)

        if skillIds[i]~=nil then
            local skill = display.newSprite("icon_list/skill/skill_"..skillIds[i]..".png",5,12):addTo(box)
            skill:setAnchorPoint(ccp(0,0))
            local word = display.newSprite("ui/skill_word/skill_wodr_"..skillIds[i]..".png",40,20):addTo(box)

            word:setScale(0.8)
            skill:setTouchEnabled(true)
            skill:addTouchEventListener(function(event, x, y)
                if event == "began" then
                    gItem:consume(self,ingot,copper,function(ret)
                        if ret==0 then
                            callback(skillIds[i])
                        elseif ret==-1 then
                            callback(-1)
                        end
                        self:removeFromParentAndCleanup(true)
                    end)
                    return true
                end
            end)
        end
    end

end


return AddSkillView