local scheduler = require("framework.scheduler")
local Text = import("app.ui.Text")

local AttributeIndicator = class("AttributeIndicator", function ()
	return display.newNode()
end)

--[[
功能(显示效果)：  属性 --> 属性
输入：now_data：当前数据
      next_data：下一个数据(若为空，则不显示)
      length：now_data的长度
]]

function AttributeIndicator:ctor(color, now_data, next_data, length)

	self:display(color, now_data, next_data, length)
end

function AttributeIndicator:display(color, now_data, next_data, length)
    --[[if type(now_data) == 'number' then
    	self.nowAttrText = ui.newBMFontLabel({
            text = now_data, 
            font = "fonts/" .. "number_big" .. ".fnt",
            align=ui.TEXT_ALIGN_LEFT}) 
        self.nowAttrText:setPosition(ccp(0,0)); 
        self.nowAttrText:setScale(0.5)
        self:addChild(self.nowAttrText);
    elseif type(now_data) == 'string' then]]
        self.nowAttrText = Text.new({
                text = now_data,
                align = ui.TEXT_ALIGN_LEFT,
                size = 18,
                color = color,
                dimensions = CCSize(18 * 10, 18 * 2),
                x = 0,
                y = 0,
                })
            :addTo(self)
    --end

    if next_data ~= nil then
        self:indicatorData(color, next_data, length)
    end
end

function AttributeIndicator:indicatorData(color, next_data, length)
    local directionIndicatorX = length * 8 + 28

    self.directionIndicator = display.newSprite("ui/public/public_arrow_a.png", directionIndicatorX, 1)
        :addTo(self)
    self.directionIndicator:setScale(0.9)

    --[[if type(next_data) == 'number' then
        self.nextAttrText = ui.newBMFontLabel({
            text = next_data, 
            font = "fonts/" .. "battle_heal" .. ".fnt",
            align=ui.TEXT_ALIGN_LEFT}) 
        self.nextAttrText:setPosition(ccp(directionIndicatorX + 20,0)); 
        self.nextAttrText:setScale(0.35)
        self:addChild(self.nextAttrText);
    elseif type(next_data) == 'string' then]]
        self.nextAttrText = Text.new({
            text = next_data,
            align = ui.TEXT_ALIGN_LEFT,
            size = 18,
            color = color,
            dimensions = CCSize(18 * 10, 18 * 2),
            x = directionIndicatorX + 20,
            y = 0,
            })
        :addTo(self)
    --end
end

function AttributeIndicator:refresh(color, now_data, next_data, length)
	self.nowAttrText:setString(now_data)

    if self.directionIndicator ~= nil then
        self:removeChild(self.directionIndicator)
        self.directionIndicator = nil
    end
    if self.nextAttrText ~= nil then
        self:removeChild(self.nextAttrText)
        self.nextAttrText = nil
    end

    if next_data ~= nil then
        self:indicatorData(color, next_data, length)
    end
end

return AttributeIndicator