local CommUtil = require("app.common.CommUtil")
local ColorTxt = import("app.ui.ColorText")


local BattleBuyPanel = class("BattleBuyPanel", function()
    local node = require("app.views.MaskNode").new()
    return node
end)


function BattleBuyPanel:ctor(parent)
    self.bg = display.newSprite("ui/mall/mall_base_truth_3.png",display.cx,display.cy):addTo(self)
    local rect = self.bg:getBoundingBox()

    ------------1 号是孙悟空 2号留魔王 3👌
    local closeBtn = cc.ui.UIPushButton.new({
        normal = "ui/public/public_button_normal.png",
        pressed = "ui/public/public_button_pressed.png",
    })
    :pos(rect.origin.x+rect.size.width-10,rect.origin.y+rect.size.height-10)
    :onButtonRelease(function(event)
      CommUtil.playSound("music/close.mp3")
        if display.getRunningScene().baseScene then
           display.getRunningScene().baseScene:resume()
        end
        if parent.refreshTimes then
          parent:refreshTimes()
        end
        self:removeSelf()
    end)
    :addTo(self,3)
    --closeBtn:setScale(0.5)

    self.itemIds = {30009,30010,30012}
    self.nums = {5,5,5}
    self.names = {"红水晶","黄水晶","绿水晶"}
    
    --print("礼包的大小是",#allItemBox)
    for i=1,3 do
        local row = math.floor((i-1)/4)
        local column = (i-1)%4

        local id = self.itemIds[i]
        local num = self.nums[i]
        local name = self.names[i]
        --print("item",boxid,itemType,id,num,name)
        local itemSprite = display.newSprite("ui/fighting/fighting_skill_"..i.."_circle.png",125+(column)*100,rect.size.height-113-row*103):addTo(self.bg)
        local fuwen = display.newSprite("ui/fighting/fighting_lection_"..i..".png",40,50):addTo(itemSprite)
        fuwen:setScale(0.5)
        local circle = display.newSprite("ui/mall/mall_indicator.png",42,-3):addTo(itemSprite)


        --[[
        ui.newTTFLabel({
              text = name,
              font = "Arial",
              color = ccc3(255,255,255),
              x=20,
              y=-10,
              size = 16,
              dimensions = CCSize(135,120),
              align = ui.TEXT_ALIGN_LEFT
        }):addTo(itemSprite)]]

        ui.newTTFLabel({
              text = num,
              font = "Arial",
              color = ccc3(255,255,255),
              x=12,
              y=17,
              size = 14,
              dimensions = CCSize(135,120),
              align = ui.TEXT_ALIGN_LEFT
        }):addTo(circle)
        
    end

    local buyBtn = cc.ui.UIPushButton.new({
        normal = "ui/mall/mall_button_buy_normal.png",
        pressed = "ui/mall/mall_button_buy_pressed.png",
    })
    :pos(rect.origin.x+rect.size.width/2,rect.origin.y+10)
    :onButtonRelease(function(event)
        --
    end)
    :addTo(self,3)

end

return BattleBuyPanel