local CommUtil = require("app.common.CommUtil")
local BattleHud = class("BattleHud",function(rect) 
    return display.newNode()
end)

function BattleHud:ctor(gameScene)
	--self.batchNode = display.newBatchNode("battle_ui.pvr.ccz"):addTo(self)
	--self.batchNode:setAnchorPoint(ccp(0,1))
    self.bg = display.newSprite("ui/fighting/fighting_player_bloodgroove.png",display.left,display.top-80):addTo(self)
    self.bg:setAnchorPoint(ccp(0,0))
    self.gameScene = gameScene

    self.cooper = display.newSprite("ui/home/home_icon_copper.png",160,15):addTo(self.bg)
    self.cooper:setScale(0.6)
    self.cooperText = ui.newTTFLabel({
		    text = "X "..gPlayer.data.copper_cnt:get(),
		    font = "Marker Felt",
		    color = ccc3(255,255,255), -- 使用纯红色
		    x = 210,
		    y = 15,
		    size = 20,
		    align = ui.TEXT_ALIGN_CENTER -- 文字内部居中对齐
	}):addTo(self.bg)

    local worldPoint = self.bg:convertToWorldSpace(ccp(85,0))

    local startX = worldPoint.x
    --for i=1 ,5 do
    --end

    display.newSprite("ui/fighting/fighting_head_tangseng.png",display.left+35,43):addTo(self.bg)

    local y = display.top - 27
    self.blood1 = display.newProgressTimer("ui/fighting/fighting_player_blood.png",display.PROGRESS_TIMER_BAR)
    self.blood1:setType(kCCProgressTimerTypeBar)
    self.blood1:setMidpoint(CCPointMake(0,0))
    self.blood1:setBarChangeRate(CCPointMake(1,0))
    self.blood1:setPercentage(100)
    self.blood1:setPosition(ccp(startX,y))
    self:addChild(self.blood1)
    startX = startX+35

    self.blood2 = display.newProgressTimer("ui/fighting/fighting_player_blood.png",display.PROGRESS_TIMER_BAR)
    self.blood2:setType(kCCProgressTimerTypeBar)
    self.blood2:setMidpoint(CCPointMake(0,0))
    self.blood2:setBarChangeRate(CCPointMake(1,0))
    self.blood2:setPercentage(100)
    self.blood2:setPosition(ccp(startX,y))
    self:addChild(self.blood2)
    startX = startX+35

    self.blood3 = display.newProgressTimer("ui/fighting/fighting_player_blood.png",display.PROGRESS_TIMER_BAR)
    self.blood3:setType(kCCProgressTimerTypeBar)
    self.blood3:setMidpoint(CCPointMake(0,0))
    self.blood3:setBarChangeRate(CCPointMake(1,0))
    self.blood3:setPercentage(100)
    self.blood3:setPosition(ccp(startX,y))
    self:addChild(self.blood3)
   	startX = startX+35

    self.blood4 = display.newProgressTimer("ui/fighting/fighting_player_blood.png",display.PROGRESS_TIMER_BAR)
    self.blood4:setType(kCCProgressTimerTypeBar)
    self.blood4:setMidpoint(CCPointMake(0,0))
    self.blood4:setBarChangeRate(CCPointMake(1,0))
    self.blood4:setPercentage(100)
    self.blood4:setPosition(ccp(startX,y))
    self:addChild(self.blood4)
    startX = startX+35

    self.blood5 = display.newProgressTimer("ui/fighting/fighting_player_blood.png",display.PROGRESS_TIMER_BAR)
    self.blood5:setType(kCCProgressTimerTypeBar)
    self.blood5:setMidpoint(CCPointMake(0,0))
    self.blood5:setBarChangeRate(CCPointMake(1,0))
    self.blood5:setPercentage(100)
    self.blood5:setPosition(ccp(startX,y))
    self:addChild(self.blood5)
    startX = startX+35

    self.waveBg = display.newSprite("ui/fighting/fighting_enemy_number_2.png",display.cx+30,y):addTo(self)
    self.waveBg:setVisible(false)
    --self.waveBg = display.newNode():addTo(self)

    local number1 =  math.floor(totalWaveNum/10)
	local number2 = totalWaveNum%10

	self.num3 = display.newSprite(string.format("#public_number_%d.png",number1),160,23):addTo(self.waveBg)
    self.num4 = display.newSprite(string.format("#public_number_%d.png",number2),190,23):addTo(self.waveBg)
    if number1==0 then
    	self.num3:setVisible(false)
    	self.num4:setPositionX(160)
    else
    	self.num3:setVisible(true)
    	self.num4:setPositionX(190)
    end
    
    self.num1 = display.newSprite("#public_number_0.png",75,23):addTo(self.waveBg)
    self.num1:setVisible(false)
    self.num2 = display.newSprite("#public_number_1.png",105,23):addTo(self.waveBg)

    self.num1:setScale(0.8)
    self.num2:setScale(0.8)
    self.num3:setScale(0.8)
    self.num4:setScale(0.8)

	if GOLD_ON and gBattle.data.home_scene_id~=701  and gBattle.data.home_scene_id~=702 then
		self.goldBg = display.newSprite("ui/home/home_gold.png",startX+70,y-2):addTo(self)
		self.gold = display.newSprite("ui/home/home_icon_copper.png",0,13):addTo(self.goldBg)
		self.goldText = ui.newTTFLabel({
		    text = "0",
		    font = "Marker Felt",
		    x=40,
		    y=11,
		    color = ccc3(255,255,255), -- 使用纯红色
		    size = 15,
		    align = ui.TEXT_ALIGN_CENTER -- 文字内部居中对齐
		}):addTo(self.goldBg)
	end
	self.addBloods = {}
	if addingBlood:get()>0 then
		self:initHeroAddingBlood()
	else
		self.cooper:setPositionX(self.cooper:getPositionX()-70)
		self.cooperText:setPositionX(self.cooperText:getPositionX()-70)
	end
	self:updateBeautyBlood()
end

function BattleHud:initHeroAddingBlood()
	self.addBlood= display.newSprite("ui/fighting/frighting_new_shield.png",90,15):addTo(self.bg)
	self.addBlood:setScale(0.5)
	self.addBloodText = ui.newTTFLabel({
		    text = "X 5",
		    font = "Marker Felt",
		    color = ccc3(255,255,255), -- 使用纯红色
		    x = 120,
		    y = 15,
		    size = 20,
		    align = ui.TEXT_ALIGN_CENTER -- 文字内部居中对齐
	}):addTo(self.bg)
	self.addBloodText:setString("X "..addingBlood:get())
end

function BattleHud:getUICooperPosition()
	return self.bg:convertToWorldSpace(ccp(self.cooper:getPositionX(),self.cooper:getPositionY()))
	--return ccp(self.cooper:getPositionX(),self.cooper:getPositionY())
end

function BattleHud:getCollectCooper()
	return tonumber(self.goldText:getString())
end

function BattleHud:updateCooper()
	self.cooperText:setString("X "..gPlayer.data.copper_cnt:get())
end

function BattleHud:updateGoldNumText()
	local how_much = tonumber(self.goldText:getString())
	local addMoney = self.gameScene.goldBase*2+math.random(1,100)
	how_much = math.floor(how_much + addMoney)
	self.goldText:setString(how_much.."")
end

function BattleHud:getGoldPosition()
	local worldPoint = self.gold:convertToWorldSpace(ccp(self.gold:getPositionX(),self.gold:getPositionY()))
	return worldPoint.x+5,worldPoint.y
end

function BattleHud:updateBeautyBlood()
	if totalHP:get()>=10 then
		self.blood1:setPercentage(100)
		self.blood2:setPercentage(100)
		self.blood3:setPercentage(100)
		self.blood4:setPercentage(100)
		self.blood5:setPercentage(100)
	elseif totalHP:get()>=9 then
		self.blood1:setPercentage(100)
		self.blood2:setPercentage(100)
		self.blood3:setPercentage(100)
		self.blood4:setPercentage(100)
		self.blood5:setPercentage(50)
	elseif totalHP:get()>=8 then
		self.blood1:setPercentage(100)
		self.blood2:setPercentage(100)
		self.blood3:setPercentage(100)
		self.blood4:setPercentage(100)
		self.blood5:setPercentage(0)
	elseif totalHP:get()>=7 then
		self.blood1:setPercentage(100)
		self.blood2:setPercentage(100)
		self.blood3:setPercentage(100)
		self.blood4:setPercentage(50)
		self.blood5:setPercentage(0)
	elseif totalHP:get()>=6 then
		self.blood1:setPercentage(100)
		self.blood2:setPercentage(100)
		self.blood3:setPercentage(100)
		self.blood4:setPercentage(0)
		self.blood5:setPercentage(0)
	elseif totalHP:get()>=5 then
		self.blood1:setPercentage(100)
		self.blood2:setPercentage(100)
		self.blood3:setPercentage(50)
		self.blood4:setPercentage(0)
		self.blood5:setPercentage(0)
	elseif totalHP:get()>=4 then
		self.blood1:setPercentage(100)
		self.blood2:setPercentage(100)
		self.blood3:setPercentage(0)
		self.blood4:setPercentage(0)
		self.blood5:setPercentage(0)
	elseif totalHP:get()>=3 then
		self.blood1:setPercentage(100)
		self.blood2:setPercentage(50)
		self.blood3:setPercentage(0)
		self.blood4:setPercentage(0)
		self.blood5:setPercentage(0)
	elseif totalHP:get()>=2 then
		self.blood1:setPercentage(100)
		self.blood2:setPercentage(0)
		self.blood3:setPercentage(0)
		self.blood4:setPercentage(0)
		self.blood5:setPercentage(0)
	elseif totalHP:get()>=1 then
		self.blood1:setPercentage(50)
		self.blood2:setPercentage(0)
		self.blood3:setPercentage(0)
		self.blood4:setPercentage(0)
		self.blood5:setPercentage(0)
	else
		self.blood1:setPercentage(0)
		self.blood2:setPercentage(0)
		self.blood3:setPercentage(0)
		self.blood4:setPercentage(0)
		self.blood5:setPercentage(0)
	end
	if self.addBloodText then
		self.addBloodText:setString("X "..addingBlood:get())
	end
end

function BattleHud:updateWave(waveNum)
	--local waveText = "回合"..currentWaveNum.."/"..totalWaveNum
	--self.wavelabel:setString(waveText)
	local number1 = math.floor(currentWaveNum/10)
	local number2 = currentWaveNum%10
	self.num1:setDisplayFrame(display.newSpriteFrame(string.format("public_number_%d.png",number1)))
	self.num2:setDisplayFrame(display.newSpriteFrame(string.format("public_number_%d.png",number2)))

	if number1==0 then
		self.num1:setVisible(false)
	else
		self.num1:setVisible(true)
	end
end

function BattleHud:updateTotalWave()
	self.waveBg:setVisible(true)
	local number1 =  math.floor(totalWaveNum/10)
	local number2 = totalWaveNum%10

	self.num3:setDisplayFrame(display.newSpriteFrame(string.format("public_number_%d.png",number1)))
    self.num4:setDisplayFrame(display.newSpriteFrame(string.format("public_number_%d.png",number2)))
    if number1==0 then
    	self.num3:setVisible(false)
    	self.num4:setPositionX(160)
    else
    	self.num3:setVisible(true)
    	self.num4:setPositionX(190)
    end
end

return BattleHud