local CommUtil = require("app.common.CommUtil")
local ColorTxt = import("app.ui.ColorText")
local monster_template = nil


local BattlePreview = class("BattlePreview", function()
    local node = require("app.views.MaskNode").new()
    return node
end)


function BattlePreview:refreshTimes()
    for i=1,3 do
        local buyItemTimes = gItem:getItemNum(self.itemIds[i])
        if buyItemTimes>0 then
            self.buyItemTimesLabel[i]:setVisible(true)
            self.buyItemTimesLabel[i]:setString(buyItemTimes)
            self.addTimesBtn[i]:setVisible(false)
        else
            self.buyItemTimesLabel[i]:setVisible(false)
            self.addTimesBtn[i]:setVisible(true)
        end
    end
end

function BattlePreview:refreshTangSengTimes()
    if gItem:getTangSengTimes()>0 then
        self.addTangSengBtn:setVisible(false)
        self.tipWords:setVisible(true)
        self.tipWords:setString(gItem:getTangSengTimes())
    else
        self.addTangSengBtn:setVisible(true)
        self.tipWords:setVisible(false)
    end
    if gItem:getTangSengTimes()>=1 then
        self.ifUseTangSeng = true
    else
        self.ifUseTangSeng = false
    end
end

function BattlePreview:initMonsterProperties(monsterid)
    for i = 1,#monster_template, 1 do
        if monster_template[i][1]==monsterid then
            self.monsterProperties[monsterid] = monster_template[i]
            return
        end
    end
end
function BattlePreview:getBodyId(monsterid)
    for i = 1,#monster_template, 1 do
        if monster_template[i][1]==monsterid then
            return  monster_template[i][10]
        end
    end
end
function BattlePreview:ifExistsInTable(bodyIdArray,bodyId)
    for i = 1,#bodyIdArray, 1 do
        if bodyIdArray[i]==bodyId then
            return true
        end
    end
    return false
end

function BattlePreview:getMonsterProperty(bId)
    for i = 1,#self.sceneData, 1 do
        local monsterid = self.sceneData[i][5]
        local bodyId = self:getBodyId(monsterid)
        local property = self.monsterProperties[monsterid]
        local wood = property[24]
        local water = property[25]
        local fire = property[26]
        local soil = property[27]
        if bId==bodyId and (wood~=0 or water~=0 or fire~=0 or soil~=0) then
            return  self.monsterProperties[monsterid]
        end
    end
    for i = 1,#self.sceneData, 1 do
        local monsterid = self.sceneData[i][5]
        local bodyId = self:getBodyId(monsterid)
        if bId==bodyId then
            return  self.monsterProperties[monsterid]
        end
    end
end

function BattlePreview:getTypeImageName(property)
    local wood = property[24]
    local water = property[25]
    local fire = property[26]
    local soil = property[27]

    if wood~=0 then 
        self.foundHeroId = 10006 
        return "frighting_new_change_tree.png" end
    if water~=0 then self.foundHeroId = 10007  return "frighting_new_change_water.png" end
    if fire~=0 then self.foundHeroId = 10005 return "frighting_new_change_fire.png" end
    if soil~=0 then self.foundHeroId = 10004 return "frighting_new_change_stone.png" end

    return nil

end

function BattlePreview:updatePassMonsters(mapId,sceneId,passId)
    --print("关卡信息",mapId,sceneId,passId)
    --for i=1,#self.monsterBodyIdArray,1 do
    --    display.removeSpriteFramesWithFile("monster/monster_"..self.monsterBodyIdArray[i]..".plist","monster/monster_"..self.monsterBodyIdArray[i]..".pvr.ccz")
    --end
    for i=1,#self.monsters do
        self.monsters[i]:removeSelf()
    end
    self.monsterProperties = {}
    self.monsterBodyIdArray = {}
    self.monsters = {}
    local world = require("app.client.template.map_"..mapId.."_template")
    self.sceneData = world[sceneId][passId]
    local totalMonsterNums = #self.sceneData
    for i = 1,totalMonsterNums, 1 do
        local monsterid = self.sceneData[i][5]
        local bodyId = self:getBodyId(monsterid)
        self:initMonsterProperties(monsterid)
        if self:ifExistsInTable(self.monsterBodyIdArray,bodyId) then
        else
            self.monsterBodyIdArray[#self.monsterBodyIdArray+1]=bodyId
        end
    end
    --for i=1,#self.monsterBodyIdArray,1 do
    --    display.addSpriteFramesWithFile("monster/monster_"..self.monsterBodyIdArray[i]..".plist","monster/monster_"..self.monsterBodyIdArray[i]..".pvr.ccz")
    --end

    local properties = {}
    for i=1,#self.monsterBodyIdArray do
        properties[#properties+1] = self:getMonsterProperty(self.monsterBodyIdArray[i])
    end
    --print("有多少个属性",#properties)

    self.monsters={}
    self.foundHeroId = 10003
    for i=1,#properties do
        body_id = properties[i][10]
        --print("bodyId",body_id)
        local monster = display.newSprite("#monster_"..body_id.."_walk_front_1.png",80+(i-1)*65,70):addTo(self.bg)
        monster:setScale(0.8)
        self.monsters[#self.monsters+1] = monster
        --local imageName = "monster_"..body_id.."_walk_front_%d.png"
        --local frames = display.newFrames(imageName, 1,8)
        --local animation = display.newAnimation(frames,1/8)
        --monster:playAnimationForever(animation)
        local typeImageName = self:getTypeImageName(properties[i])
        if typeImageName~=nil then
            display.newSprite("ui/fighting/"..typeImageName,-10,40):addTo(monster)
        end
    end


    ----根据不同的怪物推荐不同的仙将
    if (self.recommendHeroBtn ) then
        self.recommendHeroBtn:removeSelf()
    end
    --
    self.recommendHeroBtn = cc.ui.UIPushButton.new({
            normal = "#hero_head_" .. self.foundHeroId .. ".png",
            pressed ="#hero_head_" .. self.foundHeroId .. ".png",
            })
            :pos(430-80,70)
            :onButtonRelease(function(event)
                DEF_SHOW_HERO = self.foundHeroId-10000
                require("app.views.secondMenu.hero.heroNode").new():center():addTo(display.getRunningScene(), 10000)
                --
                end)
            :addTo(self.bg)

end

function BattlePreview:ctor(mapId,sceneId,passIds,ifSpecia)
    CommUtil.playSound("music/openbox.mp3")
    PREVIEW_SHOW=true
    self.heroList = gHero:getHeroMenuData()--英雄列表
    self.heroIndex = 1
    if display.getRunningScene().setMainSceneTouch then
        display.getRunningScene():setMainSceneTouch(false)
    end
    monster_template = require("app.client.template.monster_template")
    self.monsterProperties = {}
    self.monsterBodyIdArray = {}
    self.monsters = {}
    self.bg = display.newSprite("ui/public/public_base_map_b.png",display.cx,display.cy):addTo(self)
    local rect = self.bg:getBoundingBox()
    self.mapBg = display.newSprite("ui/fighting/frighting_base_1.png",200,display.cy+20):addTo(self.bg)
    local rectMap = self.mapBg:getBoundingBox()
    local map = display.newSprite("map/map"..sceneId..".jpg",rectMap.size.width/2,rectMap.size.height/2)
    self.mapBg:addChild(map)
    map:setScaleX(rectMap.size.width/map:getBoundingBox().size.width*0.93)
    map:setScaleY(rectMap.size.height/map:getBoundingBox().size.height*0.91)
    map:setPositionY(map:getPositionY()+3)
    self.mapBg:setScale(0.8)

    if not ifSpecia then
        self.title = display.newSprite("ui/checkpoint/map_name_"..mapId..".png",150,rect.size.height-40):addTo(self.bg)
    end

    ---------------------------------------------------------------------------金钟罩----------------------------------------
    local section1ContentBg1 = display.newSprite("ui/fighting/fighting_button_mostername.png",rect.size.width-160,rect.size.height-120+15):addTo(self.bg)
    section1ContentBg1:setScaleY(0.8)
    section1ContentBg1:setScaleX(0.9)
    local section1TitleBg1 = display.newSprite("ui/public/public_second_label_bg.png",section1ContentBg1:getBoundingBox().size.width/2+18,section1ContentBg1:getBoundingBox().size.height+10):addTo(section1ContentBg1)
   

    display.newSprite("ui/fighting/tip2.png",100-12,30):addTo(section1TitleBg1)

    local tangSengTimeBg = display.newSprite("ui/fighting/frighting_button_box.png",95,section1ContentBg1:getBoundingBox().size.height-90+20):addTo(section1ContentBg1,3)
    tangSengTimeBg:setScale(1.1)
    self.tipWords = ui.newTTFLabel({
          text = gItem:getTangSengTimes(),
          font = "Arial",
          color = ccc3(255,255,255),
          x =6,
          y = 15,
          size = 18,
          dimensions = CCSize(135,120),
          align = ui.TEXT_ALIGN_LEFT
    }):addTo(tangSengTimeBg)
    self.head = display.newSprite("#hero_head_30008.png",50,section1ContentBg1:getBoundingBox().size.height-60):addTo(section1ContentBg1)
    self.head:setScale(1.1)
    self.addTangSengBtn = display.newSprite("ui/hero/hero_new_plus.png",35,37):addTo(tangSengTimeBg)
    self.addTangSengBtn:setScale(0.6)
    self.addTangSengBtn:setContentSize(CCSize(100,100))
    tangSengTimeBg:setTouchEnabled(true)
    tangSengTimeBg:addTouchEventListener(function(event, x, y)
        if event == "began" then
            self:pay()
            return true -- catch touch event, stop event dispatching
        end
    end)
    self.head:setTouchEnabled(true)
    self.head:addTouchEventListener(function(event, x, y)
        if event == "began" then
            self:pay()
            return true -- catch touch event, stop event dispatching
        end
    end)

    self:refreshTangSengTimes()

    ui.newTTFLabel({
          text = "金钟罩保护唐僧\n抵挡额外5次伤害",
          font = "Arial",
          color = ccc3(255,255,255),
          x =115,
          y = 80,
          size = 21,
          dimensions = CCSize(200,120),
          align = ui.TEXT_ALIGN_LEFT
    }):addTo(section1ContentBg1)
    ---------------------------------------------------------------------------金钟罩----------------------------------------



    ---------------------------------------------------------------------------技能令牌----------------------------------------
    local section1ContentBg2 = display.newSprite("ui/fighting/fighting_button_mostername.png",rect.size.width-160,rect.size.height-270+15+20+8):addTo(self.bg)
    section1ContentBg2:setScaleY(0.8)
    section1ContentBg2:setScaleX(0.9)
    local section1TitleBg2 = display.newSprite("ui/public/public_second_label_bg.png",section1ContentBg2:getBoundingBox().size.width/2+18,section1ContentBg2:getBoundingBox().size.height+10):addTo(section1ContentBg2)
   

    display.newSprite("ui/fighting/tip3.png",100-12,30):addTo(section1TitleBg2)


    self.itemIds = {30014,30015,30012}
    self.buyItemTimesLabel = {}
    self.addTimesBtn = {}

    for i=1,3 do
        local spriteItem = display.newSprite("ui/fighting/fighting_skill_"..i.."_circle.png",-35+i*93,70):addTo(section1ContentBg2)
        local fuwenItem = display.newSprite("ui/fighting/fighting_lection_"..i..".png",40,45):addTo(spriteItem)
        fuwenItem:setScale(0.5)
        local boxbg = display.newSprite("ui/fighting/frighting_button_box.png",70,10):addTo(spriteItem)
        local buyItemTimes = gItem:getItemNum(self.itemIds[i])
        local timesLabel = ui.newTTFLabel({
              text = buyItemTimes,
              font = "Arial",
              color = ccc3(255,255,255),
              x = 6,
              y = 18,
              size = 18,
              dimensions = CCSize(135,120),
              align = ui.TEXT_ALIGN_LEFT
        }):addTo(boxbg)
        self.buyItemTimesLabel[#self.buyItemTimesLabel+1]=timesLabel
        local addBtn = display.newSprite("ui/hero/hero_new_plus.png",35,37):addTo(boxbg)
        addBtn:setScale(0.6)
        self.addTimesBtn[#self.addTimesBtn+1] = addBtn
        addBtn:setContentSize(CCSize(100,100))
        --addBtn:setTouchEnabled(false)  -- yangdx  modify
        addBtn:addTouchEventListener(function(event, x, y)
            --require("app.views.BattleBuyPanel").new(self):addTo(display.getRunningScene(),60000)
            ------------------------单个单个购买---------------------------------------------------------------------------
            self:pay(i)
        end)
        --spriteItem:setTouchEnabled(false)
        spriteItem:addTouchEventListener(function(event, x, y)
            self:pay(i)
        end)
    end
    self:refreshTimes()
    ---------------------------------------------------------------------------技能令牌----------------------------------------
    
    if not ifSpecia then
        for i=1,2 do
            local passId = passIds[i][1]
            local star = passIds[i][2]
            --print("passIds",passId,star)
            if i==1 then
                self.normalBtn = display.newSprite("ui/fighting/fighting_icon_nornallevel.png",100,250):addTo(self.bg)
                local starBg = display.newSprite("ui/hero/hero_base_3.png",110,190):addTo(self.bg)
                starBg:setScaleX(0.4)
                starBg:setScaleY(0.3)
                for i=1,3 do
                    if i>star then
                        display.newSprite("ui/public/public_flag_gray.png",70+i*20,190):addTo(self.bg)
                    elseif i==star then
                        display.newSprite("ui/public/public_flag_normal.png",70+i*20,190):addTo(self.bg)
                    else
                        display.newSprite("ui/public/public_flag_normal.png",70+i*20,190):addTo(self.bg)
                    end
                end
                self.normalPasdId = passId
            elseif i==2 then
                self.seniorBtn = display.newSprite("ui/fighting/fighting_icon_elitelevel.png",290,250):addTo(self.bg)
                local starBg = display.newSprite("ui/hero/hero_base_3.png",300,190):addTo(self.bg)
                starBg:setScaleX(0.4)
                starBg:setScaleY(0.3)
                for i=1,3 do
                    if i>star then
                        display.newSprite("ui/public/public_flag_gray.png",260+i*20,190):addTo(self.bg)
                    elseif i==star then
                        display.newSprite("ui/public/public_flag_normal.png",260+i*20,190):addTo(self.bg)
                    else
                        display.newSprite("ui/public/public_flag_normal.png",260+i*20,190):addTo(self.bg)
                    end
                end
                self.seniorPassId = passId
            end
        end

    else
        --print("+++++++++++++")
        --require("app.common.DebugUtil").print_table2(passIds,2)
        --print("+++++++++++++")
        local passId = passIds[1]
        local star = passIds[2]
        self.seniorBtn = display.newSprite("ui/fighting/fighting_icon_elitelevel.png",260,display.cy+50):addTo(self,3)
            --[[
                local starBg = display.newSprite("ui/hero/hero_base_3.png",display.cx,display.cy-50):addTo(self,2)
                starBg:setScaleX(0.4)
                starBg:setScaleY(0.3)
                for i=1,3 do
                    if i>star then
                        display.newSprite("ui/public/public_flag_gray.png",display.cx-50+i*20,display.cy-50):addTo(self,3)
                    elseif i==star then
                        display.newSprite("ui/public/public_flag_normal.png",display.cx-50+i*20,display.cy-50):addTo(self,3)
                    else
                        display.newSprite("ui/public/public_flag_normal.png",display.cx-50+i*20,display.cy-50):addTo(self,3)
                    end
                end]]
                self.seniorPassId = passId
    end
    if  not ifSpecia then
        local action = CCScaleBy:create(1,0.8,0.8)
        --self.normalBtn:runAction(CCRepeatForever:create(CCSequence:createWithTwoActions(action, action:reverse())))
        self.passId = self.normalPasdId
    else
        local action = CCScaleBy:create(1,0.8,0.8)
        --self.seniorBtn:runAction(CCRepeatForever:create(CCSequence:createWithTwoActions(action, action:reverse())))
        self.passId = self.seniorPassId
    end
    

    self.startBattleBtn = cc.ui.UIPushButton.new({
        normal = "ui/fighting/fighting_button_actionfrighting_normal.png",
        pressed = "ui/fighting/fighting_button_actionfrighting_pressed.png",
    })
    :pos(display.cx-60-12+165,rect.origin.y+40-55+76)
    :onButtonRelease(function(event)
        --display.replaceScene(require("app.scenes.PlayScene").new({worldId=mapId,sceneId=sceneId,passId=self.passId,ifUseTangSeng=self.ifUseTangSeng}))
        display.replaceScene(require("app.scenes.BattleScene").new(nil,{worldId=mapId,sceneId=sceneId,passId=self.passId,ifUseTangSeng=self.ifUseTangSeng}))
        --for i=1,#self.monsterBodyIdArray,1 do
        --    display.removeSpriteFramesWithFile("monster/monster_"..self.monsterBodyIdArray[i]..".plist","monster/monster_"..self.monsterBodyIdArray[i]..".pvr.ccz")
        --end
    end)
    :addTo(self.bg,3)

        local action=CCScaleBy:create(0.6, 1.05, 1.05)
    --self.startBattleBtn:runAction(CCRepeatForever:create(CCSequence:createWithTwoActions(action, action:reverse())))


    local height = 55
    local width = 150
    CommUtil.setBtnGuide(self.startBattleBtn , GUIDE_BTN_START_BATTLE)
    GUIDE_BTN_START_BATTLE[0].x = GUIDE_BTN_START_BATTLE[0].x - width/2
    GUIDE_BTN_START_BATTLE[0].y = GUIDE_BTN_START_BATTLE[0].y - height/2
     GUIDE_BTN_START_BATTLE[0].width = width
    GUIDE_BTN_START_BATTLE[0].height = 55
    self.closeBtn = cc.ui.UIPushButton.new({
        normal = "ui/public/public_button_normal.png",
        pressed = "ui/public/public_button_pressed.png",
    })
    :pos(rect.size.width-10-8,rect.size.height-10-8)
    :onButtonRelease(function(event)
      
        CommUtil.playSound("music/close.mp3")
        self.bg:runAction(CCScaleTo:create(0.2,0))
        self:performWithDelay(function()
            if display.getRunningScene().setMainSceneTouch then
                display.getRunningScene():setMainSceneTouch(true)
            end
            --for i=1,#self.monsterBodyIdArray,1 do
            --    display.removeSpriteFramesWithFile("monster/monster_"..self.monsterBodyIdArray[i]..".plist","monster/monster_"..self.monsterBodyIdArray[i]..".pvr.ccz")
            --end
            self:removeSelf()
        end,0.3)

        
    end)
    :addTo(self.bg,3)
    

    display.newSprite("ui/fighting/tip1.png", 100, 130):addTo(self.bg)
     display.newSprite("ui/fighting/tip4.png", 100+240, 130):addTo(self.bg)


    if  not ifSpecia then
        --self.seniorBtn:setShaderProgram(CCShaderCache:sharedShaderCache():programForKey("ShaderPositionTextureGray"))
        self.seniorBtn:setGrayShader()
        self.normalBtn:setTouchEnabled(true) -- enable sprite touch
        self.normalBtn:addTouchEventListener(function(event, x, y)
            if event == "began" then
                --self.seniorBtn:setShaderProgram(CCShaderCache:sharedShaderCache():programForKey("ShaderPositionTextureGray"))
                --self.normalBtn:setShaderProgram(CCShaderCache:sharedShaderCache():programForKey("ShaderPositionTextureColor"))
                self.seniorBtn:setGrayShader()
                self.normalBtn:setShineShader()
                self.seniorBtn:stopAllActions()
                self.normalBtn:stopAllActions()
                self.normalBtn:setScale(1)
                self.seniorBtn:setScale(1)
                local action = CCScaleBy:create(1,0.8,0.8)
                self.normalBtn:runAction(CCRepeatForever:create(CCSequence:createWithTwoActions(action, action:reverse())))
                self.passId = self.normalPasdId
                self:updatePassMonsters(mapId,sceneId,self.passId)
                --print("passid,",self.normalPasdId,self.seniorPassId,self.passId)
                return true -- catch touch event, stop event dispatching
            end
        end)
    else
        --self.seniorBtn:setShaderProgram(CCShaderCache:sharedShaderCache():programForKey("ShaderPositionTextureColor"))
        self.seniorBtn:setShineShader()
    end

    self.seniorBtn:setTouchEnabled(true) -- enable sprite touch
    self.seniorBtn:addTouchEventListener(function(event, x, y)
        if event == "began" then
            if ifSpecia then return true end
            --print(gPlayer.data.pass_id,self.seniorPassId)
            if not (gPlayer.data.pass_id >=self.seniorPassId) then
                CommUtil.toast(display.getRunningScene(),"通过普通关卡开启精英关!",0)
                return true  
            end
            --self.seniorBtn:setShaderProgram(CCShaderCache:sharedShaderCache():programForKey("ShaderPositionTextureColor"))
            --self.normalBtn:setShaderProgram(CCShaderCache:sharedShaderCache():programForKey("ShaderPositionTextureGray"))
            self.seniorBtn:setShineShader()
            self.normalBtn:setGrayShader()
            self.seniorBtn:stopAllActions()
            self.normalBtn:stopAllActions()
            self.normalBtn:setScale(1)
            self.seniorBtn:setScale(1)
            local action = CCScaleBy:create(1,0.8,0.8)
            self.seniorBtn:runAction(CCRepeatForever:create(CCSequence:createWithTwoActions(action, action:reverse())))
            self.passId = self.seniorPassId
            self:updatePassMonsters(mapId,sceneId,self.passId)
            --print("passid,",self.normalPasdId,self.seniorPassId,self.passId)
            return true -- catch touch event, stop event dispatching
        end
    end)
    self:updatePassMonsters(mapId,sceneId,self.passId)
    CommUtil.guideStep(111)

    self.bg:setPositionX(display.right)
    --self.bg:runAction(CCScaleTo:create(0.03,1))
     transition.execute(self.bg, CCMoveTo:create(0.2, CCPoint(display.cx, display.cy)),{
      easing = "bounceOut",
      onComplete = function()
      if (word_action) then
        word_action()
      end
    end
    })

end



--------------------index分别为1，2，3对应于水晶,购买唐僧为空
function BattlePreview:pay(index)
    if index==nil then        
        local priceX = 4
        if (DEF_SPECIAL_PAY_PROCESS) then
            priceX = 4
        end
       local code = 'shen_tangshen'
        require('app.views.payTips').new({
            name = "金钟罩圣僧",
            price = priceX,
            cancelCallback=function()
            end,
            confirmCallback=function() 
                DeviceUtil.xiYouPay(ChargeData[code]["ChinaMobile"], ChargeData[code]["ChinaTelecom"], ChargeData[code]["ChinaUnicom"],ChargeData[code]["Unline"], function(resultJsonString)
                        if tostring(resultJsonString)~="success" then
                            --CommUtil.toast(display.getRunningScene(),"购买失败,请重试",0)
                        else
                            --CommUtil.toast(display.getRunningScene(),"购买成功",0)
                            --gItem:addItem(30008,1)  --yangdx modi
                            self.tipWords:setString(gItem:getTangSengTimes())

                        end
                        self:refreshTangSengTimes()
                    end)
            end,
            }):center():addTo(self,100)
    else
        --yangdx modify
        if ( DEF_SPECIAL_PROCESS and (DEF_CONTROL_LEVEL==0 or  gPlayer.data.pass_id > 60003 ) ) then 
            --print("yangdx 这是啥子地方哦2")
            CommUtil.buyShuiJing(function()
                gItem:addItem(self.itemIds[index],1)
                self:refreshTimes()
            end)
        end

    end
end

function BattlePreview:hideBtn()
    self.startBattleBtn:setVisible(false)
    self.giftSprite:setVisible(false)
    self.closeBtn:setVisible(false)
    if self.title then
        self.title:setVisible(false)
    end
end

function BattlePreview:displayBtn()
    self.startBattleBtn:setVisible(true)
    self.giftSprite:setVisible(true)
    self.closeBtn:setVisible(true)
    self.title:setVisible(true)
    self.tipWords:setString(gItem:getTangSengTimes())
    self:refreshTimes()
    self:refreshTangSengTimes()
    if gHero:isHeroExists(10003) then
        self.giftSprite:setVisible(false)
    end
end

return BattlePreview