local BloodNumView = class("BloodNumView",function(num) 
    local node = display.newSprite()
    return node
end)

--默认为左对齐，direction=1为中间对齐，direction=2为右对齐
--width为数字的宽度(数字与数字间间距之和),默认为12
function BloodNumView:ctor(num, direction, width)
	self:set(num, direction, width)
	self.orix = 0
	self.num = 0
end

function BloodNumView:set(num, direction, width)
	self:removeAllChildrenWithCleanup(true)
	local numStr = ""..num
	local length = string.len(numStr)
	local startX = 0
	local fontWidth = 26

	if width ~= nil then
		fontWidth = width
	end

	if direction == 1 then
		startX = (length % 2 == 0) and startX - fontWidth * length / 2 or startX - fontWidth * math.floor(length / 2) - fontWidth / 2
	elseif direction == 2 then
		startX = startX - fontWidth * length
	end

	for i=1,length do
		local currentNumStr = string.sub(numStr,i,i)
		
		local imageName = string.format("ui/public/public_crit_number_%s.png",currentNumStr)

		local sprite = display.newSprite(imageName,startX,0)
		sprite:setAnchorPoint(CCPoint(0,0))
		self:addChild(sprite)
		startX = startX+fontWidth
	end
end

--左对齐方式,非居中
function BloodNumView:set2(num, direction)

	if (num == self.num) then
		return
	end
	self.num =num
	
	self:set(num, direction)

	--移动位置
	local numlist={10,100,1000,10000,100000,1000000,10000000,100000000,1000000000}
	local move_x = 5
	local pos=0
	for k, v in ipairs(numlist) do
		if (tonumber(num) > v) then	
			pos = pos + 1
		else
			break
		end
	end
	if (self.orix == 0) then
		local x, y = self:getPosition()
		self.orix = x
	end
	self:setPositionX(self.orix + move_x*pos)
end
return BloodNumView