local CommUtil = require("app.common.CommUtil")
local ColorTxt = import("app.ui.ColorText")
local monster_template = nil

local ClimbTowerPreview = class("ClimbTowerPreview", function()
    local node = require("app.views.MaskNode").new()
    return node
end)

function ClimbTowerPreview:pageReresh()
    local rect = self.bg:getBoundingBox()
    local size = rect.size
    if (not self.move_speed) then
    self.move_speed = 1
  end
    if (self.ares and self.ares[1] and self.ares[2]) then
       if (self.status ~= 0 and self.dida) then
        self.dida = self.dida + 1
        if (self.dida == 60) then
          self.status = 0
          self.move_speed=1
        end
      end
        for i=1, 2 do
            if i==1 then
                if self.move_speed > 0 and ((self.ares[i].initPositionY - self.ares[i]:getPositionY())>50) then
                    self.ares[i]:setPositionY(self.ares[i].initPositionY)
                end
                if self.move_speed < 0 and ((self.ares[i]:getPositionY()-self.ares[i].initPositionY)>40) then
                    self.ares[i]:setPositionY(self.ares[i].initPositionY)
                end
                self.ares[i]:setPositionY(self.ares[i]:getPositionY()-self.move_speed)
            end

            if i==2 then
                if self.move_speed > 0 and ((self.ares[i].initPositionY - self.ares[i]:getPositionY())>50) then
                    self.ares[i]:setPositionY(self.ares[i].initPositionY)
                end
                if self.move_speed < 0 and ((self.ares[i]:getPositionY()-self.ares[i].initPositionY)>40) then
                    self.ares[i]:setPositionY(self.ares[i].initPositionY)
                end
                self.ares[i]:setPositionY(self.ares[i]:getPositionY()-self.move_speed)
            end

        end
    end
end

function ClimbTowerPreview:resetBg(size,clipnode)
  if (self.ares) then
      self.ares[1]:removeFromParentAndCleanup(true)
      self.ares[2]:removeFromParentAndCleanup(true)
      self.ares = nil
  end
    self.ares={}
    self.ares[1] = display.newSprite("ui/public/pve_gossip_background.jpg",size.width/2,size.height/2+50)
    :addTo(clipnode)
    self.ares[1]:setScaleX(size.width/self.ares[1]:getBoundingBox().size.width)
    self.ares[1]:setScaleY(size.height/self.ares[1]:getBoundingBox().size.height)
    self.ares[1].initPositionY = self.ares[1]:getPositionY()

    self.ares[2] = display.newSprite("ui/public/pve_gossip_background.jpg",size.width/2,size.height/2)
    :addTo(clipnode)
    self.ares[2]:setScaleX(size.width/self.ares[2]:getBoundingBox().size.width)
    self.ares[2]:setScaleY(size.height/self.ares[2]:getBoundingBox().size.height)
    self.ares[2].initPositionY = self.ares[2]:getPositionY()
end

function ClimbTowerPreview:refreshTimes()
    for i=1,3 do
        local buyItemTimes = gItem:getItemNum(self.itemIds[i])
        if buyItemTimes>0 then
            self.buyItemTimesLabel[i]:setVisible(true)
            self.buyItemTimesLabel[i]:setString(buyItemTimes)
            self.addTimesBtn[i]:setVisible(false)
        else
            self.buyItemTimesLabel[i]:setVisible(false)
            self.addTimesBtn[i]:setVisible(true)
        end
    end
end

function ClimbTowerPreview:refreshTangSengTimes()
    if gItem:getTangSengTimes()>0 then
        self.addTangSengBtn:setVisible(false)
        self.tipWords:setVisible(true)
        self.tipWords:setString(gItem:getTangSengTimes())
    else
        self.addTangSengBtn:setVisible(true)
        self.tipWords:setVisible(false)
    end
    if gItem:getTangSengTimes()>=1 then
        self.ifUseTangSeng = true
    else
        self.ifUseTangSeng = false
    end
end

function ClimbTowerPreview:initMonsterProperties(monsterid)
    for i = 1,#monster_template, 1 do
        if monster_template[i][1]==monsterid then
            self.monsterProperties[monsterid] = monster_template[i]
            return
        end
    end
end
function ClimbTowerPreview:getBodyId(monsterid)
    for i = 1,#monster_template, 1 do
        if monster_template[i][1]==monsterid then
            return  monster_template[i][10]
        end
    end
end
function ClimbTowerPreview:ifExistsInTable(bodyIdArray,bodyId)
    for i = 1,#bodyIdArray, 1 do
        if bodyIdArray[i]==bodyId then
            return true
        end
    end
    return false
end

function ClimbTowerPreview:getMonsterProperty(bId)
    for i = 1,#self.sceneData, 1 do
        local monsterid = self.sceneData[i][5]
        local bodyId = self:getBodyId(monsterid)
        local property = self.monsterProperties[monsterid]
        local wood = property[24]
        local water = property[25]
        local fire = property[26]
        local soil = property[27]
        if bId==bodyId and (wood~=0 or water~=0 or fire~=0 or soil~=0) then
            return  self.monsterProperties[monsterid]
        end
    end
    for i = 1,#self.sceneData, 1 do
        local monsterid = self.sceneData[i][5]
        local bodyId = self:getBodyId(monsterid)
        if bId==bodyId then
            return  self.monsterProperties[monsterid]
        end
    end
end

function ClimbTowerPreview:getTypeImageName(property)
    local wood = property[24]
    local water = property[25]
    local fire = property[26]
    local soil = property[27]

    if wood~=0 then return "frighting_new_change_tree.png" end
    if water~=0 then return "frighting_new_change_water.png" end
    if fire~=0 then return "frighting_new_change_fire.png" end
    if soil~=0 then return "frighting_new_change_stone.png" end

    return nil

end

function ClimbTowerPreview:updatePassMonsters(mapId,sceneId,passId)
    --print("å…³å¡ä¿¡æ¯",mapId,sceneId,passId,self.monsterBodyIdArray)
    --for i=1,#self.monsterBodyIdArray,1 do
     --   display.removeSpriteFramesWithFile("monster/monster_"..self.monsterBodyIdArray[i]..".plist","monster/monster_"..self.monsterBodyIdArray[i]..".pvr.ccz")
    --end
    for i=1,#self.monsters do
        self.monsters[i]:removeSelf()
    end
    monster_template = require("app.client.template.monster_template")
    self.monsterProperties = {}
    self.monsterBodyIdArray = {}
    self.monsters = {}
    local world = require("app.client.template.map_"..mapId.."_template")
    self.sceneData = world[sceneId][passId]
    local totalMonsterNums = #self.sceneData
    for i = 1,totalMonsterNums, 1 do
        local monsterid = self.sceneData[i][5]
        local bodyId = self:getBodyId(monsterid)
        self:initMonsterProperties(monsterid)
        if self:ifExistsInTable(self.monsterBodyIdArray,bodyId) then
        else
            self.monsterBodyIdArray[#self.monsterBodyIdArray+1]=bodyId
        end
    end
    --for i=1,#self.monsterBodyIdArray,1 do
    --    display.addSpriteFramesWithFile("monster/monster_"..self.monsterBodyIdArray[i]..".plist","monster/monster_"..self.monsterBodyIdArray[i]..".pvr.ccz")
    --end

    local properties = {}
    for i=1,#self.monsterBodyIdArray do
        properties[#properties+1] = self:getMonsterProperty(self.monsterBodyIdArray[i])
    end
    --print("æœ‰å¤šå°‘ä¸ªå±žæ€?,#properties)

    self.monsters={}
    for i=1,#properties do
        body_id = properties[i][10]
        --print("bodyId",body_id)
        local monster = display.newSprite("#monster_"..body_id.."_walk_front_1.png",80+(i-1)*65,70):addTo(self.bg)
        monster:setScale(0.8)
        self.monsters[#self.monsters+1] = monster
        --local imageName = "monster_"..body_id.."_walk_front_%d.png"
        --local frames = display.newFrames(imageName, 1,8)
        --local animation = display.newAnimation(frames,1/8)
        --monster:playAnimationForever(animation)
        local typeImageName = self:getTypeImageName(properties[i])
        if typeImageName~=nil then
            display.newSprite("ui/fighting/"..typeImageName,-10,40):addTo(monster)
        end
    end
end

function ClimbTowerPreview:ctor()
    CommUtil.playSound("music/openbox.mp3")
    if display.getRunningScene().setMainSceneTouch then
        display.getRunningScene():setMainSceneTouch(false)
    end
    monster_template = require("app.client.template.monster_template")
    self.monsterProperties = {}
    self.monsterBodyIdArray = {}
    self.monsters = {}
    self.bg = display.newSprite("ui/public/public_base_map_b.png",display.cx,display.cy):addTo(self)
    local rect = self.bg:getBoundingBox()
    self.mapBg = display.newSprite("ui/fighting/frighting_base_1.png",200,display.cy+20):addTo(self.bg,3)
    local rectMap = self.mapBg:getBoundingBox()
    local cutX = 16
    local cutY = 15
    local clipRect = CCRect(cutX,cutY+5,rectMap.size.width-cutX*2,rectMap.size.height-cutY*2)
    local map = display.newSprite("map/map"..tostring(701)..".png",rectMap.size.width/2,rectMap.size.height/2)
    local clipnode = display.newClippingRegionNode(clipRect)
    self.mapBg:addChild(clipnode,2)
    self:resetBg(rectMap.size,clipnode)
    self:schedule(handler(self, self.pageReresh),1/60)
    self.mapBg:addChild(map,3)
    map:setScaleX(rectMap.size.width/map:getBoundingBox().size.width*0.93)
    map:setScaleY(rectMap.size.height/map:getBoundingBox().size.height*0.91)
    map:setPositionY(map:getPositionY()+3)
    self.mapBg:setScale(0.8)

    local allPassIds = {70001,70002,70003,70004,70005}
    self.passId = allPassIds[gPlayer.data.climbNum:get()]

    self.title = display.newSprite("ui/checkpoint/checkpoint_6.png",180,rect.size.height-40):addTo(self.bg)


    self.floorNO = gPlayer.data.climbNum:get()
    if self.floorNO>5 then self.floorNO=5 end
    local leftArrown = display.newSprite("ui/home/home_arrow_up.png",80,display.cy+20):addTo(self.bg,10)
    leftArrown:setRotation(-90)
    local rightArrown = display.newSprite("ui/home/home_arrow_up.png",320,display.cy+20):addTo(self.bg,10)
    rightArrown:setRotation(90)
    local floorBg = display.newSprite("ui/fighting/pve_gossip_post.png",200,display.cy+20):addTo(self.bg,10)
    self.floorText = ui.newTTFLabel({
          text = self.floorNO,
          font = "Arial",
          color = ccc3(255,255,255),
          size = 40,
          x=80,
          y=40,
    }):addTo(floorBg)

    leftArrown:setTouchEnabled(true) -- enable sprite touch
    leftArrown:addTouchEventListener(function(event, x, y)
        if event == "began" then
            if self.floorNO==1 then
                CommUtil.toastNode(display.getRunningScene(),"å·²åˆ°æœ€ä½Žå±‚",0)
                return true
            end
            self.floorNO = self.floorNO - 1
            self.move_speed = -5
            self:performWithDelay(function()
                self.move_speed = -1
            end,2)
            self.floorText:setString(self.floorNO)
            self.passId = allPassIds[self.floorNO]
            --CommUtil.vibrator_climb(self)
            return true -- catch touch event, stop event dispatching
        end
    end)

    rightArrown:setTouchEnabled(true) -- enable sprite touch
    rightArrown:addTouchEventListener(function(event, x, y)
        if event == "began" then
            print("gPlayer.data.climbNum:get()=", gPlayer.data.climbNum:get())
            print("self.floorNO=", self.floorNO)
           if gPlayer.data.climbNum:get()<(self.floorNO+1) then
                CommUtil.toastNode(display.getRunningScene(),"此次打过才能打下一层",0)
                return true
            end
            if self.floorNO==5 then
                CommUtil.toastNode(display.getRunningScene(),"已达到最高层",0)
                return true
            end
            self.floorNO = self.floorNO + 1
            self.move_speed = 5
            self:performWithDelay(function()
                self.move_speed = 1
            end,2)
            self.floorText:setString(self.floorNO)
            self.passId = allPassIds[self.floorNO]
            --CommUtil.vibrator_climb(self)
            return true -- catch touch event, stop event dispatching
        end
    end)


    ---------------------------------------------------------------------------é‡‘é’Ÿç½?---------------------------------------
    local section1ContentBg1 = display.newSprite("ui/fighting/fighting_button_mostername.png",rect.size.width-160,rect.size.height-120):addTo(self.bg)
    section1ContentBg1:setScale(0.9)
    local section1TitleBg1 = display.newSprite("ui/public/public_second_label_bg.png",section1ContentBg1:getBoundingBox().size.width/2+18,section1ContentBg1:getBoundingBox().size.height+10):addTo(section1ContentBg1)
    ui.newTTFLabel({
          text = "金钟罩",
          font = "Arial",
          color = ccc3(255,255,255),
          x = 50,
          y = 25,
          size = 22,
          dimensions = CCSize(135,120),
          align = ui.TEXT_ALIGN_LEFT
    }):addTo(section1TitleBg1)
    local tangSengTimeBg = display.newSprite("ui/fighting/frighting_button_box.png",95,section1ContentBg1:getBoundingBox().size.height-90):addTo(section1ContentBg1,3)
    tangSengTimeBg:setScale(1.1)
    self.tipWords = ui.newTTFLabel({
          text = gItem:getTangSengTimes(),
          font = "Arial",
          color = ccc3(255,255,255),
          x =6,
          y = 15,
          size = 18,
          dimensions = CCSize(135,120),
          align = ui.TEXT_ALIGN_LEFT
    }):addTo(tangSengTimeBg)
    self.head = display.newSprite("#hero_head_30008.png",50,section1ContentBg1:getBoundingBox().size.height-60):addTo(section1ContentBg1)
    self.head:setScale(1.1)
    self.addTangSengBtn = display.newSprite("ui/hero/hero_new_plus.png",35,37):addTo(tangSengTimeBg)
    self.addTangSengBtn:setScale(0.6)
    self.addTangSengBtn:setContentSize(CCSize(100,100))
    tangSengTimeBg:setTouchEnabled(true)
    tangSengTimeBg:addTouchEventListener(function(event, x, y)
        if event == "began" then
            self:pay()
            return true -- catch touch event, stop event dispatching
        end
    end)
    self.head:setTouchEnabled(true)
    self.head:addTouchEventListener(function(event, x, y)
        if event == "began" then
            self:pay()
            return true -- catch touch event, stop event dispatching
        end
    end)

    self:refreshTangSengTimes()

    ui.newTTFLabel({
         text = "金钟罩保护诸葛亮\n抵挡额外5次伤害",
          font = "Arial",
          color = ccc3(255,255,255),
          x =115,
          y = 80,
          size = 21,
          dimensions = CCSize(200,120),
          align = ui.TEXT_ALIGN_LEFT
    }):addTo(section1ContentBg1)
    ---------------------------------------------------------------------------é‡‘é’Ÿç½?---------------------------------------



    ---------------------------------------------------------------------------æŠ€èƒ½ä»¤ç‰?---------------------------------------
    local section1ContentBg2 = display.newSprite("ui/fighting/fighting_button_mostername.png",rect.size.width-160,rect.size.height-270):addTo(self.bg)
    section1ContentBg2:setScale(0.9)
    local section1TitleBg2 = display.newSprite("ui/public/public_second_label_bg.png",section1ContentBg2:getBoundingBox().size.width/2+18,section1ContentBg2:getBoundingBox().size.height+10):addTo(section1ContentBg2)
    ui.newTTFLabel({
           text = "技能令牌",
          font = "Arial",
          color = ccc3(255,255,255),
          x = 50,
          y = 25,
          size = 22,
          dimensions = CCSize(135,120),
          align = ui.TEXT_ALIGN_LEFT
    }):addTo(section1TitleBg2)

    self.itemIds = {30014,30015,30012}
    self.buyItemTimesLabel = {}
    self.addTimesBtn = {}
    for i=1,3 do
        local spriteItem = display.newSprite("ui/fighting/fighting_skill_"..i.."_circle.png",-35+i*93,70):addTo(section1ContentBg2)
        local fuwenItem = display.newSprite("ui/fighting/fighting_lection_"..i..".png",40,45):addTo(spriteItem)
        fuwenItem:setScale(0.5)
        local boxbg = display.newSprite("ui/fighting/frighting_button_box.png",70,10):addTo(spriteItem)
        local buyItemTimes = gItem:getItemNum(self.itemIds[i])
        local timesLabel = ui.newTTFLabel({
              text = buyItemTimes,
              font = "Arial",
              color = ccc3(255,255,255),
              x = 6,
              y = 18,
              size = 18,
              dimensions = CCSize(135,120),
              align = ui.TEXT_ALIGN_LEFT
        }):addTo(boxbg)
        self.buyItemTimesLabel[#self.buyItemTimesLabel+1]=timesLabel
        local addBtn = display.newSprite("ui/hero/hero_new_plus.png",35,37):addTo(boxbg)
        addBtn:setScale(0.6)
        self.addTimesBtn[#self.addTimesBtn+1] = addBtn
        addBtn:setContentSize(CCSize(100,100))
        addBtn:setTouchEnabled(true)
        addBtn:addTouchEventListener(function(event, x, y)
            --require("app.views.BattleBuyPanel").new(self):addTo(display.getRunningScene(),60000)
            ------------------------å•ä¸ªå•ä¸ªè´­ä¹°---------------------------------------------------------------------------
            self:pay(i)
        end)
        spriteItem:setTouchEnabled(true)
        spriteItem:addTouchEventListener(function(event, x, y)
            self:pay(i)
        end)
    end
    self:refreshTimes()
    ---------------------------------------------------------------------------æŠ€èƒ½ä»¤ç‰?---------------------------------------


    self.startBattleBtn = cc.ui.UIPushButton.new({
        normal = "ui/fighting/fighting_button_actionfrighting_normal.png",
        pressed = "ui/fighting/fighting_button_actionfrighting_pressed.png",
    })
    :pos(display.cx+90,rect.origin.y+40)
    :onButtonRelease(function(event)
         CommUtil.playSound("music/selectitem.mp3")
        if (gHero:isHeroExists(10003) == true) then
                display.replaceScene(require("app.scenes.BattleScene").new(nil,{worldId=701,sceneId=701,passId=self.passId,ifUseTangSeng=self.ifUseTangSeng,floorNO=self.floorNO}))
        else
          --display.replaceScene(require("app.scenes.BattleScene").new(nil,{worldId=701,sceneId=701,passId=self.passId,ifUseTangSeng=self.ifUseTangSeng,floorNO=self.floorNO}))
          --CommUtil.toast(display.getRunningScene(), 'è§£é”å¤§åœ£å­™æ‚Ÿç©ºå³å¯å¼€å¯é€šå¤©å¡?')
          --require("app.views.payShun").new():addTo(display.getRunningScene(),10000)

          --require("app.views.payShun").new():addTo(self,100)
         require('app.views.payShun').new({
            name = "提示",
            price = 2,
            cancelCallback=function()
            end,
            confirmCallback=function() 
              
            end,
            }):center():addTo(self,100)

        end
        
    end)
    :addTo(self.bg,3)

    self.closeBtn = cc.ui.UIPushButton.new({
        normal = "ui/public/public_button_normal.png",
        pressed = "ui/public/public_button_pressed.png",
    })
    :pos(rect.size.width-10,rect.size.height-10)
    :onButtonRelease(function(event)

        CommUtil.playSound("music/close.mp3")
       -- self.bg:runAction(CCScaleTo:create(0.3,0))
        self:performWithDelay(function()
            if display.getRunningScene().setMainSceneTouch then
                display.getRunningScene():setMainSceneTouch(true)
            end
            self:removeSelf()
        end,0.3)


        
    end)
    :addTo(self.bg,3)
    self.closeBtn:setScale(0.9)
    ui.newTTFLabel({
          name = "提示",
          font = "Arial",
          color = ccc3(255,255,255),
          x = 30,
          y = 130,
          size = 18,
          dimensions = CCSize(135,120),
          align = ui.TEXT_ALIGN_LEFT
    }):addTo(self.bg)


    self:updatePassMonsters(701,701,self.passId)

    self.bg:setPositionX(display.right)
    --self.bg:runAction(CCScaleTo:create(0.03,1))
     transition.execute(self.bg, CCMoveTo:create(0.2, CCPoint(display.cx, display.cy)),{
      easing = "bounceOut",
      onComplete = function()
      if (word_action) then
        word_action()
      end
    end
    })
end

--------------------indexåˆ†åˆ«ä¸?ï¼?ï¼?å¯¹åº”äºŽæ°´æ™?è´­ä¹°å”åƒ§ä¸ºç©º
function ClimbTowerPreview:pay(index)
    if index==nil then
        local priceX = 4
        if (DEF_SPECIAL_PAY_PROCESS) then
            priceX = 4
        end

        local code = 'shen_tangshen'
        require('app.views.payTips').new({
             name = "金钟罩",
            price = priceX,
            cancelCallback=function()
            end,
            confirmCallback=function() 
                DeviceUtil.xiYouPay(ChargeData[code]["ChinaMobile"], ChargeData[code]["ChinaTelecom"], ChargeData[code]["ChinaUnicom"],ChargeData[code]["Unline"], function(resultJsonString)
                        if tostring(resultJsonString)~="success" then
                            --CommUtil.toast(display.getRunningScene(),"购买成功",0)
                        else
                            --CommUtil.toast(display.getRunningScene(),"购买失败",0)
                            --gItem:addItem(30008,1)
                            --self.tipWords:setString(gItem:getTangSengTimes())

                        end
                        self:refreshTangSengTimes()
                    end)
            end,
            }):center():addTo(self,100)
    else
        --yangdx modify  爬塔
        if ( DEF_SPECIAL_PROCESS and ( DEF_CONTROL_LEVEL==0 or  gPlayer.data.pass_id > 60003 ) ) then 
           -- print("yangdx 这是啥子地方哦1")
            CommUtil.buyShuiJing(function()
                gItem:addItem(self.itemIds[index],1)
                self:refreshTimes()
            end)
        end

    end
end

function ClimbTowerPreview:hideBtn()
    self.startBattleBtn:setVisible(false)
    self.giftSprite:setVisible(false)
    self.closeBtn:setVisible(false)
    if self.title then
        self.title:setVisible(false)
    end
    
end

function ClimbTowerPreview:displayBtn()
    self.startBattleBtn:setVisible(true)
    self.giftSprite:setVisible(true)
    self.closeBtn:setVisible(true)
    self.title:setVisible(true)
    self.tipWords:setString(gItem:getTangSengTimes())
    self:refreshTimes()
    self:refreshTangSengTimes()
    if gPlayer.data.isBuyMysGift then
        self.giftSprite:setVisible(false)
    end
end

return ClimbTowerPreview