local ExitWindow = class("ExitWindow", function()
    local node = require("app.views.MaskNode").new()
    return node
end)

function ExitWindow:ctor(args)

    local config = totable(args)

    local onConfirm = config.onConfirm
    local onCancel = config.onCancel

    self.sprite = display.newSprite("ui/setting/setting_base_1.png",display.cx,display.cy):addTo(self)
    self.sprite:setScaleX(2)
    self.sprite:setScaleY(1.3)
    self.sprite1 = display.newSprite("ui/result/fighting_lose.png",display.cx-90-20,display.cy+25):addTo(self)
    self.sprite1:setScale(0.6)
    self.sprite1:setFlipX(true)
    local Text = require("app.ui.Text")
    Text.new({
                  text="悟空你走了..唔唔...",
                  x=display.cx-30,
                  y= display.cy+30,
                  size=24,
                  color = ccc3(255, 255,255),
                  align = ui.TEXT_ALIGN_LEFT,
              }):addTo(self)
    Text.new({
                  text="为师如何应对那些妖怪？",
                  x=display.cx-30,
                  y= display.cy,
                  size=24,
                  color = ccc3(255, 255,255),
                  align = ui.TEXT_ALIGN_LEFT,
              }):addTo(self)

	local YPos = display.cy-90

    local function onItem1Click()
    	onConfirm()
    	self:removeFromParentAndCleanup(true)
    end

    local function onItem2Click()
    	onCancel()
    	self:removeFromParentAndCleanup(true)
    end

    	local item1 = ui.newImageMenuItem({
	    image = "ui/public/fighting_button_leave_normal.png",
	    imageSelected = "ui/public/fighting_button_leave_pressed.png",
	    listener = onItem1Click,
	    x = display.cx-100,
	    y = YPos
		})
		local item2 = ui.newImageMenuItem({
	   image = "ui/public/fighting_button_continue_normal.png",
	    imageSelected = "ui/public/fighting_button_continue_pressed.png",
	    listener = onItem2Click,
	    x = display.cx+100,
	    y = YPos
		})

		self.menu = ui.newMenu({item1,item2})

	self:addChild(self.menu)
end


return ExitWindow