--
-- Author: hejiangcheng
-- Date: 2014-12-12 16:17:53
--
local FightResult = class("FightResult", function()
	local node = display.newNode()
	node:setTouchEnabled(true)
	node:addTouchEventListener(function(event, x, y)
	    return true
	end)
    return node
end)
local Text = require("app.ui.Text")
local scheduler = require("framework.scheduler")
local HiddenClass = require("app.data.template.HidenPassTemplateClass").new()

--[[
参数
star = 0,1,2,3 : 失败 小胜 小胜 大胜 
pass_id 当前关卡id
scene_id 当前场景
map_id	当前地图
]]
--TODO 区分爬塔 普通战斗 隐藏关卡 战斗结束保存的数据
function FightResult:ctor(args)
	self.args = totable(args)

	self.awdCopper = 0
	if HiddenClass:isPassIdExists(args.pass_id) then
		self.awdCopper = HiddenClass:getAwdCopper(args.pass_id, args.star)
	else
		self.awdCopper = gPassTemplate:getAwdCopper(args.pass_id, args.star)
		if args.pass_id < 70001 then
			gPlayer:setStarNum(args.pass_id, args.star)
		end
	end
	gPlayer:addCopper(self.awdCopper*2)

	local bg = display.newSprite("ui/public/public_mask_blank.png"):center():addTo(self)
	bg:setScaleX(display.width/bg:getContentSize().width)
	bg:setScaleY(display.height/bg:getContentSize().height)

	local color = CCLayerColor:create(ccc4(0, 0, 0, 220))
	self:addChild(color)

	--umeng
	local pveid = 60003
	if (DEF_SPECIAL_PAY_PROCESS) then
			pveid = 60000
	end
	if NETTYPE ~= 'ChinaUnicom' and gPlayer.data.pass_id > pveid
		and args.star==0 then
		 if (gHero:isHeroExists(10003) == false) then
            CommUtil.showgiftPanel(1,3)
        elseif (gHero:isHeroExists(10004) == false 
        	or gHero:isHeroExists(10005) == false
            or gHero:isHeroExists(10006) == false) then
            if (DEF_SPECIAL_PAY_PROCESS) then
                if (gHero:isHeroExists(10004) == false) then
                     CommUtil.showgiftPanel(2,3)
                elseif (gHero:isHeroExists(10005) == false) then
                    CommUtil.showgiftPanel(3,3)
                else
                    CommUtil.showgiftPanel(4,3)
                end
            else
                CommUtil.showgiftPanel(2,0)
            end
        end
        self:displayBtn()
	else
		self:displayBtn()
	end
	
end

function FightResult:displayBtn()
	if self.args.star == 0 then
		display.newSprite("ui/result/fighting_lose.png",display.cx-50, display.cy+90):addTo(self)
	else
		display.newSprite("ui/result/fighting_win.png",display.cx-50, display.cy+90):addTo(self)
	end
	self:addStar()
end

function FightResult:addStar()
	local base=display.newSprite('ui/fighting/fighting_button_mostername.png', display.cx, display.cy-100):addTo(self):scale(0.9)
	if self.args.star == 0 then
		self:addWord()
		return
	end

	base:setPositionY(display.cy-120)
	display.newSprite('ui/public/mall_base_rechangeright_1.png', display.cx, display.cy-50):addTo(self)

	local pos
	if self.args.star == 3 then
		pos={
			ccp(display.cx-60, display.cy-40),
			ccp(display.cx, display.cy-30),
			ccp(display.cx+60, display.cy-40),
		}
	elseif self.args.star == 2 then 
		pos={
			ccp(display.cx-60, display.cy-40),
			-- ccp(display.cx, display.cy-30),
			ccp(display.cx+60, display.cy-40),
		}
	else
		pos={
			-- ccp(display.cx-60, display.cy-50),
			ccp(display.cx, display.cy-30),
			-- ccp(display.cx+60, display.cy-50),
		}
	end
	for i=1, self.args.star do
		local star=display.newSprite("ui/home/home_icon_stars.png",display.cx,display.top+30):addTo(self)
		star:opacity(0):scale(3)
		local time = 0.1
		local action = transition.sequence({
			CCSpawn:createWithTwoActions(CCFadeIn:create(time),CCSpawn:createWithTwoActions(CCScaleTo:create(time, 0.8),CCMoveTo:create(time, pos[i]))),
			CCScaleTo:create(0.05, 1.5),
			CCScaleTo:create(0.1, 1),
		})

		transition.execute(star, action, {delay=(i-1)*(time+0.1+0.05+0.08),onComplete=function() 
			if i== self.args.star then 
				self:addWord()
			end
		end})
	end
end

function FightResult:addWord()
	if self.args.star==0 then
		display.newSprite('ui/result/fighting_text_lose.png', display.cx, display.cy-100):addTo(self)
		self:addButton()
	else
		-- display.newSprite('ui/result/fighting_text_win.png', display.cx-60, display.cy-120):addTo(self)
		display.newSprite('ui/home/home_icon_copper.png', display.cx+30-80, display.cy-120):addTo(self)

		--[[self.copperNode = display.newNode():addTo(self)
		local i=0
		self.handle = scheduler.scheduleGlobal(function() 
			if i > self.awdCopper then
				scheduler.unscheduleGlobal(self.handle)
				self:addButton()
			else
				self.copperNode:removeAllChildren()
				local node=CommUtil.makeNum(i)
				node:scale(0.7):pos(display.cx+80,display.cy-120):addTo(self.copperNode)
				i=i+1
			end
		end, 0)	]]
		local node=CommUtil.makeNum(gPlayer.data.copper_cnt:get())--self.awdCopper
		node:scale(0.7):pos(display.cx+80-80,display.cy-120):addTo(self)
		self:addButton()
	end
end

function FightResult:addButton()
	local offsetX = self.args.star==0 and 50 or 0
	local backBtn = cc.ui.UIPushButton.new({
			normal="ui/public/fighting_button_backcity_normal.png",
			pressed="ui/public/fighting_button_backcity_pressed.png",
		}):pos(display.cx-100-offsetX, display.cy-180):addTo(self)
		:onButtonRelease(function(event)
				event.target:setButtonEnabled(false)
				local nextScene = import("app.scenes.MainScene").new()
				display.replaceScene(nextScene, "fade", 0.5, ccc3(0, 0, 0))
				self:removeSelf()
			end)
	if self.args.star>0 then
		if self.args.map_id~=702 then
		cc.ui.UIPushButton.new({ --下一关 702困难模式不进入下一关
				normal="ui/result/fighting_button_nextround_normal.png",
				pressed="ui/result/fighting_button_nextround_pressed.png",
			}):pos(display.cx+100+offsetX, display.cy-180):addTo(self)
			:onButtonRelease(function(event)
					event.target:setButtonEnabled(false)
					local para={}
					if self.args.map_id~=701 then--702困难
						if self.args.pass_id+1 <= gPlayer.data.pass_id then
							para.passId = self.args.pass_id+1
						else
							para.passId = self.args.pass_id
						end
						para.worldId = gPassTemplate:getMapidByPassid(para.passId)
						para.sceneId = gPassTemplate:getSceneidByPassid(para.passId)
					else--701爬塔
						if self.args.pass_id+1 <= 70005 then
							para.passId = self.args.pass_id+1
						else
							para.passId = self.args.pass_id
						end
						para.worldId = 701
						para.sceneId = 701
					end

					display.replaceScene(require("app.scenes.BattleScene").new(nil,para))
					self:removeSelf()
				end)
		else
			backBtn:setPositionX(display.cx)
		end
	else
		local lifeBtn = cc.ui.UIPushButton.new({ --继续战斗
				normal="ui/fighting/fighting_button_resurgence_normal.png",
				pressed="ui/fighting/fighting_button_resurgence_normal.png",
			}):pos(display.cx+100+offsetX, display.cy-180):addTo(self)
			:onButtonRelease(function(event)
							local code ='relife'
		    				DeviceUtil.xiYouPay(ChargeData[code]["ChinaMobile"], ChargeData[code]["ChinaTelecom"], ChargeData[code]["ChinaUnicom"],ChargeData[code]["Unline"], function(resultJsonString)
		    	                if tostring(resultJsonString)~="success" then
		    	                    CommUtil.toast(display.getRunningScene(),"购买失败,请重试",0)
		    	                else		
		    	                    CommUtil.toast(display.getRunningScene(),"购买成功,原地复活",0)
		    	                    totalHP = require("app.common.Number").new(10)
		    						display.getRunningScene().baseScene.gameHud:updateBeautyBlood()
		    						display.getRunningScene().baseScene.gameLogicLayer.gameOver = false
		    						display.getRunningScene().baseScene:resume()
		    						self:removeSelf()
		    	                end
		    	            end)
					    --end,
					    --}):center():addTo(self,100)
				end)
CommUtil.bubbleBtn(lifeBtn, 170, 62)
	end

	if self.args.star>0 then return end
	--[[
	cc.ui.UIPushButton.new({ --英雄修炼
			normal="ui/result/fighting_result_practice.png", 
		}):pos(display.cx, display.cy-180):addTo(self)
		:onButtonRelease(function(event)
				event.target:setButtonEnabled(false)
				local nextScene = import("app.scenes.MainScene").new({enterHero=true})
				display.replaceScene(nextScene, "fade", 0.5, ccc3(0, 0, 0))
			end)]]
end

return FightResult