
local scheduler = require("framework.scheduler")
local MaskNode = class("MaskNode",function() 
    local node = display.newNode()
    node:setTouchEnabled(true)
    node:addTouchEventListener(function(event, x, y)
        return true
    end)
     node:registerScriptHandler(function(event)
        if event == "enter" then
            node:onEnter()
        elseif event == "exit" then
            node:onExit()
        end
    end)
    return node
end)


function MaskNode:ctor()
     self.sprite = CommUtil.addBlankLayer(self)
end

function MaskNode:exit()
     self:removeFromParentAndCleanup(true)
end
function MaskNode:freeImage()
    if (self.loadImg_) then
         for k, v in ipairs(self.loadImg_) do
            display.removeSpriteFramesWithFile(v ..".plist", v ..".png")
        end
    end
end

function MaskNode:loadSocket()
end

function MaskNode:loadImage()
    local param = self.loadImg_
    CommUtil.addFreeze(self)
    
   local pos = 0
   local tick = function()
        if (pos ~= #param) then
            display.addSpriteFramesWithFile(param[pos+1] ..".plist",param[pos+1] ..".png")
            pos = pos + 1
        else
            scheduler.unscheduleGlobal(self.tickScheduler) 
            CommUtil.cutFreeze(self)
            self:onCtor()
        end
    end
    self.tickScheduler = scheduler.scheduleGlobal(tick, 0.1)

end


return MaskNode