local CommUtil = require("app.common.CommUtil")
local AnimationFactory = require("app.factory.AnimationFactory")
local skill = require("app.client.desc.skill")

local SkillPanel = class("SkillPanel",function(canTouch,controller,baseScene,rect,skillIds) 
    if not rect then rect = CCRect(0, 0, 0, 0) end
    local node = display.newClippingRegionNode(rect)
    node.rect=rect
    node:setNodeEventEnabled(true)
    require("framework.api.EventProtocol").extend(node)
    return node
end)

function SkillPanel:updateDiDaPercentage(ifUpdateAll,noChangeSkillIndex)
    if true then return end
    --[[
    if currentDiDa:get()<20 then
        self.baseScene.chargeDidaBtn:setVisible(true)
    else
        self.baseScene.chargeDidaBtn:setVisible(false)
    end

   
    self.shiningSprite:setVisible(true)
    self:performWithDelay(function()
        self.shiningSprite:setVisible(false)
    end,0.2)

    local didaPercentage = currentDiDa:get()
    local time = math.abs((self.didaContainer:getPercentage()-didaPercentage))/100*2
    self.didaContainer:runAction(CCProgressFromTo:create(time,self.didaContainer:getPercentage(),didaPercentage))
    self.water:runAction(CCMoveTo:create(time,ccp(self.water:getPositionX(),didaPercentage/100*117)))
    local length = math.sqrt(didaPercentage*(100-didaPercentage))*2
    local scaleX = length/100
    self.water:runAction(CCScaleTo:create(time,scaleX,1))

    self.text:setString(currentDiDa:get().."")]]
    
    local noChangeSkill = self.skills[noChangeSkillIndex]

    if ifUpdateAll then
        for i = 1, #self.skills do
            local skill = self.skills[i]
            if not skill.ifCoolDown and (skill~=noChangeSkill) then
                if currentDiDa:get()<skill.cost then
                        --print("进度为0")
                        self.timers[i]:setPercentage(0)
                else
                    if skill~=noChangeSkill and self.timers[i]:getPercentage()~=100 then
                        self.timers[i]:setPercentage(100)
                        --[[
                        local skillX,skillY = skill:getPosition()
                        local frames = display.newFrames("skill_cd_%02d.png", 1, 10)
                        local animation = display.newAnimation(frames,1/10)
                        local skillCDEffect = display.newSprite(frames[1],skillX-15,skillY-17):addTo(self.view,30)
                        skillCDEffect:setAnchorPoint(ccp(0,0))
                        transition.execute(skillCDEffect,CCAnimate:create(animation),{
                        onComplete = function()
                            skillCDEffect:removeSelf()
                        end
                        })]]
                    end    
                end
            end
        end
    end
end

function SkillPanel:getTopLeftPoint()
    --return self.topLeftPoint
    return self.middleBg:convertToWorldSpace(ccp(50,50))
end

function SkillPanel:getSkillViewsCenterPointArray()
    local pointArray = {}
    pointArray[#pointArray+1] = self.bg[1]:convertToWorldSpace(ccp(70,45))
    pointArray[#pointArray+1] = self.bg[2]:convertToWorldSpace(ccp(70,45))
    pointArray[#pointArray+1] = self.bg[3]:convertToWorldSpace(ccp(70,45))
    return pointArray
end


function SkillPanel:getFuwenDestinationPoint(index)
    return ccp(self.bg[index]:getPositionX()+50,self.bg[index]:getPositionY()+50)
end

function SkillPanel:ctor(canTouch,controller,baseScene,rect,skillIds)
    --display.newColorLayer(ccc4(255, 255, 255, 255)):addTo(self)
    self.beautySkillNums = #skillIds
    self.baseScene = baseScene
    self.controller = controller
    self.view = display.newLayer()
    self:addChild(self.view)


    self.touchRect = CCRect(display.cx-(2*100),rect.origin.y,display.width,rect.size.height)
    self.offsetX = 0
    self.offsetY = 0
    
    self.skills = {}
    self.timers = {}

    self.cooldowns = {}
    self.initCooldowns = {}
    self.canTouch = canTouch

    self.view:setTouchEnabled(true)
    self.view:addTouchEventListener(function(event, x, y)
        return self:onTouch(event, x, y)

    end)

    local startX=self.rect.origin.x
    local skillWidth = self.beautySkillNums*90

    local x1,x2,x3,x4 = 0
    local skillX1,skillX2,skillX3,skillX4 = 0

    x1 = display.left + 40
    x2 = x1 + 105
    x3 = x2 + 103

    skillX1 = x1+32
    skillX2 = x2+5
    skillX3 = x3+5

    self.skillBg = display.newSprite("ui/fighting/fighting_skill_1_bg.png",display.left + 185,25):addTo(self.view,30)

    self.bg = {}
    local bg1 = display.newSprite("ui/fighting/fighting_skill_1_circle.png",x1,25)
    bg1:setAnchorPoint(CCPoint(0,0))
    self.view:addChild(bg1,20)
    local bg2 = display.newSprite("ui/fighting/fighting_skill_2_circle.png",x2,25)
    bg2:setAnchorPoint(CCPoint(0,0))
    self.view:addChild(bg2,20)
    local bg3 = display.newSprite("ui/fighting/fighting_skill_3_circle.png",x3,25)
    bg3:setAnchorPoint(CCPoint(0,0))
    self.view:addChild(bg3,20)

    self.bg[#self.bg+1] = bg1
    self.bg[#self.bg+1] = bg2
    self.bg[#self.bg+1] = bg3
    
    local skill1 = display.newSprite("ui/fighting/fighting_lection_1.png",18,23)
    skill1:setAnchorPoint(CCPoint(0,0))
    skill1.skillId = skillIds[1]
    skill1.ifCoolDown = false
    --skill1:setOpacity(50)
    --[[
    local progressTimer1 = display.newProgressTimer("ui/fighting/fighting_lection_1.png",display.PROGRESS_TIMER_BAR)
    progressTimer1:setAnchorPoint(CCPoint(0,0))
    progressTimer1:setMidpoint(CCPointMake(0, 0))
    progressTimer1:setBarChangeRate(CCPointMake(0,1))
    progressTimer1:setPercentage(100)
    progressTimer1:setTag(9999)
    skill1:addChild(progressTimer1)]]
    skill1.cooldown = skill[""..skillIds[1]].cooldown
    skill1.cost = skill[""..skillIds[1]].cost
    self.skills[#self.skills + 1] = skill1
    --self.timers[#self.timers + 1] = progressTimer1
    self.cooldowns[#self.cooldowns + 1] = skill[""..skillIds[1]].cooldown
    self.initCooldowns[#self.initCooldowns + 1] = skill[""..skillIds[1]].cooldown
    bg1:addChild(skill1)

    local skill2 = display.newSprite("ui/fighting/fighting_lection_2.png",18,23)
    skill2:setAnchorPoint(CCPoint(0,0))
    skill2.skillId = skillIds[2]
    skill2.ifCoolDown = false
    --skill2:setOpacity(50)
    --[[
    local progressTimer2 = display.newProgressTimer("ui/fighting/fighting_lection_2.png",display.PROGRESS_TIMER_BAR)
    progressTimer2:setAnchorPoint(CCPoint(0,0))
    progressTimer2:setMidpoint(CCPointMake(0, 0))
    progressTimer2:setBarChangeRate(CCPointMake(0,1))
    progressTimer2:setPercentage(100)
    progressTimer2:setTag(9999)
    skill2:addChild(progressTimer2)]]
    skill2.cooldown = skill[""..skillIds[2]].cooldown
    skill2.cost = skill[""..skillIds[2]].cost
    self.skills[#self.skills + 1] = skill2
    --self.timers[#self.timers + 1] = progressTimer2
    self.cooldowns[#self.cooldowns + 1] = skill[""..skillIds[2]].cooldown
    self.initCooldowns[#self.initCooldowns + 1] = skill[""..skillIds[2]].cooldown
    bg2:addChild(skill2)


    local skill3 = display.newSprite("ui/fighting/fighting_lection_3.png",18,23)
    skill3:setAnchorPoint(CCPoint(0,0))
    skill3.skillId = skillIds[3]
    skill3.ifCoolDown = false
    --skill3:setOpacity(50)
    --[[
    local progressTimer3 = display.newProgressTimer("ui/fighting/fighting_lection_3.png",display.PROGRESS_TIMER_BAR)
    progressTimer3:setAnchorPoint(CCPoint(0,0))
    progressTimer3:setMidpoint(CCPointMake(0, 0))
    progressTimer3:setBarChangeRate(CCPointMake(0,1))
    progressTimer3:setPercentage(100)
    progressTimer3:setTag(9999)
    skill3:addChild(progressTimer3)]]
    skill3.cooldown = skill[""..skillIds[3]].cooldown
    skill3.cost = skill[""..skillIds[3]].cost
    self.skills[#self.skills + 1] = skill3
    --self.timers[#self.timers + 1] = progressTimer3
    self.cooldowns[#self.cooldowns + 1] = skill[""..skillIds[3]].cooldown
    self.initCooldowns[#self.initCooldowns + 1] = skill[""..skillIds[3]].cooldown
    bg3:addChild(skill3)

    for i=1,3 do
        local skill = self.skills[i]
        --local timer = self.timers[i]
        skill:setScale(0.5)
    end

    self.skillNumTexts = {}
    self.itemIds = {30014,30015,30012}
    for i=1,#self.bg do
        local posX = 83
        if i==2 then posX=186 end
        if i==3 then posX=290 end
        local bg = self.bg[i]
        local text = ui.newTTFLabel({
            text = gItem:getItemNum(self.itemIds[i]),
            font = "Marker Felt",
            size = 16,
            x = posX,
            y = 16,
            color = ccc3(255, 0, 0),
            align = ui.TEXT_ALIGN_CENTER
        }):addTo(self.skillBg)
        self.skillNumTexts[#self.skillNumTexts+1] = text
    end
    -------------------------------------初始化的时候技能都能使用----------------------------------
    self:updateItem()
end

function SkillPanel:updateItem()
    for i=1,3 do
        local skill = self.skills[i]
        local bg = self.bg[i]
        --local timer = self.timers[i]
        local buyItemTimes = gItem:getItemNum(self.itemIds[i])
        if buyItemTimes<=0 and self.baseScene.freeItemItems[i]<=0 then
            skill:setGrayShader()
            bg:setGrayShader()
            --skill:setShaderProgram(CCShaderCache:sharedShaderCache():programForKey("ShaderPositionTextureGray"))
            --bg:setShaderProgram(CCShaderCache:sharedShaderCache():programForKey("ShaderPositionTextureGray"))
            --timer:setShaderProgram(CCShaderCache:sharedShaderCache():programForKey("ShaderPositionTextureGray"))
        else
            skill:setShineShader()
            bg:setShineShader()
            --skill:setShaderProgram(CCShaderCache:sharedShaderCache():programForKey("ShaderPositionTextureColor"))
            --bg:setShaderProgram(CCShaderCache:sharedShaderCache():programForKey("ShaderPositionTextureColor"))
            --timer:setShaderProgram(CCShaderCache:sharedShaderCache():programForKey("ShaderPositionTextureColor"))
        end

        if self.baseScene.freeItemItems[i]>0 then
            self.skillNumTexts[i]:setColor(ccc3(255, 0, 0))
            self.skillNumTexts[i]:setString("+"..self.baseScene.freeItemItems[i])
        else
            self.skillNumTexts[i]:setColor(ccc3(0,255, 0))
            self.skillNumTexts[i]:setString(buyItemTimes)
        end
    end
end

function SkillPanel:getHeroIndex(heroId)
    for i=1,#self.heroId do
        if self.heroId[i]==heroId then
            return i
        end
    end
    return -1
end

function SkillPanel:lockSkill(heroId)
    local index = self:getHeroIndex(heroId)
    self.locks[index] = 1
    local skill = self.skills[index]
    local timer = self.timers[index]
    skill:setShaderProgram(CCShaderCache:sharedShaderCache():programForKey("ShaderPositionTextureGray"))
    timer:setShaderProgram(CCShaderCache:sharedShaderCache():programForKey("ShaderPositionTextureGray"))
end

function SkillPanel:unLockSkill(heroId)
    local index = self:getHeroIndex(heroId)
    self.locks[index] = 0
    local skill = self.skills[index]
    local timer = self.timers[index]
    skill:setShaderProgram(CCShaderCache:sharedShaderCache():programForKey("ShaderPositionTextureColor"))
    timer:setShaderProgram(CCShaderCache:sharedShaderCache():programForKey("ShaderPositionTextureColor"))
end

function SkillPanel:updateSkillBgPosition()
    for i=1,#self.skills do
        local skill = self.skills[i]
        local skillBg = self.skillBgs[i]
        if skill.skillId==10001 then
            skillBg:setPosition(ccp(skill:getPositionX()+30,skill:getPositionY()+25))
        else
            skillBg:setPosition(ccp(skill:getPositionX()+32,skill:getPositionY()+32))
        end
    end
end

function SkillPanel:ifSkillPanelSkillRelease()
    if self.skillId~=-1 then
        return false
    else
        return true
    end
end

function SkillPanel:setTouchable(canTouch)
    self.canTouch = canTouch
end

function SkillPanel:hide()
    --print("技能面板隐藏起来")
    self:setVisible(false)
    self.canTouch = false
end


function SkillPanel:getCanExpandSkills()
    local returnSkills = {}
    local unUse = gBeauty:getUnlockSkills()

    local ifExists = function(id)
        for i=1,#self.skills do
            local skill = self.skills[i]
            local skillId = skill.skillId
            if skillId==id then
                return true
            end
        end
        return false
    end

    for i=1,#unUse do
        if not ifExists(unUse[i]) then
            returnSkills[#returnSkills+1] = unUse[i]
        end
    end
    return returnSkills
end

function SkillPanel:onTouch(event, x, y)
    if not self.canTouch then
        return false
    end
    if CCDirector:sharedDirector():isPaused() then
        return false
    end
    if event == "began" then
        return self:onTouchBegan(x, y)
    end
end


function SkillPanel:addDidaByIndex(index,dida)
    local skill = self.skills[index]
    local progressTimer = skill:getChildByTag(9999)
    gItem:addItem(index+300,dida)
    if gItem:getItemNum(index+300)>=200 then gItem:setItemNum(index+300,200) end
    progressTimer:setPercentage(gItem:getItemNum(index+300))
end

function SkillPanel:decreaseDida(dida)
    for i = 1,#self.skills do
        local skill = self.skills[i]
        local progressTimer = skill:getChildByTag(9999)
        gItem:cutItem(i+300,dida)
        if gItem:getItemNum(i+300)<0 then gItem:setItemNum(i+300,0) end
        progressTimer:setPercentage(gItem:getItemNum(i+300))
    end
end

function SkillPanel:onTouchBegan(x, y)
    if (not SKILL_CAN_TOUCH) then
        return
    end
    if self.baseScene.towerFactory.ifSendingHero then return false end
    local skill,index = self:checkWichSkillClicked(x,y)
    --print("次数",self.baseScene.freeItemItems[index])
    if skill~=nil then
        if not skill:getParent():isVisible() then
            return false
        end
        if gItem:getItemNum(self.itemIds[index])<=0 and self.baseScene.freeItemItems[index]<=0 then
            --CommUtil.toast(self.controller,"没有道具,弹出界面购买",0)
            --self.baseScene:pause()
            --require("app.views.BattleBuyPanel").new(self):addTo(self.baseScene,60000)
            ------------------------------------单个个购买---------------------------------------
            --yangdx modify 
            if ( DEF_SPECIAL_PROCESS and ( DEF_CONTROL_LEVEL==0 or  gPlayer.data.pass_id > 60003 ) ) then 
                --print("yangdx 这是啥子地方哦2")
                CommUtil.buyShuiJing(function()
                    gItem:addItem(self.itemIds[index],1)
                    self.baseScene:resume()
                    self:updateItem()
                    self.baseScene.gameHud:updateCooper()
                end)
            end 


            return false
        end
        if skill.ifCoolDown then
            --CommUtil.toast(self.controller,"技能冷却中,点亮才可使用",0)
            return false
        end
        self:dispatchEvent({name = "onSkillRelease",skillId=index,x=x,y=y})
        self:releaseSkillByIndex(index)
        print("释放技能完毕")
    end
    return true
end

function SkillPanel:makeOneItem(index,posX,posY,zOrder)
    local cheatBg = display.newSprite("ui/fighting/fighting_skill_"..index.."_circle.png",posX,posY)
    cheatBg:setAnchorPoint(CCPoint(0,0))
    local skill = display.newSprite("ui/fighting/fighting_lection_"..index..".png",18,23)
    skill:setAnchorPoint(CCPoint(0,0))
    cheatBg:addChild(skill,zOrder)
    skill:setScale(0.5)
    self.view:addChild(cheatBg)
    return cheatBg
end

function SkillPanel:releaseSkillByIndex(index)
    local skill = self.skills[index]
    
    self.bg[index]:setVisible(false)

    local cheatBg1 = self:makeOneItem(index,self.bg[index]:getPositionX(),self.bg[index]:getPositionY(),0)
    local bezier = ccBezierConfig()
    bezier.controlPoint_1 = ccp(self.bg[index]:getPositionX()+10*(math.random(2)==1 and 1 or -1),self.bg[index]:getPositionY()+math.random(50)+50)
    bezier.controlPoint_2 = ccp(self.bg[index]:getPositionX()+20*(math.random(2)==1 and 1 or -1),self.bg[index]:getPositionY()+math.random(100)+50)
    local endPoint = ccp(self.bg[index]:getPositionX()+30*(math.random(2)==1 and 1 or -1),self.bg[index]:getPositionY()+math.random(200)+50)
    bezier.endPosition = endPoint
    local bezierTo = CCBezierTo:create(1,bezier)
    local action1 = transition.sequence({
        CCScaleTo:create(0.05,1.2),
        CCScaleTo:create(0.05,1),
        --CCDelayTime:create(0.3),
        --CCMoveBy:create(1,ccp(0,200)),
        bezierTo,
        CCCallFunc:create(function()
            cheatBg1:removeFromParentAndCleanup(true)
        end),
    })
    cheatBg1:runAction(action1)

    skill:performWithDelay(function()
        local cheatBg2 = self:makeOneItem(index,self.bg[index]:getPositionX(),self.bg[index]:getPositionY()-100,-1)
        local action2 = transition.sequence({
            CCMoveBy:create(0.3,ccp(0,100)),
            CCCallFunc:create(function()
                cheatBg2:removeFromParentAndCleanup(true)
            end),
        })
        cheatBg2:runAction(action2)
    end,self.cooldowns[index]-0.3)
    
    --local progressTimer = skill:getChildByTag(9999)
    skill.ifCoolDown = true
    --progressTimer:runAction(CCProgressTo:create(self.cooldowns[index],100))
    if self.baseScene.freeItemItems[index]>0 then
        --CommUtil.toast(self.controller,"使用搜集的免费次数,不扣除付费道具",0)
        self.baseScene.freeItemItems[index] = self.baseScene.freeItemItems[index] - 1
    else
        gItem:cutItem(self.itemIds[index],1)
    end
    self:updateItem()
    skill:performWithDelay(function()
        self.bg[index]:setVisible(true)
        skill.ifCoolDown = false
        self:updateItem()
    end,self.cooldowns[index])
end

function SkillPanel:selectSkill(index)
    local skill = self.skills[index]
    local skillX,skillY = skill:getPosition()
    local frames,animation = require("app.factory.AnimationFactory").getSkillSelectAniamtion()
    self.SkillSelect = display.newSprite(frames[1],skillX+10,skillY-15):addTo(self.view,30)
    self.SkillSelect:playAnimationForever(animation)
    self.SkillSelect:setAnchorPoint(CCPoint(0,0))
end

function SkillPanel:removeSelectSkill()
    if self and self.SkillSelect then
        self.SkillSelect:removeFromParentAndCleanup(true)
        self.SkillSelect = nil
    end
end

function SkillPanel:onTouchMoved(x, y)
    if self.releaseSprite==nil and self.drag~=nil then
        if math.abs(x-self.drag.startX) < 100 and math.abs(y-self.drag.startY) < 100 then
            --触摸范围小，认为是单击
            self.singleTap = true
        else
            --生成的技能提示图表跟随鼠标转动
            self.singleTap = false
            local skillProperties = Attributes.get_real_skill(self.skillId.."")
            local frames,animation = AnimationFactory.getSkillReleaseAnimation()
            self.releaseSprite = display.newSprite(frames[1])
            --self.releaseSprite:setScale(0.3)
            self.controller:addChild(self.releaseSprite)
            self.releaseSprite:playAnimationForever(animation)
        end
    else
        if self.releaseSprite~=nil then self.releaseSprite:setPosition(x,y) end 
    end
end

function SkillPanel:onTouchEnded(x, y)
    if not self.singleTap and self.releaseSprite~=nil then--移动释放
        local skill = self.skills[self.currentIndex]
        if skill~=nil and (not skill.ifCoolDown) and (currentDiDa:get()>=skill.cost) then
            self:dispatchEvent({name = "onSkillRelease",skillId=self.skillId,x=x,y=y})
            if self.selectGuideSkill then self.selectGuideSkill=false end
            self:updateDiDaPercentage(true,-1)
            currentDiDa:set(currentDiDa:get()-skill.cost)
            if currentDiDa:get()<0 then currentDiDa:set(0) end
            self:updateDiDaPercentage(true,self.currentIndex)
            --progressTimer:setPercentage(100)
            skill.ifCoolDown = true
            local progressTimer = skill:getChildByTag(9999)
            progressTimer:runAction(CCProgressTo:create(self.cooldowns[self.currentIndex],100))
            local index = self.currentIndex
            skill:performWithDelay(function()
                skill.ifCoolDown = false
                self:playSkillCanUseAnimation(index)
            end,self.cooldowns[self.currentIndex])
        end
        self.skillId = -1
        self.currentIndex = -1
        self.drag = nil
        self.ifRelease = true
        self.releaseSprite:removeSelf()
        self.releaseSprite = nil
        if self.SkillSelect~=nil then
            self.SkillSelect:removeSelf()
            self.SkillSelect = nil
        end
    else--单击释放
        self.drag = nil
    end
end

function SkillPanel:onTouchCancelled(x, y)
    self.drag = nil
end

function SkillPanel:checkWichSkillClicked(x, y)
    local pos = CCPoint(x, y)
    for i = 1, #self.skills do
        local skill = self.skills[i]
        if skill~=nil and skill:getParent():getBoundingBox():containsPoint(pos) then
            CommUtil.guideStep(16)
            return skill,i
        end
    end
    return nil
end

function SkillPanel:addGuideEffect()
    local skill = self.skills[1]
    local skillX,skillY = skill:getPosition()
    local frames = display.newFrames("skill_cd_%02d.png", 1, 10)
    local animation = display.newAnimation(frames,1/10)
    self.guideEffect = display.newSprite(frames[1],skillX-15,skillY-17):addTo(self.view,30)
    self.guideEffect:setAnchorPoint(ccp(0,0))
    self.guideEffect:playAnimationForever(animation)
end

function SkillPanel:removeGuideEffect()
    self.guideEffect:removeSelf()
end

function SkillPanel:changeCooldowns(index)
    local skill = self.skills[index]
    local timer = self.timers[index]
    local cooldown = self.cooldowns[index]
    --print("timer",timer,index)
    if timer:getPercentage()<100 then
        timer:stopAllActions()
        skill:stopAllActions()

        local percantage = timer:getPercentage()
        addPercantage = percantage + (20/cooldown)*100

        if addPercantage>=100 then
                timer:setPercentage(100)
                skill.ifCoolDown = false
                self:playSkillCanUseAnimation(index)
        else
            local newTime = cooldown*((100-percantage)/100)
            timer:runAction(CCProgressTo:create(newTime,100))
            skill:performWithDelay(function()
                skill.ifCoolDown = false
                self:playSkillCanUseAnimation(index)
            end,newTime)
        end
    end
end

function SkillPanel:addSkillSelectBox(index)
    local skill = self.skills[index]
    local skillX,skillY = skill:getPosition()
    local frames,animation = require("app.factory.AnimationFactory").getSkillSelectAniamtion()
    self.SkillSelect = display.newSprite(frames[1],skillX-18,skillY-17):addTo(self.view,30)
    self.SkillSelect:playAnimationForever(animation)
    self.SkillSelect:setAnchorPoint(CCPoint(0,0))
end


function SkillPanel:ifClickCharge(x, y)
    --[[
    local pos = ccp(x,y)
    if self.middleBg:getBoundingBox():containsPoint(pos) and currentDiDa:get()<20 then
        self.baseScene:chargeDida()
    end
    return nil]]
end



return SkillPanel