local CommUtil = require("app.common.CommUtil")
local AnimationFactory = require("app.factory.AnimationFactory")
local scheduler = require("framework.scheduler")
local defCoolDown = 10
local SkillPanelBeauty = class("SkillPanelBeauty",function(canTouch,controller,baseScene,rect,skillIds) 
    if not rect then rect = CCRect(0, 0, 0, 0) end
    local node = display.newClippingRegionNode(rect)
    node.rect=rect
    node:setNodeEventEnabled(true)
    require("framework.api.EventProtocol").extend(node)
    return node
end)


function SkillPanelBeauty:updateDiDaPercentage(ifUpdateAll,noChangeSkillIndex)
    local skillWidth = self.beautySkillNums*72
    local diDaScale = skillWidth * (1) / 75.5
    transition.scaleTo(self.diDaPercentage, {scaleX = diDaScale, time = 0.3,onComplete=function() 
        --self.label:setString(text)
    end})
    --self.diDaPercentage:setScaleX(diDaScale)
    
    local noChangeSkill = self.skills[noChangeSkillIndex]

    if ifUpdateAll then
        for i = 1, #self.skills do
            local skill = self.skills[i]
            if not skill.ifCoolDown and (skill~=noChangeSkill) then
                if skill.skillId==40021 or skill.skillId==40022 then
                    local battleItem = gItem:getPveBattleItem()
                    --local battleItem = {0,0}
                    if skill.skillId==40021 then--桃
                        
                    else--杀
                      
                    end
                else
                  
                        if skill~=noChangeSkill and self.timers[i]:getPercentage()~=100 then
                            self.timers[i]:setPercentage(100)
                                local skillX,skillY = skill:getPosition()
                                local skillCDEffect = display.newSprite("#skill_cd_01.png",skillX-15,skillY-17):addTo(self.view,30)
                                skillCDEffect:setAnchorPoint(ccp(0,0))
                                transition.execute(skillCDEffect,CCAnimate:create(AnimationFactory.getSkillCDAnimation()),{
                                    onComplete = function()
                                        skillCDEffect:removeSelf()
                                    end
                                })
                        end    
                end
            end
        end
    end
end

function SkillPanelBeauty:getTopLeftPoint()
    return self.topLeftPoint
end

function SkillPanelBeauty:getSkillViewsCenterPointArray()
    local pointArray = {}
    pointArray[#pointArray+1] = self.bg1:convertToWorldSpace(ccp(45,45))
    pointArray[#pointArray+1] = self.bg2:convertToWorldSpace(ccp(45,45))
    pointArray[#pointArray+1] = self.bg3:convertToWorldSpace(ccp(45,45))
    pointArray[#pointArray+1] = self.bg4:convertToWorldSpace(ccp(45,45))
    return pointArray
end

function SkillPanelBeauty:setOK()
    if (gSkill:isSkillExists(102)) then
        if (self.lock2) then self.lock2:setVisible(false)  end
    end
    if (gSkill:isSkillExists(103)) then
        if (self.lock3) then  self.lock3:setVisible(false)  end
    end
    if (gSkill:isSkillExists(104)) then
        if (self.lock4) then   self.lock4:setVisible(false)  end
    end
end

function SkillPanelBeauty:ctor(canTouch,controller,baseScene,rect,skillIds,panelType)

    --display.newColorLayer(ccc4(255, 255, 255, 255)):addTo(self)
    self.beautySkillNums = #skillIds
    self.baseScene = baseScene
    self.controller = controller
    self.view = display.newLayer()
    self:addChild(self.view)

    self.touchRect = rect
    self.offsetX = 0
    self.offsetY = 0
    
    self.skills = {}
    self.timers = {}

    self.cooldowns = {}
    self.initCooldowns = {}
    
    self.canTouch = canTouch

    --print("技能面板触摸",self.canTouch,canTouch)

    self.view:setTouchEnabled(true)
    self.view:setTouchSwallowEnabled(false)
    self.view:addTouchEventListener(function(event, x, y)
        return self:onTouch(event, x, y)
    end)
    --self.view = display.newBatchNode("battle_ui.pvr.ccz"):addTo(self.view)

    local startX=self.rect.origin.x

    local skillWidth = self.beautySkillNums*72

   
     
   

    local x1,x2,x3,x4,x5,x6,x7,x8 = 0
    local skillX1,skillX2,skillX3,skillX4,skillX5,skillX6,skillX7,skillX8 = 0
      x1 = startX
        x2 = x1 + 99
        x3 = x2 + 72
        x4 = x3 + 72

         self.beauty = display.newSprite("hero_10381.png",x4,80)
        self.beauty:setAnchorPoint(CCPoint(0,0))
        self.view:addChild(self.beauty,20)


        self.bg1 = display.newSprite("ui/home/home_skill.png",x1,0)
        self.bg1:setAnchorPoint(CCPoint(0,0))
        self.view:addChild(self.bg1,20)
        self.bg2 = display.newSprite("ui/home/home_skill_2.png",x2,3)
        self.bg2:setAnchorPoint(CCPoint(0,0))
        self.view:addChild(self.bg2,20)
        self.bg3 = display.newSprite("ui/home/home_skill_2.png",x3,3)
        self.bg3:setFlipX(true)
        self.bg3:setAnchorPoint(CCPoint(0,0))
        self.view:addChild(self.bg3,20)
        self.bg4 = display.newSprite("ui/home/home_skill.png",x4,0)
        self.bg4:setFlipX(true)
        self.bg4:setAnchorPoint(CCPoint(0,0))
        self.view:addChild(self.bg4,20)

        skillX1 = x1+32
        skillX2 = x2+5
        skillX3 = x3+5
        skillX4 = x4+5
   
   

    self.diDaPercentage = display.newSprite("ui/home/home_skill_figure.png",x3,80)
    self.diDaPercentage:setAnchorPoint(CCPoint(0,0))
    self.diDaPercentage:setScaleX(0)
    self.view:addChild(self.diDaPercentage,30)
    
    if panelType=="climbTower" then
        self.topLeftPoint = self.bg3:convertToWorldSpace(ccp(0,90))
        self.diDaPercentage:setPositionX(x3+30)
        --self.label:setPositionX(x5)
    elseif panelType=="worldBoss" then
        self.topLeftPoint = self.bg1:convertToWorldSpace(ccp(0,90))
        self.diDaPercentage:setPositionX(x1+30)
        --self.label:setPositionX(startX+skillWidth/2+10)
    else
        self.topLeftPoint = self.bg1:convertToWorldSpace(ccp(0,90))
        self.diDaPercentage:setPositionX(x1+30)
        --self.label:setPositionX(startX+skillWidth/2+10)
    end

    local startY = 10


        local skill1 = display.newSprite("icon_list/skill/skill_"..skillIds[1]..".png",skillX1,startY)
        skill1:setAnchorPoint(CCPoint(0,0))
        skill1.skillId = skillIds[1]
        skill1.ifCoolDown = false
        skill1:setOpacity(50)
        local progressTimer1 = display.newProgressTimer("icon_list/skill/skill_"..skillIds[1]..".png",display.PROGRESS_TIMER_RADIAL)
        progressTimer1:setAnchorPoint(CCPoint(0,0))
        progressTimer1:setPercentage(100)
        progressTimer1:setTag(9999)
        skill1:addChild(progressTimer1)
        skill1.cooldown = 25
        skill1.cost = 0
        self.skills[#self.skills + 1] = skill1
        self.timers[#self.timers + 1] = progressTimer1
        self.cooldowns[#self.cooldowns + 1] = 25
        self.initCooldowns[#self.initCooldowns + 1] = 25
        self.view:addChild(skill1,-1)




        local skill2 = display.newSprite("icon_list/skill/skill_"..skillIds[2]..".png",skillX2,startY)
        skill2:setAnchorPoint(CCPoint(0,0))
        skill2.skillId = skillIds[2]
        skill2.ifCoolDown = false
        skill2:setOpacity(50)
        local progressTimer2 = display.newProgressTimer("icon_list/skill/skill_"..skillIds[2]..".png",display.PROGRESS_TIMER_RADIAL)
        progressTimer2:setAnchorPoint(CCPoint(0,0))
        progressTimer2:setPercentage(100)
        progressTimer2:setTag(9999)
        skill2:addChild(progressTimer2)
        skill2.cooldown = 15
        skill2.cost = 0
        self.skills[#self.skills + 1] = skill2
        self.timers[#self.timers + 1] = progressTimer2
        self.cooldowns[#self.cooldowns + 1] = 15
        self.initCooldowns[#self.initCooldowns + 1] = 15
        self.view:addChild(skill2,-1)
        if (not gSkill:isSkillExists(102)) then
            self.lock2 = display.newSprite("ui/home/public_lock.png", 32,32)
            self.lock2:setScale(0.8)
            skill2:addChild(self.lock2)
        end


    

    self:schedule(handler(self, self.onInterval),1)


    local skill3 = display.newSprite("icon_list/skill/skill_"..skillIds[3]..".png",skillX3,startY)
    skill3:setAnchorPoint(CCPoint(0,0))
    skill3.skillId = skillIds[3]
    skill3.ifCoolDown = false
    skill3:setOpacity(50)
    local progressTimer3 = display.newProgressTimer("icon_list/skill/skill_"..skillIds[3]..".png",display.PROGRESS_TIMER_RADIAL)
    progressTimer3:setAnchorPoint(CCPoint(0,0))
    progressTimer3:setPercentage(100)
    progressTimer3:setTag(9999)
    skill3:addChild(progressTimer3)
    skill3.cooldown = 20
    skill3.cost = 0
    self.skills[#self.skills + 1] = skill3
    self.timers[#self.timers + 1] = progressTimer3
    self.cooldowns[#self.cooldowns + 1] = 20
    self.initCooldowns[#self.initCooldowns + 1] = 20
    self.view:addChild(skill3,-1)
     if (not gSkill:isSkillExists(103)) then
            self.lock3 = display.newSprite("ui/home/public_lock.png", 32,32)
            self.lock3:setScale(0.8)
            skill3:addChild(self.lock3)
        end

 local skill4 = display.newSprite("icon_list/skill/skill_"..skillIds[4]..".png",x4,startY)
        skill4:setAnchorPoint(CCPoint(0,0))
        skill4.skillId = skillIds[4]
        skill4.ifCoolDown = false
        skill4:setOpacity(50)
        local progressTimer4 = display.newProgressTimer("icon_list/skill/skill_"..skillIds[4]..".png",display.PROGRESS_TIMER_RADIAL)
        progressTimer4:setAnchorPoint(CCPoint(0,0))
        progressTimer4:setPercentage(100)
        progressTimer4:setTag(9999)
        skill4:addChild(progressTimer4)
        skill4.cooldown = 9
        skill4.cost = 0
        self.skills[#self.skills + 1] = skill4
        self.timers[#self.timers + 1] = progressTimer4
        self.cooldowns[#self.cooldowns + 1] = 9
        self.initCooldowns[#self.initCooldowns + 1] = 9
        self.view:addChild(skill4,-1)
 if (not gSkill:isSkillExists(104)) then
            self.lock4 = display.newSprite("ui/home/public_lock.png", 32,32)
            self.lock4:setScale(0.8)
            skill4:addChild(self.lock4)
        end
    
    self.ifRelease = true
    self.singleTap = true
    self.skillId = -1

    for i=1,#self.skills do
        local skill = self.skills[i]
        if skill.skillId==40021 or skill.skillId==40022 then
            skill.ingot = display.newSprite("ui/home/home_ingot.png",22,10):addTo(skill)
            skill.ingotText = ui.newTTFLabel({
                text = "X 20",
                font = "Arial",
                size = 12,
                color = ccc3(255,255,255),
                x = 37,
                y = 10
            }):addTo(skill)
            skill.numText = ui.newTTFLabel({
                text = "",
                font = "Arial",
                size = 16,
                color = ccc3(251, 216, 96),
                x = 50,
                y = 10
            }):addTo(skill)
          
            skill.ingotText:setVisible(false)
            skill.ingot:setVisible(false)
            skill.numText:setVisible(false)
        end
    end

    self.skillBgs = {}
    for i=1,#self.skills do
        local skill = self.skills[i]
        local skillBg = display.newSprite("ui/home/home_skill_mask.png")
        if skill.skillId==10001 then
            skillBg:setPosition(ccp(skill:getPositionX()+30,skill:getPositionY()+25))
        else
            skillBg:setPosition(ccp(skill:getPositionX()+32,skill:getPositionY()+32))
        end
        self.skillBgs[#self.skillBgs+1] = skillBg
        self.view:addChild(skillBg,-2)
    end




    -----------------------------------------锁技能逻辑--------------------------------------------------
    self.locks={}
    self.locks[1]=nil
    self.locks[2]=nil
    self.locks[3]=nil
    self.locks[4]=nil


end


function SkillPanelBeauty:onInterval()
        if (gSkill:isSkillExists(102)) then    
            self:setOK()
        end 
    end

    
function SkillPanelBeauty:updateSkillBgPosition()
    for i=1,#self.skills do
        local skill = self.skills[i]
        local skillBg = self.skillBgs[i]
        if skill.skillId==10001 then
            skillBg:setPosition(ccp(skill:getPositionX()+30,skill:getPositionY()+25))
        else
            skillBg:setPosition(ccp(skill:getPositionX()+32,skill:getPositionY()+32))
        end
    end
end

function SkillPanelBeauty:ifSkillPanelBeautySkillRelease()
    if self.skillId~=-1 then
        return false
    else
        return true
    end
end

function SkillPanelBeauty:setTouchable(canTouch)
    self.canTouch = canTouch
end

function SkillPanelBeauty:hide()
    --print("技能面板隐藏起来")
    self:setVisible(false)
    self.canTouch = false
end


function SkillPanelBeauty:getCanExpandSkills()
    local returnSkills = {}
    local unUse = gBeauty:getUnlockSkills()

    local ifExists = function(id)
        for i=1,#self.skills do
            local skill = self.skills[i]
            local skillId = skill.skillId
            if skillId==id then
                return true
            end
        end
        return false
    end

    for i=1,#unUse do
        if not ifExists(unUse[i]) then
            returnSkills[#returnSkills+1] = unUse[i]
        end
    end
    return returnSkills
end

function SkillPanelBeauty:onTouch(event, x, y)
    if not self.canTouch then
        return false
    end

    if CCDirector:sharedDirector():isPaused() then
        return false
    end

    if event == "began" then
        --local noUseRect = CCRect(display.right-math.abs(CommUtil.getBlankWidth())-(#self.skills*85), display.bottom,#self.skills*85,100)
        if not self.ifRelease then
            if self.selectGuideSkill then
                print("还没有释放引导技能",self.selectGuideSkill)
              --  return true
            end
            print("comskill1")
            --local tower,tag = (self.baseScene).towerFactory:checkWhickTowerClicked(x, y)

           -- if not self.touchRect:containsPoint(CCPoint(x, y)) then
                local skill = self.skills[self.currentIndex]
                print("comskill2")
                if skill~=nil and (not skill.ifCoolDown) then
                    print("self.skillId=", self.skillId)
                    
                    --
                    self.baseScene:setTowerLayerTouchable(false)
                    self:dispatchEvent({name = "onSkillReleaseBeauty",skillId=self.skillId,x=x,y=y})
                    if self.selectGuideSkill then
                        self.selectGuideSkill = false
                    end
                    self:updateDiDaPercentage(true,self.currentIndex)
                    local progressTimer = skill:getChildByTag(9999)
                    skill.ifCoolDown = true
                    progressTimer:runAction(CCProgressTo:create(self.cooldowns[self.currentIndex],100))
                    local index = self.currentIndex
                    skill:performWithDelay(function()
                        skill.ifCoolDown = false
                        self:playSkillCanUseAnimation(index)
                    end,self.cooldowns[self.currentIndex])
                end
                self.skillId = -1
                self.currentIndex = -1
                self.drag = nil
                self.ifRelease = true
                if self.SkillSelect~=nil then
                    self.SkillSelect:removeSelf()
                    self.SkillSelect = nil
                end
                return true
--else
           --     local skill,index = self:checkWichSkillClicked(x,y)
             --   if skill==nil then
            -- -       --print("已经选择了技能，但是点击范伟没有在可释放区域")
               --     return true
               -- end
          --  end
        end
        print("com1")
        return self:onTouchBegan(x, y)
    elseif event == "moved" then
        --self:onTouchMoved(x, y)
    elseif event == "ended" then
        self:onTouchEnded(x, y)
    else--cancelled
        self:onTouchCancelled(x, y)
    end
end

function SkillPanelBeauty:onTouchBegan(x, y)
    --self.ifRelease = false
    print("com2")
    local skill,index = self:checkWichSkillClicked(x,y)
    if skill~=nil then
        if self.currentIndex==index then
            if self.SkillSelect~=nil then
                self.SkillSelect:removeSelf()
                self.SkillSelect = nil
            end
            self.currentIndex = -1
            self.ifRelease = true
            self.skillId = -1
             self.canTouch = false
            print("com3")
            print("强制引导技能if self.currentIndex==index")
            return true
        end
        
        --print("com4")
        if self.baseScene:isForceGuide() then
            if self.baseScene:getGuideSkillIndex()~=nil then
                if self.baseScene:getGuideSkillIndex()==index then
                    print("强制引导技能","选正确了技能")
                    self.selectGuideSkill = true
                    self.baseScene:guideAfterSelectSkill(index)
                else
                    print("强制引导技能","选错了技能")
                    return false
                end
            end
        else
           --print("com5")
            if self.baseScene:getGuideSkillIndex()~=nil and self.baseScene:getGuideSkillIndex()==index then
                print("非强制引导技能","选正确了技能")
                self.selectGuideSkill = true
                self.baseScene:guideAfterSelectSkill(index)
            else
                print("非强制引导技能","选错了技能")
            end
        end
    end
    --print("com6")
    if skill~=nil then
        local goXiYouPay = function()
            if (DEF_SPECIAL_PAY_PROCESS) then
                if (skill.skillId==40016) then
                     DeviceUtil.xiYouPay('xx','TOOL15','TOOL15','14221', function(resultJsonString)
                     if resultJsonString == "success" then
                            -- gSkill:insertSkill(103)
                            -- gItem:addItem(30014,1)
                            -- gItem:addItem(30012,1)
                            -- gItem:addItem(30015,1)
                         display.resume()
                         --CommUtil.toast(display.getRunningScene(),"购买技能成功",0)
                          if (self.lock3) then self.lock3:setVisible(false)  end
                    else
                        display.resume()
                        --CommUtil.toast(display.getRunningScene(),"技能解锁失败",0)
                    end
                    end,3)
                elseif  (skill.skillId==40004) then
                     DeviceUtil.xiYouPay('xx','TOOL16','TOOL16','14220', function(resultJsonString)
                     if resultJsonString == "success" then
                            -- gSkill:insertSkill(102)
                            -- gItem:addItem(30014,1)
                            -- gItem:addItem(30012,1)
                            -- gItem:addItem(30015,1)
                         display.resume()
                         --CommUtil.toast(display.getRunningScene(),"购买技能成功",0)
                          if (self.lock2) then self.lock2:setVisible(false)  end
                    else
                        display.resume()
                        --CommUtil.toast(display.getRunningScene(),"技能解锁失败",0)
                    end
                    end,3)
                else
                     DeviceUtil.xiYouPay('xx','TOOL17','TOOL17','14222', function(resultJsonString)
                     if resultJsonString == "success" then
                            -- gSkill:insertSkill(104)
                            -- gItem:addItem(30014,1)
                            -- gItem:addItem(30012,1)
                            -- gItem:addItem(30015,1)
                         display.resume()
                         --CommUtil.toast(display.getRunningScene(),"购买技能成功",0)
                          if (self.lock4) then self.lock4:setVisible(false)  end
                    else
                        display.resume()
                        --CommUtil.toast(display.getRunningScene(),"技能解锁失败",0)
                    end
                    end,3)
                end
            else
                 require("app.views.GiftPanel2").new(2):addTo(display.getRunningScene(),100000)
            end
        end
        --进行判断是否能够点击
        if (skill.skillId==40004) then
            print("hello1")
            if (not gSkill:isSkillExists(102)) then
                print("hello2")
                goXiYouPay()
                return
            end
        elseif (skill.skillId==40016) then
            if (not gSkill:isSkillExists(103)) then
                goXiYouPay()
                return
            end
        elseif (skill.skillId==40020) then
            if (not gSkill:isSkillExists(104)) then
                goXiYouPay()
                return
            end
        end
        --
        if self.SkillSelect~=nil then
            self.SkillSelect:removeSelf()
            self.SkillSelect = nil
        end
        local progressTimer = skill:getChildByTag(9999)
        local percantage = progressTimer:getPercentage()

        if skill.ifCoolDown then
            self.ifRelease = true
            self.skillId = -1
            self.currentIndex = -1
            return true
        end
        
        self.currentIndex = index
  
            self.ifRelease = false
            self.skillId = skill.skillId
            local skillX,skillY = skill:getPosition()
    local frames = display.newFrames("Skill_Box_Selected_Ani_%d.png", 1,9)
    local animation = display.newAnimation(frames,1.5/9)
    display.setAnimationCache("skillSelect",animation)


            self.SkillSelect = display.newSprite("#Skill_Box_Selected_Ani_1.png",skillX-18,skillY-17):addTo(self.view,30)
            self.SkillSelect:playAnimationForever(animation)
            self.SkillSelect:setAnchorPoint(CCPoint(0,0))
            print("com63")
            self.drag = {
                currentOffsetX = self.offsetX,
                currentOffsetY = self.offsetY,
                startX = x,
                startY = y,
                isTap = true,
            }
    end
    return true
end

function SkillPanelBeauty:selectSkill(index)
    local skill = self.skills[index]
    local skillX,skillY = skill:getPosition()
    local frames,animation = require("app.factory.AnimationFactory").getSkillSelectAniamtion()
    --self.SkillSelect = display.newSprite("ui/home/home_skill_select.png",skillX-5,skillY-6):addTo(self.view,30)
    self.SkillSelect = display.newSprite(frames[1],skillX-18,skillY-17):addTo(self.view,30)
    self.SkillSelect:playAnimationForever(animation)
    self.SkillSelect:setAnchorPoint(CCPoint(0,0))
end

function SkillPanelBeauty:removeSelectSkill()
    if self and self.SkillSelect then
        self.SkillSelect:removeFromParentAndCleanup(true)
        self.SkillSelect = nil
    end
end

function SkillPanelBeauty:onTouchMoved(x, y)
    if self.releaseSprite==nil and self.drag~=nil then
        if math.abs(x-self.drag.startX) < 100 and math.abs(y-self.drag.startY) < 100 then
            --触摸范围小，认为是单击
            self.singleTap = true
        else
            --生成的技能提示图表跟随鼠标转动
            self.singleTap = false
            local frames,animation = AnimationFactory.getSkillReleaseAnimation()
            self.releaseSprite = display.newSprite(frames[1])
            --self.releaseSprite:setScale(0.3)
            self.controller:addChild(self.releaseSprite)
            self.releaseSprite:playAnimationForever(animation)
        end
    else
        if self.releaseSprite~=nil then self.releaseSprite:setPosition(x,y) end 
    end
end

function SkillPanelBeauty:onTouchEnded(x, y)
    if not self.singleTap and self.releaseSprite~=nil then--移动释放
        local skill = self.skills[self.currentIndex]
        if skill~=nil and (not skill.ifCoolDown) then
            self:dispatchEvent({name = "onSkillReleaseBeauty",skillId=self.skillId,x=x,y=y})
            if self.selectGuideSkill then self.selectGuideSkill=false end
            self:updateDiDaPercentage(true,-1)
            self:updateDiDaPercentage(true,self.currentIndex)
            --progressTimer:setPercentage(100)
            skill.ifCoolDown = true
            local progressTimer = skill:getChildByTag(9999)
            progressTimer:runAction(CCProgressTo:create(self.cooldowns[self.currentIndex],100))
            local index = self.currentIndex
            skill:performWithDelay(function()
                skill.ifCoolDown = false
                self:playSkillCanUseAnimation(index)
            end,self.cooldowns[self.currentIndex])
        end
        self.skillId = -1
        self.currentIndex = -1
        self.drag = nil
        self.ifRelease = true
        self.releaseSprite:removeSelf()
        self.releaseSprite = nil
        if self.SkillSelect~=nil then
            self.SkillSelect:removeSelf()
            self.SkillSelect = nil
        end
    else--单击释放
        self.drag = nil
    end
end

function SkillPanelBeauty:onTouchCancelled(x, y)
    self.drag = nil
end

function SkillPanelBeauty:playSkillCanUseAnimation(index)

    local skill = self.skills[index]


            self.timers[index]:setPercentage(100)
            local skillX,skillY = skill:getPosition()
            local skillCDEffect = display.newSprite("#skill_cd_01.png",skillX-15,skillY-17):addTo(self.view,30)
            skillCDEffect:setAnchorPoint(ccp(0,0))
    local frames = display.newFrames("skill_cd_%02d.png", 1, 10)
    local animation = display.newAnimation(frames,1/10)
    display.setAnimationCache("skillCD",animation)
    
            transition.execute(skillCDEffect,CCAnimate:create(animation),{
                onComplete = function()
                    skillCDEffect:removeSelf()
                end
            })
    self:updateDiDaPercentage(true,index)
end

function SkillPanelBeauty:checkWichSkillClicked(x, y)
    local pos = CCPoint(x, y)
    for i = 1, #self.skills do
        local skill = self.skills[i]
        if skill~=nil and skill:getBoundingBox():containsPoint(pos) then
            local lock = self.locks[i]
            if lock~=nil then
                CommUtil.toastNode(display.getRunningScene(),"再战一关解锁新妖姬技能!", 0)
                return nil
            else
                return skill,i
            end
        end
    end
    return nil
end

function SkillPanelBeauty:releaseSkillAuto(index,x,y)

    local skill = self.skills[index]
    if skill~=nil then
        self:dispatchEvent({name = "onSkillReleaseBeauty",skillId=skill.skillId,x=x,y=y})
        if self.selectGuideSkill then self.selectGuideSkill=false end
        self:updateDiDaPercentage(true,-1)
        local progressTimer = skill:getChildByTag(9999)
        skill.ifCoolDown = true
        progressTimer:runAction(CCProgressTo:create(self.cooldowns[index],100))

        skill:performWithDelay(function()
            skill.ifCoolDown = false
            self:playSkillCanUseAnimation(index)
        end,self.cooldowns[index])
    end
end


function SkillPanelBeauty:addGuideEffect()
    local skill = self.skills[1]
    local skillX,skillY = skill:getPosition()
    self.guideEffect = display.newSprite("#skill_cd_01.png",skillX-15,skillY-17):addTo(self.view,30)
    self.guideEffect:setAnchorPoint(ccp(0,0))
    self.guideEffect:playAnimationForever(AnimationFactory.getSkillCDAnimation())
end

function SkillPanelBeauty:removeGuideEffect()
    self.guideEffect:removeSelf()
end



function SkillPanelBeauty:changeCooldowns(index)
    local skill = self.skills[index]
    local timer = self.timers[index]
    local cooldown = self.cooldowns[index]
    if timer:getPercentage()<100 then
        timer:stopAllActions()
        skill:stopAllActions()

        local percantage = timer:getPercentage()
        addPercantage = percantage + (20/cooldown)*100

        if addPercantage>=100 then
                timer:setPercentage(100)
                skill.ifCoolDown = false
                self:playSkillCanUseAnimation(index)
        else
            local newTime = cooldown*((100-percantage)/100)
            timer:runAction(CCProgressTo:create(newTime,100))
            skill:performWithDelay(function()
                skill.ifCoolDown = false
                self:playSkillCanUseAnimation(index)
            end,newTime)
        end
    end
end

function SkillPanelBeauty:addSkillSelectBox(index)
    local skill = self.skills[index]
    local skillX,skillY = skill:getPosition()
    local frames,animation = require("app.factory.AnimationFactory").getSkillSelectAniamtion()
    self.SkillSelect = display.newSprite(frames[1],skillX-18,skillY-17):addTo(self.view,30)
    self.SkillSelect:playAnimationForever(animation)
    self.SkillSelect:setAnchorPoint(CCPoint(0,0))
end



return SkillPanelBeauty