local WindowSecond = require("app.ui.WindowSecond")
local beauty_skill = require("app.client.desc.beauty_skill")
local hero_skill = require("app.client.desc.hero_skill")
local SkillWindow = class("SkillWindow", WindowSecond)

--[[
    eg : 
        require("app.views.SkillWindow").new({skill_type=1, skill_id = 222})
    参数说明
    skill_type:  1英雄 2妖姬
    skill_id: 技能id
]]
function SkillWindow:ctor(args)    
    local itable = {}
    local name, desc, damage, damage_type
    if (args.skill_type == 2) then
        name, desc, damage =self:getSkillDesc(beauty_skill, args.skill_id)
    else
        --name, desc, damage =self:getSkillDesc(hero_skill, args.skill_id)
        itable.hero_skill = true
        name, desc, damage, damage_type = self:getHeroSkillDesc(args.skill_id)
    end
    --
    itable.title = name
    itable.bottorm_line=desc
        itable.icon = {
            image=CommUtil.getSkillPath(args.skill_id)
    }
    itable.right_line = {}
    if args.skill_type == 2 then
        itable.right_line[1]="攻击力:" .. damage
        itable.right_line[2]="技能范围:" .. "区域"
    else
        itable.right_line[1]="技能等级: " .. gSkillLvl:getSkillLvlBySkillId(args.skill_id)
        itable.right_line[2]="技能类型: " .. damage_type
    end

    itable.button = {}
    itable.button[1] ={
                normal = "ui/public/public_definite_normal.png",
                pressed = "ui/public/public_definite_pressed.png",
                onButtonRelease = function()
                   self:removeFromParentAndCleanup(true)
                end
            }

    if args.skill_type == 1 and OPEN_THINKING then
        local hero = gHero:getData(args.hero_id)
        if hero and hero.quality:get() > 1 then
            itable.button[1] = nil
            itable.button[1] ={
                        normal = "ui/public/public_to_rise_normal.png",
                        pressed = "ui/public/public_to_rise_pressed.png",
                        onButtonRelease = function()
                            gPVPMenu:enterPVPGongFa(args.skill_id)

                            self:removeFromParentAndCleanup(true)
                        end
                    }
        end
    end

    SkillWindow.super.ctor(self,itable)
end

function SkillWindow:getHeroSkillDesc(id)
    local skill = Attributes.get_real_hero_skill(id)

    if skill then
        local desc, damage_type
        if skill.damage then
            if skill.damage.damage_coeff then
                desc = skill.damage.damage_coeff
            else
                desc = "0"
            end

            if skill.damage.damage_type then
                if skill.damage.damage_type == 1 then
                    damage_type = "物理伤害"
                elseif skill.damage.damage_type == 2 then
                    damage_type = "法术伤害"
                else
                    damage_type = "未知"
                end
            else
                damage_type = "未知"
            end
        else
            desc = "0"
            damage_type = "未知"
        end

        return skill.name, skill.desc, desc, damage_type
    else
        return "未名技能", "未名技能描述", 11332
    end
end

function SkillWindow:getSkillDesc(tb, id)    
    id = tostring(id)
    if (tb[id]) then
        local desc
        if (tb[id].damage and tb[id].damage.damage_coeff) then
            desc = tb[id].damage.damage_coeff
        else
            desc = "0"
        end
        return tb[id].name, tb[id].desc,  desc
    else
        return "未名技能", "未名技能描述", 11332
    end
end

function SkillWindow:onExit()
    --SCROLL_CAN_TOUCH = false
end

return SkillWindow