--local tower_template = require("app.client.template.tower_template")
local CommUtil = require("app.common.CommUtil")
local ColorTxt = import("app.ui.ColorText")


local TowerUpgradeView = class("TowerUpgradeView", function()
    local node = require("app.views.MaskNode").new()
    return node
end)

function TowerUpgradeView:getTowerNameByLevel(towerType,level)
    local towerTypeValve = CommUtil.getTowerTypeValve(towerType)
    for i=1,#tower_template do
        if tower_template[i][3]==towerTypeValve and tower_template[i][4]==level then
            return tower_template[i][2]
        end
    end
end


function TowerUpgradeView:getUpLevelName(nextLevel)
    local name = nil
    if nextLevel==2 then
        name="一转"
    elseif nextLevel==3 then
        name="二转"
    elseif nextLevel==4 then
        name="三转"
    elseif nextLevel==5 then
        name="四转"
    end
    return name
end

function TowerUpgradeView:ctor(args)

    local config = totable(args)

    config.towerFactory:disableTouch()

    local bg = display.newSprite("ui/public/public_base map3.png",display.cx,display.cy):addTo(self)
    self.closeBtn = cc.ui.UIPushButton.new({
            normal = "ui/public/public_button_close_normal.png",
            pressed = "ui/public/public_button_close_pressed.png",
        })
    :pos(DEF_SEC_WINDOW_X, DEF_SEC_WINDOW_Y)
    :addTo(self)
    :onButtonRelease(function(event)
    	config.towerFactory:enableTouch()
    	self:removeFromParentAndCleanup(true)
    end)

    local size = bg:getContentSize()


    local titleLable = ui.newTTFLabel({
        text = "塔防升级",
        font = "Arial",
        size = 18,
        color = ccc3(255, 0, 0), -- 使用纯红色
        x = size.width/2-25,
        y = size.height-25
    })
    titleLable:addTo(bg)


    local towerFrame1 = display.newSprite("ui/public/public_equipment.png",size.width/4,size.height/5*3):addTo(bg)
    local towerFrame2 = display.newSprite("ui/public/public_equipment.png",size.width/4*3,size.height/5*3):addTo(bg)


    local towerFrameSize = towerFrame1:getContentSize()

    local nextLevel = config.towerLevel + 1
    if nextLevel >5 then nextLevel=5 end

    local curLevelTowerName = self:getTowerNameByLevel(config.towerType,config.towerLevel)
    local nextLevelTowerName = self:getTowerNameByLevel(config.towerType,nextLevel)


    local towerImageLeft = string.format("#tower_%s_lv%d_%d.png",config.towerType,math.random(1,2),math.random(1,3))
    local towerImageRight = string.format("#tower_%s_lv%d_%d.png",config.towerType,math.random(1,2),math.random(1,3))

    local leftTower = display.newSprite(towerImageLeft,towerFrameSize.width/2,towerFrameSize.height/2):addTo(towerFrame1)
    local rightTower = display.newSprite(towerImageRight,towerFrameSize.width/2,towerFrameSize.height/2):addTo(towerFrame2)
    
    --[[
    local leftTowerName = ui.newTTFLabel({
        text = curLevelTowerName,
        font = "Arial",
        size = 18,
        color = ccc3(255, 0, 0),-- 使用纯红色
        x = 0,
        y = -40
    })]]

    local leftTowerName = ColorTxt.new({
        text = "#1"..curLevelTowerName, 
        size = 18,
        x = 0,
        y = -40
    })
    
    --[[
    local leftTowerName = ColorTxt.new({
        text = curLevelTowerName, 
        color = display.COLOR_RED,
        size = 18,
        x = 0,
        y = -40
    })]]


    leftTowerName:addTo(leftTower)
    --[[
    local RightTowerName = ui.newTTFLabel({
        text = nextLevelTowerName,
        font = "Arial",
        size = 18,
        color = ccc3(255, 0, 0), -- 使用纯红色
        x = 0,
        y = -40
    })]]
    local RightTowerName = ColorTxt.new({
        text = "#1"..nextLevelTowerName, 
        size = 18,
        x = 0,
        y = -40
    })
    RightTowerName:addTo(rightTower)

    local arrow = display.newSprite("ui/public/public_arrow_b.png",size.width/2,size.height/5*3):addTo(bg)

    local bottomFrame = display.newSprite("ui/public/public_text2.png",size.width/2,70):addTo(bg)
    local bottomFrameSize = bottomFrame:getContentSize()


    self.zhuangBtn = cc.ui.UIPushButton.new({
            normal = "ui/hero/hero_reincarnate_btn_normal.png",
            pressed = "ui/hero/hero_reincarnate_btn_pressed.png",
        })
    :pos(bottomFrameSize.width-65,bottomFrameSize.height/2-10)
    :addTo(bottomFrame)
    :onButtonRelease(function(event)
        BusInterface.PromotionHero(self, config.towerType)  --进入转生
        config.towerFactory:enableTouch()
        self:removeFromParentAndCleanup(true)
    end)
    self.zhuangBtn:setScaleX(0.7)
    self.zhuangBtn:setScaleY(0.8)





    local text = "#7任一".."#1"..curLevelTowerName.."#7仙将完成".."#1"..self:getUpLevelName(nextLevel).."#7自动升级为".."#1"..nextLevelTowerName
    self.txt = ColorTxt.new({
        text = text, 
        size = 16,
        x = 10,
        y = 65
    }):addTo(bottomFrame)


    --[[

    local label1 = ui.newTTFLabel({
        text = "任一",
        font = "Arial",
        size = 14,
        color = ccc3(0, 0, 0), -- 使用纯红色
        x = 10,
        align = ui.TEXT_ALIGN_LEFT,
        y = bottomFrameSize.height/2+20
    })
    label1:addTo(bottomFrame)

    local label1Size = label1:getContentSize()

    local label2 = ui.newTTFLabel({
        text = curLevelTowerName,
        font = "Arial",
        size = 14,
        color = ccc3(255, 0, 0), -- 使用纯红色
        x = label1Size.width+8,
        align = ui.TEXT_ALIGN_LEFT,
        y = bottomFrameSize.height/2+20
    })
    label2:addTo(bottomFrame)

    local label2Size = label2:getContentSize()

    local label3 = ui.newTTFLabel({
        text = "仙将完成",
        font = "Arial",
        size = 14,
        color = ccc3(0, 0, 0), -- 使用纯红色
        x = label1Size.width+label2Size.width+5,
        align = ui.TEXT_ALIGN_LEFT,
        y = bottomFrameSize.height/2+20
    })
    label3:addTo(bottomFrame)

    local label3Size = label3:getContentSize()

    local label4 = ui.newTTFLabel({
        text = self:getUpLevelName(nextLevel),
        font = "Arial",
        size = 14,
        color = ccc3(255, 0, 0), -- 使用纯红色
        x = label1Size.width+label2Size.width+label3Size.width+5,
        align = ui.TEXT_ALIGN_LEFT,
        y = bottomFrameSize.height/2+20
    })
    label4:addTo(bottomFrame)

    local label4Size = label4:getContentSize()

    local label5 = ui.newTTFLabel({
        text = "自动升级为",
        font = "Arial",
        size = 14,
        color = ccc3(0, 0, 0), -- 使用纯红色
        x = label1Size.width+label2Size.width+label3Size.width+label4Size.width+5,
        align = ui.TEXT_ALIGN_LEFT,
        y = bottomFrameSize.height/2+20
    })
    label5:addTo(bottomFrame)

    local label5Size = label5:getContentSize()

    local label6 = ui.newTTFLabel({
        text = nextLevelTowerName,
        font = "Arial",
        size = 14,
        color = ccc3(255, 0, 0), -- 使用纯红色
        x = label1Size.width+label2Size.width+label3Size.width+label4Size.width+label5Size.width+5,
        align = ui.TEXT_ALIGN_LEFT,
        y = bottomFrameSize.height/2+20
    })
    label6:addTo(bottomFrame)]]


end


return TowerUpgradeView