--
-- Author: hejiangcheng
-- Date: 2014-03-05 10:42:44
--
local WinOrLose = class("WinOrLose", function()
	local node = display.newNode()
	node:setTouchEnabled(true)
	node:addTouchEventListener(function(event, x, y)
	    return true
	end)
    return node
end)
local Text = require("app.ui.Text")
local scheduler = require("framework.scheduler")
--[[
--pve
item={
{object_type=9,object_num=2342},
{object_type=1,object_num=232342},
-- {object_type=4,object_id=31005,object_num=1111},
-- {object_type=8,object_id=32001},
}
require("app.views.WinOrLose2").new({win=false, star=3, object_list=item}):addTo(self)

--pvp
require("app.views.WinOrLose").new({win=true, star=3,score = 10}):addTo(self)
]]

function WinOrLose:ctor(args)
	self.args = args
		
	self.isBossBattle = self.args.isBossBattle
	self.damage = self.args.damage
	self.totalDamage = self.args.totalDamage
	self.typePVP = 	self.args.score or self.args.honor --判断是否是PVP掉落

	if (self.args.win 
		and  gPlayer.data.pve_pass_id==gBattle.data.home_pass_id 
		and drop_hero_pass[gPlayer.data.pve_pass_id-1]) then
		--CommUtil.addLayer(self)
		--self:playNewHeroAnimation()
		return
	end

	display.newSprite('ui/fighting/fight2/fighting_sky.png'):addTo(self):center()

	if self.isBossBattle then
		self:performWithDelay(function()
			display.newSprite("ui/fighting/fighting_win_boss.png",190,80):addTo(self,2)
			self.damageLabel = ui.newBMFontLabel({
		        text= self.totalDamage,
		        --text = 6898760720,
		        x = 300,
				y= 80,
		        font = "fonts/number2.fnt",
		    }):addTo(self,2)
		end,1)
	end

    local sp_ink = CCProgressTimer:create(CCSprite:create('ui/fighting/fight2/fighting_lnk2.png'))
    sp_ink:setType(kCCProgressTimerTypeBar)
    sp_ink:setMidpoint(CCPointMake(0, 0))
    sp_ink:setBarChangeRate(CCPointMake(1, 0)) --todo可设置进度条起始位置
    sp_ink:setPosition(CCPointMake(display.cx - 20, display.cy + 30))
    -- sp_ink:runAction(CCRepeatForever:create(to1))
    sp_ink:runAction(CCProgressTo:create(0.1, 100))
	self:addChild(sp_ink)

	local sp_result 
	local offsetx = -400
	if self.args.win then 
		local pic_path = 'ui/home/home_cat_master.png'
		-- sp_result = display.newSprite('ui/fighting/fight2/beauty_10.png',display.cx - 20 - 110 + offsetx,display.cy + 30):addTo(self):scale(0.55):opacity(0)
		sp_result = display.newSprite(pic_path,display.cx - 20 - 110 + offsetx - 30,display.cy + 15):addTo(self):scale(0.725):opacity(0)
	else
		if  (device.platform == 'android' and DEF_SPECIAL_PROCESS) then
                    luaj.callStaticMethod("org/cocos2dx/lib/Function", "showAd", {},"()V")
        end
		sp_result = display.newSprite('ui/fighting/fight2/fighting_lose_cat.png',display.cx - 20 - 75 + offsetx,display.cy + 30 - 18):addTo(self):opacity(0)
	end

	-- local action = CCSequence:createWithTwoActions(CCFadeIn:create(0.1), CCMoveBy:create(0.2, ccp(-offsetx,0)))
	local action = transition.sequence({
		CCFadeIn:create(0.1),
		CCMoveBy:create(0.1, ccp(-offsetx,0)),
		CCMoveBy:create(0.1, ccp(-15,0)),
		CCMoveBy:create(0.1, ccp(15,0)),
	})
	transition.execute(sp_result,action,{
		delay = 0.1,
		onComplete = function ()
			self:starAction()
		end
		})
end

--星星
function WinOrLose:starAction()
	if not self.args.win then self:wordAction() return end
	local star_png
	if self.args.star == 0 then
		star_png = {'ui/fighting/fight2/fighting_star_gray.png', 'ui/fighting/fight2/fighting_star_gray.png', 'ui/fighting/fight2/fighting_star_gray.png'}
	elseif self.args.star == 1 then
		star_png = {'ui/fighting/fight2/fighting_star_gold.png', 'ui/fighting/fight2/fighting_star_gray.png', 'ui/fighting/fight2/fighting_star_gray.png'}
	elseif self.args.star == 2 then
		star_png = {'ui/fighting/fight2/fighting_star_gold.png', 'ui/fighting/fight2/fighting_star_gold.png', 'ui/fighting/fight2/fighting_star_gray.png'}
	else
		star_png = {'ui/fighting/fight2/fighting_star_gold.png', 'ui/fighting/fight2/fighting_star_gold.png', 'ui/fighting/fight2/fighting_star_gold.png'}
	end

	local posx,posy,offsetx = display.cx - 20 , display.cy + 30 + 64, 64
	local star1 = display.newSprite(star_png[1],posx,posy-10):addTo(self)
	local star2 = display.newSprite(star_png[2],posx + offsetx,posy-10):addTo(self)
	local star3 = display.newSprite(star_png[3],posx + 2*offsetx,posy-10):addTo(self)

	-- star1:setRotation(-20)
	-- star3:setRotation(20)
	star1:setScale(5)
	star2:setScale(5)
	star3:setScale(5)
	star1:setOpacity(0)
	star2:setOpacity(0)
	star3:setOpacity(0)

	local time = 0.05
	-- transition.execute(star1, CCFadeIn:create(time), {
	-- 	onComplete = function ()
	-- 		transition.execute(star2, CCFadeIn:create(time), {
	-- 			onComplete = function ()
	-- 				transition.execute(star3, CCFadeIn:create(time),{
	-- 					onComplete = function ()
	-- 						self:wordAction()
	-- 					end,
	-- 					})
	-- 			end
	-- 			})
	-- 	end
	-- 	})

	-- local action = CCSpawn:createWithTwoActions(CCFadeIn:create(time),CCSpawn:createWithTwoActions(CCScaleTo:create(time, 0.5),CCMoveBy:create(time, ccp(0,10))))
	local action = transition.sequence({
		CCSpawn:createWithTwoActions(CCFadeIn:create(time),CCSpawn:createWithTwoActions(CCScaleTo:create(time, 0.5),CCMoveBy:create(time, ccp(0,10)))),
		CCScaleTo:create(0.05, 0.7),
		CCScaleTo:create(0.1, 0.5),
		})
	
	action:retain()

	transition.execute(star1, action, {
		onComplete = function ()
			transition.execute(star2, action:copy(), {
				delay = 0.08,
				onComplete = function ()
					transition.execute(star3, action:copy(),{
						delay = 0.08,
						onComplete = function ()
							action:release()
							self:wordAction()
						end,
						})
				end
				})
		end
		})
end

--汉字
function WinOrLose:wordAction()
	local word1,word2
	if self.args.win then
		if self.args.star == 3 then
			word1 = 'ui/fighting/fight2/fighting_win.png' 
		elseif self.args.star == 2 then
			word1 = 'ui/fighting/fight2/fighting_win2.png' 
		else
			word1 = 'ui/fighting/fight2/fighting_win3.png' 
		end
		word2 = 'ui/fighting/fight2/fighting_win4.png' 
	else
		if self.typePVP then
			if self.args.star == 3 then
				word1 = 'ui/fighting/fight2/fighting_lose.png'
			elseif self.args.star == 2 then
				word1 = 'ui/fighting/fight2/fighting_lose3.png'
			else
				word1 = 'ui/fighting/fight2/fighting_lose4.png'
			end
		else
			word1 = 'ui/fighting/fight2/fighting_lose.png' 
		end
		word2 = 'ui/fighting/fight2/fighting_lose2.png' 
	end

	local sp_word1,sp_word2
	sp_word1 = display.newSprite(word1, display.cx - 20, display.cy + 30 + 130 - 10):addTo(self):scale(2):opacity(0)
	sp_word2 = display.newSprite(word2, display.cx - 20 + 60, display.cy + 30 + 118 - 10):addTo(self):scale(2):opacity(0)

	local action = CCSpawn:createWithTwoActions(CCFadeIn:create(0.2),CCSpawn:createWithTwoActions(CCScaleTo:create(0.2, 0.27),CCMoveBy:create(0.2, ccp(0,10))))

	transition.execute(sp_word1, action,{
		onComplete = function() 
			-- transition.execute(sp_word2, action:copy(), {
			-- 	onComplete = function ()
			-- 		self:progressAndexpAction()
			-- 	end,
			-- 	})
		end})
	transition.execute(sp_word2, action:copy(), {
		onComplete = function ()
			if self.typePVP then
				self:showPVPScore()
			else
				self:progressAndexpAction()
			end
		end,
		})
end

--pvp积分显示
function WinOrLose:showPVPScore()
	local posx,posy = display.cx + 60, display.cy + 10 + 20
	if self.args.score then
		display.newSprite('ui/fighting/fight2/fighting_lnk.png', posx,posy):addTo(self)
		Text.new({
				text = '积分：', 
	         	size = 18,
	            color = ccc3(245, 222, 31)})
		        :pos(posx - 20, posy)
		        :addTo(self)

	 	Text.new({
	 			text = self.args.score, 
	          	size = 18,
	             color = ccc3(255, 255, 255)})
	 	        :pos(posx + 40, posy)
	 	        :addTo(self)
	end

 	-- honor
 	posy = posy - 25
 	if self.args.honor then
 		if self.args.honor ~= 0 then
			display.newSprite('ui/fighting/fight2/fighting_lnk.png', posx,posy):addTo(self)
			Text.new({
					text = '荣誉：', 
		         	size = 18,
		            color = ccc3(245, 222, 31)})
			        :pos(posx - 20, posy)
			        :addTo(self)

		 	Text.new({
		 			text = self.args.honor, 
		          	size = 18,
		             color = ccc3(255, 255, 255)})
		 	        :pos(posx + 40, posy)
		 	        :addTo(self)
		else
			display.newSprite('ui/fighting/fight2/fighting_lnk.png', posx,posy):addTo(self)
			Text.new({
					text = '掠夺道具:', 
		         	size = 18,
		            color = ccc3(245, 222, 31)})
			        :pos(posx - 20, posy)
			        :addTo(self)
		end
	end	

 	if self.args.win then
 		self:addAwdObjed()
 	else
 		self:addLoseObjed()
	end        
end

--进度条和经验值
function WinOrLose:progressAndexpAction()
	local posx ,posy
	if self.args.win then
		posx ,posy = display.cx - 20 - 20, display.cy + 30 + 32
	else
		posx ,posy = display.cx - 20, display.cy + 30 + 32
	end

	display.newSprite('ui/fighting/fight2/fighting_lv_lnk.png', posx + 108, posy):addTo(self)
	Text.new({
			text = gPlayer.data.level:get(), 
         	size = 18,
            color = ccc3(245, 222, 31)})
	        :pos(posx + 36, posy)
	        :addTo(self)

    local progress_level = CCProgressTimer:create(CCSprite:create('ui/fighting/fight2/fighting_lv_progress.png'))
    progress_level:setType(kCCProgressTimerTypeBar)
    progress_level:setMidpoint(CCPointMake(0, 0))
    progress_level:setBarChangeRate(CCPointMake(1, 0)) --todo可设置进度条起始位置
    progress_level:setPosition(CCPointMake(posx + 134, posy + 2))
    -- progress_level:runAction(CCProgressTo:create(0.3, 85)) --todo加入百分比
	self:addChild(progress_level)

	local offsetx,offsety = 22,-30
	display.newSprite('ui/fighting/fight2/fighting_lnk.png', posx + offsetx + 40,posy + offsety):addTo(self)
	display.newSprite('ui/fighting/fight2/fighting_lnk.png', posx + offsetx + 40,posy + 2*offsety):addTo(self)
	display.newSprite('ui/fighting/fight2/fighting_lnk.png', posx + offsetx + 40,posy + 3*offsety):addTo(self)
	--1:铜钱数量 2:魂将数量 
	--3:元宝数量 4:鲜花数量 5:体力点数 6:英雄 7:装备 8:道具 9经验值 10好友经验值  11精气',
	local exp,copper,goal
    local exp_num, copper_num, goal_num
	if self:getTypeNum(1) == 0 then
		exp_num, copper_num, goal_num = self:getTypeNum(9),self:getTypeNum(11),self:getTypeNum(2)
		exp = display.newSprite('ui/fighting/fight2/fighting_label.png', posx + offsetx, posy + offsety):addTo(self)
		copper = display.newSprite('ui/fighting/fight2/fighting_label_7.png', posx + offsetx, posy + 2*offsety):addTo(self)
		goal = display.newSprite('ui/fighting/fight2/fighting_label_3.png', posx + offsetx, posy + 3*offsety):addTo(self)
	elseif self:getTypeNum(2) ==0 then
		exp_num, copper_num, goal_num = self:getTypeNum(9),self:getTypeNum(1),self:getTypeNum(11)
		exp = display.newSprite('ui/fighting/fight2/fighting_label.png', posx + offsetx, posy + offsety):addTo(self)
		copper = display.newSprite('ui/fighting/fight2/fighting_label_2.png', posx + offsetx, posy + 2*offsety):addTo(self)
		goal = display.newSprite('ui/fighting/fight2/fighting_label_7.png', posx + offsetx, posy + 3*offsety):addTo(self)
	elseif self:getTypeNum(9) == 0 then
		exp_num, copper_num, goal_num = self:getTypeNum(11),self:getTypeNum(1),self:getTypeNum(2)
		exp = display.newSprite('ui/fighting/fight2/fighting_label_7.png', posx + offsetx, posy + offsety):addTo(self)
		copper = display.newSprite('ui/fighting/fight2/fighting_label_2.png', posx + offsetx, posy + 2*offsety):addTo(self)
		goal = display.newSprite('ui/fighting/fight2/fighting_label_3.png', posx + offsetx, posy + 3*offsety):addTo(self)
	else
		exp_num, copper_num, goal_num = self:getTypeNum(9),self:getTypeNum(1),self:getTypeNum(2)
		exp = display.newSprite('ui/fighting/fight2/fighting_label.png', posx + offsetx, posy + offsety):addTo(self)
		copper = display.newSprite('ui/fighting/fight2/fighting_label_2.png', posx + offsetx, posy + 2*offsety):addTo(self)
		goal = display.newSprite('ui/fighting/fight2/fighting_label_3.png', posx + offsetx, posy + 3*offsety):addTo(self)
	end

	local exp_label = 	Text.new({
									text = 0, 
						         	size = 18,
						         	align = ui.TEXT_ALIGN_LEFT,
						            color = ccc3(255,255,255)})
							        :pos(posx + 4*offsetx, posy + offsety)
							        :addTo(self)
	local copper_label = 	Text.new({
									text = 0, 
						         	size = 18,
						         	align = ui.TEXT_ALIGN_LEFT,
						            color = ccc3(255,255,255)})
							        :pos(posx + 4*offsetx, posy + 2*offsety)
							        :addTo(self)
	local goal_label = 	Text.new({
									text = 0, 
						         	size = 18,
						         	align = ui.TEXT_ALIGN_LEFT,
						            color = ccc3(255,255,255)})
							        :pos(posx + 4*offsetx, posy + 3*offsety)
							        :addTo(self)

    local func = function ()
    	if (self.handle == nil) then
    		return
    	end
    	--
    	local num1,num2,num3 = toint(exp_label:getString()),toint(copper_label:getString()),toint(goal_label:getString())
    	local func1 = function (temp1,temp2)
    		if temp1 - temp2 >= 10000 then
    			return temp2 + 10000
    		elseif temp1 - temp2 >= 1000 then
    			return temp2 + 1000
    		elseif temp1 - temp2 >= 100 then
    			return temp2 + 100
    		-- elseif temp1 - temp2 >= 10 then
    		-- 	return temp2 + 10
    		else
    			return temp2 + 1
    		end
    	end

    	if num1 ~= exp_num or num2 ~= copper_num or goal_num ~= num3 then 
    		if num1 < exp_num then exp_label:setString(func1(exp_num,num1)) end
    		if num2 < copper_num then copper_label:setString(func1(copper_num,num2)) end
    		if num3 < goal_num then goal_label:setString(func1(goal_num,num3)) end
    	else
    		scheduler.unscheduleGlobal(self.handle)
    		self.handle = nil
    		-- if self.args.win then
	    	-- 	self:addAwdObjed()
	    	-- else
	    	-- 	self:addLoseObjed()
	    	-- end
    	end
    end
    --计算百分比
    local per
    if RELEASE_PLATFORM ~= 'test' then
	    local ret_tb= gExpTemplate:getLevelNeedExp(gPlayer.data.level:get())
	    per = 100-((ret_tb[1]-gPlayer.data.exp:get())/ret_tb[2])*100
	    if per <= 0 then
	    	per = 1 
	    elseif per >= 100 then
	    	per = 99
	    end
	else
		per = 50
	end
    progress_level:runAction(CCProgressTo:create(0.5, per))
	self.handle = scheduler.scheduleGlobal(func, 0)		

	if self.args.win then
		self:addAwdObjed()
	else
		if self:haveDropObject() then --修复如果战斗失败有物品掉落时不能显示物品bug
			self:addAwdObjed()
		else
			self:addLoseObjed()
		end
	end					        							      
end

--添加奖励物品
function WinOrLose:addAwdObjed()
	if self:haveDropObject() then
		local sp = {}
		local movex = 200
		for k, v in ipairs(self.args.object_list) do
			if v.object_type ~= 11 and  v.object_type ~= 9 and  v.object_type ~= 10 
				and v.object_type ~= 1 and v.object_type ~= 2  and v.object_type ~= 5 then
				sp[#sp + 1] = display.newSprite(CommUtil.getObjectPath(v),display.cx - 20 + 70 + movex, display.cy + 30 - 140):addTo(self):opacity(0):scale(1.5)--:scale(1):opacity(0)
				display.newSprite('ui/public/public_equipment2.png', sp[#sp]:getContentSize().width/2, sp[#sp]:getContentSize().height/2 - 2):addTo(sp[#sp])
				if (v.object_num and v.object_num > 1) then
					display.newSprite('ui/friends/friend_number_of_boxes.png', sp[#sp]:getContentSize().width - 6, 8):addTo(sp[#sp])
			 		Text.new({
			 		text =  v.object_num or '1', 
			 		x 	= sp[#sp]:getContentSize().width - 6,
			 		y 	= 8, 
	                size = 14,
	                color = display.COLOR_BLACK,
	                -- outlineColor = display.COLOR_BLACK,
	                align = ui.TEXT_ALIGN_CENTER,
	                }):addTo(sp[#sp])
			 	end
	            	
				if #sp == 3 then break end
			end
		end	

		local offset,index
		if 1 == #sp then
			offset, index = 0,1
		elseif 2 == #sp then
			offset, index = sp[#sp]:getContentSize().width * 2, 1.5
		elseif 3 == #sp then
			offset,index = sp[#sp]:getContentSize().width * 1.5, 2
		end

		for i = 1, #sp do
			local action = transition.sequence({
						    CCFadeIn:create(0.05),
						    CCSpawn:createWithTwoActions(CCScaleTo:create(0.18, 70/sp[i]:getContentSize().width), CCMoveBy:create(0.18,ccp(-movex + (i - index)*offset, 20))),
						    CCScaleTo:create(0.05, 70/sp[i]:getContentSize().width + 0.2),
						    CCScaleTo:create(0.05, 70/sp[i]:getContentSize().width),
						})
			transition.execute(sp[i], action, {
					onComplete = function()
						if i == #sp then
							if self.typePVP then
								self:addButtonPVP()
							else
								self:addButton()
							end
							-- self:playNewHeroAnimation()
						end
					end
				})
		end
	else
		local sp = display.newSprite('ui/fighting/fighting_box_nothing2.png',display.cx - 20 + 70, display.cy + 30 - 140 -20):addTo(self):opacity(0):scale(0.7)
		-- local action = CCSpawn:createWithTwoActions(CCFadeIn:create(0.1), CCMoveBy:create(0.1,ccp(0, 20)))	 
		local action = CCMoveBy:create(0.1,ccp(0, 20))	 
		transition.execute(sp,  action, {
			onComplete = function()
				if self.typePVP then
					self:addButtonPVP()
				else
					self:addButton()
				end
				-- self:playNewHeroAnimation()
			end,
		})
	end
end

--失败无奖励
function WinOrLose:addLoseObjed()
	local posx,posy,offsetx,offsety = display.cx - 20 + 90,display.cy + 30 - 140-20,100,0
	local txt={
					{"神坛寻仙", "探寻高级仙将"},
					{"装备强化", "打造鬼斧神工"},
					{"仙将修炼", "魔高一尺，道高一丈"}
			}	
	local btn = {}

	for i=1, 3 do
	 	btn[i] = cc.ui.UIPushButton.new({
	        normal = gWelfare:get_activity_icon(130 .. (i==1 and 4 or i==2 and 3 or 1)),
	        pressed = gWelfare:get_activity_icon(130 .. (i==1 and 4 or i==2 and 3 or 1)),
        })
        -- :pos(posx + (i-2)*offsetx,posy)
        :pos(posx ,posy)
        :opacity(0)
        :addTo(self)
        :onButtonRelease(function(event)
        		CommUtil.NPCSCeneAction(i,self)  --通过主城进入寻仙
        	end)
        btn[i]:setScale(68/75)

        display.newSprite('ui/public/public_equipment2.png',0, 0):addTo(btn[i]):scale(75/68)
	 	import("app.ui.Text").new({text =  txt[i][1], 
                size = 18,
                color = display.COLOR_WHITE,
                align = ui.TEXT_ALIGN_CENTER,
                valign = ui.TEXT_VALIGN_CENTER,})
            	:pos(0, -106/2 )
            	:addTo(btn[i])
        -- import("app.ui.Text").new({text =  txt[i][2], 
        --         size = 18,
        --         color = ccc3(245, 222, 31),
        --         align = ui.TEXT_ALIGN_CENTER,
        --         valign = ui.TEXT_VALIGN_CENTER,
        --         })
        --     	:pos(0, -116/2 - 20 + 9 - 5)
        --     	:addTo(btn[i])
	 end

	local time = 0.1
	-- local sequence =CCSpawn:createWithTwoActions(CCMoveBy:create(time,ccp(-offsetx, 20)),CCFadeIn:create(0.1))
	-- local sequence1 = CCSpawn:createWithTwoActions(CCMoveBy:create(time,ccp(0, 20)),CCFadeIn:create(0.1))
	-- local sequence2 = CCSpawn:createWithTwoActions(CCMoveBy:create(time,ccp(offsetx, 20)),CCFadeIn:create(0.1))
	local sequence =CCSequence:createWithTwoActions(CCFadeIn:create(0.1),CCMoveBy:create(time,ccp(-offsetx, 40)))
	local sequence1 = CCSequence:createWithTwoActions(CCFadeIn:create(0.1),CCMoveBy:create(time,ccp(0, 40)))
	local sequence2 = CCSequence:createWithTwoActions(CCFadeIn:create(0.1),CCMoveBy:create(time,ccp(offsetx, 40)))
	 transition.execute(btn[1],  sequence, {
	     onComplete = function()
	     end,
	 })
	 transition.execute(btn[2],  sequence1, {
	     onComplete = function()
	     end,
	 })
	 transition.execute(btn[3],  sequence2, {
	     onComplete = function()
	     	if self.typePVP then
	     		self:addButtonPVP()
	     	else
		     	self:addButton()
		     	-- self:playNewHeroAnimation()
		     end
	     end,
	 })
end

--添加PVP相关按钮
function WinOrLose:addButtonPVP()
	local posx,posy
	if self.args.win then 
		posx,posy = display.cx - 20 + 90 - 20,display.cy + 30 - 120 - 85
	else
		posx,posy = display.cx - 20 + 90,display.cy + 30 - 200
	end

    cc.ui.UIPushButton.new({
    	normal = 'ui/public/fighting_button_backcity_normal.png',
    	pressed = 'ui/public/fighting_button_backcity_pressed.png',
    })
    :pos(posx,posy)
    :addTo(self)
    :onButtonRelease(function(event)
    	if RELEASE_PLATFORM ~= "test" then
    		gPVPMenu:enterPVPScene()
        end
    end)
end

--添加动画
function WinOrLose:playNewHeroAnimation()	
	self.light = display.newSprite('ui/fighting/fighting_ray.png', display.cx, display.cy):addTo(self):scale(0.2)
	self.light:setAnchorPoint(ccp(271/512, 259/512))

	local action = CCSpawn:createWithTwoActions(CCScaleTo:create(1, 1, 1), CCRotateTo:create(1, 720))
	transition.execute(self.light, action, {
	-- transition.rotateTo(self.light, {time = 1, rotate = 720, 
		onComplete =  function() 

				-- self.card = display.newNode():addTo(self):pos(display.cx + 40 + 22, display.cy - 120)

				-- self.data = gHeroTemplate:getData(10381)

				-- local heroBg = display.newSprite(gHero:getHeroBg(self.data.quality), 0, 0):addTo(self.card)
				-- heroBg:setAnchorPoint(CCPoint(0.5, 0.1))
				-- heroBg:setScale(0.8)

				-- local hero = display.newSprite(gHero:getHeroBody(gHeroTemplate:getHeroBodyId(self.data.hero_template_id))):addTo(self.card)
				-- hero:setScaleX(0.77)
				-- hero:setScaleY(0.77)
				-- hero:setAnchorPoint(CCPoint(0.5, 0.08))
				
				-- local heroClass = display.newSprite(gHero:getHeroClass(self.data.class), 61, 160):addTo(self.card)
				-- heroClass:setScale(0.55)

				-- local heroQuality = display.newSprite(gHero:getHeroQuality(self.data.quality), -66, 163):addTo(self.card)
				-- heroQuality:setScale(0.66)

				-- CommUtil.addLevelFrame(self.card, -66, -5, 1)

				-- local heroName = display.newSprite("ui/bag/bag_information.png", 64, 24):addTo(self.card)
				-- heroName:setRotation(90)
				-- heroName:setScaleX(0.6)
				-- local heroNameText = Text.new({
				-- 		text = self.data.name,
				-- 		align = ui.TEXT_ALIGN_CENTER,
				-- 		size = 12,
				-- 		color = ccc3(255, 0, 0),
				-- 		dimensions = CCSize(14*1, 14*5),
				-- 		x = 64,
				-- 		y = 27,
				-- 	}):addTo(self.card)

			self:addButton()
		end})
	
	local skill_id = tostring(self.args.award_skill)
	local beauty_skill = import("app.client.desc.beauty_skill")

	-- local skill_panel = display.newNode():pos(display.cx - 190/2, display.cy - 382/2 - 80):addTo(self)
	local skill_panel = display.newNode():pos(display.cx, display.cy):addTo(self)
	skill_panel:setAnchorPoint(ccp(0.5,0.5))
	-- display.newSprite("ui/public/public_card_empty.png"):pos(0, 0):addTo(skill_panel):setScaleY(0.6)
	display.newSprite("ui/activity/activity_3rd_bg_2_.png", x, y):pos(0, 0):addTo(skill_panel):scale(0.85)
	-- local skill_name_bg = display.newSprite("ui/public/public_nametext.png"):addTo(skill_panel):pos(0, 335 - 265)
	local skill_name = display.newSprite(gBeauty:getSkillWord(skill_id)):addTo(skill_panel):pos(0, 335 - 265 - 110)
	-- local skill_frame_outside = display.newSprite("ui/public/public_equipment.png"):addTo(skill_panel):pos(0, 240 - 265)

	local skill_icon = display.newSprite(CommUtil.getSkillPath(skill_id)):addTo(skill_panel):pos(0, 233 - 265 + 60)
	local skill_frame = display.newSprite("ui/public/public_equipment2.png"):addTo(skill_icon):pos(31, 28)
	-- local skill_enegy_icon = display.newSprite("ui/beauty/beauty_icon_skill.png"):addTo(skill_frame_outside):pos(15, 23)
	-- local skill_enegy_lable = Text.new({
	-- 		text         = tostring(beauty_skill[skill_id].cost),
	-- 		x            = 13,
	-- 		y            = 10,
	-- 		size         = 14,
	-- 		color        = ccc3(0, 0, 0),
	-- 		align        = ui.TEXT_ALIGN_CENTER,
	-- 	}):addTo(skill_enegy_icon)

	Text.new({
				text         = '恭喜获得新妖姬技能',
				x            = 0,
				y            = 240 + 170 - 265,
				size         = 24,
				color        = ccc3(255, 255, 0),
				align        = ui.TEXT_ALIGN_CENTER,
			}):addTo(skill_panel)

	-- local skill_cd_icon = display.newSprite("ui/beauty/beauty_icon_time.png"):addTo(skill_frame_outside):pos(126, 17):scale(0.8)
	-- local skill_cd_lable = Text.new({
	-- 		text         = tostring(beauty_skill[skill_id].cooldown),
	-- 		x            = 18,
	-- 		y            = 12,
	-- 		size         = 14,
	-- 		color        = ccc3(0, 0, 0),
	-- 		align        = ui.TEXT_ALIGN_CENTER,
	-- 	}):addTo(skill_cd_icon):scale(1.25)
	skill_panel:scale(0.2)
	skill_panel:scaleTo(1, 1.0)
end

--添加按钮
function WinOrLose:addButton()
	local posx,posy
	if self.args.win then 
		posx,posy = display.cx - 20 + 90 - 20 - 60,display.cy + 30 - 190
	else
		posx,posy = display.cx - 20 + 90 - 10 - 60,display.cy + 30 - 200
	end

	if self.args.award_skill then 
		posx,posy = display.cx - 70, display.cy + 30 - 200
	end

	local normal, pressed
	if self.args.continue_fight then
		normal = "#fighting_button_next_normal.png"
		pressed = "#fighting_button_next_pressed.png"
	else
		normal = 'ui/public/fighting_button_backcity_normal.png'
		pressed = 'ui/public/fighting_button_backcity_pressed.png'
	end

        cc.ui.UIPushButton.new({
        	normal = normal,
        	pressed = pressed,
        })
        :pos(posx + 70,posy)
        :addTo(self)
        :onButtonRelease(function(event)
        	if self.handle then 
        		scheduler.unscheduleGlobal(self.handle)
    			self.handle = nil 
        	end
        	if (self.args.quick_fight) then
        		self:removeFromParentAndCleanup(true)
        	else
        		----------------------------------------------------------------
        		if (gVar.data.btn_clicking) then
                	return
                end
                gVar.data.btn_clicking= true
                local scheduler = require("framework.scheduler") 
                	scheduler.performWithDelayGlobal(function()
                	gVar.data.btn_clicking = false
                end, 3)
               	----------------------------------------------------------------
               	if self.args.continue_fight then --继续下一关战斗
               		--display.addSpriteFramesWithFile("ani/ui/fight_door.plist","ani/ui/fight_door.pvr.ccz")
	               	local OpenDoor = require("app.views.OpenDoor")
	               	local open = OpenDoor.new()
	               	display.getRunningScene():add(open, 5000)
	               	CommUtil.closeSelf(self)
	               	return
	            end

        		if (gBattle.data.home_scene_id ~= 701) then	
	            	GameInstance:sharedInstance():cleanSceneData()
	            	display.replaceScene(require("app.scenes.NPCScene").new())
	            else
	            	
	            	CommUtil.EntryClimbScene()   --进入试炼
	            end
	        end
        end)
       

end

function WinOrLose:getTypeNum(type)
	local object_list = self.args.object_list
	for k, v in ipairs(object_list) do
		if (v.object_type == type) then
			return v.object_num
		end
	end
	return 0
end

function WinOrLose:haveDropObject()
	local object_list = self.args.object_list
	if not object_list or type(object_list) ~= "table" then return false end 
	for k, v in ipairs(object_list) do
		if v.object_type == 7 or v.object_type == 8 or v.object_type == 4 then
			-- print('have some')
			return true
		end
	end
	return false
end

return WinOrLose