--
-- Author: hejiangcheng
-- Date: 2014-12-05 16:19:48
--
local baseMenu = class("baseMenu",function() 
    local node = display.newNode()
    node:setTouchEnabled(true)
    node:addTouchEventListener(function(event, x, y)
        return true
    end)
     node:registerScriptHandler(function(event)
        if event == "enter" then
            node:onEnter()
        elseif event == "exit" then
            node:onExit()
        end
    end)
    return node:scale(0.01):opacity(0)
end)

function baseMenu:ctor(scale,isSmallMenu)
	if display.getRunningScene().setMainSceneTouch then
		display.getRunningScene():setMainSceneTouch(false)
	end
	self.bgScale = scale or 1
	if isSmallMenu then
		self.bg = display.newSprite('ui/fighting/frighting_base_1.png',  0,0):addTo(self):scale(self.bgScale)
	else
		self.bg = display.newSprite("ui/public/public_base_map_b.png", 0,0):addTo(self):scale(self.bgScale)
	end
	self.closeBtn = cc.ui.UIPushButton.new({
					normal = "ui/public/public_button_normal.png",
					pressed = "ui/public/public_button_pressed.png"})
					:pos(self.bg:getContentSize().width*self.bgScale/2-18,self.bg:getContentSize().height*self.bgScale/2-18):addTo(self,10)--:scale(0.55)
					:onButtonRelease(function(event)
						CommUtil.playSound("music/close.mp3")
						self:closeSelf()
					end)

	self.view_ = display.newLayer()
	self.view_:registerScriptTouchHandler(handler(self,self.onTouch_))
	self:addChild(self.view_)

	local action = CCSpawn:createWithTwoActions(CCScaleTo:create(0.2, 1), CCFadeTo:create(0.2, 255))
	transition.execute(self, action, {onComplete=function() self.view_:setTouchEnabled(true) end})
end

function baseMenu:onTouch_(event,x,y)
	if event == "began" and self.canClick then
		if self.closeBtn:getCascadeBoundingBox():containsPoint(ccp(x,y)) then return false end
		if x < display.cx-self.bg:getContentSize().width*self.bgScale/2 or x > display.cx+self.bg:getContentSize().width*self.bgScale/2
			or y > display.cy+self.bg:getContentSize().height*self.bgScale/2 or y < display.cy-self.bg:getContentSize().height*self.bgScale/2 then
			self:closeSelf()
		end
		return true
	else
	    return true
	end  
end

function baseMenu:setTouchEnabled(b)
	echoError("child node should over write this method setTouchEnabled !")
end

function baseMenu:closeSelf()
	self.closeBtn:setButtonEnabled(false) self:setTouchEnabled(false)
	local action = CCSpawn:createWithTwoActions(CCScaleTo:create(0.2, 0.01), CCFadeTo:create(0.2, 0))
	transition.execute(self, action, {onComplete = function() 
			self:removeSelf()
		end})
end

function baseMenu:onExit()
	if display.getRunningScene().setMainSceneTouch then
		display.getRunningScene():setMainSceneTouch(true)
	end
	CCTextureCache:sharedTextureCache():removeUnusedTextures()
end

return baseMenu