--
-- Author: hejiangcheng
-- Date: 2014-12-02 15:12:59
--
local HiddenClass = require("app.data.template.HidenPassTemplateClass").new()
local points_template = require("app.client.template.points_template")
local Text = require("app.ui.Text")
local mapView = class("mapView",function()
	local node = display.newNode()
	-- node:setTouchEnabled(true)
	-- node:addTouchEventListener(function(event, x, y)
	--     return true
	-- end)
	node:registerScriptHandler(function(event)
	    if event == "enter" then
	        node:onEnter()
	    elseif event == "exit" then
	        node:onExit()
	    end
	end)
	return node
end)

function mapView:ctor(map_id)
	self.map_id = map_id
	self.map_label = {}
	self.map_points = {}
	self.allSceneId = {}

	self.map = display.newNode():addTo(self)
	local map = display.newSprite("ui/checkpoint/checkpoint_map.png",display.cx, display.cy-33):addTo(self.map)
	self.map_width = map:getContentSize().width
	display.newSprite("ui/checkpoint/checkpoint_map.png",display.cx+self.map_width,display.cy-33):addTo(self.map)
	display.newSprite("ui/checkpoint/checkpoint_map.png",display.cx-self.map_width,display.cy-33):addTo(self.map)

	self.map_label[map_id] = display.newSprite("ui/checkpoint/map_" .. self.map_id ..".png", display.cx, display.cy-70):addTo(self)
	self.map_points[map_id] = self:addPoints(map_id):addTo(self,3)
	if map_id==504 then self.map_label[map_id]:setPositionY(display.cy-30) 
	elseif map_id==503 then self.map_label[map_id]:setPositionY(display.cy-50)
	elseif map_id==501 then self.map_label[map_id]:setPositionY(display.cy-50) end

	self.map_cloud = display.newNode():addTo(self,2)
	local bg = display.newSprite("ui/checkpoint/checkpoint_cloud_1.png")
	self.map_cloud_width = bg:getContentSize().width
	display.newSprite("ui/checkpoint/checkpoint_cloud_1.png",display.cx,display.bottom+bg:getContentSize().height/2):addTo(self.map_cloud)
	display.newSprite("ui/checkpoint/checkpoint_cloud_1.png",display.cx+self.map_cloud_width,display.bottom+bg:getContentSize().height/2):addTo(self.map_cloud)
	display.newSprite("ui/checkpoint/checkpoint_cloud_1.png",display.cx-self.map_cloud_width,display.bottom+bg:getContentSize().height/2):addTo(self.map_cloud)

	local light = display.newSprite("ui/checkpoint/checkpoint_light.png"):addTo(self,3)
	light:pos(display.cx,display.top-light:getContentSize().height/2)

	self.view = display.newLayer()
	self.view:setTouchEnabled(true)
	self.view:registerScriptTouchHandler(handler(self,self.onTouch))
	self:addChild(self.view)

	self.miniMapNode = self:initMiniMap(map_id)
	self.canClick = true
end

function mapView:initMiniMap(map_id)
	local miniMapNode = display.newNode():addTo(self,4)
	self.map_name = display.newSprite("ui/checkpoint/map_name_"..map_id..".png", display.cx, display.bottom+20):addTo(miniMapNode)

	local sp_left = display.newSprite("ui/home/home_arrow_left.png", display.cx-125+30, display.bottom+55-35):addTo(miniMapNode)
	sp_left:addTouchEventListener(function(event,x,y) 
		local action = CCScaleBy:create(0.1, 0.9, 0.9)
		sp_left:runAction(CCSequence:createWithTwoActions(action, action:reverse()))
		if self.canClick == true then
			self:setTouchEnabled(false)
			self:moveToPrev()
		end
		end)
	sp_left:setTouchEnabled(true)

	local sp_right = display.newSprite("ui/home/home_arrow_left.png", display.cx+125-30, display.bottom+55-35):flipX(true):addTo(miniMapNode)
	sp_right:addTouchEventListener(function(event,x,y) 
		local action = CCScaleBy:create(0.1, 0.9, 0.9)
		sp_right:runAction(CCSequence:createWithTwoActions(action, action:reverse()))
		if self.canClick == true then
			self:setTouchEnabled(false)
			self:moveToNext()
		end
		end)
	sp_right:setTouchEnabled(true)

	return miniMapNode
end
--切换地图
function mapView:scanMiniMap(map_id)
	local sp_cache = CCTextureCache:sharedTextureCache():addImage('ui/checkpoint/map_name_'..map_id..'.png')
	self.map_name:setTexture(sp_cache)
	CCTextureCache:sharedTextureCache():removeTexture(sp_cache)
end

function mapView:addPoints(map_id)
	self.allSceneId = gPassTemplate:getAllSceneidByPassid(gPassTemplate:getPassidByMapid(map_id))
	
	local node = display.newNode()
	local first = 0
	for i,v in pairs(points_template[map_id]) do
		print("----------------------------map_id==", map_id)
		if self:isMapLocked(map_id) then
			if map_id == 501 then
				--display.newSprite("ui/home/home_point_not.png", v.x, v.y):addTo(node)
				--display.newSprite("ui/home/monster_" .. i ..  ".png", v.x, v.y):addTo(node)
			else
				--display.newSprite("ui/home/home_point_not2.png", v.x, v.y):addTo(node)
			end
		else
			if gPlayer.data.scene_id >= self.allSceneId[i] then
				local path
				if map_id == 501 then
					path=gPlayer.data.scene_id > self.allSceneId[i] and "ui/home/home_point_win.png" or "ui/home/home_point_now.png"
				else
					path=gPlayer.data.scene_id > self.allSceneId[i] and "ui/home/home_point_win2.png" or "ui/home/home_point_now2.png"
				end
				--点击按钮
				local clickbtn = cc.ui.UIPushButton.new({normal=path}):addTo(node):pos(v.x, v.y)
				:onButtonRelease(function(event)
					if self.fastClick then
						return
					end
					self.fastClick = true
					self:performWithDelay(function()
						self.fastClick = false
					end,1)
					--
					require("app.views.BattlePreview").new(map_id,self.allSceneId[i],gPlayer:getPassidAndStar(self.allSceneId[i])):addTo(display.getRunningScene(),5000)
					--require("app.views.ClimbTowerPreview").new(map_id,self.allSceneId[i],gPlayer:getPassidAndStar(self.allSceneId[i])):addTo(display.getRunningScene(),5000)
					--local passIdTable = gPlayer:getPassidAndStar(self.allSceneId[i])
					--require("app.common.DebugUtil").print_table2(passIdTable,2)
					--print("sceneId",map_id,self.allSceneId[i])
					--[[
					if not tolua.isnull(self.popStarPanel) then 
						if  i==self.popStarPanel.tag then return end
						self.popStarPanel:removeSelf(true) self.popStarPanel=nil 
					end
					self.popStarPanel = popStarPanel.new({map_id=map_id,scene_id=self.allSceneId[i],pass_detail=gPlayer:getPassidAndStar(self.allSceneId[i])}):addTo(self,10):pos(v.x,v.y+20)
					self.popStarPanel.tag=i 
					CommUtil.guideStep(10)]]
					end)
				local btn={}
				if map_id == 501 then
					btn = display.newSprite("ui/home/monster_" .. i ..  ".png", v.x, v.y):addTo(node)
					
				end
				if (path == "ui/home/home_point_win.png") then
					clickbtn:setGrayShader()
					if map_id == 501 then
						btn:setGrayShader()
					end
				end
				if gPlayer.data.scene_id == self.allSceneId[i] then
					local now
					if (map_id == 501) then
						now = display.newSprite("ui/home/home_icon_fighting.png", v.x, v.y+45-25-30):addTo(node)
					else
						now = display.newSprite("ui/home/home_icon_fighting.png", v.x, v.y+45):addTo(node)
					end
					--
					local action = CCScaleBy:create(0.3, 0.8, 0.8)
					now:runAction(CCRepeatForever:create(CCSequence:createWithTwoActions(action, action:reverse())))
				end
				self:addStars(toint(gPlayer:getStarNum(self.allSceneId[i])), map_id):addTo(node):pos(v.x, v.y-30+55)
				if (first==0) then
					 CommUtil.setBtnGuide(clickbtn, GUIDE_BTN_PASS1)
					 GUIDE_BTN_PASS1[0].x = GUIDE_BTN_PASS1[0].x - 32
    				 GUIDE_BTN_PASS1[0].y = GUIDE_BTN_PASS1[0].y - 32
    				 GUIDE_BTN_PASS1_SIMPLE[0]={}
    				 GUIDE_BTN_PASS1_SIMPLE[0].x = GUIDE_BTN_PASS1[0].x
    				 GUIDE_BTN_PASS1_SIMPLE[0].y = GUIDE_BTN_PASS1[0].y + 100
    				 GUIDE_BTN_PASS1_SIMPLE[0].width = GUIDE_BTN_PASS1[0].width
    				 GUIDE_BTN_PASS1_SIMPLE[0].height = GUIDE_BTN_PASS1[0].height
				end
				if (first==1) then
					 CommUtil.setBtnGuide(clickbtn, GUIDE_BTN_PASS2)
					 GUIDE_BTN_PASS2[0].x = GUIDE_BTN_PASS2[0].x - 32
    				 GUIDE_BTN_PASS2[0].y = GUIDE_BTN_PASS2[0].y - 32
				end
				first = first + 1
			else
				if map_id == 501 then
					--display.newSprite("ui/home/home_point_not.png", v.x, v.y):addTo(node)
					--display.newSprite("ui/home/monster_" .. i ..  ".png", v.x, v.y):addTo(node)
				else
					--yx modify
					--display.newSprite("ui/home/home_point_not2.png", v.x, v.y):addTo(node)
				end
			end

		end
		

	end

	--boss
	if gPlayer.data.map_id <= map_id then --正在战斗场景或者未解锁的场景才显示boss
		if not tolua.isnull(self.boss) then self.boss:removeSelf() self.boss=nil end
		if not CCSpriteFrameCache:sharedSpriteFrameCache():spriteFrameByName('monster_70043_walk_front_1.png') then
			--display.addSpriteFramesWithFile("monster/monster_70043.plist", "monster/monster_70043.pvr.ccz")
		end
		local frames = display.newFrames('monster_70043_walk_front_%d.png', 1,8)
		local animations = display.newAnimation(frames,0.6/10)

		--
		


		self.boss = display.newNode():addTo(node):pos(-200,40)
		local wuya1=display.newSprite(frames[1], points_template[map_id][5].x-15+60, points_template[map_id][5].y+45):addTo(self.boss,1):scale(0.65):flipX(true)
		wuya1:playAnimationForever(animations)
		local wuya2=display.newSprite(frames[1], points_template[map_id][5].x+15+60, points_template[map_id][5].y+40):addTo(self.boss):scale(0.65)
		wuya2:playAnimationForever(animations)
		display.newSprite("ui/checkpoint/hero_10000_body2.png", points_template[map_id][5].x+50, points_template[map_id][5].y+30):addTo(self.boss):scale(0.7)

		local action=CCMoveBy:create(0.5, ccp(0,10))
		self.boss:runAction(CCRepeatForever:create(CCSequence:createWithTwoActions(action, action:reverse())))
		if (map_id ~= 501) then
			self.boss:setVisible(false)
		end
	end

	--显示隐藏关卡
	if not self:isMapLocked(map_id) then
		local star=0
		for i,v in pairs(self.allSceneId) do star=star+gPlayer:getStarNum(v) end

		local x,y=display.cx, display.cy
		local path="ui/checkpoint/checkpoint_hidden03.png"
		if map_id==501 then
			x,y = display.cx+60, display.cy-120
		elseif map_id==502 then
			x,y = display.cx, display.cy-60
		elseif map_id==503 then
			path="ui/checkpoint/checkpoint_hidden02.png"
			x,y = display.cx-110, display.cy-170
		elseif map_id==504 then
			path="ui/checkpoint/checkpoint_hidden02.png"
		elseif map_id==505 then
			path="ui/checkpoint/checkpoint_hidden01.png"
			x,y=display.cx, display.cy-120
		end

		local mysBtn=display.newSprite(path):pos(x,y):addTo(node)
		mysBtn:addTouchEventListener(function(event,x,y) 
			if event~='ended' then return true end
			local action = CCScaleBy:create(0.1, 0.9, 0.9)
			mysBtn:runAction(CCSequence:createWithTwoActions(action, action:reverse()))
			if self.canClick~=true then return end
			if star<30 then CommUtil.toast(self,"未满星通过不可进入神秘空间！");return; end

			local passDetail = HiddenClass:getData(map_id-500)
			if self.fastClick then
				return
			end
			self.fastClick = true
			self:performWithDelay(function()
				self.fastClick = false
			end,1)
			require("app.views.BattlePreview").new(passDetail.name,passDetail.scene,{passDetail.id,0},true):addTo(display.getRunningScene(),5000)
		end)
		mysBtn:setTouchEnabled(true)
		
		mysBtn:setScale(0.7)
		if star<30 then 
			mysBtn:setGrayShader()
			--mysBtn:setShaderProgram(CCShaderCache:sharedShaderCache():programForKey("ShaderPositionTextureGray"))
		else
			-- mysBtn:runAction(CCRepeatForever:create(CCRotateBy:create(1, -360)))
			local action1 = CCScaleBy:create(1, 0.9)
			mysBtn:runAction(CCRepeatForever:create(CCSequence:createWithTwoActions(action1, action1:reverse())))
		end
	end

	--显示解锁按钮
	if self:isMapLocked(map_id) then 
		self.lockCloud = display.newSprite("ui/checkpoint/map_local_cloud.png",display.cx+30,display.cy-20):addTo(node) 
		self.lockCloud:setScaleX(1.2*display.width/self.lockCloud:getContentSize().width);self.lockCloud:setScaleY(1.2*display.height/self.lockCloud:getContentSize().height);

		self.needStar = display.newSprite("ui/checkpoint/unlock_tip.png", display.cx, display.cy):addTo(node)
		CommUtil.makeNum(gPlayer:calUnlockMapStar(map_id)):addTo(self.needStar):pos(400+60,30)

	end
	return node
end

--移除云和升级提示
function mapView:removeCloudAndTips()
	if not tolua.isnull(self.needStar) then self.needStar:fadeOut(0.1) end
	if not tolua.isnull(self.unlockBtn) then self.unlockBtn:fadeOut(0.1) end
	if not tolua.isnull(self.lockCloud) then
		local action = CCSpawn:createWithTwoActions(CCMoveTo:create(0.5, ccp(display.cx,display.top)), CCFadeOut:create(0.5))
		transition.execute(self.lockCloud, action, {onComplete=function()
				self.needStar:removeSelf(true)
				self.lockCloud:removeSelf(true)
				self.unlockBtn:removeSelf(true)

				if not tolua.isnull(self.map_points[self.map_id]) then self.map_points[self.map_id]:removeSelf() end
				self.map_points[self.map_id] = self:addPoints(self.map_id):addTo(self, 3)
				display.getRunningScene():setMainSceneTouch(true)
			end})
	else
		display.getRunningScene():setMainSceneTouch(true)
	end
end

function mapView:addStars(num, map_id)
	local starNode = display.newNode()
	--[[local star1,star2,star3
	if num == 0 or num==0.5 then
		star1,star2,star3="ui/public/public_flag_gray.png","ui/public/public_flag_gray.png","ui/public/public_flag_gray.png"
	elseif num == 1 or num==1.5 then
		star1,star2,star3="ui/public/public_flag_normal.png","ui/public/public_flag_gray.png","ui/public/public_flag_gray.png"
	elseif num ==2 or num==2.5 then
		star1,star2,star3="ui/public/public_flag_normal.png","ui/public/public_flag_normal.png","ui/public/public_flag_gray.png"
	elseif num == 3 then
		star1,star2,star3="ui/public/public_flag_normal.png","ui/public/public_flag_normal.png","ui/public/public_flag_normal.png"
	end
	local easy = display.newSprite(star1, -20, 0):addTo(starNode)
	local normal = display.newSprite(star2, 0, 0):addTo(starNode)
	local hard = display.newSprite(star3, 20, 0):addTo(starNode)
	if num==0.5 then
	    local half_star = CCProgressTimer:create(CCSprite:create('ui/public/public_flag_normal.png'))
	    half_star:setType(kCCProgressTimerTypeBar)
	    half_star:setMidpoint(CCPointMake(0, 0))
	    half_star:setBarChangeRate(CCPointMake(1, 0))
	    half_star:setPosition(CCPointMake(19/2, 19/2))
	    half_star:runAction(CCProgressTo:create(0.1, 50))
		easy:addChild(half_star)
	elseif num==1.5 then
	    local half_star = CCProgressTimer:create(CCSprite:create('ui/public/public_flag_normal.png'))
	    half_star:setType(kCCProgressTimerTypeBar)
	    half_star:setMidpoint(CCPointMake(0, 0))
	    half_star:setBarChangeRate(CCPointMake(1, 0))
	    half_star:setPosition(CCPointMake(19/2, 19/2))
	    half_star:runAction(CCProgressTo:create(0.1, 50))
		normal:addChild(half_star)
	elseif num==2.5 then
	    local half_star = CCProgressTimer:create(CCSprite:create('ui/public/public_flag_normal.png'))
	    half_star:setType(kCCProgressTimerTypeBar)
	    half_star:setMidpoint(CCPointMake(0, 0))
	    half_star:setBarChangeRate(CCPointMake(1, 0))
	    half_star:setPosition(CCPointMake(19/2, 19/2))
	    half_star:runAction(CCProgressTo:create(0.1, 50))
		hard:addChild(half_star)
	end]]

	if num>0 and num<=6 then
		if (map_id == 501) then
			display.newSprite('ui/home/head_bottorm.png',0,-20+5):addTo(starNode)
			display.newSprite('ui/public/public_flag_normal.png',-12,-60+2):addTo(starNode)
			display.newSprite('ui/home/home_star_x'..num..'.png', 10, -60+2):addTo(starNode):scale(1/1.2)
		else
			display.newSprite('ui/public/public_flag_normal.png',-12,0):addTo(starNode)
			display.newSprite('ui/home/home_star_x'..num..'.png', 10, 0):addTo(starNode):scale(1/1.2)
		end
	end
	return starNode:scale(1.2)
end

function mapView:moveToNext()
	if self:isMapLocked(self.map_id) then CommUtil.toast(self,"当前地图未解锁！");self:setTouchEnabled(true);return; end

	if io.exists("res/ui/checkpoint/map_" .. self.map_id+1 ..".png") ~= true then 
		CommUtil.toast(self,"地图已全部解锁！");self:setTouchEnabled(true); return; 
	end
	display.getRunningScene():setMainSceneTouch(false)

	self.map_label[self.map_id+1] = display.newSprite("ui/checkpoint/map_" .. self.map_id+1 ..".png",display.cx + display.width + 200,display.cy-70):addTo(self)
	if self.map_id+1==504 then self.map_label[self.map_id+1]:setPositionY(display.cy-30) 
	elseif self.map_id+1==503 then self.map_label[self.map_id+1]:setPositionY(display.cy-50) 
	elseif self.map_id+1==501 then self.map_label[self.map_id+1]:setPositionY(display.cy-50) end
	self.map_points[self.map_id+1] = self:addPoints(self.map_id+1):addTo(self, 3):pos(display.width+200,0)

	local  t, index = 0.8, self.map_id
	transition.moveTo(self.map_label[self.map_id], {x = display.cx -self.map_width-200,time = t,onComplete = function() 
		self.map_label[index]:removeSelf();self:scanMiniMap(index+1);
	end})
	transition.moveTo(self.map_points[self.map_id], {x = -display.width-200,time = t,onComplete = function() 
		self.map_points[index]:removeSelf() 
	end})

	transition.moveTo(self.map_cloud, {x = display.cx - 1.5*self.map_cloud_width, time = t,
		onComplete = function() self.map_cloud:setPositionX(0) end})

	transition.moveTo(self.map_label[self.map_id+1], {x = display.cx,time = t})
	transition.moveTo(self.map_points[self.map_id+1], {x = 0,time = t})

	transition.moveTo(self.map, {x =self.map:getPositionX()-120,time = t,
		onComplete = function() 
			self.map_id = self.map_id+1;self:setTouchEnabled(true) 
			display.getRunningScene():setMainSceneTouch(true)
			if math.abs(self.map:getPositionX())+120 >= 1.5*self.map_width then
				self.map:setPositionX(0)
			end
		end})
end

function mapView:moveToPrev()
	-- if self.map_id <= 501 then self:setTouchEnabled(true); return; end
	if io.exists("res/ui/checkpoint/map_" .. self.map_id-1 ..".png") ~= true then 
		self:setTouchEnabled(true); return; 
	end
	display.getRunningScene():setMainSceneTouch(false)

	self.map_label[self.map_id-1] = display.newSprite("ui/checkpoint/map_" .. self.map_id-1 ..".png",display.cx - display.width - 200,display.cy-70):addTo(self)
	if self.map_id-1==504 then self.map_label[self.map_id-1]:setPositionY(display.cy-30) 
	elseif self.map_id-1==503 then self.map_label[self.map_id-1]:setPositionY(display.cy-50)
	elseif self.map_id-1==501 then self.map_label[self.map_id-1]:setPositionY(display.cy-50) end
	self.map_points[self.map_id-1] = self:addPoints(self.map_id-1):addTo(self,3):pos(-display.width-200,0)

	local  t, index = 0.8, self.map_id
	transition.moveTo(self.map_label[self.map_id], {x = display.cx + self.map_width+200,time = t,onComplete = function() 
		self.map_label[index]:removeSelf();self:scanMiniMap(index-1);
	end})
	transition.moveTo(self.map_points[self.map_id], {x = display.width+200,time = t,onComplete = function() 
		self.map_points[index]:removeSelf() 
	end})

	transition.moveTo(self.map_cloud, {x = -display.cx + 1.5*self.map_cloud_width, time = t,
		onComplete = function() self.map_cloud:setPositionX(0) end})

	transition.moveTo(self.map_label[self.map_id-1], {x = display.cx,time = t})
	transition.moveTo(self.map_points[self.map_id-1], {x = 0,time = t})

	transition.moveTo(self.map, {x =self.map:getPositionX()+120,time = t,
		onComplete = function() 
			self.map_id = self.map_id-1;self:setTouchEnabled(true) 
			display.getRunningScene():setMainSceneTouch(true)
			if math.abs(self.map:getPositionX())+120 >= 1.5*self.map_width then
				self.map:setPositionX(0)
			end
		end})
end

function mapView:onTouch(event,x,y)
	if self.canClick~=true then return end
	if event == "began" then
		self.startx = x; self.starty = y;
		return true
	elseif event == "moved" then
		return true
	elseif event == "ended" then
	    if x - self.startx >= 50 then
	    	self:setTouchEnabled(false)
	    	self:moveToPrev()
	    elseif x - self.startx <= -50 then
	    	self:setTouchEnabled(false)
	    	self:moveToNext()
	    else
	    end
	    return true
	end  
end

-- 当前地图是否锁定
function mapView:isMapLocked(map_id)
	return gPlayer.data.map_id < map_id
end

function mapView:setTouchEnabled(b)
	self.canClick = b
	self.view:setTouchEnabled(b)
end

function mapView:onExit()
	--self.view:removeTouchEventListener()
	--display.removeSpriteFramesWithFile("monster/monster_70043.plist", "monster/monster_70043.pvr.ccz")
	CCTextureCache:sharedTextureCache():removeUnusedTextures()
end

return mapView