--
-- Author: hejiangcheng
-- Date: 2014-03-10 10:51:12
--
local move_time = 0.15
local scheduler = require("framework.scheduler")
local PlaceHero = class("PlaceHero",function() 
    local node = display.newNode()
    --[[
    node:setTouchEnabled(true)
    node:addTouchEventListener(function(event, x, y)
        return true
    end)]]
     node:registerScriptHandler(function(event)
        if event == "enter" then
            node:onEnter()
        elseif event == "exit" then
            node:onExit()
        end
    end)
    return node
end)

function PlaceHero:close()
	self:removeFromParentAndCleanup(true)
end

function PlaceHero:ctor(args)
	 SKILL_CAN_TOUCH = false
	 CommUtil.playSound("music/openbox.mp3")
	assert(type(args.data) == 'table','PlaceHero:ctor(para) para.data error!')
	CommUtil.addBlankLayer(self)

	CommUtil.transPage(self)
	self.args = args

	if #args.data <= 0 then
		self:noHeroFunc()
	else
		self:init_ScrollCell()
	end

	self.canRemoveSelf = false
	self.startx = 0 
	self.starty = 0
	self.layer = display.newLayer()
	self.layer:setTouchEnabled(true)
	self.layer:addTouchEventListener(handler(self,self.onTouch))
	self:addChild(self.layer)
end

function PlaceHero:onTouch(event, x, y)
	if not self.canRemoveSelf then return true end
	if event == 'began' then
		self.startx, self.starty = x, y
		return true
    elseif event == 'ended' then 
		-- if self.startx == x and self.starty == y then
		if math.abs(self.startx - x) < 10 and math.abs(self.starty - y) < 10 then
			if self.cloudbg then
				local rect = CCRect(self.seekbtn:getBoundingBox().origin.x - 189/2,self.seekbtn:getBoundingBox().origin.y - 127/2,189,127)
				if not rect:containsPoint(ccp(x,y)) then
					self:removeSelf()
				end
			else
				if #self.args.data >= 6 then
					if not self.ClipNode:getBoundingBox():containsPoint(ccp(x,y)) then
						self:removeSelf()
					end
				else
					local rect1 = self.ClipNode:getBoundingBox()
					local rect = CCRect(rect1.origin.x,rect1.origin.y,(rect1.size.width/6) * (#self.args.data),rect1.size.height)
					if not rect:containsPoint(ccp(x,y)) then
						if (not gPlayer.data.is_guiding) then
							self:removeSelf()
						else
							print("mobi2us is guiding")
							CommUtil.guideStep(11111)
						end
					end
				end
			end
		end
		return true
	else
		return true
	end
end

function PlaceHero:removeSelf()
	
	self.canRemoveSelf = false
	if self.args.pvpCancelcallback and type(self.args.pvpCancelcallback) == 'function' then
		self.args.pvpCancelcallback()
	end

	if self.cloudbg then
		transition.execute(self.cloudbg, CCMoveBy:create(move_time, ccp(0,-150)), {
			onComplete = function()
				self:removeAllChildren()
				self:removeFromParent()
			end
			})
	elseif self.cloud and self.ClipNode then
		transition.moveBy(self.ClipNode, {y = -150, time = move_time})
		transition.moveBy(self.cloud, {y = -150, time = move_time})
		transition.execute(self.cloud, CCMoveBy:create(move_time, ccp(0,-150)), {
			onComplete = function()
				self:removeAllChildren()
				self:removeFromParent()
			end
			})		
	end
	if type(self.removeTouchEventListener) == 'function' then
		self:removeTouchEventListener()
	end
	show_hero_pandle = false
end

function PlaceHero:noHeroFunc()
		self.cloudbg = display.newSprite('ui/home/home_hero_bg.png', display.cx, display.cy - 200 - 150 - 1):addTo(self)
		self.cloudbg:setScaleX(display.width/self.cloudbg:getContentSize().width)

		self.seekbtn = cc.ui.UIPushButton.new({
	                    normal = 'ui/home/home_hero_seek.png',
	                    })
	                :pos(100 + 40,60)
	                :addTo(self.cloudbg)
	                :onButtonRelease(function(event)
	                	event.target:setButtonEnabled(false)
	                	local func = function()
	                	   	self:removeAllChildren()
	                	   	self:removeFromParent()  
		                end
	                	transition.execute(self.cloudbg, CCMoveBy:create(move_time, ccp(0,-150)), {
		                		onComplete = func,
	                		})
	                end)
	    require('app.ui.Text').new({
	    	text='已无仙将！',
	    	x=220 + 40,
	    	y=40,
	    	size=20,
	    	color = ccc3(0, 0, 0),
	    	outlineColor = ccc3(255, 255, 255),
	    	align = ui.TEXT_ALIGN_LEFT,
	    	valign = ui.TEXT_VALIGN_CENTER,
	    	}):addTo(self.cloudbg)
   		-- transition.moveBy(self.cloudbg, {y = 150, time = 0.2})
   		transition.execute(self.cloudbg, CCMoveBy:create(move_time, ccp(0,150)), {
   			onComplete = function()
	   			self.canRemoveSelf = true
	   		end
   			})
end

function PlaceHero:init_ScrollCell()	
	-- local cloud = display.newSprite('ui/home/home_bg_cloud.png', display.cx, display.cy - 198 - 150):addTo(self)
	self.cloud = display.newSprite('ui/home/home_hero_bg.png', display.cx, display.cy - 200 - 150 - 1):addTo(self)
	self.cloud:setScaleX(display.width/self.cloud:getContentSize().width)
    local PlaceHeroCell = require("app.views.secondMenu.friend.PlaceHeroCell")
    local rect = CCRect(0,0,540,120)
    self.PlaceHeroCell = PlaceHeroCell.new({
													clippingnodesize = {width = rect.size.width,height = rect.size.height},
													data=self.args.data,
													-- data = self.args.data,
													delegate = self,
													towerPos = self.args.towerPos,
													position = self.args.position,
													callback = self.args.callback,
													callback1 = self.args.callback1,
                                            	})
    -------
	local scale_Y 
	local rect1
	if display.widthInPixels/display.heightInPixels < 5/3 then
		scale_Y = display.widthInPixels/display.heightInPixels*3/5
		rect1 = CCRect(0,0,rect.size.width*scale_Y,rect.size.height)
	else
		scale_Y = 1
		rect1 = CCRect(0,0,rect.size.width*scale_Y,rect.size.height)
	end	
	--------
    self.ClipNode = display.newClippingRegionNode(rect1)
    self.ClipNode:setPosition(display.cx - 540/2,display.cy - 220 - 150 - 20)
    self.ClipNode:addChild(self.PlaceHeroCell,0)

    self:addChild(self.ClipNode,1)

    transition.moveBy(self.cloud, {y = 150, time = move_time})
    -- transition.moveBy(self.ClipNode, {y = 150, time = 0.2})
    transition.execute(self.ClipNode, CCMoveBy:create(move_time, ccp(0,150)), {
    	onComplete = function()
    		self.canRemoveSelf = true
    		if (gPlayer.data.is_guiding) then
    		end
    		CommUtil.guideStep(45)
	    end
    	})
end

function PlaceHero:removeCloud()
	self.canRemoveSelf = false
	transition.moveBy(self.ClipNode, {y = -150, time = move_time})
	transition.moveBy(self.cloud, {y = -150, time = move_time})
end

function PlaceHero:setTouchEnabled(b)
	self.layer:setTouchEnabled(b)
end

function PlaceHero:onExit()
	-- self.PlaceHeroCell:onExit()
	self:cleanup()
	SKILL_CAN_TOUCH = true
	print("关闭派驻页面")
	--
	if (gPlayer.data.is_guiding) then
		if (not tolua.isnull(display.getRunningScene().baseScene)) and display.getRunningScene().baseScene  then
			display.getRunningScene().baseScene:resume()
		end
	end
	--
	-- self:removeFromParent()
end

return PlaceHero