--
-- Author: hejiangcheng
-- Date: 2014-03-10 10:51:30
--
local ScrollViewII = require('app.ui.ScrollViewII')
local PlaceHeroCell = class('PlaceHeroCell', ScrollViewII)
local Text = require('app.ui.Text')
local scheduler =  require(cc.PACKAGE_NAME .. ".scheduler")
--[[
ctor 参数：
clippingnodesize = {width,height}
data = {}
]]
local return_callback  --反馈回调
local delegate 

function PlaceHeroCell:ctor(paras)
	self.init_page_over = false
	self.paras = totable(paras)
	assert(self.paras ~= nil and type(self.paras) == 'table','PlaceHeroCell:ctor paras error')
	return_callback = paras.callback
	delegate = paras.delegate
	--
	self.num_cell = 6
	self.paras.cellsize = {width = self.paras.clippingnodesize.width/self.num_cell, height = self.paras.clippingnodesize.height}
	self.paras.nodesize = {width = self.paras.cellsize.width*(#self.paras.data),height = self.paras.cellsize.height} --TODO
	self.paras.direction = ScrollViewII.DIRECTION_HORIZONTAL

	PlaceHeroCell.super.ctor(self,self.paras)

	self.itemNodes = {}
	self.canClick = true --可点击
	self.needCountDown = false --是否需要倒计时
	self.coutDownTxt={} --记录倒计时节点
	self:initCell(self.paras.data)
	self.init_page_over = true
	self:countDownFunc()
end

function PlaceHeroCell:countDownFunc()
	if not self.needCountDown then return end
	self.countDown = scheduler.scheduleGlobal(function() 
			if #self.coutDownTxt == 0 then 
				if self.countDown then scheduler.unscheduleGlobal(self.countDown);self.countDown=nil; end
				return 
			end

			for i=#self.coutDownTxt,1,-1 do
				local num=gHero:getHeroCD(self.coutDownTxt[i][2])
				if not tolua.isnull(self.coutDownTxt[i][1]) then 
					self.coutDownTxt[i][1]:removeAllChildren()
					self.coutDownTxt[i][1]:addChild(CommUtil.makeNum(num))
				end
				if num == 0 then 
					if not tolua.isnull(self.coutDownTxt[i][1]) then self.coutDownTxt[i][1]:removeSelf() end
					table.remove(self.coutDownTxt,i)
				end
			end
		end, 0.5)
end

function PlaceHeroCell:initCell(data)
	self:setScrollPosition(self:getPosition()) --设置滑动范围
	local posx,posy = self.paras.cellsize.width/2,self.paras.cellsize.height/2
	local first = true
	for i= 1,#data do
		local celldata = data[i]
		local node = display.newNode():addTo(self):pos((i-1)*self.paras.cellsize.width + posx,posy)
		self.itemNodes[#self.itemNodes + 1] = node
		node:setContentSize(CCSize(self.paras.cellsize.width,self.paras.cellsize.height))
		node:setAnchorPoint(ccp(0.5,0.5))

		local head=display.newSprite("#hero_head_"..celldata.id..".png"):pos(posx,posy+10):addTo(node)
		local name=display.newSprite("ui/hero/hero_name_"..celldata.id..".png", x, y):pos(posx,posy-head:getContentSize().height/2):addTo(node)

		

		if celldata.needBuy then
			  local frames = display.newFrames("Skill_Box_Selected_Ani_%d.png", 1,9)
    local animation = display.newAnimation(frames,1.5/9)
    display.setAnimationCache("skillSelect",animation)
			local SkillSelect = display.newSprite("#Skill_Box_Selected_Ani_1.png",x, y):pos(posx,posy+10):addTo(node)
			SkillSelect:playAnimationForever(animation)
			--没有购买的显示一个
			--head:setShaderProgram(CCShaderCache:sharedShaderCache():programForKey("ShaderPositionTextureGray"))
			--name:setShaderProgram(CCShaderCache:sharedShaderCache():programForKey("ShaderPositionTextureGray"))
		else
			Text.new({text=celldata.energy:get(),x=posx+25,y=posy-15,size=14,color = ccc3(255,255,255),align = ui.TEXT_ALIGN_CENTER}):addTo(node)
		end

        first = false

		local num = gHero:getHeroCD(celldata.id)
		if num > 0 then
			self.needCountDown = true
			local numNode=display.newNode():addTo(node):pos(posx, posy+10)
			CommUtil.makeNum(num):addTo(numNode)
			table.insert(self.coutDownTxt,{numNode,	celldata.id})
		end
	end

end

function PlaceHeroCell:onClicked(x,y)
	--页面没有加载完,退出点击事件
	if (not self.init_page_over) then
		return
	end
	if (not self.playAction) then
		return
	end
	--

	if not self.canClick then return end
	local rect2 = self.paras.delegate.ClipNode:getBoundingBox()
	if x < rect2.origin.x + 10 or x > rect2.size.width + rect2.origin.x - 10 then return end
	local pos1 = ccp(x-42.5,y)
	-- local pos1 = self:convertToWorldSpace(ccp(x,y))
	for i,v in pairs(self.itemNodes) do
		local pos = self:convertToWorldSpace(v:getPositionInCCPoint())
		-- local pos = v:getPositionInCCPoint()
		local rect = CCRect(pos.x-85, pos.y-61.5, 85, 114)
		-- display.newSprite("ui/public/public_flag_normal.png", pos.x, pos.y):addTo(self)
		-- display.newSprite("ui/public/public_flag_normal.png", pos.x+v:getCascadeBoundingBox().size.width/2, pos.y+v:getCascadeBoundingBox().size.height/2):addTo(self,TOP_BLACK_Z_ORDER )
		-- display.newSprite("ui/public/public_flag_normal.png", pos1.x,pos1.y):addTo(self)
		-- print(i,"true",v:getCascadeBoundingBox(true).size.width,v:getCascadeBoundingBox(true).size.height)
		-- print(i,"false",v:getCascadeBoundingBox().size.width,v:getCascadeBoundingBox().size.height)

		if rect:containsPoint(pos1) then
			self.canClick = false
			local posx,posy = pos.x,pos.y--v:getPosition()
			local celldata = self.paras.data[i]
			local code = ''
			CommUtil.guideStep(14)
			if celldata.needBuy then
				display.pause()
				self.paras.delegate:setTouchEnabled(false)
				self.paras.delegate:removeSelf()
				--print("yangdx 这是啥子地方哦5")
				if (celldata.id == 10003) then
					 code='hero_3'	    
				elseif (celldata.id == 10004) then
					code='hero_4'
					--CommUtil.showgiftPanel(2,3)
				elseif (celldata.id == 10005) then
					code='hero_5'
					--CommUtil.showgiftPanel(3,3)
				elseif (celldata.id == 10006) then
					code='hero_6'
					--CommUtil.showgiftPanel(4,3)
				end
                 --print("yangdx 这是啥子地方哦5 code=",code)
				 DeviceUtil.xiYouPay(ChargeData[code]["ChinaMobile"], ChargeData[code]["ChinaTelecom"], ChargeData[code]["ChinaUnicom"],ChargeData[code]["Unline"], function(resultJsonString)
                    -- if tostring(resultJsonString)~="success" then
                    --     CommUtil.toast(display.getRunningScene(),"购买失败,请重试",0)
                    -- else
                    --     CommUtil.toast(display.getRunningScene(),"购买成功",0)
                    -- end
                    display:resume()
                    end,3)

				return
			end
			if gHero:getHeroCD(celldata.id) > 0 then self.canClick=true;return;	end --倒计时中
			self.paras.delegate:removeCloud()
			self:playActionCard(celldata,ccp(posx,posy))
			self:PlaceHeroSock(celldata,ccp(posx,posy))
			return
		end
	end
	self.paras.delegate:removeSelf()
end


--[[
selectData:当前选中英雄信息table
startPos:当前选中英雄坐标CCPoint
功能：完成派驻英雄通信，成功后回调callback
]]
function PlaceHeroCell:PlaceHeroSock(selectData,startPos)
	gHero:setHeroInBattle(selectData.id)
	return_callback(selectData)
	-- if (delegate and delegate.close) then
	-- 	delegate:close()
	-- end
end

function PlaceHeroCell:playAction(selectData,startPos)
	print("playAction---------------------------------------------------------------")
	self.paras.callback(selectData)
	self.paras.delegate:removeFromParent()
end

function PlaceHeroCell:playActionCard(selectData,startPos)
	-- local picPath = 'hero/hero_10001/hero_10001_stand_front_1.png'
	local picPath = '#hero_' .. selectData.id ..'_stand_front_1.png'
	local head = display.newSprite(picPath, startPos.x ,startPos.y):addTo(self.paras.delegate, TOP_BLACK_Z_ORDER):scale(0.5)

	local time = 0.5
	local point = ccp(self.paras.towerPos.x, display.top + 40)
	local action1 = CCSpawn:createWithTwoActions(CCScaleTo:create(time, 1), CCMoveTo:create(time, point))
	transition.execute(head, action1, {
		easing = 'exponentialIn',
		onComplete = function()
			self.paras.callback1({playAction = true})
			head:removeFromParent()

			if (delegate and delegate.close) then
				delegate:close()
			end
		end,
	})

end

function PlaceHeroCell:onExit()
	if self.countDown then scheduler.unscheduleGlobal(self.countDown) end
end

return PlaceHeroCell