--
-- Author: hejiangcheng
-- Date: 2014-12-05 16:41:36
--
local scheduler = require("framework.scheduler")
local baseMenu = require("app.views.baseMenu")
local heroMenu = class("heroMenu",baseMenu)
local Text = require("app.ui.Text")
local GroupTemplateClass = require("app.data.template.GroupTemplateClass").new()
local hero_skill = require("app.client.desc.hero_skill")
local AnimationFactory = require("app.factory.AnimationFactory")

function heroMenu:ctor()
	heroMenu.super.ctor(self)

	self.heroIndex = 1--读取到第几个英雄
	self.heroData = gHero:getHeroData(gHero.data[self.heroIndex])--英雄详情
	self.reachMaxLvl = gHero:reachMaxLvl(gHero.data[self.heroIndex])
	self.heroDataNext = gHero:getHeroDataNextLvl(gHero.data[self.heroIndex])

	self.width,self.height = self.bg:getContentSize().width,self.bg:getContentSize().height
	self:addBasePic()

	self.view = display.newLayer()
	self.view:registerScriptTouchHandler(handler(self,self.onTouch))
	self:addChild(self.view)
	self:setTouchEnabled(true)
	
end

--不变的图片
function heroMenu:addBasePic()
	self.sp_left = display.newSprite("ui/home/home_arrow_left.png", -self.width/4-85, self.height/2-45):addTo(self)
	self.sp_left:addTouchEventListener(function(event,x,y) 
		local action = CCScaleBy:create(0.1, 0.9, 0.9)
		self.sp_left:runAction(CCSequence:createWithTwoActions(action, action:reverse()))
		if self.canClick == true then self:setTouchEnabled(false);self:changeMenu(true);self:setTouchEnabled(true); end
		end)
	self.sp_right = display.newSprite("ui/home/home_arrow_left.png", -self.width/4+85, self.height/2-45):addTo(self):flipX(true)
	self.sp_right:addTouchEventListener(function(event,x,y)
		local action = CCScaleBy:create(0.1, 0.9, 0.9)
		self.sp_right:runAction(CCSequence:createWithTwoActions(action, action:reverse()))
		if self.canClick == true then self:setTouchEnabled(false);self:changeMenu(false);self:setTouchEnabled(true); end
		end)
	self.sp_left:setTouchEnabled(true);self.sp_right:setTouchEnabled(true);

	display.newSprite("ui/hero/hero_iconbox_3.png", -self.width/4, 35):addTo(self):scale(0.9)
	display.newSprite("ui/hero/hero_frame_attribute.png", self.width/4-30, 100):addTo(self)

	display.newSprite("ui/public/public_second_label_bg.png", -self.width/4-61, -40):addTo(self):setScaleX(114/167)
	display.newSprite("ui/public/public_second_label_bg.png", -self.width/4+61, -40):addTo(self):setScaleX(114/167)
	display.newSprite("ui/public/public_second_label_bg.png", -self.width/4, -self.height/4+5):addTo(self):setScaleX(238/167)
	display.newSprite("ui/public/public_second_label_bg.png", -self.width/4, -self.height/2+55):addTo(self):setScaleX(238/167)

	-- display.newSprite("ui/public/public_equipment2.png", 30, -self.height/2+90):addTo(self)
	local sp=display.newSprite("ui/public/public_card_empty_1.png", self.width/4-30, -self.height/2+95):addTo(self):rotation(-90)
	sp:setScaleX(135/223); sp:setScaleY(300/331)
	display.newSprite("ui/public/public_embellish.png", self.width/4-80, -30):addTo(self):setScaleX(0.7)

	self.ingotTxt = CommUtil.makeNum(self.heroData.ingot:get()):pos(self.width/4-60, -30):addTo(self):scale(0.6)
	display.newSprite("ui/hero/hero_needwing_word.png", self.width/4-120, -30):addTo(self):scale(0.9)

	Text.new({text="攻击",x=self.width/4-124,y= 157,size=20,color = ccc3(255,255,255),align = ui.TEXT_ALIGN_CENTER}):addTo(self)
	Text.new({text="攻速",x=self.width/4-124,y= 113,size=20,color = ccc3(255,255,255),align = ui.TEXT_ALIGN_CENTER}):addTo(self)
	Text.new({text="射程",x=self.width/4-124,y= 72,size=20,color = ccc3(255,255,255),align = ui.TEXT_ALIGN_CENTER}):addTo(self)
	Text.new({text="特性",x=self.width/4-124,y= 30,size=20,color = ccc3(255,255,255),align = ui.TEXT_ALIGN_CENTER}):addTo(self)

	self.attackL= Text.new({text=self.heroData.attackpower:get(),x=self.width/4-28,y= 157,size=20,color = ccc3(255,255,255),align = ui.TEXT_ALIGN_CENTER}):addTo(self)
	self.speedL = Text.new({text=self.heroData.attackspeed:get(),x=self.width/4-28,y= 113,size=20,color = ccc3(255,255,255),align = ui.TEXT_ALIGN_CENTER}):addTo(self)
	self.lenL   = Text.new({text=self.heroData.range:get(),x=self.width/4-28,y= 72,size=20,color = ccc3(255,255,255),align = ui.TEXT_ALIGN_CENTER}):addTo(self)
	self.proL   = Text.new({text=self.heroData.property,x=self.width/4-28,y= 30,size=12,color = ccc3(255,255,255),align = ui.TEXT_ALIGN_CENTER}):addTo(self)

	if not self.reachMaxLvl then
		self.attackR= Text.new({text=self.heroDataNext.attackpower:get(),x=self.width/4+89,y= 157,size=20,color = ccc3(255,255,255),align = ui.TEXT_ALIGN_CENTER}):addTo(self)
		self.speedR = Text.new({text=self.heroDataNext.attackspeed:get(),x=self.width/4+89,y= 113,size=20,color = ccc3(255,255,255),align = ui.TEXT_ALIGN_CENTER}):addTo(self)
		self.lenR   = Text.new({text=self.heroDataNext.range:get(),x=self.width/4+89,y= 72,size=20,color = ccc3(255,255,255),align = ui.TEXT_ALIGN_CENTER}):addTo(self)
		self.proR   = Text.new({text=self.heroDataNext.property,x=self.width/4+89,y= 30,size=12,color = ccc3(255,255,255),align = ui.TEXT_ALIGN_CENTER}):addTo(self)
	else
		self.attackR= Text.new({text="",x=self.width/4+89,y= 157,size=20,color = ccc3(255,255,255),align = ui.TEXT_ALIGN_CENTER}):addTo(self)
		self.speedR = Text.new({text="",x=self.width/4+89,y= 113,size=20,color = ccc3(255,255,255),align = ui.TEXT_ALIGN_CENTER}):addTo(self)
		self.lenR   = Text.new({text="",x=self.width/4+89,y= 72,size=20,color = ccc3(255,255,255),align = ui.TEXT_ALIGN_CENTER}):addTo(self)
		self.proR   = Text.new({text="",x=self.width/4+89,y= 30,size=12,color = ccc3(255,255,255),align = ui.TEXT_ALIGN_CENTER}):addTo(self)
	end

	self.baoText = Text.new({text="暴击率:"..self.heroData.crit:get(),x=-self.width/4-61,y= -40,size=20,color = ccc3(255,255,255),align = ui.TEXT_ALIGN_CENTER}):addTo(self)
	self.poText = Text.new({text="破甲率:"..self.heroData.sunder:get(),x=-self.width/4+61,y= -40,size=20,color = ccc3(255,255,255),align = ui.TEXT_ALIGN_CENTER}):addTo(self)
	if self.heroData.id == 10005 then
	self.com1Text = Text.new({text='叼到没朋友！',x=-self.width/4-110,y=-self.height/4+5,size=14,color = ccc3(255,255,255),align = ui.TEXT_ALIGN_LEFT,dimensions=CCSize(14*15,14*3)}):addTo(self)
	else
	self.com1Text = Text.new({text=GroupTemplateClass:getNameAndDesc(self.heroData.group1),x=-self.width/4-110,y=-self.height/4+5,size=14,color = ccc3(255,255,255),align = ui.TEXT_ALIGN_LEFT,dimensions=CCSize(14*15,14*3)}):addTo(self)
	end
	self.com2Text = Text.new({text=GroupTemplateClass:getNameAndDesc(self.heroData.group2),x=-self.width/4-110,y=-self.height/2+55,size=14,color = ccc3(255,255,255),align = ui.TEXT_ALIGN_LEFT,dimensions=CCSize(14*15,14*3)}):addTo(self)

	self.heroName = display.newSprite("ui/hero/hero_name_"..self.heroData.id..".png", -self.width/4, self.height/2-45):addTo(self)
	self.starNode = display.newNode():addTo(self):pos(-self.width/4, self.height/2-80)
	self:addStar(self.heroData.star:get())
	-- self.hero = display.newSprite("#hero_"..self.heroData.id.."_stand_front_1.png", -self.width/4, 80):addTo(self)
	local frames,animation=self:getAnimation(self.heroData.id)
	self.hero = display.newSprite(frames[1], -self.width/4, 80):addTo(self)
	self.hero:playAnimationForever(animation)

	-- self.skillPic = display.newSprite("icon/item_32001.png", 30, -self.height/2+91):addTo(self)
	self.skillNode = display.newNode():addTo(self):pos(self.width/4-30, -self.height/2+95)
	self:addSkillDetail(self.heroData.skillid)

	self.upHeroStar=cc.ui.UIPushButton.new({
		normal = "ui/hero/hero_button_upstar_normal.png",
		pressed = "ui/hero/hero_button_upstar_pressed.png",
		}):addTo(self):pos(self.width/4+50,-30)
		:onButtonRelease(function(event) 
			if not self.canClick then return end
			if self.reachMaxLvl then CommUtil.toast(self,"已经升到最高级！");return; end
			if self.heroData.ingot:get() == 0 then CommUtil.toast(self,"数据异常，请退出游戏重新购买！");return; end
			if gPlayer.data.ingot_cnt:get() < self.heroData.ingot:get() then CommUtil.toast(self,"元宝不足，请到市集购买！");return; end
			self:setTouchEnabled(false)
			gHero:upHeroStar(self.heroData.id, self.heroData.star:get()+1)
			gPlayer:useIngot(self.heroData.ingot:get())

			self.heroData = gHero:getHeroData(gHero.data[self.heroIndex])--英雄详情
			self.reachMaxLvl = gHero:reachMaxLvl(gHero.data[self.heroIndex])
			self.heroDataNext = gHero:getHeroDataNextLvl(gHero.data[self.heroIndex])

			self:updatePanel()
			self:setTouchEnabled(true)
		end)
end

function heroMenu:changeMenu(left)
	-- print(#gHero.data, self.heroIndex, left)
	if self.heroIndex == 1 and left then CommUtil.toast(self,"已到达最左边！") return end
	if self.heroIndex == #gHero.data and (not left) then CommUtil.toast(self,"已到达最右边！") return end
	if left then
		self.heroIndex = self.heroIndex-1--读取到第几个英雄
		self.heroData = gHero:getHeroData(gHero.data[self.heroIndex])--英雄详情
		self.reachMaxLvl = gHero:reachMaxLvl(gHero.data[self.heroIndex])
		self.heroDataNext = gHero:getHeroDataNextLvl(gHero.data[self.heroIndex])
	else
		self.heroIndex = self.heroIndex+1--读取到第几个英雄
		self.heroData = gHero:getHeroData(gHero.data[self.heroIndex])--英雄详情
		self.reachMaxLvl = gHero:reachMaxLvl(gHero.data[self.heroIndex])
		self.heroDataNext = gHero:getHeroDataNextLvl(gHero.data[self.heroIndex])
	end
	self:updatePanel()
end

function heroMenu:updatePanel()
	self.attackL:setString(self.heroData.attackpower:get())
	self.speedL:setString(self.heroData.attackspeed:get()) 
	self.lenL:setString(self.heroData.range:get())  
	self.proL:setString(self.heroData.property) 

	if not self.reachMaxLvl then
		self.attackR:setString(self.heroDataNext.attackpower:get())
		self.speedR:setString(self.heroDataNext.attackspeed:get()) 
		self.lenR:setString(self.heroDataNext.range:get())   
		self.proR:setString(self.heroDataNext.property)  
	else
		self.attackR:setString("")
		self.speedR:setString("")
		self.lenR:setString("")
		self.proR:setString("")
	end

	local x,y = self.ingotTxt:getPositionX(), self.ingotTxt:getPositionY()
	self.ingotTxt:removeSelf()
	self.ingotTxt = CommUtil.makeNum(self.heroData.ingot:get()):pos(x,y):addTo(self):scale(0.6)

	self.baoText:setString("暴击率:"..self.heroData.crit:get()) 
	self.poText:setString("破甲率:"..self.heroData.sunder:get()) 
	if self.heroData.id==10005 then
		self.com1Text:setString('叼到没朋友！')
	else
		self.com1Text:setString(GroupTemplateClass:getNameAndDesc(self.heroData.group1))
	end
	self.com2Text:setString(GroupTemplateClass:getNameAndDesc(self.heroData.group2))

	if io.exists("res/ui/hero/hero_name_"..self.heroData.id..".png") == true then 
		local sp_cache = CCTextureCache:sharedTextureCache():addImage("ui/hero/hero_name_"..self.heroData.id..".png")
		self.heroName:setTexture(sp_cache)
		CCTextureCache:sharedTextureCache():removeTexture(sp_cache)
	end

	transition.stopTarget(self.hero)
	local frames,animation = self:getAnimation(self.heroData.id)
	self.hero:setDisplayFrame(frames[1])
	self.hero:playAnimationForever(animation)

	self:addStar(self.heroData.star:get())
	self:addSkillDetail(self.heroData.skillid)
end

function heroMenu:addStar(num)
	self.starNode:removeAllChildren()
	local star1,star2,star3
	if num == 0 then
		star1,star2,star3="ui/public/public_flag_gray.png","ui/public/public_flag_gray.png","ui/public/public_flag_gray.png"
	elseif num == 1 then
		star1,star2,star3="ui/public/public_flag_normal.png","ui/public/public_flag_gray.png","ui/public/public_flag_gray.png"
	elseif num == 2 then
		star1,star2,star3="ui/public/public_flag_normal.png","ui/public/public_flag_normal.png","ui/public/public_flag_gray.png"
	elseif num == 3 then
		star1,star2,star3="ui/public/public_flag_normal.png","ui/public/public_flag_normal.png","ui/public/public_flag_normal.png"
	end
	display.newSprite(star1, -25, 0):addTo(self.starNode)
	display.newSprite(star2, 0, 0):addTo(self.starNode)
	display.newSprite(star3, 25, 0):addTo(self.starNode)
end

function heroMenu:addSkillDetail(skill_id)
	self.skillNode:removeAllChildren()
	Text.new({text=hero_skill[tostring(skill_id)].name,x=0,y=45,size=18,color = ccc3(0,0,0),align = ui.TEXT_ALIGN_CENTER}):addTo(self.skillNode)
	Text.new({text=hero_skill[tostring(skill_id)].desc,x=-15,y=-10,size=16,color = ccc3(0,0,0),align = ui.TEXT_ALIGN_LEFT,valign=ui.TEXT_VALIGN_CENTER,dimensions =CCSize(8*16, 5*16)}):addTo(self.skillNode)
	display.newSprite("ui/public/public_equipment2.png",  -80, -14):addTo(self.skillNode)
	display.newSprite("#skill_"..skill_id..".png", -80, -14):addTo(self.skillNode)
end

function heroMenu:onTouch(event,x,y)
	if not self.canClick then return end
	if event == "began" then
		self.startx = x; self.starty = y;
		return true
	elseif event == "moved" then
		return true
	elseif event == "ended" then
		if self.upHeroStar:getCascadeBoundingBox():containsPoint(ccp(x,y)) then 
			return true 
		end
	    if x - self.startx >= 50 then
	    	self:setTouchEnabled(false)
	    	self:changeMenu(true)
	    	self:setTouchEnabled(true)
	    elseif x - self.startx <= -50 then
	    	self:setTouchEnabled(false)
	    	self:changeMenu(false)
	    	self:setTouchEnabled(true)
	    end
	    return true
	end  
end

function heroMenu:setTouchEnabled(b)
	self.view:setTouchEnabled(b)
	self.canClick = b
end

function heroMenu:getAnimation(hero_id)
	local frames = display.newFrames('hero_' .. hero_id ..'_stand_front_%d.png', 1,8)
	local animation = display.newAnimation(frames,1.5/9)
	return frames,animation
end

function heroMenu:onExit()
	if display.getRunningScene().setMainSceneTouch then
		display.getRunningScene():setMainSceneTouch(true)
	end
	CCTextureCache:sharedTextureCache():removeUnusedTextures()
end

return heroMenu