--
-- Author: hejiangcheng
-- Date: 2014-12-05 16:41:36
--
-- local scheduler = require("framework.scheduler")
local baseMenu = require("app.views.baseMenu")
local heroMenu = class("heroMenu",baseMenu)
local Text = require("app.ui.Text")
-- local GroupTemplateClass = require("app.data.template.GroupTemplateClass").new()
local hero_skill = require("app.client.desc.hero_skill")
-- local AnimationFactory = require("app.factory.AnimationFactory")

function heroMenu:ctor()
	CommUtil.playSound("music/openbox.mp3")
	heroMenu.super.ctor(self)

	self.heroList = gHero:getHeroMenuData()--英雄列表
	self.heroIndex = DEF_SHOW_HERO--读取到第几个英雄
	self:loadHeroData()

	self.width,self.height = self.bg:getContentSize().width,self.bg:getContentSize().height
	self:addBasePic()

	self:setTouchEnabled(true)
end

function heroMenu:loadHeroData()
	--[[self.heroData = gHero:getHeroData(gHero.data[self.heroIndex])--英雄详情
	self.reachMaxLvl = gHero:reachMaxLvl(gHero.data[self.heroIndex])
	self.heroDataNextLvl = gHero:getHeroDataNextLvl(gHero.data[self.heroIndex])]]
	self.heroList = gHero:getHeroMenuData()
	self.needBuy = isset(self.heroList[self.heroIndex],'needBuy') and self.heroList[self.heroIndex].needBuy == true
	self.heroData = gHero:getHeroData(self.heroList[self.heroIndex])--英雄详情
	self.reachMaxLvl = gHero:reachMaxLvl(self.heroList[self.heroIndex])
	self.heroDataNextLvl = gHero:getHeroDataNextLvl(self.heroList[self.heroIndex])
	-- print('self.needBuy = ',self.needBuy)
end

--不变的图片
function heroMenu:addBasePic()

	local successCallBack = function()
				self:loadHeroData()
					    		self:addSixHeroBtns()
					    		self:updatePanel()
					    		CommUtil.toast(self,'^o^ 恭喜解锁新英雄成功')

	end
	display.newSprite('ui/hero/hero_new_base_03.png',-self.width/4-33,46):addTo(self)
	self.heroPicNode=display.newNode():pos(-self.width/4-33,46):addTo(self)
	self:addHeroPicAndName()

	--skill detail
	display.newSprite('ui/hero/hero_line.png', self.width/4-160, 127+13):addTo(self):rotation(90):scale(0.5)
	display.newSprite('ui/hero/hero_line.png', self.width/4-160, 91+13-15):addTo(self):rotation(90):scale(0.5)
	display.newSprite('ui/hero/hero_line.png', self.width/4-160, 55+13-25):addTo(self):rotation(90):scale(0.5)
	local proName,propTxt,propPath=self:getProperty()
	display.newSprite('ui/hero/hero_new_hurticon.png', self.width/4-224, 127+30):addTo(self)
	display.newSprite('ui/hero/hero_new_rangeicon.png', self.width/4-224, 91+20):addTo(self)
	display.newSprite('ui/hero/hero_new_rateicon.png', self.width/4-224, 55+10):addTo(self)
	if propPath~='' then
		self.propSp=display.newSprite(propPath, self.width/4-224, 19):addTo(self)--:scale(0.4)
	end
	Text.new({text="攻击:",x=self.width/4-180,y= 127+30,size=20,color = ccc3(255,255,255),align = ui.TEXT_ALIGN_CENTER}):addTo(self)
	Text.new({text="攻速:",x=self.width/4-180,y= 91+20,size=20,color = ccc3(255,255,255),align = ui.TEXT_ALIGN_CENTER}):addTo(self)
	Text.new({text="射程:",x=self.width/4-180,y= 55+10,size=20,color = ccc3(255,255,255),align = ui.TEXT_ALIGN_CENTER}):addTo(self)
	local defcolor = ccc3(255,255,255)
	if (self.heroData.id == 10003) then
		defcolor = ccc3(255,255,0)
	end
	self.proptyName = Text.new({text=proName,x=self.width/4-180,y= 19,size=20,color = defcolor,align = ui.TEXT_ALIGN_CENTER}):addTo(self)

	self.attack= Text.new({text=self.heroData.attackpower:get(),x=self.width/4-150,y= 127+30,size=20,color = ccc3(255,255,255),align = ui.TEXT_ALIGN_LEFT}):addTo(self)
	self.speed = Text.new({text=self.heroData.attack_times:get(),x=self.width/4-150,y= 91+20,size=20,color = ccc3(255,255,255),align = ui.TEXT_ALIGN_LEFT}):addTo(self)
	self.len   = Text.new({text=self.heroData.range:get(),x=self.width/4-150,y= 55+10,size=20,color = ccc3(255,255,255),align = ui.TEXT_ALIGN_LEFT}):addTo(self)
	self.proptyTxt= Text.new({text=propTxt,x=self.width/4-150+70-60,y= 19,size=20,color = defcolor,align = ui.TEXT_ALIGN_LEFT}):addTo(self)

	self.skillNode = display.newNode():addTo(self):pos(self.width/4+40, self.height/4)
	self:addSkillDetail(self.heroData.skillid)

	self.practiseNode=display.newNode():addTo(self):pos(-120,53)
	
		self:addPracDetail()

	display.newSprite('ui/hero/hero_base_3.png', 0, -self.height/4-42):addTo(self):setScaleX(2.5)
	self.heroBtnsNode=display.newNode():addTo(self)
	self:addSixHeroBtns()

	self.upHeroStar=cc.ui.UIPushButton.new({
		normal='ui/hero/hero_new_practice_normal.png',
		pressed='ui/hero/hero_new_practice_normal.png',
		}):addTo(self):pos(self.width/4+80,-70):scale(0.8)
		:onButtonRelease(function(event) 
			if self.canClick~=true then return end
			if self.needBuy==true then 
				self:setTouchEnabled(false)
				require("app.views.GiftPanel").new():addTo(self,10):pos(-display.cx,-display.cy)
				return
			end
			if self.reachMaxLvl then CommUtil.toast(self,"已升级到最高级！");return; end
			if gItem:getItemNum(30006) < self.heroData.stone:get() then 
				--CommUtil.toast(self, '经验石不足，请前往商城选购！'); 
				self:setTouchEnabled(false)
				require('app.views.secondMenu.hero.lackResNode').new({parent=self}):addTo(self,100)
				return
			end

			self:setTouchEnabled(false)
			gItem:cutItem(30006, self.heroData.stone:get())
			gHero:upHeroStar(self.heroData.id, self.heroData.star:get()+1)

			self:loadHeroData()
			self:updatePanel()
			self:setTouchEnabled(true)
			CommUtil.toast(self,'^o^ 恭喜升级成功,战斗力提升!')
		end)

	local oneTopAction = function()
		if self.canClick~=true then return end
			if self.needBuy==true then 
				self:setTouchEnabled(false)
				self:buySingleHero(self.heroData.id-10000)  --购买仙将
				return
			end
			if self.reachMaxLvl then CommUtil.toast(self,"已升级到最高级！");return; end

			self:setTouchEnabled(false)
			local priceTop = 10
			if (DEF_SPECIAL_PAY_PROCESS) then
				priceTop = 10
			end
			local code ='one_top'
			require('app.views.payTips').new({
			    name = "一键顶级",
			    price =priceTop,
			    cancelCallback=function()
			    	self:setTouchEnabled(true)
			    end,
			    confirmCallback=function() 

			        DEF_CURUPGRADEHEROID=self.heroData.id
			        
				    DeviceUtil.xiYouPay(ChargeData[code]["ChinaMobile"], ChargeData[code]["ChinaTelecom"], ChargeData[code]["ChinaUnicom"],ChargeData[code]["Unline"],function(ret) 
				    		if ret == 'success' then

				    			--gHero:upHeroStar(self.heroData.id, 3)
				    			self:loadHeroData()
				    			self:updatePanel()
				    			CommUtil.toast(self,'^o^ 恭喜一键升级成功,战斗力提升！')

				    		
				    		else
				    			CommUtil.toast(self,'很遗憾升级失败')
				    		end
				    		self:setTouchEnabled(true)
				    	end)
			    end,
			    }):addTo(self,100)
	end
	----
	local png1= 'ui/hero/mall_button_top_normal.png'
	local png2 =  'ui/hero/mall_button_top_normal.png'
	local left_x = self.width/4+80-240
	local left_x2=self.width/4+80-50
	local height=-30+20-20-10 
	self.oneKeyTop=cc.ui.UIPushButton.new({
		normal=png1,
		pressed=png2,
		}):addTo(self):pos(self.width/4+80,-30+20)
		:onButtonRelease(function(event) 
			oneTopAction()
		end)
	local png = 'ui/hero/buyhero1.png'
	-- if (DEF_SPECIAL_PAY_PROCESS) then
	-- 	png = 'ui/hero/buyhero0.png'
	-- end

	self.needBuyBtn=cc.ui.UIPushButton.new({
		normal=png,
		pressed=png,
		}):addTo(self):pos(left_x-10,height)
		:onButtonRelease(function(event) 
			--print("购买东西了")
			oneTopAction()
		end)
	self.needBuyBtn:setScale(0.9)
	-- if (DEF_SPECIAL_PAY_PROCESS) then
	--    CommUtil.bubbleBtn2(self.needBuyBtn, 169,59, 1.1)
    -- end

	self.needBuyBtn2=cc.ui.UIPushButton.new({
	normal='ui/hero/buyhero2.png',
	pressed='ui/hero/buyhero2.png',
	}):addTo(self):pos(left_x2,height)
	:onButtonRelease(function(event) 
		print("self.id = ", self.heroData.id)   --当前英雄ID
		if DEF_SPECIAL_PAY_PROCESS then
			if (self.heroData.id == 10003) then
				CommUtil.showgiftPanel(1,3)  
			else
				CommUtil.showgiftPanel(5,3)  
			end
		else 
			if (self.heroData.id == 10003) then
				require("app.views.GiftPanel").new(1, successCallBack):addTo(display.getRunningScene(),1000001)
			else
				require("app.views.GiftPanel").new(2, successCallBack):addTo(display.getRunningScene(),1000001)
			end
	    end 
	end)
	self.needBuyBtn2:setScale(1.1)
	CommUtil.bubbleBtn2(self.needBuyBtn2, 169,59, 1.1)


	-- if (DEF_SPECIAL_PAY_PROCESS) then
	-- 	self.needBuyBtn2:setVisible(false)
	-- end
	--
	local xx = 169/2-75-5
	local yy = 59/2-30
	
	self.price_8_left=cc.ui.UIPushButton.new({
		normal='ui/hero/price_8.png',
		pressed='ui/hero/price_8.png',
		}):addTo(self):pos(left_x,height)
		:onButtonRelease(function(event) 
			oneTopAction()
		end)
	self.price_8_right=cc.ui.UIPushButton.new({
		normal='ui/hero/price_8.png',
		pressed='ui/hero/price_8.png',
		}):addTo(self.needBuyBtn2):pos(xx, yy)
		:onButtonRelease(function(event) 
			require("app.views.GiftPanel").new(2, successCallBack):addTo(display.getRunningScene(),1000001)
		end)
	self.price_10_left=cc.ui.UIPushButton.new({
		normal='ui/hero/price_10.png',
		pressed='ui/hero/price_10.png',
		}):addTo(self):pos(left_x,height)
		:onButtonRelease(function(event) 
			oneTopAction()
		end)
	self.price_10_right=cc.ui.UIPushButton.new({
		normal='ui/hero/price_10.png',
		pressed='ui/hero/price_10.png',
		}):addTo(self.needBuyBtn2):pos(xx, yy)
		:onButtonRelease(function(event) 
			require("app.views.GiftPanel").new(2, successCallBack):addTo(display.getRunningScene(),1000001)
		end)

	self.price_20_left=cc.ui.UIPushButton.new({
		normal='ui/hero/price_20.png',
		pressed='ui/hero/price_20.png',
		}):addTo(self):pos(left_x,height)
		:onButtonRelease(function(event) 
			oneTopAction()
		end)
	self.price_20_right=cc.ui.UIPushButton.new({
		normal='ui/hero/price_20.png',
		pressed='ui/hero/price_20.png',
		}):addTo(self.needBuyBtn2):pos(xx, yy)
		:onButtonRelease(function(event) 
			require("app.views.GiftPanel").new(1, successCallBack):addTo(display.getRunningScene(),1000001)
		end)
	self.price_15_left=cc.ui.UIPushButton.new({
		normal='ui/hero/price_15.png',
		pressed='ui/hero/price_15.png',
		}):addTo(self):pos(left_x,height)
		:onButtonRelease(function(event) 
			oneTopAction()
		end)
	self.price_15_right=cc.ui.UIPushButton.new({
		normal='ui/hero/price_15.png',
		pressed='ui/hero/price_15.png',
		}):addTo(self.needBuyBtn2):pos(xx, yy)
		:onButtonRelease(function(event) 
			require("app.views.GiftPanel").new(2, successCallBack):addTo(display.getRunningScene(),1000001)
		end)

		local action=CCScaleBy:create(0.6, 1.1, 1.1)
		local action1=CCScaleBy:create(0.6, 1.1, 1.1)
    --self.needBuyBtn:runAction(CCRepeatForever:create(CCSequence:createWithTwoActions(action, action:reverse())))
    --self.oneKeyTop:runAction(CCRepeatForever:create(CCSequence:createWithTwoActions(action1, action:reverse())))
    self.price_red=cc.ui.UIPushButton.new({
		normal='ui/hero/buyhero_red.png',
		pressed='ui/hero/buyhero_red.png',
		}):addTo(self.needBuyBtn2):pos(xx, yy)
		:onButtonRelease(function(event) 
			print("self.id = ", self.heroData.id)   --当前英雄ID
			--
			if (self.heroData.id == 10003) then
				require("app.views.GiftPanel").new(1, successCallBack):addTo(display.getRunningScene(),1000001)
			else
				require("app.views.GiftPanel").new(2, successCallBack):addTo(display.getRunningScene(),1000001)
			end
		end)
    if ( gHero:isHeroExists(self.heroData.id)) then
    	self.upHeroStar:setVisible(true)
    	self.oneKeyTop:setVisible(true)
    	self.needBuyBtn:setVisible(false)
		self.needBuyBtn2:setVisible(false)
		self.price_red:setVisible(false)
		self.price_8_left:setVisible(false)
		self.price_8_right:setVisible(false)
		self.price_10_left:setVisible(false)
		self.price_10_right:setVisible(false)
		self.price_15_left:setVisible(false)
		self.price_15_right:setVisible(false)
		self.price_20_left:setVisible(false)
		self.price_20_right:setVisible(false)
    else
    	self.upHeroStar:setVisible(false)
    	self.oneKeyTop:setVisible(false)
    	self:showBuyBtn()
    end

  


    --
--[[local action1=CCScaleBy:create(0.8, 1.1)
		self.oneKeyTop:runAction(CCRepeatForever:create(CCSequence:createWithTwoActions(action1, action1:reverse())))
		self.needBuyBtn:runAction(CCRepeatForever:create(CCSequence:createWithTwoActions(action1, action1:reverse())))]]

end

--添加6个英雄头像按钮
function heroMenu:addSixHeroBtns()
	self.heroBtnsNode:removeAllChildren()
	local offsetX = 90
	--DebugUtil.print_table(self.heroList)
	for i=1, 6 do
		local head = display.newSprite('#hero_head_'..self.heroList[i][1]..'.png', (i-3)*offsetX-85/2, -self.height/4-45):addTo(self.heroBtnsNode)

		head:addTouchEventListener(function(event,x,y) 
			if self.canClick ~= true then return end
			head:stopAllActions()
			head:scale(1)
			local action = CCScaleBy:create(0.1, 0.9, 0.9)
			head:runAction(CCSequence:createWithTwoActions(action, action:reverse()))
			self:setTouchEnabled(false)
				if not tolua.isnull(self.selectPic) then self.selectPic:removeSelf() end
				self.selectPic=display.newSprite('ui/home/home_skill_select.png', 85/2-0.5, 85/2+1):addTo(head):scale(1.1)
				self.heroIndex=i
				self:loadHeroData()
				self:updatePanel()

			self:setTouchEnabled(true)
		end)
		head:setTouchSwallowEnabled(false)
		head:setTouchEnabled(true)

		if isset(self.heroList[i],'needBuy') and self.heroList[i].needBuy == true then
			head:setGrayShader()
		end

		if i==self.heroIndex then
			self.selectPic=display.newSprite('ui/home/home_skill_select.png', 85/2-0.5, 85/2+1):addTo(head):scale(1.1)
		end
	end
end


function heroMenu:buySingleHero(i)
			if isset(self.heroList[i],'needBuy') and self.heroList[i].needBuy == true then

				local hero_id = self.heroList[i][1]
				
					local code = ''
					if (hero_id== 10003) then
						code = 'hero_3'
					elseif (hero_id== 10004) then
						code = 'hero_4'
					elseif (hero_id== 10005) then
						code = 'hero_5'
					else
						code = 'hero_6'
					end

					    DeviceUtil.xiYouPay(ChargeData[code]["ChinaMobile"], ChargeData[code]["ChinaTelecom"], ChargeData[code]["ChinaUnicom"],ChargeData[code]["Unline"], function(ret) 
					    	if ret == 'success' then
					    		-- if (not DEF_SPECIAL_PAY_PROCESS) then
					    		-- 	gHero:insertHero(hero_id)
					    		-- end					    		
					    		self:loadHeroData()
					    		self:addSixHeroBtns()
					    		self:updatePanel()
					    		CommUtil.toast(self,'^o^ 恭喜解锁新英雄成功')

					    		
					    	else
					    		CommUtil.toast(self,'抱歉解锁新英雄失败')
					    	end
					    	self:setTouchEnabled(true)
					    end,DEF_SPECIAL_PAY_PROCESS and 2 or 0)
				    --end,
				    --}):addTo(self,100)
	end
end




function heroMenu:addHeroPicAndName()
	self.heroPicNode:removeAllChildren()
	local head = display.newSprite('#hero_' ..self.heroData.id.. '_stand_front_1.png', 0, 0):addTo(self.heroPicNode)
	local frames = display.newFrames("hero_" ..self.heroData.id.. "_stand_front_%d.png", 1, 8)
    local animation = display.newAnimation(frames, 1 / 8)
    head:playAnimationForever(animation)
    head:setScale(1.4)

	local name = display.newSprite('ui/hero/hero_name_'..self.heroData.id..'.png', 0, 98):addTo(self.heroPicNode)

	if self.needBuy==true then
		head:setGrayShader()
		name:setGrayShader()
	end
end

--购买豪华礼包回调
function heroMenu:displayBtn()
	if gHero:isHeroExists(10003) then
		self:loadHeroData()
		self:addSixHeroBtns()
		self:updatePanel()
	end
	self:setTouchEnabled(true)
end

function heroMenu:updatePanel()
	--[[self.groupBtn:setVisible((not (self.heroData.group1==0 and self.heroData.group2==0)) and self.needBuy~=true)]]
	self.attack:setString(self.heroData.attackpower:get())
	self.speed:setString(self.heroData.attack_times:get()) 
	self.len:setString(self.heroData.range:get()) 
	local proName,propTxt,propPath=self:getProperty()
	self.proptyName:setString(proName)
	self.proptyTxt:setString(propTxt)
	if not tolua.isnull(self.propSp) then self.propSp:removeSelf() end
	if propPath~='' then
		self.propSp=display.newSprite(propPath, self.width/4-224, 19):addTo(self)--:scale(0.4)
	end

	self:addHeroPicAndName()

	self:addSkillDetail(self.heroData.skillid)
	self:addPracDetail()
end


function heroMenu:addSkillDetail(skill_id)
	self.skillNode:removeAllChildren()
	display.newSprite("ui/public/public_equipment2.png",  35, 31):addTo(self.skillNode)
	display.newSprite("#skill_"..skill_id..".png", 35, 33):addTo(self.skillNode)

	display.newSprite('ui/public/public_second_label_bg.png', 35, -15):addTo(self.skillNode):scale(0.6)
	Text.new({text=hero_skill[tostring(skill_id)].name,x=35,y=-15,size=18,color = ccc3(255,255,255),align = ui.TEXT_ALIGN_CENTER}):addTo(self.skillNode)
	Text.new({text=hero_skill[tostring(skill_id)].desc,x=-25,y=-65,size=16,color = ccc3(255,255,255),align = ui.TEXT_ALIGN_LEFT,valign=ui.TEXT_VALIGN_CENTER,dimensions =CCSize(8*16, 5*16)}):addTo(self.skillNode)
end
function heroMenu:showBuyBtn()
	self.needBuyBtn:setVisible(true)
	self.needBuyBtn2:setVisible(true)
	self.price_red:setVisible(true)
	self.price_20_left:setVisible(false)
	self.price_20_right:setVisible(false)
	self.price_8_left:setVisible(false)
	self.price_8_right:setVisible(false)
    self.price_10_left:setVisible(false)
	self.price_10_right:setVisible(false)
    			self.price_15_left:setVisible(false)
				self.price_15_right:setVisible(false)
	if 10003==self.heroData.id then
    			self.price_20_left:setVisible(true)
				self.price_20_right:setVisible(true)
			elseif 10004==self.heroData.id then
self.price_8_left:setVisible(true)
self.price_8_right:setVisible(true)

			elseif 10005==self.heroData.id then
    			self.price_10_left:setVisible(true)
self.price_10_right:setVisible(true)
			elseif 10006==self.heroData.id then
    			self.price_15_left:setVisible(true)
				self.price_15_right:setVisible(true)
			end

if NETTYPE == 'ChinaUnicom' then
	self.needBuyBtn2:setVisible(false)
	self.price_10_right:setVisible(true)
	self.price_8_right:setVisible(true)
	self.price_15_right:setVisible(true)
	self.price_20_right:setVisible(true)
end


  if (DEF_SPECIAL_PAY_PROCESS) then
  	--self.needBuyBtn2:setVisible(false)
    	self.price_red:setVisible(false)
		self.price_8_left:setVisible(false)
		self.price_8_right:setVisible(false)
		self.price_10_left:setVisible(false)
		self.price_10_right:setVisible(false)
		self.price_15_left:setVisible(false)
		self.price_15_right:setVisible(false)
		self.price_20_left:setVisible(false)
		self.price_20_right:setVisible(false)
end
end


function heroMenu:addPracDetail()

	self.practiseNode:removeAllChildren()
	
	--
	if (self.oneKeyTop) then
		if (self.needBuy) then
			self.upHeroStar:setVisible(false)
			self.oneKeyTop:setVisible(false)
			self:showBuyBtn()
		else
			self.upHeroStar:setVisible(true)
			self.oneKeyTop:setVisible(true)
			self.needBuyBtn:setVisible(false)
self.needBuyBtn2:setVisible(false)
self.price_red:setVisible(false)
self.price_8_left:setVisible(false)
self.price_8_right:setVisible(false)
self.price_10_left:setVisible(false)
self.price_10_right:setVisible(false)
self.price_15_left:setVisible(false)
self.price_15_right:setVisible(false)
self.price_20_left:setVisible(false)
self.price_20_right:setVisible(false)
		end
	end
	if (self.needBuy) then
		return
	end
	for i=1,4 do
		local skillpath='ui/fighting/fighting_attack_2.png'
		if i==2 then
			skillpath = 'ui/fighting/fighting_attack_6.png'
		elseif i==3 then
			skillpath = 'ui/fighting/fighting_attack_1.png'
		elseif i==4 then
			skillpath = 'ui/fighting/fighting_attack_4.png'
		end

		local base=display.newSprite(skillpath, self.width/4-20+(i-2.5)*70,-self.height/4+25):addTo(self.practiseNode):scale(0.9)
		local txt = Text.new({text="LV"..i,x=45,y= 12,size=18,color = ccc3(255,255,255),align = ui.TEXT_ALIGN_CENTER}):addTo(base)
		base:addTouchEventListener(function(event,x,y) 
			if self.canClick ~= true then return end
			base:stopAllActions()
			base:scale(0.9)
			local action = CCScaleBy:create(0.1, 0.9, 0.9)
			base:runAction(CCSequence:createWithTwoActions(action, action:reverse()))
			self:setTouchEnabled(false)

			local heroData = gHero:getHeroData({self.heroData.id, Number.new(i-1)})
			self.attack:setString(heroData.attackpower:get())
			self.speed:setString(heroData.attack_times:get()) 
			self.len:setString(heroData.range:get()) 
			local proName,propTxt,propPath=self:getProperty(heroData)
			self.proptyName:setString(proName)
			self.proptyTxt:setString(propTxt)
			if not tolua.isnull(self.propSp) then self.propSp:removeSelf() end
			if propPath~='' then
				self.propSp=display.newSprite(propPath, self.width/4-224, 19):addTo(self)--:scale(0.4)
			end

			self:setTouchEnabled(true)
		end)

		base:setTouchSwallowEnabled(false)
		base:setTouchEnabled(true)

		if self.needBuy or self.heroData.star:get()+1 < i then
			base:setGrayShader()
			txt:setGrayShader()
		end
	end

	if (self.needBuy~=true) and (not self.reachMaxLvl) then
		display.newSprite('ui/hero/hero_exp_stone.png', self.width/4+180,-self.height/4-45):addTo(self.practiseNode):scale(0.6)
		Text.new({text=self.heroData.stone:get()..'/'..gItem:getItemNum(30006),x=self.width/4+200,y=-self.height/4-45,size=18,color = ccc3(255,255,255),outlineColor=ccc3(0,0,0),align = ui.TEXT_ALIGN_LEFT}):addTo(self.practiseNode)
	else
		-- display.newSprite('ui/hero/hero_exp_stone.png', self.width/4-70, -self.height/4-25):addTo(self.practiseNode):scale(0.9)
		-- Text.new({text="拥有经验石 × "..gItem:getItemNum(30006),x=self.width/4-25,y=-self.height/4-25,size=18,color = ccc3(255,255,255),outlineColor=ccc3(0,0,0),align = ui.TEXT_ALIGN_LEFT}):addTo(self.practiseNode)
	end

	if self.needBuy~=true then
		local progressBg=display.newSprite('ui/hero/hero_button_01.png', self.width/4-20, -self.height/4-25):addTo(self.practiseNode)
	    local bar = CCProgressTimer:create(CCSprite:create('ui/hero/hero_button_02.png'))
	    bar:setType(kCCProgressTimerTypeBar)
	    bar:setMidpoint(CCPointMake(0, 0))
	    bar:setBarChangeRate(CCPointMake(1, 0))
	    bar:setPosition(CCPointMake(251/2, 15/2))
	    bar:runAction(CCProgressTo:create(0, (self.heroData.star:get()+1)/4*100))
		progressBg:addChild(bar)
	end
end

function heroMenu:getProperty(heroData)
	if not heroData then heroData = self.heroData end
	local name,txt,path=' ',' ',''
	if heroData.anti_wood:get() ~= 0 then
		name, txt, path = '克星:','对木怪伤害'..(heroData.anti_wood:get()*100)..'%','ui/fighting/frighting_new_change_tree.png'
	elseif heroData.anti_water:get() ~= 0 then
		name, txt, path = '克星:','对水怪伤害'..(heroData.anti_water:get()*100)..'%','ui/fighting/frighting_new_change_water.png'
	elseif heroData.anti_fire:get() ~= 0 then
		name, txt, path = '克星:','对火怪伤害'..(heroData.anti_fire:get()*100)..'%','ui/fighting/frighting_new_change_fire.png'
	elseif heroData.anti_soil:get() ~= 0 then
		--name, txt, path = '克星:','对土怪伤害'..(heroData.anti_soil:get()*100)..'%','ui/fighting/frighting_new_change_stone.png'
		name, txt, path = '特技:','全体攻击+10%','ui/fighting/frighting_new_change_stone.png'
	end
	return name,txt,path
end

function heroMenu:setTouchEnabled(b)
	self.canClick = b
end

function heroMenu:getAnimation(hero_id)
	local frames = display.newFrames('hero_' .. hero_id ..'_stand_front_%d.png', 1,8)
	local animation = display.newAnimation(frames,1.5/9)
	return frames,animation
end

function heroMenu:onExit()
	if display.getRunningScene().setMainSceneTouch then
		display.getRunningScene():setMainSceneTouch(true)
		display.getRunningScene().ingoViewHeroTouched=false --yangdx
	end
	CCTextureCache:sharedTextureCache():removeUnusedTextures()
end

return heroMenu