--
-- Author: hejiangcheng
-- Date: 2015-01-13 11:01:45
--
local baseMenu = require("app.views.baseMenu")
local heroPractice = class("heroPractice",baseMenu)
local Text = require('app.ui.Text')

function heroPractice:ctor(para)
	heroPractice.super.ctor(self,0.7)
	self.parent = para.parent

	self.width,self.height = self.bg:getContentSize().width*self.bgScale,self.bg:getContentSize().height*self.bgScale
	self:addBasePic()

	self:setTouchEnabled(true)
end

function heroPractice:addBasePic()
	display.newSprite("ui/home/home_arrow_left.png", -85, self.height/2-25):addTo(self):scale(0.9)
	display.newSprite("ui/home/home_arrow_left.png", 85, self.height/2-25):addTo(self):flipX(true):scale(0.9)
	display.newSprite('ui/hero/fighting_word.png', 0, self.height/2-25):addTo(self)
	display.newSprite('ui/hero/attribute_base_03.png', 0, self.height/2-110):addTo(self):scale(1.3)
	display.newSprite('ui/home/home_arrow_down.png', 0, self.height/2-115):addTo(self):rotation(-90)

	local x,y,offset=-self.width/4-30,self.height/2-115,30
	Text.new({text="攻击",x=x,y= y+offset,size=20,color = ccc3(0,0,0),align = ui.TEXT_ALIGN_CENTER}):addTo(self)
	Text.new({text="攻速",x=x,y= y,size=20,color = ccc3(0,0,0),align = ui.TEXT_ALIGN_CENTER}):addTo(self)
	Text.new({text="射程",x=x,y= y-offset,size=20,color = ccc3(0,0,0),align = ui.TEXT_ALIGN_CENTER}):addTo(self)

	x = -self.width/4+28
	self.attackL= Text.new({text=self.parent.heroData.attackpower:get(),x=x,y=y+offset,size=20,color = ccc3(0,0,0),align = ui.TEXT_ALIGN_CENTER}):addTo(self)
	self.speedL = Text.new({text=self.parent.heroData.attack_times,x=x,y=y,size=20,color = ccc3(0,0,0),align = ui.TEXT_ALIGN_CENTER}):addTo(self)
	self.lenL   = Text.new({text=self.parent.heroData.range:get(),x=x,y=y-offset,size=20,color = ccc3(0,0,0),align = ui.TEXT_ALIGN_CENTER}):addTo(self)

	x = self.width/4
	if not self.parent.reachMaxLvl then
		self.attackR= Text.new({text=self.parent.heroDataNextLvl.attackpower:get(),x=x,y= y+offset,size=20,color = ccc3(0,0,0),align = ui.TEXT_ALIGN_CENTER}):addTo(self)
		self.speedR = Text.new({text=self.parent.heroDataNextLvl.attack_times,x=x,y= y,size=20,color = ccc3(0,0,0),align = ui.TEXT_ALIGN_CENTER}):addTo(self)
		self.lenR   = Text.new({text=self.parent.heroDataNextLvl.range:get(),x=x,y= y-offset,size=20,color = ccc3(0,0,0),align = ui.TEXT_ALIGN_CENTER}):addTo(self)
	else
		self.attackR= Text.new({text="",x=x,y= y+offset,size=20,color = ccc3(0,0,0),align = ui.TEXT_ALIGN_CENTER}):addTo(self)
		self.speedR = Text.new({text="",x=x,y= y,size=20,color = ccc3(0,0,0),align = ui.TEXT_ALIGN_CENTER}):addTo(self)
		self.lenR   = Text.new({text="",x=x,y= y-offset,size=20,color = ccc3(0,0,0),align = ui.TEXT_ALIGN_CENTER}):addTo(self)
	end

	self.progressBg=display.newSprite('ui/hero/attribute_button_01.png', 0, -35):addTo(self)
	self.progressBg:setScaleX(1.2)

	self.ClipNode = display.newClippingRegionNode(CCRect(0, 0, 240*1.2, 10)):hide()
	self.ClipNode:setPosition(-240*1.2/2, -35-10/2)
	self:addChild(self.ClipNode)

	--[[self.progress = display.newSprite('ui/hero/attribute_button_02.png', -120*1.2, -35):addTo(self.ClipNode)
	display.newSprite('ui/hero/attribute_button_02.png', 0, -35):addTo(self.ClipNode)
	display.newSprite('ui/hero/attribute_button_02.png', 120*1.2, -35):addTo(self.ClipNode):setAnchorPoint(ccp(1,0.5))
	self.progress:setAnchorPoint(ccp(0,0.5))]]
	self.progress = display.newSprite('ui/hero/attribute_button_02.png', 0, 5):addTo(self.ClipNode)
	display.newSprite('ui/hero/attribute_button_02.png', 120*1.2, 5):addTo(self.ClipNode)
	display.newSprite('ui/hero/attribute_button_02.png', 240*1.2, 5):addTo(self.ClipNode):setAnchorPoint(ccp(1,0.5))
	self.progress:setAnchorPoint(ccp(0,0.5))
	self:performWithDelay(function() 
		self:setClippingRegion(gHero.data[self.parent.heroIndex][3]:get()/self.parent.heroData.exp:get(), 1) 
		self.ClipNode:show()
	end, 0.25)

	self.expNode = display.newNode():addTo(self)
	self:addExpText()

	self.practiceBtn = cc.ui.UIPushButton.new({
		normal='ui/hero/hero_new_practice_normal.png',
		pressed='ui/hero/hero_new_practice_pressed.png',
	}):pos(0, -self.height/2+40):addTo(self)
	:onButtonRelease(function(event)
		if self.canClick ~= true then return end
		if self.parent.reachMaxLvl then CommUtil.toast(self,'已修炼至最高级') return end
		self:setTouchEnabled(false)
		if gItem:getItemNum(30006)>0 or gItem:getItemNum(30004)>0 then --第个加100经验值
			print('进入循环体')
			print('  高级经验石='..gItem:getItemNum(30006))
			print('  初级经验石='..gItem:getItemNum(30004))
			print('  星级='..self.parent.heroData.star:get(), ' 经验='..gHero.data[self.parent.heroIndex][3]:get())
			repeat
				if gItem:getItemNum(30006)>0 then
					print('高级经验石-------------------')
					local itemNum = gItem:getItemNum(30006)
					local needExp = self.parent.heroData.exp:get() - gHero.data[self.parent.heroIndex][3]:get() --需要的经验值
					local needItem = math.ceil(needExp/100)
					if needItem <= itemNum then
						gHero:upHeroStar(self.parent.heroData.id, self.parent.heroData.star:get()+1, needItem*100-needExp)
						gItem:cutItem(30006, needItem)
						self.parent:loadHeroData()

						print('使用高级经验石='..needItem,' 星级='..self.parent.heroData.star:get(), ' 经验='..gHero.data[self.parent.heroIndex][3]:get(), ' 总经验石='..itemNum)
					else
						gHero:saveHeroExp(self.parent.heroData.id, itemNum*100+gHero.data[self.parent.heroIndex][3]:get())
						gItem:cutItem(30006, itemNum)
						self.parent:loadHeroData()

						print('使用高级经验石='..needItem,' 星级='..self.parent.heroData.star:get(), ' 经验='..gHero.data[self.parent.heroIndex][3]:get(), ' 总经验石='..itemNum)
					end
				elseif gItem:getItemNum(30004)>0 then
					print('初级经验石-------------------')
					local itemNum = gItem:getItemNum(30004)
					local needExp = self.parent.heroData.exp:get() - gHero.data[self.parent.heroIndex][3]:get()
					local proExp = 0 --生成经验值
					local cutItemNum = 0
					math.random(1,100)
					math.random(1,100)
					math.random(1,100)
					for i=1,itemNum do
						cutItemNum = cutItemNum + 1
						proExp = proExp+math.random(1,100)
						if proExp >= needExp then break end
					end
					if proExp >= needExp then
						gHero:upHeroStar(self.parent.heroData.id, self.parent.heroData.star:get()+1, proExp-needExp)
					else
						gHero:saveHeroExp(self.parent.heroData.id, proExp+gHero.data[self.parent.heroIndex][3]:get())
					end
					gItem:cutItem(30004, cutItemNum)
					self.parent:loadHeroData()
					print('使用初级经验石='..cutItemNum,' 星级='..self.parent.heroData.star:get(), ' 经验='..gHero.data[self.parent.heroIndex][3]:get(), ' 总经验石='..itemNum)
				end
			until (self.parent.reachMaxLvl or (gItem:getItemNum(30006)<=0 and gItem:getItemNum(30004)<=0))
			print('退出循环体')
			print('  高级经验石='..gItem:getItemNum(30006))
			print('  初级经验石='..gItem:getItemNum(30004))
			print('  星级='..self.parent.heroData.star:get(), ' 经验='..gHero.data[self.parent.heroIndex][3]:get())

			self:setClippingRegion(gHero.data[self.parent.heroIndex][3]:get()/self.parent.heroData.exp:get(),1)
			self:addExpText()
			self:updatePanel()
			if self.parent.reachMaxLvl then 
				CommUtil.toast(self,'英雄修炼成功至最高级！')
			else
				CommUtil.toast(self,'英雄修炼成功！')
			end

			self:setTouchEnabled(true)
		else
			CommUtil.toast(self, '经验石不足，请前往商城选购！')
			self:setTouchEnabled(true)
		end
	end)
end

function heroPractice:addExpText()
	self.expNode:removeAllChildren()
	local text,num='',0
	if gItem:getItemNum(30006) > 0 then
		text,num='当前拥有经验石:',gItem:getItemNum(30006)
	elseif gItem:getItemNum(30004) > 0 then
		text,num='当前拥有初级经验石:',gItem:getItemNum(30004)
	else
		text='当前无经验石！'
	end

	if num > 0 then
		Text.new({text=text,x=-50,y=-60,size=20,color = ccc3(0,255,0),align = ui.TEXT_ALIGN_CENTER}):addTo(self.expNode)
		Text.new({text=num,x=45,y=-60,size=20,color = ccc3(0,255,0),align = ui.TEXT_ALIGN_LEFT}):addTo(self.expNode)
	else
		Text.new({text=text,x=0,y=-60,size=20,color = ccc3(255,0,0),align = ui.TEXT_ALIGN_CENTER}):addTo(self.expNode)	
	end
end

--更新技能详情显示
function heroPractice:updatePanel()
	self.attackL:setString(self.parent.heroData.attackpower:get())
	self.speedL:setString(self.parent.heroData.attack_times)
	self.lenL:setString(self.parent.heroData.range:get())

	if not self.parent.reachMaxLvl then
		self.attackR:setString(self.parent.heroDataNextLvl.attackpower:get())
		self.speedR:setString(self.parent.heroDataNextLvl.attack_times)
		self.lenR:setString(self.parent.heroDataNextLvl.range:get())
	else
		self.attackR:setString('')
		self.speedR:setString('')
		self.lenR:setString('')
	end
end

function heroPractice:setPercentage(per)
	local sx = self.progressBg:getCascadeBoundingBox().size.width*per/100/self.progress:getContentSize().width
	self.progress:runAction(CCScaleTo:create(0.2, sx, self.progress:getScaleY()))
end

function heroPractice:setClippingRegion(scaleX, scaleY)
	if self.parent.reachMaxLvl then scaleX = 1 end
	local rect = self.ClipNode:getClippingRegion()
	local new_rect = CCRect(rect.origin.x, rect.origin.y, 240*1.2*scaleX, rect.size.height*scaleY)
	self.ClipNode:setClippingRegion(new_rect)
end

function heroPractice:setTouchEnabled(b)
	self.canClick = b
end

function heroPractice:onExit()
	self.parent:loadHeroData()
	self.parent:updatePanel()
	self.parent:setTouchEnabled(true)
end

return heroPractice